//*****************************************************************************
//*
//*
//*		BackupDoc.cpp
//*
//*
//*****************************************************************************

#include "StdAfx.h"
#include "Backup.h"
#include "BackupDoc.h"
#include "BackupView.h"
#include "TaskbarTools.h"
#include "VarTools.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CBackupDoc, CDocument)
BEGIN_MESSAGE_MAP  (CBackupDoc, CDocument)
	//{{AFX_MSG_MAP(CBackupDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//*****************************************************************************
//*
//*		Konstructor
//*
//*****************************************************************************
CBackupDoc::CBackupDoc()
{
	has_tray_icon = FALSE;
}

//*****************************************************************************
//*
//*		Destructor
//*
//*****************************************************************************
CBackupDoc::~CBackupDoc()
{
}

//*****************************************************************************
//*
//*		OnNewDocument
//*
//*****************************************************************************
BOOL CBackupDoc::OnNewDocument()
{
POSITION		 pos;
CBackupView	    *view;


	if(!CDocument::OnNewDocument())
		{
		return FALSE;
		}

	pos  =			     GetFirstViewPosition();// Zeiger auf View
	view = (CBackupView*)GetNextView(pos);
	if(!view)return TRUE;

	view->NewView();


return TRUE;
}



//*****************************************************************************
//*
//*		Serialize
//*
//*****************************************************************************
void CBackupDoc::Serialize(CArchive& ar)
{
int				 x,y,z,unter,modus,art=0,anz=0,letzte=0;
POSITION		 pos;
CBackupView	    *view;
char			 zeichen;
char			 puffer[MAX_PATH+1024];
char			 quelle[MAX_PATH+1024];
char			 ziel  [MAX_PATH+1024];
char			 plus  [MAX_PATH+1024];
char			 minus [MAX_PATH+1024];
char			 zusatz[MAX_PATH+1024];


	puffer[0] = 0;
	quelle[0] = 0;
	ziel  [0] = 0;
	plus  [0] = 0;
	minus [0] = 0;
	zusatz[0] = 0;

	pos   =			      GetFirstViewPosition();	// Zeiger auf View
	view  = (CBackupView*)GetNextView(pos);
	if(!view)return;

	modus = MODE_COPY;

///****************** Datei speichern *******************************************
if(ar.IsStoring())
	{
	anz=view->GetInfo(BKU_ANZAHL);

	for(x=0;x<anz;x++)								// Alle Eintrge speichern
		{
		ar.WriteString("[EINTRAG]");
		ar.WriteString("\r\n"     );
		for(y=0;y<7;y++)
			{
			if(y==4)continue;
			if(y==5)continue;
			z=view->GetTextEx(puffer+3,MAX_PATH+1024-8,x,y);
			if((z==-1)||!puffer[3])continue;
			puffer[0]='\t';
			puffer[1]="QZPM__X"[y];
			puffer[2]=':';
			ar.WriteString(puffer);
			ar.WriteString("\r\n");
			}
		z=view->GetTextEx(puffer,MAX_PATH+1024-8,x,4);
		if(stricmp(puffer,"Nein"))
			{
			ar.WriteString("\t/UNTER");
			ar.WriteString("\r\n");
			}
		z=view->GetTextEx(puffer,MAX_PATH+1024-8,x,5);
		if(!stricmp(puffer,"Zip"))
			{
			ar.WriteString("\t/ZIP");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Zip Add"))
			{
			ar.WriteString("\t/ZIP_ADD");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Reg"))
			{
			ar.WriteString("\t/REG");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Reg Add"))
			{
			ar.WriteString("\t/REG_ADD");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Move"))
			{
			ar.WriteString("\t/MOVE");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Del"))
			{
			ar.WriteString("\t/DEL");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Ftp"))
			{
			ar.WriteString("\t/FTP");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Ftp Del"))
			{
			ar.WriteString("\t/FTP_DEL");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Synch"))
			{
			ar.WriteString("\t/SYNCH");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Puffer"))
			{
			ar.WriteString("\t/BUFFER");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Update"))
			{
			ar.WriteString("\t/UPDATE");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Copy Del"))
			{
			ar.WriteString("\t/COPY_DEL");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Copy File"))
			{
			ar.WriteString("\t/COPY_FILE");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Version"))
			{
			ar.WriteString("\t/VERSION");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Shrink"))
			{
			ar.WriteString("\t/SHRINK");
			ar.WriteString("\r\n");
			}
		if(!stricmp(puffer,"Backup"))
			{
			ar.WriteString("\t/BACKUP");
			ar.WriteString("\r\n");
			}
		}

	anz=view->GetInfo(BKU_ZEITPLAN_ANZ);	// Zeitplan speichern
	art=view->GetInfo(BKU_ZEITPLAN_ART);
	itostr(art,ziel,1);
	itostr(anz,plus,0);
	strcpy(puffer,"/ZEITPLAN=");
	strcat(puffer,ziel);
	strcat(puffer,"," );
	strcat(puffer,plus);
	ar.WriteString(puffer);
	ar.WriteString("\r\n");
	x=view->GetInfo(BKU_ZEITPLAN_LETZTE);	// Letzte Speicherung
	if(x)
		{
		itostr(x,ziel,1);
		strcpy(puffer,"/LETZTE=");
		strcat(puffer,ziel);
		ar.WriteString(puffer);
		ar.WriteString("\r\n");
		}
	view->SetGeaendert(0);
	}
//****************** Datei laden **********************************************
else{										// Zeilenweise laden
	view->OnSelectAll();
	view->Delete(FALSE);

	for(;;)
		{
		try	{
			if(!ar.ReadString((char*)puffer,sizeof(puffer)))break;
			}
		catch(...)
			{
			break;
			}

		x=strlen (puffer);
		y=strcspn(puffer  ,":[/");
		z=strspn (puffer+y,"\t ")+y;
		if(puffer[z]==':')z++;

		for(;x>=0;x--)						// Leerzeichen entfernen
			{
			zeichen=puffer[x];
			if((zeichen!=' ' )&&(zeichen!='\t')&&
			   (zeichen!='\r')&&(zeichen!='\n'))break;
			    puffer[x]=0;
			}

		if(puffer[y]=='[')
			{
			if(!stricmp(puffer+y,"[EINTRAG]"))// Blcke
				{
				if(quelle[0]&&(ziel[0]||modus==MODE_REG||modus==MODE_DEL))
				view->Insert(-1,quelle,ziel,plus,minus,unter,modus,zusatz);
				quelle[0]=0;
				ziel  [0]=0;
				plus  [0]=0;
				minus [0]=0;
				zusatz[0]=0;
				unter    =0;
				modus    =MODE_COPY;
				}
			continue;
			}

		if(puffer[y]=='/')					// Flags laden
			{
			if(!stricmp (puffer+y,"/COPY_FILE"))modus=MODE_COPYFILE;
			if(!stricmp (puffer+y,"/COPY_DEL" ))modus=MODE_COPYDEL;
			if(!stricmp (puffer+y,"/ZIP"      ))modus=MODE_ZIP;
			if(!stricmp (puffer+y,"/ZIP_ADD"  ))modus=MODE_ZIPADD;
			if(!stricmp (puffer+y,"/REG"      ))modus=MODE_REG;
			if(!stricmp (puffer+y,"/REG_ADD"  ))modus=MODE_REGADD;
			if(!stricmp (puffer+y,"/MOVE"     ))modus=MODE_MOVE;
			if(!stricmp (puffer+y,"/DEL"      ))modus=MODE_DEL;
			if(!stricmp (puffer+y,"/FTP"      ))modus=MODE_FTP;
			if(!stricmp (puffer+y,"/FTP_DEL"  ))modus=MODE_FTPDEL;
			if(!stricmp (puffer+y,"/SYNCH"    ))modus=MODE_SYNCH;
			if(!stricmp (puffer+y,"/BUFFER"   ))modus=MODE_BUFFER;
			if(!stricmp (puffer+y,"/UPDATE"   ))modus=MODE_UPDATE;
			if(!stricmp (puffer+y,"/VERSION"  ))modus=MODE_VERSION;
			if(!stricmp (puffer+y,"/SHRINK"   ))modus=MODE_SHRINK;
			if(!stricmp (puffer+y,"/BACKUP"   ))modus=MODE_BACKUP;
			if(!stricmp (puffer+y,"/UNTER"    ))unter=1;
			if(!strnicmp(puffer+y,"/ZEITPLAN=",10))
				{
				z=strcspn(puffer+y+10,",")+y+10;
				if(puffer[z]==',')
					anz=strtoi (puffer+z+1 );
					art=strtoi (puffer+y+10);
				view->Zeitplan(art,anz);
				}
			if(!strnicmp(puffer+y,"/LETZTE=",8))
				{
				z=     strcspn(puffer+y+8,",")+y+8;
				letzte=strtoi (puffer+y+8);
				view->LetzteSpeicherung(letzte);
				}
			continue;
			}

		if(!y||(x<=z)||(puffer[y]!=':'))continue;

		switch(puffer[y-1])					// Eintrge kopieren
			{
		case 'Q':
		case 'q':	strlcpy(quelle,puffer+z,sizeof(quelle));	break;
		case 'Z':
		case 'z':	strlcpy(ziel  ,puffer+z,sizeof(ziel));		break;
		case 'P':
		case 'p':	strlcpy(plus  ,puffer+z,sizeof(plus));		break;
		case 'M':
		case 'm':	strlcpy(minus ,puffer+z,sizeof(minus));		break;
		case 'X':
		case 'x':	strlcpy(zusatz,puffer+z,sizeof(zusatz));	break;
			}
		}

	if(quelle[0]&&(ziel[0]||modus==MODE_REG||modus==MODE_DEL))
		view->Insert(-1,quelle,ziel,plus,minus,unter,modus,zusatz);
		view->SetGeaendert(0);
	}


}

//*****************************************************************************
//*
//*		IsModified
//*
//*****************************************************************************
BOOL CBackupDoc::IsModified()
{
POSITION		 pos;
CBackupView	    *view;


	pos  =		  	     GetFirstViewPosition();	// Zeiger auf View
	view = (CBackupView*)GetNextView(pos);
	if(!view)return 0;

return view->GetGeaendert();
}

//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void CBackupDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBackupDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif



//*****************************************************************************
//*
//*		OnSaveDocument
//*
//*****************************************************************************
BOOL CBackupDoc::OnSaveDocument(LPCTSTR pPathName)
{
char	 puffer[256];


	if(CDocument::OnSaveDocument(pPathName))
		{
		GetFilePath (puffer,pPathName,sizeof(puffer));
		DelBackSlash(puffer);
		VarSet("BKU_PATH",puffer);
		VarSet("BKU_FILE",pPathName);
		return TRUE;
		}


return FALSE;
}

//*****************************************************************************
//*
//*		OnOpenDocument
//*
//*****************************************************************************
BOOL CBackupDoc::OnOpenDocument(LPCTSTR pPathName)
{
BOOL			 ok;
POSITION		 pos;
CBackupApp      *app;
CBackupView	    *view;
char			 puffer[256];



	GetFilePath (puffer,pPathName,sizeof(puffer));
	DelBackSlash(puffer);
	VarSet("BKU_PATH",puffer);
	VarSet("BKU_FILE",pPathName);

	pos  =			     GetFirstViewPosition();// Zeiger auf View
	view = (CBackupView*)GetNextView(pos);
	ok   = CDocument::OnOpenDocument(pPathName);


	   app=(CBackupApp*)AfxGetApp();
	if(app->start && ok )
		{
		int	art=6;

 		if(app->immer)							// Backup immer ausfhren
			{
			art=view->GetInfo(BKU_ZEITPLAN_ART);
			art=(art&0x8000)? 3:2;
			}

		if(app->fenster)						// Keine Fenster anzeigen
			{
			GetFileBody(puffer,pPathName,sizeof(puffer));

			view->hide = 1;
			AfxGetMainWnd()->ShowWindow(SW_HIDE);
			TaskbarHide(AfxGetMainWnd()->m_hWnd);
			TaskbarIconAdd(view->m_hWnd,IDR_MAINFRAME,puffer);
			my_icon = GetTickCount();
			has_tray_icon = 1;

			art&=~2;
			}
		else{
			has_tray_icon = 0;
			}

		my_mode = art;
		my_view = view;
		my_path = pPathName;
		AfxBeginThread(RunThread,this);
		}

	app->start=0;
	app->immer=0;


return ok;
}

//*****************************************************************************
//*
//*		RunThread
//*
//*****************************************************************************
UINT CBackupDoc::RunThread(LPVOID param){return ((CBackupDoc*)param)->RunThread();}
UINT CBackupDoc::RunThread()
{
UINT	diff;

	my_view->Run(my_mode);

	if(IsModified())
		{
		OnSaveDocument(my_path);
		}

	if(has_tray_icon)
		{
		diff    = GetTickCount()-my_icon;
		if(diff<1000)Sleep(1000-diff);
		TaskbarIconDel(my_view->m_hWnd);
		}


	my_view->PostMessage(WM_QUIT);


return 0;
}
