//*****************************************************************************
//*
//*
//*		CBackupView.h
//*
//*
//*****************************************************************************
#if !defined(AFX_BACKUPVIEW_H__3827DA2F_B14F_11D2_84E4_D45E713A360A__INCLUDED_)
#define      AFX_BACKUPVIEW_H__3827DA2F_B14F_11D2_84E4_D45E713A360A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

#include <time.h>
#include <string.h>
#include <afxcmn.h>
#include <afxole.h>
#include <afxcview.h>
#include <afxwin.h>

#include "RegWnd.h"
#include "RegText.h"
#include "DateiView.h"
#include "ZipFile.h"
#include "FileFinder.h"
#include "TreeListCtrl.h"
#include "StringFunctions.h"
#include "FtpTools/FtpTools.h"

class CProgressDialog;
class CBackupDoc;
class CFtpBase;

#define 	WM_SETBREAK			0x5693

//*****************************************************************************
//*
//*		CBackupView
//*
//*****************************************************************************
class CBackupView : public CView
{
public:

	BOOL	hide;	

protected:

#define		IDC_EDITVIEW		0x88770010	// ID fr Editview
#define		IDC_LISTVIEW		0x88770011	// ID fr Listview
#define		IDC_DATEIVIEW		0x88770012	// ID fr Dateiview
#define		IDC_REGVIEW			0x88770013	// ID fr Regview
#define		ID_EDITRETURN		0x8700		// Returntaste beim Text ndern
#define		ID_EDITESCAPE		0x8701		// Returntaste beim Text ndern
#define		ID_STATUSBARSET		0x12346666	// ID Stadusbarset

#define		BKU_ANZAHL			0
#define		BKU_ZEITPLAN_ART	1
#define		BKU_ZEITPLAN_ANZ	2
#define		BKU_ZEITPLAN_LETZTE	3
#define 	BKU_FILTER			4

#define 	MODE_COPY			0
#define 	MODE_COPYDEL		1
#define 	MODE_COPYFILE		2
#define 	MODE_ZIP			3
#define 	MODE_ZIPADD			4
#define 	MODE_REG			5
#define 	MODE_REGADD			6
#define 	MODE_MOVE			7
#define 	MODE_DEL			8
#define 	MODE_FTP			9
#define 	MODE_FTPDEL			10
#define 	MODE_SYNCH			11
#define 	MODE_BUFFER			12
#define 	MODE_UPDATE			13
#define 	MODE_VERSION		14
#define 	MODE_SHRINK			15
#define 	MODE_BACKUP			16

	struct	SortData
		{
		CTreeListCtrl  *list;
		int				nr,richtung;
		};

	CProgressDialog*dlg_view;				// Zeiger auf Verlaufsfenster
	CTreeListCtrl list_view;				// Fenster mit Dateiliste
	CDateiView	  datei_view;				// Fenster mit Dateibaum
	CRegWnd	      reg_view;					// Registry Fenster
	int			  reg_on;					// Regfenster anzeigen
	int			  dlg_break;				// Abbruch fr Dialog Fenster
	int			  teilung;					// Teilung der Fenster
	int			  anzahl;					// Anzahl der gefunden Dateien im Listview
	int			  geaendert;				// Wurden Eintrge gendert
	int			  lock_escape;				// ESC beendet nicht das Programm
	__int64		  size_offset;				// Offset fr fr die Verlaufsanzeige
	int			  size_mode;				// Modus fr Verlaufsanzeige (0=keine nderung 1=size_offset 2=size_offset+sub_size 3=size_offset+size_now 4=zip)
	int			  size_now;					// Maximale sub_size fr die Verlaufsanzeige (wenn size_mode==2)
	int			  size_max;					// Maximale sub_size fr die Verlaufsanzeige (wenn size_mode==2)
	int			  set_statubar;				// Statusbar setzen
	int			  sort_art;					// Sortier-Art
	int			  sort_richtung;			// Sortier-Richtung
	int			  kopie_anz;				// Anzahl der Kopierten Dateien
	int			  zeitplan_art;				// Art des Zeitplanes 0=Nie 1=Tage 2=Wochen 3=Monate
	int			  zeitplan_anz;				// Abstand des Zeitplanes
	time_t		  zeitplan_letzte;			// Letzte Speicherung
	DWORD		  time_from;				// Start-Tick des Backups	
	char		  prog_text[MAX_PATH*2+256];

	HCURSOR		  cursor_size;				// Gren Cursor
	HTREEITEM	  base_item;				// Erster Eintrag in der Liste
	UINT		  filter_tick;				// Ticker fr Filter-Update
	BOOL		  filter_on;				// Den Filter einblenden
	CString		  filters[7];				// Aktuelle Filtertexte	
	CString		  call_bat;					// Eine BAT-Datei am Ende starten
	CStringChain  undo_str;					// Texte fr's Wiederherstellen
	int			  undo_ok;					// Wiederherstellen	mglich
											
	CZipFile	  zip;						// Zip-Klasse 
	CStringChain  lock_str;					// Verzeichnisse die bersprungen werden
	CFtpBase     *ftp_conn;					// FTP Verbindung fr's Backup
	char		 *lock_mem;					// Verzeichnisspeicher der gerade bersprungen wird
	int			  lock;						// Lnge des Verzeichnisspeichers
	int			  filter_pos;				// Wo soll der Filter angepasst werden
											
static	char	 *modi[];
static	int		  mb_isshown;


//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************

protected: 

	CBackupView();
	DECLARE_DYNCREATE(CBackupView)

public:
	CBackupDoc* GetDocument();

public:

	//{{AFX_VIRTUAL(CBackupView)
public:
	virtual BOOL Create( LPCTSTR pClassName, LPCTSTR pWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnDraw(CDC *pDC);  
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	//}}AFX_VIRTUAL


// Implementierung
public:

	static	int MessageBoxOn();
	void	LetzteSpeicherung(time_t Letzte);
	void	Zeitplan	 (int Art,int Anz);
	void	OnPathUp	 ();
	void	OnStart		 ();
	void	NewView		 ();
	void	ZeitplanView ();
	int 	DeleteFtp	 (CFtpBase *Ftp,char *Path,CStringChain &List,int Art,int *Pos=0);
	int		GetInfo		 (int Art=0);

	int		Run		   	 (int   Art);
	int		Run		   	 (int   Nummer,int Art);
	int		CopyPath   	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyDel    	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyZip    	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyReg    	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyFtp    	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyMove   	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopySynch  	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyCpDel  	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyBuffer 	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyShrink   (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyUpdate 	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopySingle 	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyVersion	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);
	int		CopyBackup	 (char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art=0);

	int		IsLockLast 	 (const char *Path);
	int		IsLockPath 	 (const char *Path,int Len =1024);
	int		SetLockPath	 (const char *List,int Mode=0);
	int		CheckLocal 	 (const char *Path,const FILETIME *Time,int Art);
	int		CheckLocal 	 (const char *Path,time_t          Time,int Art);
	int		DeleteFtpDir (      char *Path,int Size,int Max,const char *Plus,const char *Minus);
	char   *ErrorToText	 (unsigned Error,char *Default);

	int		GetTextEx	 (char *Text,int Len,int Y_pos     ,int X_pos=0);
	int		GetText		 (char *Text,int Len,HTREEITEM Item,int X_pos=0);
	int		GetText		 (char *Text,int Len,int Y_pos     ,int X_pos=0);
	int		SetText		 (char *Text,int Y_pos             ,int X_pos=0);
	int		SetGeaendert (int Geaendert);
	int		GetGeaendert ();
	int		StatusbarInit();
	int		StatusbarExit();
	int		StatusbarSet ();
	int		Insert		 ();
	int		Insert		 (int Pos,char *Quelle,char *Ziel=0,char *Plus=0,char *Minus=0,int Unter=1,int Modus=0,char *Zusatz=0);
	int		Insert		 (int Pos,int Filter  ,char *Quelle);
	int		SetIcon		 (int Nr ,int Warnung=0);
	int		SetIcon		 (HTREEITEM Item,int Warnung=0);
	int		HitTest		 (CPoint Point,int *X_pos,int *Y_pos);
	int		Delete		 (BOOL Undo=TRUE);
	int		ItemMove	 (int Item,int Dir);
	int		CheckHost	 (char **Zusatz);

	void    OnSelectAll();
	virtual ~CBackupView();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

static  void  _cdecl   FtpBreak	 (void *);
static  void  _cdecl   FindBreak (void *);
static  int   _cdecl   RunProc	 (CProgressDialog *Dlg);
static  void  _cdecl   CopyPos	 (CProgressDialog *Dlg,void *Param);
static  int	  _cdecl   ZipProc	 (void *Sunbmit,int Art,int Sub,CArchiveFile *Zip,char *Text);
static	int   _cdecl   ExtDrop	 (const char *Pfad,CStringChain *Dateien  ,int Art,void *Element,void *Data);
static	int   _cdecl   ExtGetMode(UINT  nFlags ,void *Element,void *Data);
static	int   _cdecl   ExtHitTest(CPoint Point ,void *Element,void *Data);
static  int   _cdecl   BufferProc(void *Dlg,int Mode,const char *Text);
static	int   _cdecl   DiffDays  (FILETIME &Time1,FILETIME &Time2);
static	int   _cdecl   DiffSecs  (FILETIME &Time1,FILETIME &Time2);
static	int   CALLBACK SortList  (HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1, LPARAM lParam2,LPARAM lParamSort);
int CBackupView::MessageBox(LPCTSTR Text, LPCTSTR Caption,UINT Type);


	void UpdateFilters(BOOL ReadBack);
	void OnRegOn(CCmdUI *pCmdUI);
	void OnSetCpp();

	//{{AFX_MSG(CBackupView)
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int iSizeX, int iSizeY);
	afx_msg void OnContextMenu(CWnd* pWnd,CPoint sPoint);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMenuFilter(CCmdUI *pCmdUI);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnMenuUndo(CCmdUI *pCmdUI);
	afx_msg void OnPathUpUI(CCmdUI *pCmdUI);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSetFilter();
	afx_msg void OnFieldCopy();
	afx_msg void OnFullCopy();
	afx_msg void OnNewEntry();
	afx_msg void OnPathCtrl();
	afx_msg void OnItemDown();
	afx_msg void OnMakeRel();
	afx_msg void OnSetPath();
	afx_msg void OnDestroy();
	afx_msg void OnItemUp();
	afx_msg void OnClose();
	afx_msg void OnPaint();
	afx_msg void OnRegOn();
	//}}AFX_MSG

	
	afx_msg void OnStartUI    (CCmdUI *pCmdUI);
	afx_msg void OnItemUpUI	  (CCmdUI *pCmdUI);
	afx_msg void OnItemDownUI (CCmdUI *pCmdUI);
	afx_msg void OnMenuSelect (CCmdUI *pCmdUI);
	afx_msg void OnPathCtrlUI (CCmdUI *pCmdUI);
	afx_msg void OnNotifyIcon (WPARAM  wParam,LPARAM   lParam );
	afx_msg void OnStartEdit  (NMHDR  *pNmHdr,LRESULT *pResult);
	afx_msg void OnItemsMoved (NMHDR  *pNmHdr,LRESULT *pResult);
	afx_msg void OnTreeKeyDown(NMHDR  *pNmHdr,LRESULT *pResult);
	afx_msg void OnColumnClick(NMHDR  *pNmHdr,LRESULT *pResult);
	afx_msg void OnEndEdit    (NMHDR  *pNmHdr,LRESULT *pResult);
	afx_msg void OnStartEdit();
	afx_msg void OnSettings();
	afx_msg void OnDoFilter();
	afx_msg void OnInsert();
	afx_msg void OnDelete();
	afx_msg void OnUndo();
	afx_msg void OnStop();

	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // Testversion in DateiView.cpp
inline CBackupDoc* CBackupView::GetDocument()   { return (CBackupDoc*)m_pDocument; }
#endif

inline int	CBackupView::SetIcon(HTREEITEM Item,int Warnung){return SetIcon((int)Item|0x71000000,Warnung);}


#endif
