//*****************************************************************************
//*
//*
//*		KLASSE  CDateiView
//*
//*
//*****************************************************************************
// 	char *GetPath()							Ergibt den aktuellen Pfad
// 	char *SetPath(char *)					Ergibt den aktuellen Pfad
// 	int   Set (char*="C:\\",char*=0,int=0)	Neuen Pfad Setzen
//	int   Filter (char *,char *,int =1)		Neuen Datei-Filter einstellen
// 	void  OnSelectAll()						Alles auswhlen
// 	int   GetSelect(CStringChain *,int=0)	Ergibt die ausgewhlen Dateien
// 	int	  SetStyle(int,int Maske=0xFFFF)	ndert Aussehen
// 	int	  Delete()							Lscht ausgewhlten Dateien
// 	int	  CreateNewFolder(char *Name=0)		Erzeugt ein neues Verzeichnis
// 	int	  DoDrop(char *Pfad,int Art)		Dorp-Funktion ausfhren
// 	int   HitTest(CPoint,void *)			Ergibt Eintragnr. unter Cursor
// 	int   SetListView(int=LVS_REPORT)		ndert die Ansicht des Listviews
// 	int   Sort(int Art=0,int Richtung=0)	Sortiere ListView
//
//	Einstellen der Drop-Funktionen
//
// 	void  SetDrop(	int(*Drop_fnk)(char *Pfad,CStringChain *Dateien  ,int Art,void *Element,void *Data)=0,void *Data=0);
// 	void  SetView(	int(*Extern_hit_test)(CPoint Point ,void *Element	     ,void *Data)=0,
// 					int(*Extern_get_pfad)(void *Element,char *Puffer ,int Len,void *Data)=0,
// 					int(*Extern_get_mode)(UINT  nFlags ,void *Element	     ,void *Data)=0);
// 	HTREEITEM Read(char *Pfad,int Art=0,HTREEITEM Wurzel=0);

#include "StdAfx.h"
#include <winreg.h>


#include "WinExtension.h"
#include "AfxUtility.h"
#include "DateiView.h"
#include "CopyDlg.h"
#include "MainFrm.h"



#ifndef	ID_PATHUP
#define	ID_PATHUP		0x8801
#endif
#ifndef	ID_SETICON
#define	ID_SETICON		0x8802
#endif
#ifndef	ID_SETLIST
#define	ID_SETLIST		0x8803
#endif
#ifndef	ID_SETSMALLICON
#define	ID_SETSMALLICON	0x8804
#endif
#ifndef	ID_SETREPORT
#define	ID_SETREPORT	0x8805
#endif
#ifndef	ID_SELECTALL
#define	ID_SELECTALL	0x8806
#endif
#ifndef	ID_NEWDIR
#define	ID_NEWDIR		0x8807
#endif
#ifndef	ID_DELETE
#define	ID_DELETE		0x8808
#endif
#ifndef	ID_SELECTALL
#define	ID_SELECTALL	0x8809
#endif
#ifndef	ID_RETURN
#define ID_RETURN		0x880A
#endif
#ifndef	ID_TABULATOR
#define ID_TABULATOR	0x880B
#endif
#ifndef	ID_PATHPREV
#define ID_PATHPREV		0x880C
#endif
#ifndef	ID_PATHNEXT
#define ID_PATHNEXT		0x880D
#endif
#ifndef	ID_FOLTERUP
#define ID_FOLTERUP		0x880E
#endif


#define	IDC_TREEVIEW	0x88880000			// ID fr Treeview
#define	IDC_LISTVIEW	0x88880001			// ID fr Listview
#define IDC_COMBOBOX	0x88880002			// ID fr ComboBox
#define ID_PATHSEL		0x00006700			// ID fr um Pfad zu whlen
#define	ID_STATUSBARSET	0x12346666			// ID Stadusbarset
#define ID_COMBOUPDATE	0x12347777			// ID Pfad aus ComboBox holen
#define COMBO_FRAME		3					// Breite des Ramens um die Combobox




#define		FRAME_CLASS		CMainFrame		// Klasse mit StatusBar
//Anmerkung FRAME_CLASS.m_wndStatusBar muss als public definiert sein

#ifdef     _DEBUG
#define new DEBUG_NEW
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//*****************************************************************************
//*
//*   Nachrichten Verarbeitung
//*
//*****************************************************************************

BEGIN_MESSAGE_MAP(CDateiView, CWnd)
	//{{AFX_MSG_MAP(CDateiView)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_KEYUP()
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_WM_CREATE()
	ON_WM_KEYDOWN()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_DROPFILES()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	ON_CBN_CLOSEUP	(IDC_COMBOBOX,OnCbCloseUp )
	ON_CBN_SETFOCUS (IDC_COMBOBOX,OnCbSetFocus)
	ON_CBN_SELCHANGE(IDC_COMBOBOX,OnSelChanged)
	//}}AFX_MSG_MAP

	ON_COMMAND(ID_SETICON		, OnIcon)
	ON_COMMAND(ID_SETLIST		, OnList)
	ON_COMMAND(ID_PATHUP		, OnPathUp)
	ON_COMMAND(ID_SETREPORT		, OnReport)
	ON_COMMAND(ID_SETSMALLICON	, OnSmallIcon)
	ON_COMMAND(ID_STATUSBARSET	, OnStatusbarSet)
	ON_COMMAND(ID_SELECTALL		, OnSelectAll)
	ON_COMMAND(ID_NEWDIR		, OnNewDir)
	ON_COMMAND(ID_DELETE		, OnDelete)
	ON_COMMAND(ID_RETURN		, OnReturn)
	ON_COMMAND(ID_TABULATOR		, OnTabulator)
	ON_COMMAND(ID_PATHPREV		, OnPathPrev)
	ON_COMMAND(ID_PATHNEXT		, OnPathNext)
	ON_COMMAND(ID_FOLTERUP		, OnPathUp)
	ON_COMMAND_RANGE(ID_PATHSEL,ID_PATHSEL+32  , OnPathSelect)

	ON_UPDATE_COMMAND_UI(ID_SETICON			   , OnMenu)
	ON_UPDATE_COMMAND_UI(ID_SETLIST			   , OnMenu)
	ON_UPDATE_COMMAND_UI(ID_SETSMALLICON	   , OnMenu)
	ON_UPDATE_COMMAND_UI(ID_SETREPORT		   , OnMenu)

	ON_NOTIFY(TVN_SELCHANGED	, IDC_TREEVIEW , OnTreeview)
	ON_NOTIFY(TVN_ITEMEXPANDED	, IDC_TREEVIEW , OnTreeview)
	ON_NOTIFY(TVN_BEGINDRAG		, IDC_TREEVIEW , OnTreeview)
	ON_NOTIFY(TVN_ENDLABELEDIT	, IDC_TREEVIEW , OnTreeview)
	ON_NOTIFY(TVN_BEGINLABELEDIT, IDC_TREEVIEW , OnTreeview)
	ON_NOTIFY(TVN_KEYDOWN		, IDC_TREEVIEW , OnTreeview)
	ON_NOTIFY(NM_SETFOCUS		, IDC_TREEVIEW , OnTreeview)
	ON_NOTIFY(NM_RCLICK			, IDC_TREEVIEW , OnTreeview)


	ON_NOTIFY(LVN_ITEMCHANGED 	, IDC_LISTVIEW , OnListview)
	ON_NOTIFY(LVN_COLUMNCLICK	, IDC_LISTVIEW , OnListview)
	ON_NOTIFY(LVN_KEYDOWN		, IDC_LISTVIEW , OnListview)
	ON_NOTIFY(LVN_ENDLABELEDIT	, IDC_LISTVIEW , OnListview)
	ON_NOTIFY(LVN_BEGINLABELEDIT, IDC_LISTVIEW , OnListview)
	ON_NOTIFY(LVN_BEGINDRAG		, IDC_LISTVIEW , OnListview)
	ON_NOTIFY(LVN_KEYDOWN		, IDC_LISTVIEW , OnListview)
	ON_NOTIFY(NM_DBLCLK			, IDC_LISTVIEW , OnListview)
	ON_NOTIFY(NM_RETURN			, IDC_LISTVIEW , OnListview)
	ON_NOTIFY(NM_SETFOCUS		, IDC_LISTVIEW , OnListview)

END_MESSAGE_MAP()

//*****************************************************************************
//*
//*		Statische Variableln
//*
//*****************************************************************************

const int CDateiView::m_sSortArray[4]=		// Sortier-Modi
		{
		CFF_SORT_NAME,			// Nach Namen sortieren
		CFF_SORT_LEN,			// Nach Datei lnge sortieren
		CFF_SORT_TYPE,			// Nach Typ sortieren
		CFF_SORT_WRITE			// Nach letztdem Schreibzugriff  sortieren
		};

//*****************************************************************************
//*
//*		Konstruktor ... Grundeinstellung der Variabeln
//*
//*****************************************************************************
CDateiView::CDateiView()
{
	m_iStyle		= 0;
	m_iPathOk		= 0;
	m_iPathEnd		= 0;
	m_iPathPos		= 0;
	m_iPathStart	= 0;
	m_iLastFocus	= 0;
	m_iDoRename		= 0;
	m_pPath			= 0;
	m_pDropProc		= 0;
	m_iInit			= 0;
	m_hTreeOpen		= 0;
	m_hSetThread	= 0;
	m_iSetState		= 0;
	m_iSetStatubar	= 0;
	m_iSortMode		= 0;			
	m_iSortDir		= 0;			
	m_iDragState	= 0;
	m_pDragImages	= 0;
	m_iDragImgMode	= 0;
	m_pDragPath		= 0;
	m_iDropMode		=-1;
	m_iDrives		= 0;
	m_pMinus		= 0;
	m_pPlus			= 0;
	m_bSepChanged	= FALSE;
	m_iSeparator	= DVS_SEPARATOR;

	m_hCursorSize=LoadCursor(0,IDC_SIZEWE);
	m_hCursorNull=LoadCursor(0,IDC_ARROW );
	m_hCursorWait=LoadCursor(0,IDC_WAIT  );
	m_hCursorDis =LoadCursor(0,IDC_NO    );
	m_hCursorCopy=LoadCursor(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDC_CURSORCOPY   ));
	m_hCursorMove=LoadCursor(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDC_CURSORMOVE   ));
	m_iCursorMode=0;

	m_pHitTestProc	= 0;
	m_pGetModeProc	= 0;
	m_pGetPathProc	= 0;

	m_iSeparator   *= GetSystemMetrics(SM_CXICON);
	m_iSeparator   /= 32;

}

//*****************************************************************************
//*
//*		Destruktor ...
//*
//*****************************************************************************
CDateiView::~CDateiView()
{
	if(m_hSetThread)									// Thread beenden
		{
		TerminateThread(m_hSetThread,0);
		CloseHandle(m_hSetThread);
		m_hSetThread=0;
		}

	if(m_pPlus )delete m_pPlus;
	if(m_pMinus)delete m_pMinus;

	if(m_iDragImgMode && m_pDragImages)					// Imagelist lschen
					delete m_pDragImages;
	if(m_pPath	  )	delete m_pPath;
	if(m_pDragPath)	delete m_pDragPath;
}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
// Aufruf bevor Fenster sichtbar wird
BOOL CDateiView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CWnd::PreCreateWindow(cs);
}

//*****************************************************************************
//*
//*		Create  Fenstererzeugung
//*
//*****************************************************************************
// Erzeugen eines Fensters
BOOL CDateiView::Create( LPCTSTR pClassName, LPCTSTR pWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID,char *Plus,char *Minus, CCreateContext* pContext)
{
char		*zeiger,puffer[260];
CWnd		*pWnd;
int			 x,art;
int			 iPos;
RECT		 sTemp;
RECT		 rec;
SHFILEINFO	 sfi;
HIMAGELIST	 hImageList;
HTREEITEM	 hRoot,next;
CFileFinder  laufwerke;
static int	 width;


	rec.top   = 0;
	rec.bottom= 0;
	rec.left  =10;
	rec.right =10;

	m_iStyle=dwStyle;
	if(Plus||Minus)Filter(Plus,Minus,0);

	dwStyle&=0xFFFF0000;
	x=CWnd::Create(pClassName,pWindowName,dwStyle,rect,pParentWnd,nID,pContext);
	SetClassLongPtr(m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorSize);


//******************* Namenszeile **********************************************


	art = CBS_DROPDOWN|WS_CHILD;

	sTemp.top    = COMBO_FRAME;
	sTemp.left   = COMBO_FRAME;
	sTemp.bottom = 390;
	sTemp.right  = 210;

	m_cComboBox.Create(art,sTemp,this,IDC_COMBOBOX);

	hImageList = (HIMAGELIST)SHGetFileInfo( "",0,&sfi,sizeof(sfi),SHGFI_PIDL |SHGFI_SMALLICON |SHGFI_SYSICONINDEX );

	m_cComboBox.SetImageList(CImageList::FromHandle(hImageList));
	m_cComboBox.GetWindowRect(&sTemp);
	m_cComboBox.SetExtendedStyle(CBES_EX_PATHWORDBREAKPROC,CBES_EX_PATHWORDBREAKPROC);

	m_iComboHight = sTemp.bottom-sTemp.top;
	m_iComboAdd	  = m_cComboBox.GetItemHeight(0)*16+4+m_iComboHight;
	m_iComboEnd	  = m_iComboHight+COMBO_FRAME*2+5;
	m_bComboTimer = FALSE;
	m_uComboTick  = 0;
	m_uComboFast  = 0;
	m_bComboSave  = 0;
	m_bUbEnable   = 0;

	pWnd = m_cComboBox.GetEditCtrl();
	SubclassWnd(pWnd,ComboEditProc);

	m_cBtPrev.Create(_T(""),WS_CHILD|BS_PUSHBUTTON|BS_BITMAP,rect,this,ID_PATHPREV);
	m_cBtNext.Create(_T(""),WS_CHILD|BS_PUSHBUTTON|BS_BITMAP,rect,this,ID_PATHNEXT);
	m_cBtDoUp.Create(_T(""),WS_CHILD|BS_PUSHBUTTON|BS_BITMAP,rect,this,ID_FOLTERUP);

	m_cBtPrev.EnableWindow(FALSE);
	m_cBtNext.EnableWindow(FALSE);
	m_cBtDoUp.EnableWindow(FALSE);

	SetButtonBitmap(m_cBtPrev,IDB_PATHPREV);
	SetButtonBitmap(m_cBtNext,IDB_PATHNEXT);
	SetButtonBitmap(m_cBtDoUp,IDB_FOLTERUP);

	if(!(m_iStyle&DVS_NOCOMBOBOX))
		{
		m_cComboBox.ShowWindow(SW_SHOW);
		m_cBtPrev  .ShowWindow(SW_SHOW);
		m_cBtNext  .ShowWindow(SW_SHOW);
		m_cBtDoUp  .ShowWindow(SW_SHOW);
		}


//******************* Tree-View ************************************************


	art=TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS|TVS_SHOWSELALWAYS|WS_VSCROLL;
	if(m_iStyle&DVS_RENAME)art|=TVS_EDITLABELS;

	m_cTreeView.Create    (art, rec, this, IDC_TREEVIEW);
	if(!(m_iStyle&DVS_NOTREEVIEW))m_cTreeView.ShowWindow( SW_SHOW );


//******************* List-View ************************************************


 	if(width==0)												// Schriftbreite holen
		{
		width = (GetDefaultSize()*256)/7;
		}


	art=(m_iStyle&DVS_RENAME)? LVS_REPORT|LVS_EDITLABELS:LVS_REPORT;
	m_cListView.Create(art,rec, this, IDC_LISTVIEW);
	m_cListView.InsertColumn(0,"Dateiname" ,LVCFMT_LEFT ,(200*width)/256);
	m_cListView.InsertColumn(1,"Gre"     ,LVCFMT_RIGHT,( 70*width)/256);
	m_cListView.InsertColumn(2,"Typ"       ,LVCFMT_LEFT ,(150*width)/256);
	m_cListView.InsertColumn(3,"Bearbeitet",LVCFMT_LEFT ,( 90*width)/256);
	if(!(m_iStyle&DVS_NOLISTVIEW))m_cListView.ShowWindow( SW_SHOW );

	// Sytem-Image-Listen mit List-View verbinden.
	::SendMessage(m_cListView.m_hWnd, LVM_SETIMAGELIST, LVSIL_SMALL , (LPARAM)hImageList );
	::SendMessage(m_cTreeView.m_hWnd, TVM_SETIMAGELIST, TVSIL_NORMAL, (LPARAM)hImageList );
	::SendMessage(m_cTreeView.m_hWnd, TVM_SETIMAGELIST, TVSIL_STATE , (LPARAM)hImageList );
	hImageList = (HIMAGELIST)SHGetFileInfo( "",0,&sfi,sizeof(sfi),SHGFI_PIDL |SHGFI_SYSICONINDEX|SHGFI_SYSICONINDEX );
	::SendMessage(m_cListView.m_hWnd, LVM_SETIMAGELIST, LVSIL_NORMAL, (LPARAM)hImageList);

	
//******************** Die ComboBox fllen ************************************


	for(iPos=0;iPos<m_sCombo.Count();iPos++)
		{
		COMBOBOXEXITEM	sItem;
		int				iNum;

		iNum			  = GetLevel(m_sCombo[iPos],-1,&sItem.iSelectedImage);
		sItem.mask		  = CBEIF_TEXT|CBEIF_IMAGE|CBEIF_SELECTEDIMAGE;
		sItem.iImage	  =	sItem.iSelectedImage;
		sItem.pszText	  = m_sCombo[iPos];
		sItem.iItem		  = iPos;

		m_cComboBox.InsertItem(&sItem);
		}


//********************** Laufwerke einlesen ************************************


	SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorWait);
	if(HitTest()==1)::SetCursor(m_hCursorWait);

	m_cTreeView.SetRedraw(FALSE);


	laufwerke.Set(":",CFF_FIND_DIR);
	hRoot=m_cTreeView.GetRootItem();				// Ersten Eintrag finden
	

	while(zeiger=laufwerke.Next())
		{
		strcpy(puffer,zeiger);
		strcat(puffer,"\\"  );
		SHGetFileInfo(puffer,_A_SUBDIR,&sfi,sizeof(sfi),SHGFI_SYSICONINDEX|SHGFI_USEFILEATTRIBUTES);
		next=m_cTreeView.InsertItem(	TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,
									zeiger,sfi.iIcon,sfi.iIcon,0,0,
									0x12340000,TVI_ROOT,TVI_SORT);

		m_cTreeView.InsertItem(	TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,
								"\\(null)",0,0,0,0,0x12340000,next,TVI_SORT);

		if(puffer[1]==':')
			{
			if(puffer[0]=='C')m_cTreeView.SelectItem(next);
			this->m_iDrives = 1 << (int)(puffer[0]-'A');
			}
		}


	SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);

	m_cTreeView.SetRedraw(TRUE);
	
	SetTimer(ID_STATUSBARSET,1000,0);

	m_iInit=1;


return x;
}

BOOL CDateiView::Create(DWORD dwStyle,const RECT& rect, CWnd* pParentWnd, UINT nID,char *Plus,char *Minus, CCreateContext* pContext)
{

	dwStyle|=WS_VISIBLE|WS_CHILD;

return Create(NULL,"DateiView",dwStyle,rect,pParentWnd,nID,Plus,Minus,pContext);
}
//*****************************************************************************
//*
//*   SetCursor
//*
//*****************************************************************************
// Stelle einen der 4 Cursors ein
// Mode == 0	Normaler Cursor
//         1	Disable  Cursor
//         2	Copy     Cursor
//         3	Move     Cursor
// Ergibt den alten Modus
int CDateiView::SetCursor(int Mode)
{
int	alt;

	alt=m_iCursorMode;

	if(Mode!=alt)
	switch(Mode)
			{
	case 0:	::SetCursor(m_hCursorNull);	m_iCursorMode=0; break;
	case 1:	::SetCursor(m_hCursorDis );	m_iCursorMode=1; break;
	case 2:	::SetCursor(m_hCursorCopy);	m_iCursorMode=2; break;
	case 3:	::SetCursor(m_hCursorMove);	m_iCursorMode=3; break;
	case 4:	::SetCursor(m_hCursorSize);	m_iCursorMode=4; break;
			}

return alt;
}

//*****************************************************************************
//*
//*   OnPaint    Fenster neuzeichnen
//*
//*****************************************************************************
// Neu zeichnen des Fensters
void CDateiView::OnPaint( )
{
CPaintDC	sDc(this);
CRect		sRect;
CRect		sArea;
int			iTop;


	if(m_iStyle&DVS_NOCOMBOBOX)
		{
		iTop = 0;
		}
	else{
		iTop = m_iComboEnd;

		GetClientRect(&sRect);
		GetPosRect(&m_cComboBox,&sArea);

		sRect.bottom = iTop-7;

		SetBkColor   (sDc.m_hDC,GetSysColor(COLOR_MENU));
		DrawFrame    (sDc.m_hDC,&sRect,&sArea);
		DrawSeparator(sDc.m_hDC,iTop-7,sRect.right,TRUE);
		}


	if((m_iStyle&(DVS_NOLISTVIEW|DVS_NOTREEVIEW))==(DVS_NOLISTVIEW|DVS_NOTREEVIEW))
		{
		sDc.SelectStockObject(NULL_PEN);
		sDc.SelectObject(GetSysColorBrush(COLOR_WINDOW));
		sDc.Rectangle(0,iTop,10000,10000);
		}
	else{
		DrawSeparator(iTop,sDc.m_hDC,m_iSeparator,10000,FALSE);
		}

}

//*****************************************************************************
//*
//*   Debug Funktionen
//*
//*****************************************************************************

#ifdef _DEBUG
void CDateiView::AssertValid() const
{
	CWnd::AssertValid();
}

void CDateiView::Dump(CDumpContext& dc) const
{
	CWnd::Dump(dc);
}

#endif

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
// Gren nderung des Fensters
void CDateiView::OnSize(UINT nType,int iSizeX,int iSizeY)
{
int		iTop;


	if(!m_hWnd)return;

	iTop = 0;

	if(m_bSepChanged==FALSE)
		{
		m_iSeparator = (iSizeX<DVS_SEPARATOR*4)? DVS_SEPARATOR:iSizeX/4;
		}

	if(IsWindow(m_cListView.m_hWnd) &&!(m_iStyle&DVS_NOCOMBOBOX))
		{
		if(m_iStyle&DVS_NOCOMBOBOX)
			{
			m_cComboBox.MoveWindow(iSizeX,0,0,0);
			}
		else{
			iTop = m_iComboEnd;
			m_cBtPrev  .MoveWindow(COMBO_FRAME                ,COMBO_FRAME,m_iComboHight,m_iComboHight);
			m_cBtNext  .MoveWindow(COMBO_FRAME+m_iComboHight  ,COMBO_FRAME,m_iComboHight,m_iComboHight);
			m_cBtDoUp  .MoveWindow(COMBO_FRAME+m_iComboHight*2,COMBO_FRAME,m_iComboHight,m_iComboHight);
			m_cComboBox.MoveWindow(COMBO_FRAME+m_iComboHight*3+COMBO_FRAME/2,COMBO_FRAME,iSizeX-COMBO_FRAME*2-COMBO_FRAME/2-m_iComboHight*3,m_iComboAdd);
			}
		}

	if(IsWindow(m_cListView.m_hWnd) &&!(m_iStyle&DVS_NOLISTVIEW))
		{
		if(m_iStyle&DVS_NOTREEVIEW)
			 m_cListView.MoveWindow(0             ,iTop,iSizeX               ,iSizeY-iTop);
		else m_cListView.MoveWindow(m_iSeparator+7,iTop,iSizeX-m_iSeparator-7,iSizeY-iTop);
		}

	if(IsWindow(m_cTreeView.m_hWnd) &&!(m_iStyle&DVS_NOTREEVIEW))
		{
		if(m_iStyle&DVS_NOLISTVIEW)
			 m_cTreeView.MoveWindow(0,iTop,iSizeX	   ,iSizeY-iTop);
		else m_cTreeView.MoveWindow(0,iTop,m_iSeparator,iSizeY-iTop);
		}

}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CDateiView::OnDestroy()
{
	
	GetCbList();

	// Die Image-Listen fr das Tree-View lschen
	::SendMessage(m_cTreeView.m_hWnd,TVM_SETIMAGELIST,TVSIL_NORMAL,(LPARAM)0 );
	::SendMessage(m_cTreeView.m_hWnd,TVM_SETIMAGELIST,TVSIL_STATE ,(LPARAM)0 );

	// Die Image-Listen fr das List-View lschen
	::SendMessage(m_cListView.m_hWnd,LVM_SETIMAGELIST,LVSIL_SMALL ,(LPARAM)0 );
	::SendMessage(m_cListView.m_hWnd,LVM_SETIMAGELIST,LVSIL_NORMAL,(LPARAM)0 );

	// Die Image-Listen fr die ComboBox lschen
	m_cComboBox.SetImageList(NULL);


	CWnd::OnDestroy();

}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
// Speichert den Pfad von Eintrag im Puffer mit der Lnge Len
// Am Pfadende wird immer ein `\' angehngt.
// Ergibt die Lnge des Pfades bzw. 0 bei einem Fehler
int CDateiView::GetPath(HTREEITEM Eintrag,char *Puffer,int Len)
{
char		 str[260];
int			 ebene,anz,x,y,pos;
HTREEITEM	 nr[36];
TV_ITEM		 item;



	if(Len<=0)return 0;
	Len--;


	item.mask=TVIF_PARAM;						// Prfe ob Eintrag ok
	item.hItem=Eintrag;
	m_cTreeView.GetItem( &item);
	if((item.lParam&0xFFFF0000)!=0x12340000)
		{
		if(Len>0)Puffer[0]=0;
		return 0;
		}


	nr[0]=Eintrag;
	for(anz=1;anz<36;anz++)						// Baum durchsuchen
		{
		if((item.lParam&0xFFFF0000)!=0x12340000)
			{
			if(Len>0)Puffer[0]=0;
			return 0;
			}

		nr[anz]=m_cTreeView.GetNextItem(nr[anz-1],TVGN_PARENT);
		if(!nr[anz])break;
		}


	item.pszText=str;
	item.cchTextMax=256;
	item.mask=TVIF_PARAM|TVIF_TEXT;

	for(x=anz-1,ebene=0,pos=0;x>=0;x--,ebene++)	// Pfad erzeugen
		{
		item.hItem=nr[x];
		m_cTreeView.GetItem( &item);				// Hole Name und Wert
		if(ebene != (item.lParam&0xFFF))		// Stimmt die Ebene
			{
			if(Len>0)Puffer[0]=0;
			return 0;
			}
		y=strlen(str);
		if(pos+y+1>=Len)						// Ist die Lnge ok
			{
			if(Len>0)Puffer[0]=0;
			return 0;
			}
		memcpy(Puffer+pos,str,y);
		pos+=y;
		Puffer[pos]='\\',pos++;
		}

	Puffer[pos]=0;


return pos;
}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
// Ergibt den aktuellen Pfad
char *CDateiView::GetPath()
{
return m_pPath;
}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
// Speichert den Pfad von Eintrag (Listfeld) im Puffer mit der Lnge Len
// Am Pfadende wird ein `\' angehngt wenn es sich um ein Verzeichnis handelt.
// Ergibt die Lnge des Pfades bzw. 0 bei einem Fehler
int CDateiView::GetPath(int Eintrag,char *Puffer,int Len)
{
int		x,y;
char   *zeiger;


	if(Len<=0)return 0;
	Len--;

	if(!m_pPath || (Eintrag<0) || (Eintrag>=m_iCount))
		{
		Puffer[0]=0;
		return 0;
		}

	zeiger=m_sFiles.Name(Eintrag);
	y=strlen(zeiger);
	x=strlen(m_pPath);

	if(x+y>=Len)
		{
		Puffer[0]=0;
		return 0;
		}

	memcpy(Puffer  ,m_pPath  ,x);
	memcpy(Puffer+x,zeiger,y);x+=y;
	if((x<Len) && m_sFiles.IsDir(Eintrag)){Puffer[x]='\\';x++;}
	Puffer[x]=0;

return x;
}

//*****************************************************************************
//*
//*		SetPath
//*
//*****************************************************************************
//	Setzt einen neuen Pfad frs List View
//	Ergibt den aktuellen Pfad
char *CDateiView::SetPath(char *Pfad,char *Plus,char *Minus)
{

	Filter(Plus,Minus,0);
	Set(Pfad);

return m_pPath;
}

//*****************************************************************************
//*
//*		Filter
//*
//*****************************************************************************
//	Setzt einen neuen Filter
//	Ist Art != 0 so wird das Listview erneuert.
//	Ergibt 1 wenn Listview erneuert wurde
int CDateiView::Filter(char *Plus,char *Minus,int Art)
{
int		x;

	if(!Plus)
		{
		if(m_pPlus){delete m_pPlus;m_pPlus=0;x=1;}
		}
	else{
		if(!m_pPlus || stricmp(Plus,m_pPlus))
			{
			x=1;
			if(m_pPlus)delete          m_pPlus;
			   m_pPlus=new char[strlen(Plus)+1];
			strcpy(m_pPlus,Plus);
			}
		}

	if(!Minus)
		{
		if(m_pPlus){delete m_pMinus;m_pMinus=0;x=1;}
		}
	else{
		if(!m_pMinus || stricmp(Minus,m_pMinus))
			{
			x=1;
			if(m_pMinus)delete          m_pMinus;
			   m_pMinus=new char[strlen(Minus)+1];
			strcpy(m_pMinus,Minus);
			}
		}

	if(Art && m_iInit && x){Set(m_pPath,0,2);return 1;}

return 0;
}

//*****************************************************************************
//*
//*		Read
//*
//*****************************************************************************
// Liest die Verzeichnisse eines Pfades ins Treelistfeld ein
// Ist Art!=0 wird der Pfad aufgeklappt
// Wurzel ist das Start Element von der die Suche ausgehen soll;
//		  Pfad wird dann an den Wurzelpfad angehngt.
// Ergibt den Eintrag fr den Pfad
//		  bzw. 0 bei einem Fehler (wenn der Pfad nicht gefunden wurde);

HTREEITEM CDateiView::Read(const char * Pfad,int Art,HTREEITEM Wurzel)
{
char		 puffer[MAX_PATH+16],mem[MAX_PATH+16],str[260];
char		*name,alt;
int			 x,y,anz,ebene,pos,len,ok,ist_lw;
HTREEITEM	 next,wo,exit=0;
TV_ITEM		 item;
CFileFinder	 verz,unterverz;
CTime		 zeit;
struct      _finddata_t find;
long		 hfile;


	if(m_iStyle&DVS_NOTREEVIEW)return 0;			// TreeView ausgeblendet ?

	if(Wurzel)										// Pfad aus Wurzel Holen ?
		{
		x=GetPath(Wurzel,puffer,MAX_PATH+2);
		if(Pfad && *Pfad)
			{
			strncat (puffer+x,"\\",  MAX_PATH+2-x);
			strncat (puffer+x,Pfad,  MAX_PATH+2-x);
			}

		x=strlen(puffer);
		}
	else{
		x=GetFullPathName( Pfad,MAX_PATH,puffer,0);	// Vollstntiger Dateiname
		}

	if(x > MAX_PATH){x=MAX_PATH+1;puffer[x]=0;}


	if((x>0) && puffer[x-1]=='\\')
		{puffer[x-1]=0;x--;}

	ist_lw=(x &&(puffer[x-1]==':'));

	if(ist_lw)										// Ist Laufwerk vorhanden
		{
		ok=GetLogicalDrives();
		y=puffer[0]-'A';
		if(y>32)y-=32;
		y=1<<y;
		}
	else{
		hfile = _findfirst( puffer, &find );		// Ist Pfad vorhanden ?
		if(hfile==-1)return 0;
		_findclose( hfile );
		if(!(find.attrib & _A_SUBDIR))return 0;		// Ist Pfad ein Verzeichnis ?
		}

//**************** Treefeld auffllen ******************************************

	item.pszText=str;
	item.cchTextMax=256;

	if(Art)Art=1;

	ebene=0;
	len=0;
	pos=0;
	next=m_cTreeView.GetRootItem();					// Ersten Eintrag finden

	anz=0;
	pos=0;
	name =puffer;
	len  =strcspn(puffer+pos,"\\");

//***************** Suche im Treefeld ******************************************

for(;;)
	{
	anz=0;wo=0;
	len=strcspn(name,"\\");							// Lnge des aktuellen Verzeichnisses
	alt=name[len];name[len]=0;

	while(next)
		{
		anz++;

		item.hItem=next;
		item.mask=TVIF_PARAM|TVIF_TEXT|TVIF_STATE;
		item.stateMask=TVIS_EXPANDED;
		m_cTreeView.GetItem( &item);				// Hole Name und Wert

		if(len)
			{
			ok=strnicmp(name,str,len);
			if(!ok && str[len])
				{
				ok=1;
				}
			}
		else{
			ok=1;
			}

		if(!ok)
		do	{
			wo=next;								// Eintrag fr nchste Ebene

			if(alt && !(Art&2))
			if(!(item.state&TVIS_EXPANDED))
				{
				//m_cTreeView.SelectSetFirstVisible(next);
				m_cTreeView.Expand(next,TVE_EXPAND);
				}

			if(alt||(Art&2))break;

			exit=next;								// Eintrag fr den Pfad

			if(!(item.lParam&0x8000))break;

			y=strlen(puffer);
			memcpy  (mem  ,puffer,y+1);
			if(y && (mem[y-1]==':')){mem[y]='\\';mem[y+1]=0;}
			y=ReadSubDirs(next,mem,1);				// Prfe ob Eintrge aktuell

			if(!y && !ebene)
				{
				m_cTreeView.InsertItem(	TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,
							"\\(null)",0,0,0,0,0x12340000,next,TVI_LAST);
				m_cTreeView.Expand(next,TVE_COLLAPSE);
				}
			}while(0);

		//******************* Unter-Ortner einlesen ****************************

		if(ebene||!ok)
			{
			x=pos;y=strlen(str);
			memcpy(mem  ,puffer,pos);x=pos;	if(x && (mem[x-1]!='\\')){mem[x]='\\';x++;}
			memcpy(mem+x,str   ,y  );x+=y;	if(!ebene){mem[x]='\\';x++;}
			mem[x]=0;
			y=ReadSubDirs(next,mem,0);
			if(!y && !ebene)
				{
				m_cTreeView.InsertItem(	TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,
							"\\(null)",0,0,0,0,0x12340000,next,TVI_LAST);
				m_cTreeView.Expand(next,TVE_COLLAPSE);
				}
			}

		next=m_cTreeView.GetNextItem(next,TVGN_NEXT);	// Nchster Eintrag
		}


	if(!wo)break;

	//******************* Nchste Ebene ****************************************

	next=m_cTreeView.GetNextItem(wo,TVGN_CHILD);

    name[len]=alt;
	if(!alt)
		{
		if(!(Art&1))break;
		Art|=2;Art&=~1;
		}

	name+=len;if(*name      =='\\')name++;
	pos +=len;if(puffer[pos]=='\\')pos++;

	if(len  >256)len=256;
	if(len  <=0)break;
	if(ebene>32)break;
	   ebene++;
	}


return exit;
}

//*****************************************************************************
//*
//*		ReadSubDirs
//*
//*****************************************************************************
// Liest fr den Eintrag die Unterverzeichnisse ein.
// Ist Art == 0 werden die Eintrge nur erneuert wenn das Ok-Bit fehlt
// Ist Art == 1 werden die Eintrge nur erneuert wenn eine nderung gefunden wurde.
// Ist Art == 2 werden die Eintrge immer erneuert.
// Pfad ist der Pfad fr die Suche
// Ist Pfad gleich 0 so wird der Pfad von GetPath geholt
// Ergibt 1 wenn Eintrge gefunden bzw. eingelesen wurden.

int CDateiView::ReadSubDirs(HTREEITEM Eintrag,char *Pfad,int Art)
{
char		*zeiger,puffer[MAX_PATH+16],str[260],*name;
int			 x,y,anz,ebene,child,pos;
SHFILEINFO   sfi;
HTREEITEM	 next,nr;
TV_ITEM		 item;
CFileFinder	 verz;



	item.hItem=Eintrag;
	item.mask =TVIF_PARAM|TVIF_CHILDREN;
	m_cTreeView.GetItem(&item);				// Hole Daten
	child= item.cChildren;

	if((Art==0)&&(item.lParam&0x8000))return child;

	ebene=(item.lParam&0xFFF)+1;			// Ebene prfen
	if(ebene>=20)return 0;

	if(!Pfad)								// Pfad vom Eintrag holen
		{
		GetPath(Eintrag,puffer,MAX_PATH+2);
		Pfad=puffer;
		}


	SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorWait);
	if(HitTest()==1)::SetCursor(m_hCursorWait);

	m_cListView.SetRedraw(FALSE);

		   verz.Set(Pfad,CFF_FIND_DIR);
	zeiger=verz.Next();
	   anz=verz.Count();
		   verz.Filter(CFF_FILTER_BEGIN|CFF_FILTER_ONLYBIG|CFF_FILTER_POINT);


//******************* Prfe Eintrge *******************************************


	if(Art==1)
	do	{
		if(!child)									// Keine Eintrge vorhanden
			{
			if(anz>0){Art=2;break;}
			SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);
			m_cListView.SetRedraw(TRUE);
			return 0;
			}

		next=m_cTreeView.GetNextItem(Eintrag,TVGN_CHILD);

		item.mask   =TVIF_TEXT;
		item.pszText=str;
		item.cchTextMax=256;

		for(x=0;next;x++)
			{
			item.hItem=next;
			m_cTreeView.GetItem(&item);				// Hole Dateiname
			y=verz.Find(str);
			next=m_cTreeView.GetNextItem(next,TVGN_NEXT);
			if(y==-1)      							// Datei nicht gefunden
					m_cTreeView.DeleteItem(item.hItem);
			else	verz.Del(y);
			}


		SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);

		m_cListView.SetRedraw(TRUE);

		anz=verz.Count();
		if(!next && !anz)return child;
		Art=2;
		}while(0);


//******************* Alles lschen ********************************************

	
	if(child)
		{
		next=m_cTreeView.GetNextItem(Eintrag,TVGN_CHILD);

		while(next)
			{
			nr=m_cTreeView.GetNextItem(next,TVGN_NEXT);
			   m_cTreeView.DeleteItem (next);
			if(next==m_hTreeOpen)m_hTreeOpen=0;
			next=nr;
			}
		}

//******************* Alles neu einlesen ***************************************

	anz=verz.Count();

	for(pos=0;pos<anz;pos++)
		{
		name=verz.Name(pos,1);
		SHGetFileInfo(name,_A_SUBDIR,&sfi,sizeof(sfi),SHGFI_SYSICONINDEX|SHGFI_SMALLICON);
		m_cTreeView.InsertItem(TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_STATE,
								verz.Name(pos),
								sfi.iIcon,		 // int nImage,
								sfi.iIcon,		 // int nSelectedImage,
								0,				 // UINT nState,
								0,				 // UINT nStateMask,
								ebene|0x12340000,// LPARAM lParam,
								Eintrag,
								TVI_SORT);

		}


	SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);

	m_cListView.SetRedraw(TRUE);

	item.mask  =TVIF_PARAM;						// Ok Bit setzen
	item.hItem =Eintrag;
	item.lParam=(ebene-1)|0x12348000;
	m_cTreeView.SetItem(&item);


return (anz!=0);
}

//*****************************************************************************
//*
//*		SetListView
//*
//*****************************************************************************
// ndert die Ansicht des Listviews
// Art:		LVS_ICON		: Groe  Icons
//			LVS_SMALLICON	: Kleine Icons
//			LVS_LIST		: Kleine Iconsliste
//			LVS_REPORT		: Kleine Iconsliste mit Deteils
// Ergibt den letzten Zustand des ListViews;
int CDateiView::SetListView(int Art)
{
int	alt,m_iStyle;



	m_iStyle=::GetWindowLong(m_cListView.m_hWnd,GWL_STYLE );
	alt =LVS_TYPEMASK & m_iStyle;
	Art&=LVS_TYPEMASK;
	if(alt==Art)return alt;

	m_iStyle&=~LVS_TYPEMASK;
	m_iStyle|= Art;

	::SetWindowLong(m_cListView.m_hWnd,GWL_STYLE,m_iStyle);
	m_cListView.UpdateWindow();

return alt;
}

//*****************************************************************************
//*
//*		OnIcon   OnSmallIcon  OnList  OnReport
//*
//*****************************************************************************
void CDateiView::OnIcon     (){SetListView(LVS_ICON     );}
void CDateiView::OnSmallIcon(){SetListView(LVS_SMALLICON);}
void CDateiView::OnList     (){SetListView(LVS_LIST     );}
void CDateiView::OnReport   (){SetListView(LVS_REPORT   );}

//*****************************************************************************
//*
//*		Insert
//*
//*****************************************************************************
// Fgt alle in CFileFinder m_sFiles gefunden Dateien ins Listview ein
// Ergibt die m_iCount der gefundenen Dateien
int CDateiView::Insert()
{
char			puffer[MAX_PATH+512],uhr_zeit[32],*name;
int				x,anz,flag,sys=0;
SHFILEINFO		sfi;
SysFindStruct  *info;
_finddata_t		find;
int				attr;



	SetClassLongPtr(m_cListView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorWait);
	if(HitTest()==2)::SetCursor(m_hCursorWait);


	m_iSetState=1;

	 strlcpy(puffer,m_pPath,sizeof(puffer));				// Ist das Verzeichnis ein Sytem-Verzeichnis
	x=strlen(puffer);
	if(x && (puffer[x-1]=='\\'))puffer[x-1]=0;
	x=_findfirst(puffer,&find);
	if(x!=-1)
		{
		_findclose(x);
		if(find.attrib&_A_SYSTEM)sys=1;
		}


	anz=m_sFiles.Count();

	m_cListView.SetRedraw(FALSE);
	m_cListView.DeleteAllItems();
	m_cListView.SetItemCount(anz);


	for(x=0;x<anz;x++)										// Alle Dateien einfgen
		{
		info=m_sFiles.Info(x);
		name=m_sFiles.Name(x,1);

		flag=(sys)? SHGFI_USEFILEATTRIBUTES:0;
		attr=(info->dwAttr&SYS_DIR)? FILE_ATTRIBUTE_DIRECTORY:0;
		SHGetFileInfo(name,attr,&sfi,sizeof(sfi),SHGFI_TYPENAME|SHGFI_SYSICONINDEX|flag);

		qtostr((m_sFiles.Len64(x)+1023)>>10,puffer,15);
		strcat(puffer," kByte");
		m_cListView.InsertItem (x,m_sFiles.Name(x),sfi.iIcon);
		m_cListView.SetItemText(x,1, puffer	);
		m_cListView.SetItemText(x,2, sfi.szTypeName	);

		strtimeset(uhr_zeit,m_sFiles.Time(x));
		m_cListView.SetItemText(x,3, uhr_zeit);
		}

	SetClassLongPtr(m_cListView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);

	m_cListView.SetRedraw(TRUE);
	
	m_iSetState=2;


return anz;
}


//*****************************************************************************
//*
//*		StartThread
//*
//*****************************************************************************
DWORD WINAPI CDateiView::StartThread(LPVOID datei_view)
{
return ((CDateiView*)datei_view)->Insert();
}

//*****************************************************************************
//*
//*		SetComboBox
//*
//*****************************************************************************
//	Eintrag in ComboBox setzen
//	Setzt den aktuellen Eintrag in der ComboBox
//	pPath		: Ist der neue Pfad
//	iLen		: Ist die Lnge des Pfades
//	iLevel		: Ist die Ebene des Pfades (0=Root, -1=automatisch ermitteln)
int	CDateiView::SetComboBox(LPCTSTR pPath,int iLen,int iLevel)
{
COMBOBOXEXITEM	sData;



	if(m_iStyle&DVS_NOCOMBOBOX)
		{
		return -1;
		}

	if(iLevel<0)										// Level ermitteln
		{
		iLevel = GetLevel(pPath,iLen);
		}

	GetLevel(pPath,-1,&sData.iSelectedImage);

	sData.mask		  =  CBEIF_TEXT|CBEIF_IMAGE|CBEIF_SELECTEDIMAGE;
	sData.pszText	  =  (LPTSTR)pPath;
	sData.iImage	  =  sData.iSelectedImage;
	sData.iItem		  = -1;


	m_cComboBox.SetItem(&sData);


return 1;
}


//*****************************************************************************
//*
//*		Set
//*
//*****************************************************************************
// Set den aktuellen Pfad fr das List-Feld
// Ist Pfad ==0 so wird der aktuelle genommen
// Ist Unter!=0 so wird Unter an Pfad angehngt
// Ist Art  ==1 so wird das List-Fenster nicht aktualisiert Insert() muss
//				dann extra noch aufgerufen werden.
// Ist Art  ==2 so wird das List-Fenster immer aktualisiert
// Ergibt die Anzahl der gefunden Dateien
//		  bzw. -1 bei einem Fehler (wenn der Pfad nicht gefunden wurde);
int CDateiView::Set(const char *Pfad,char *Unter,int Art,BOOL History)
{
char		 puffer[MAX_PATH+512],name[MAX_PATH+512];
int			 x,y,anz,neu;
SHFILEINFO   sfi;
HTREEITEM	 open;
TV_ITEM		 item;
CTime		 zeit;


	neu=(Art==2);

	if(!Pfad)										// Alten Pfad nehmen ?
		{
		Pfad=(m_pPath)? m_pPath:"C:\\";
		strncpy(name,m_pPath ,sizeof(name));
		Pfad=name;
		Unter=0;
		neu=1;
		}

	if(Unter)										// Unterverzeichnis anhngen
		{
		strncpy(name,Pfad ,sizeof(name));
		strncat(name,Unter,sizeof(name));
		Pfad=name;
		}

	if(!(m_iStyle&DVS_NOTREEVIEW))					// TreeView ausgeblendet ?
		{
		open=Read(Pfad);							// Treefeld aktualisieren
		if(!open)return -1;
		}

	   x=GetFullPathName( Pfad,MAX_PATH,puffer,0);
	if(x && (puffer[x-1]!='\\')){puffer[x]='\\';x++;puffer[x]=0;}
	if(x > MAX_PATH)x=MAX_PATH+1;
	if(m_pPath && !neu && !stricmp(m_pPath,puffer))return m_sFiles.Count();


	if(m_pPath)delete m_pPath;						// Neuen Pfad speichern
	   m_pPath=new char[MAX_PATH+16];
	
	memcpy(m_pPath,puffer,x+1);


//**************** OpenImage in Treefeld setzen ********************************


	if(m_hTreeOpen)									// Alten offenen Ordner
		{
		y=GetPath(m_hTreeOpen,name,MAX_PATH+2);
		if(y)y--;
		if(y && (name[y]=='\\'))y--;

		if(name[y]!=':')
			{
			SHGetFileInfo(name,_A_SUBDIR,&sfi,sizeof(sfi),SHGFI_SYSICONINDEX|SHGFI_SMALLICON);

			item.hItem			=m_hTreeOpen;
			item.iImage			=sfi.iIcon;
			item.iSelectedImage	=sfi.iIcon;
			item.mask           =TVIF_SELECTEDIMAGE|TVIF_IMAGE;
			m_cTreeView.SetItem(&item);
			}
		m_hTreeOpen=0;
		}
	
	if(open)										// Neuen offenen Ordner
		{
		y=(x)? x-1:0;

		if(y && (m_pPath[y]=='\\'))y--;
		if(m_pPath[y]!=':')
			{
			SHGetFileInfo(m_pPath,_A_SUBDIR,&sfi,sizeof(sfi),SHGFI_SYSICONINDEX|SHGFI_SMALLICON|SHGFI_OPENICON);

			m_hTreeOpen=open;

			item.hItem			=m_hTreeOpen;
			item.iImage			=sfi.iIcon;
			item.iSelectedImage	=sfi.iIcon;
			item.mask           =TVIF_SELECTEDIMAGE|TVIF_IMAGE;
			m_cTreeView.SetItem(&item);
			m_cTreeView.SelectItem(open);
			}
		}


//******************** ComboBox einstellen *************************************


	SetComboBox(m_pPath,x,0);						

	if(History)
		{
		AddToHistory(m_pPath);
		}

	if(x>0 && m_pPath[x-1]=='\\')
		{
		x--;
		}

	for(y=0;y<x;y++)
		{
		if(m_pPath[y]=='\\')break;
		}

	m_bUbEnable   = y<x;
	m_cBtDoUp.EnableWindow(m_bUbEnable);



//**************** Listfeld auffllen ******************************************

	if(m_iStyle&DVS_NOLISTVIEW)						// ListView ausgeblendet ?
		{
		StatusbarSet();
		m_iCount=0;
		return 0;
		}

		m_sFiles.Set(puffer,CFF_FIND_ADDDIR,m_pPlus,m_pMinus);
	if( m_sFiles.Next())							// Dateien suchen
	   {m_sFiles.Sort(m_sSortArray[m_iSortMode],(m_iSortDir)? CFF_SORT_INVERT:0);
		m_sFiles.Filter(CFF_FILTER_BEGIN|CFF_FILTER_ONLYBIG|CFF_FILTER_POINT);
		}
	else{
		   x=m_sFiles.Error();
		if(x==CFF_ERROR_ACCESS)
			{
			  strcpy  (puffer,"Auf " );
			  strncat (puffer,m_pPath,32);
			x=strcspn (puffer,"\\/"  );puffer[x+1]=0;
			  strcat  (puffer," kann nicht zugegriffen werden\n\nDas Gert ist nicht bereit !");
			MessageBox(puffer,NULL,MB_OK|MB_ICONERROR);
			}
		}

	anz=m_sFiles.Count();

	if(m_hSetThread)								// Thread beenden
		{
		TerminateThread(m_hSetThread,0);
		CloseHandle(m_hSetThread);
		m_hSetThread=0;
		}

	x=strcspn(m_pPath,":");							// Laufwerksnamen
		   puffer[0]='(';
	memcpy(puffer+1,m_pPath,x+1);
	strcpy(puffer+x+2,")");

	m_iSetState=0;

	if(Art==0 || Art==2)
		{
		m_hSetThread =CreateThread(0,0,StartThread,this,0,&m_dwSetThreadId);
		}

	StatusbarSet();
	m_iCount=anz;

	PostMessage(WM_COMMAND,(DSN_PATHCHANGE&0x0FFFF)|0x10000,0);



return anz;
}

//*****************************************************************************
//*
//*		Sort
//*
//*****************************************************************************
// Sortiert das Listview je nach Art und Richtung
// Art: = 0		Nach Namen sortieren
//        1		Nach Datei lnge sortieren
//        2		Nach Typ sortieren
//        3		Nach letztdem Schreibzugriff  sortieren
// Ist Richtung!=0 wird die Liste verkehrt sortiert.
// Ergibt die vorige Sortier-Art
int  CDateiView::Sort(int Art,int Richtung)
{
int		alt;

	alt=m_iSortMode;

	m_iSortMode     =Art;
	m_iSortDir=Richtung;
	m_sFiles.Sort(m_sSortArray[m_iSortMode],(m_iSortDir)? CFF_SORT_INVERT:0);

	m_hSetThread =CreateThread(0,0,StartThread,this,0,&m_dwSetThreadId);

return alt;
}

//*****************************************************************************
//*
//*		HitTest
//*
//*****************************************************************************
// Stellt fest auf welchem Eintrag im List oder Treefeld der Cursor steht
// Point sind die Cursor-Koordinaten relatic zur linken oberen
// Bildschirm Ecke.
// Ist ein Eintrag im Listview betroffen so wird sein Index in
//      *(int*)Element gespeichert.
// Ist ein Eintrag im Listview betroffen so wird sein Zeiger in
//      *(HTREEITEM*)Element gespeichert.
// Ergibt	0 wenn kein Eintrag gefunden wurde.
//			1 wenn ein  Eintrag aus dem Treefeld gefunden wurde.
//			2 wenn ein  Eintrag aus dem Listfeld gefunden wurde.
//			3 wenn ein  Eintrag aus der ComboBox gefunden wurde.
//		    4 wenn ein  Eintrag in einem zustzlichen Feld liegt

int CDateiView::HitTest(CPoint Point,void *Element)
{
int			index;
CPoint		pt;
CRect		rect;
UINT		flags;
HTREEITEM	item;


//************** Ist Cusor im Treefeld ? ***************************************

	m_cTreeView.GetWindowRect(&rect);
	if(rect.PtInRect(Point))
		{
		pt.x=Point.x-rect.left;
		pt.y=Point.y-rect.top;

		item=m_cTreeView.HitTest(pt,&flags);
		if(flags&(TVHT_ABOVE|TVHT_BELOW))item=0;
		*(HTREEITEM*)Element=item;
		return (item)? 1:0;
		}

//************** Ist Cusor im Listfeld ? ***************************************

	m_cListView.GetWindowRect(&rect);
	if(rect.PtInRect(Point))
		{
		pt.x=Point.x-rect.left;
		pt.y=Point.y-rect.top;

		index=m_cListView.HitTest(pt,&flags);
		if(flags&(LVHT_ABOVE|LVHT_BELOW))index=-1;
		*(int*)Element=index;
		return (index!=-1)? 2:0;
		}

//************** Ist Cursor in ComboBox ? **************************************

	m_cComboBox.GetWindowRect(&rect);

	if(rect.PtInRect(Point))
		{
		pt.x = Point.x-rect.left;
		pt.y = Point.y-rect.top;

		*(int*)Element=0;

		return 3;
		}

//************** Ist Cusor in einem Externen Feld ? ****************************

	*(int*)Element=0;
	
	if(m_pHitTestProc)
		{
		if(m_pHitTestProc(Point,Element,m_pData))return 4;
		}


	

return 0;
}

int CDateiView::HitTest(LPVOID pEntry)
{
CPoint	sPoint;
HWND	hWnd;

	GetCursorPos(&sPoint);

	if(!pEntry)
		{
		hWnd = ::WindowFromPoint(sPoint);
		
		if(hWnd==m_cTreeView.m_hWnd)return 1;
		if(hWnd==m_cListView.m_hWnd)return 2;
		if(hWnd==m_cComboBox.m_hWnd)return 3;
		
		return 0;
		}

return HitTest(sPoint,pEntry);		
}

//*****************************************************************************
//*
//*		OnKeyDown
//*
//*****************************************************************************
void CDateiView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{

	if(m_iDragState)
	if((nChar==0x10)||(nChar==0x11))
		{
		int x;

		x =m_iDropFlags;
		x|=(nChar==0x10)? MK_SHIFT:MK_CONTROL;

		OnMouseMove(x,CPoint(0,0));
		}
}

//*****************************************************************************
//*
//*		OnKeyUp
//*
//*****************************************************************************
void CDateiView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{

	if(m_iDragState)
	if((nChar==0x10)||(nChar==0x11))
		{
		int x;

		x =m_iDropFlags;
		x&=(nChar==0x10)? ~MK_SHIFT:~MK_CONTROL;

		OnMouseMove(x,CPoint(0,0));
		}
}

//*****************************************************************************
//*
//*		OnMouseMove
//*
//*****************************************************************************
void CDateiView::OnMouseMove(UINT nFlags, CPoint point)
{
char		puffer[MAX_PATH],*zeiger;
int			x,nummer,wo;
HTREEITEM 	eintrag;
CString		text;
CPoint		cp;



	if(!m_iDragState)
		{
		if(!(m_iStyle&DVS_NOCOMBOBOX) && point.y<m_iComboEnd)
			{
			::SetCursor(m_hCursorNull);					// Auf Namenszeile
			}

		return;
		}
	

	GetCursorPos (&cp);									// Cursorposition
	m_pDragImages->DragMove(cp);						// ImageList verschieben
	wo=HitTest(cp,&x);									// Eintrag ermitteln
	if((m_iStyle&DVS_NODROP)&&(wo<4))wo=0;

	nFlags&=MK_SHIFT|MK_CONTROL;
	if(!(m_iDropFlags^nFlags))
	if(  m_iDropView   ==wo  )
	if(  m_iDropEntry  ==x   )return;					// Gab es eine Vernderung

	m_iDropView    =wo;
	m_iDropEntry   =x;
	m_iDropFlags   =nFlags;

	//************** Alte Dropziele neuzeuchen *********************************

	if(m_hDropItem)										// DropTarget lschen
		{
		m_pDragImages->DragShowNolock(0);
		m_cTreeView.SelectDropTarget (0);
		m_pDragImages->SetOverlayImage(0,0);
		m_pDragImages->DragShowNolock(1);
		m_hDropItem=0;
		}
	if(m_iDropItem!=-1)									// DropTarget lschen
		{
		m_pDragImages->DragShowNolock(0);
		m_cListView.SetItem(m_iDropItem,0,LVIF_STATE,0,0,0,LVIS_DROPHILITED,0);
		m_cListView.UpdateWindow();
		m_pDragImages->DragShowNolock(1);
		m_iDropItem=-1;
		}
	switch(wo)
		{
	//************** Ist Cusor im Treefeld ? ***********************************
	case 1:
		eintrag=(HTREEITEM)x;

		m_pDragImages->DragShowNolock(0);				// DropTarget neu zeichnen
		m_cTreeView.SelectDropTarget(eintrag);
		m_pDragImages->DragShowNolock(1);
		m_hDropItem=eintrag;

		GetPath(eintrag,puffer,MAX_PATH);				// Ablage erlaubt ?
		if(!stricmp(m_pDragPath,puffer) ||
		  (m_iDropNext  && !puffer[m_iDropNext] && !strnicmp(m_pDragPath,puffer,m_iDropNext)))
			{
			m_iDropMode=-1;
			SetCursor(1);
			return;
			}

		x=strnicmp(puffer,m_pDragPath,m_iDragDrive);	// Move oder Copy ?
		if(nFlags&MK_SHIFT  )x=0;
		if(nFlags&MK_CONTROL)x=1;
		if(x){SetCursor(2);m_iDropMode=0;}				// Copy
		else {SetCursor(3);m_iDropMode=1;}				// Move

		return;

	//************** Ist Cusor im Listfeld ? ***********************************
	case 2:
		nummer=x;

		m_pDragImages->DragShowNolock(0);				// DropTarget neu zeichnen
		if(m_iDropItem!=-1)

		m_cListView.SetItem(m_iDropItem,0,LVIF_STATE,0,0,0      ,LVIS_DROPHILITED,0);
		m_cListView.SetItem(nummer,0,LVIF_STATE,0,0,LVIS_DROPHILITED,LVIS_DROPHILITED,0);
		m_cListView.UpdateWindow();
		m_pDragImages->DragShowNolock(1);
		m_iDropItem=nummer;

		x=m_sFiles.IsDir(nummer);
		if(!x)zeiger=m_pPath;
		else{
			GetPath(nummer,puffer,MAX_PATH);
			zeiger=puffer;
			}

		if(zeiger)											// Ablage erlaubt ?
		if(!stricmp(m_pDragPath,zeiger) ||
		  ( m_iDropNext && !zeiger[m_iDropNext] && !strnicmp(m_pDragPath,zeiger,m_iDropNext)))
			{
			m_iDropMode=-1;
			SetCursor(1);
			return;
			}

		x=strnicmp(puffer,m_pDragPath,m_iDragDrive);		// Move oder Copy ?
		if(nFlags&MK_SHIFT  )x=0;
		if(nFlags&MK_CONTROL)x=1;
		if(x){SetCursor(2);m_iDropMode=0;}					// Copy
		else {SetCursor(3);m_iDropMode=1;}					// Move
														
		return;

	//************** Ist Cusor in externen Feld ? ******************************
	case 4:

		x=(m_pGetModeProc)? m_pGetModeProc(nFlags,&m_iDropEntry,m_pData):2;
		if(x==1){SetCursor(2);m_iDropMode= 1;return;}
		if(x==2){SetCursor(3);m_iDropMode= 0;return;}
	default: 	 SetCursor(1);m_iDropMode=-1;return;		// Ablage sperren
		}


}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CDateiView::OnLButtonDown(UINT nFlags, CPoint point)
{
CRect	rect;
CPoint	pt;
int		x;


	GetRectView(rect);

	if(!(m_iStyle&DVS_NOCOMBOBOX))
		{
		if(point.y<m_iComboEnd)
			{
			::SetCursor(m_hCursorNull);
			return;
			}
		
		rect.top += m_iComboEnd;
		}

	pt   =point;
	pt.x-=m_iSeparator;

	x=Resize(this,TRUE,rect,m_iSeparator,pt,7,5);

	if(!x)return;

	GetClientRect(&rect);

	   m_iSeparator+=x;
	if(m_iSeparator>=rect.right)m_iSeparator=rect.right-1;
	if(m_iSeparator<          0)m_iSeparator=0;
		
	m_bSepChanged = TRUE;

	OnSize(0,rect.right,rect.bottom);
	
}

//*****************************************************************************
//*
//*		OnLButtonUp
//*
//*****************************************************************************
void CDateiView::OnLButtonUp(UINT nFlags, CPoint point)
{
int			x,nummer;
char		puffer[MAX_PATH+16];
CPoint		cp;


	if(m_iDragState)
		{
		m_iDragState=0;
		m_pDragImages->EndDrag();			// ImageList interne Puffer freigeben
		m_pDragImages->DragLeave(NULL);	// DragImage von Fenster entfernen
		delete m_pDragImages;
			   m_pDragImages=0;

		ReleaseCapture();                           // Capture freigeben
		SetCursor(0);

		if(m_hDropItem)
			{
			m_cTreeView.SelectDropTarget(0);
			m_hDropItem=0;
			}
		if(m_iDropItem!=-1)
			{
			m_cListView.SetItem(m_iDropItem,0,LVIF_STATE,0,0,0,LVIS_DROPHILITED,0);
			m_cListView.UpdateWindow( );
			m_iDropItem=-1;
			}

		GetCursorPos(&cp);
		x=HitTest(cp,&nummer);					// Eintrag ermitteln
		if((m_iStyle&DVS_NODROP)&&(x<3))x=0;
		if(x)
			{
			puffer[0]=0;
			if((x==3)&&m_pGetPathProc)
					   m_pGetPathProc(&nummer,puffer,MAX_PATH,m_pData);
			if( x==1)GetPath((HTREEITEM)nummer,puffer,MAX_PATH);
			if( x==2)GetPath(           nummer,puffer,MAX_PATH);
			DoDrop(puffer,m_iDropMode);
			}
		}
}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CDateiView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)return -1;

	if(  m_iStyle&DVS_DRAGDROP)
	if(!(m_iStyle&DVS_NODROP ))DragAcceptFiles();

return 0;
}

//*****************************************************************************
//*
//*		OnDropFiles
//*
//*****************************************************************************
void CDateiView::OnDropFiles(HDROP hDropInfo)
{
char		puffer[MAX_PATH+16];
int			x,anz,nummer;
POINT		pt;


	if(!m_iDragState)
	do	{
		DragQueryPoint(hDropInfo,&pt);
		x=HitTest(pt,&nummer);				// Eintrag ermitteln
		if((m_iStyle&DVS_NODROP)&&(x<3))x=0;
		if(x==0)break;
		if(x==1)GetPath((HTREEITEM)nummer,puffer,MAX_PATH);
		if(x==2)GetPath(           nummer,puffer,MAX_PATH);

		m_sDragFiles.Del();					// Darg-Dateien einlesen
		anz=DragQueryFile(hDropInfo,-1,puffer,MAX_PATH);
		for(x=0;x<anz;x++)
			{
			anz=DragQueryFile(hDropInfo,x,puffer,MAX_PATH);
			m_sDragFiles.Add(puffer);
			}

		if(anz)DoDrop(puffer,0);

		}while(0);


	DragFinish(hDropInfo);

}

//*****************************************************************************
//*
//*		Rename
//*
//*****************************************************************************
// Benennt die Datei um in den neuen Namen
// Ergibt 1 wenn erfolgrreich
int CDateiView::Rename(char *Datei, char *Name)
{
char	puffer[MAX_PATH+16],neu[MAX_PATH+16];;
int		x,y,z;


	if(!Datei || !Name)return 0;

	x=strlen(Datei);
	y=strlen(Name );

	if(!x || !y)return 0;

	z=y;
	while(z>0)								// Von Name den Pfad abspalten
		{
		if(Name[z-1]==':' )break;
		if(Name[z-1]=='\\')break;
		z--;
		}
	Name+=z;y-=z;

	if(x && (Datei[x-1]=='\\'))				// '\' am Ende endfernen
		{
		if(x>=MAX_PATH)return 0;
		memcpy(puffer,Datei,x);
		x--;puffer[x]=0;
		Datei=puffer;
		}

	if(x>=MAX_PATH)return 0;
	while(x>0)
		{
		x--;
		if(Datei[x]==':' )break;
		if(Datei[x]=='\\'){x++;break;}
		}

	if(x+y>=MAX_PATH)return 0;
	  memcpy (neu,Datei,x);neu[x]=0;
	  strncat(neu,Name ,MAX_PATH);
	x=strcspn(neu  ,"*?");if(neu  [x])return 0;
	x=strcspn(Datei,"*?");if(Datei[x])return 0;


	return MoveFile(Datei,neu);
}

//*****************************************************************************
//*
//*		OnPathUp
//*
//*****************************************************************************
// Der aktuelle Pfad wird um eins nach Oben durchlaufen.
void CDateiView::OnPathUp()
{
char	puffer[MAX_PATH+512];
int		len;

	if(!m_pPath)return;

		strncpy(puffer,m_pPath,sizeof(puffer));
	len=strlen (puffer);

	if(len && (puffer[len-1]=='\\'))len--;
	if(puffer[len]==':')
		{
		m_cBtDoUp.EnableWindow(FALSE);
		m_bUbEnable = FALSE;
		return;
		}

	while(len)
		{
		len--;
		if(puffer[len]=='\\')break;
		if(puffer[len]!=':' )continue;

		m_cBtDoUp.EnableWindow(FALSE);
		m_bUbEnable = FALSE;
		return;
		}

	puffer[len+1]=0;
	Set(puffer);
}


//*****************************************************************************
//*
//*     OnSetFocus
//*
//*****************************************************************************
void CDateiView::OnSetFocus(CWnd *pOldWnd)
{

	StatusbarInit();

	if(m_iLastFocus==1 && !(m_iStyle&DVS_NOTREEVIEW)){m_cTreeView.SetFocus();return;}
	if(m_iLastFocus==2 && !(m_iStyle&DVS_NOLISTVIEW)){m_cListView.SetFocus();return;}
	if(m_iLastFocus==3 && !(m_iStyle&DVS_NOCOMBOBOX)){m_cComboBox.SetFocus();return;}
	

	if(!(m_iStyle&DVS_NOTREEVIEW)){m_cTreeView.SetFocus();return;}
	if(!(m_iStyle&DVS_NOLISTVIEW)){m_cListView.SetFocus();return;}
	if(!(m_iStyle&DVS_NOCOMBOBOX)){m_cComboBox.SetFocus();return;}

}


//*****************************************************************************
//*
//*		SetFocus
//*
//*****************************************************************************
CWnd *CDateiView::SetFocus(int iMode)
{

	if(iMode==1 && !(m_iStyle&DVS_NOTREEVIEW))return m_cTreeView.SetFocus();
	if(iMode==2 && !(m_iStyle&DVS_NOLISTVIEW))return m_cListView.SetFocus();
	if(iMode==3 && !(m_iStyle&DVS_NOCOMBOBOX))return m_cComboBox.SetFocus();

	if(GetAsyncKeyState(VK_SHIFT)&0x8000)
		{
		if(!(m_iStyle&DVS_NOLISTVIEW))return m_cListView.SetFocus();
		if(!(m_iStyle&DVS_NOTREEVIEW))return m_cTreeView.SetFocus();
		if(!(m_iStyle&DVS_NOCOMBOBOX))return m_cComboBox.SetFocus();
		}
	else{
		if(!(m_iStyle&DVS_NOCOMBOBOX))return m_cComboBox.SetFocus();
		if(!(m_iStyle&DVS_NOTREEVIEW))return m_cTreeView.SetFocus();
		if(!(m_iStyle&DVS_NOLISTVIEW))return m_cListView.SetFocus();
		}


return NULL;
}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CDateiView::OnTimer(UINT_PTR nIdEvent)
{

	if(nIdEvent==ID_STATUSBARSET)
		{
		if(m_iSetStatubar)
			{
			m_iSetStatubar=0;
			StatusbarSet();
			m_iSetStatubar=0;
			}
		}


	if(nIdEvent==ID_COMBOUPDATE)
		{
		if(!m_uComboTick)
			{
			m_bComboTimer = FALSE;
			KillTimer(ID_COMBOUPDATE);
			return;
			}

			m_uComboTick--;
		if(!m_uComboTick)
			{
			CbUpdate();
			}

		return;
		}


	CWnd::OnTimer(nIdEvent);
}

//*****************************************************************************
//*
//*		GetCbText
//*
//*****************************************************************************
//	Holt den Text eines Eintrages aus der Combobox
//	iPos		: Ist die Position des Eintrages (-1 Edit-Zeile)
//	pBuffer		: Puffer wo der Text gespeichert wird
//	Ergibt die Textlnge oder -1 bei einem Fehler.
int CDateiView::GetCbText(int iPos,LPTSTR pBuffer)
{
COMBOBOXEXITEM	sData;


	sData.mask		  = CBEIF_TEXT;
	sData.cchTextMax  = MAX_PATH+16;
	sData.pszText	  = pBuffer;
	sData.iItem		  = iPos;

	if(!m_cComboBox.GetItem(&sData))
		{
		return -1;
		}


return _tcslen(pBuffer);
}

//*****************************************************************************
//*
//*		CbUpdate
//*
//*****************************************************************************
//	Holt den Pfad aus der ComboBox und aktalisiert Tree- und Listenfenster.
//	Erbibt eine Status-Code ber die Aktion:
//			0 =	ComboBox ist nicht sichtbar
//			1 = Der eingegebene Pfad existiert nicht
//			2 = Es wurde der aktuelle Pfad eingegeben
//			3 = Ein neuer Pfad wurde ausgewhlt
int	CDateiView::CbUpdate()
{
TCHAR		 	cPath[MAX_PATH+16];
TCHAR		 	cName[MAX_PATH+16];
CStringChain	sEntries;
CWnd		   *pFocus;
COMBOBOXEXITEM	sData;
BOOL			bFlag;
int				iData;
int				iLen;
int				iNum;
int				iPos;


	bFlag		 = m_bComboSave;
	m_bComboSave = FALSE;


	if(m_iStyle&DVS_NOCOMBOBOX)							// Keine ComboBox sichtbar
		{
		return 0;
		}

	sData.mask		  =  CBEIF_TEXT;
	sData.cchTextMax  =  MAX_PATH+16;
	sData.pszText	  =  cPath;
	sData.iItem		  = -1;

	if(!m_cComboBox.GetItem(&sData))
		{
		return 0;
		}

	iLen = _tcslen(cPath  );
	iNum = _tcslen(m_pPath);

	if(iLen>0 && cPath[iLen-1]=='\\')
		{
		iLen--;
		}

	if(iNum>0 && m_pPath[iNum-1]=='\\')
		{
		iNum--;
		}

	if(iLen==iNum && !_tcsnicmp(cPath,m_pPath,iLen))	// Ist der Pfad bereits gesetzt
		{
		return 2;
		}

	iData = GetLevel(cPath,iLen);


	if(!iLen || ExistFile(cPath)<2)						// Existiert der Pfad
		{
		   iData = m_cComboBox.GetCurSel();
		if(iData<0)
			{
			pFocus = GetFocus();

			if(pFocus && pFocus->m_hWnd==m_cComboBox.GetEditCtrl()->m_hWnd)
				{
				MessageBeep(MB_ICONASTERISK);
				return 1;
				}
			}

		SetComboBox(m_pPath,iNum);						// Alten Pfad wieder eintragen

		return 1;
		}


	if(bFlag)											// Den Eintrag in die Combo-Liste eintragen
		{
		cPath[iLen] = 0;

		
		iPos = m_cComboBox.GetCount();

		while(iPos>15)									// Gibt es zu viele Eintrge
			{
			iPos -= 1;
			m_cComboBox.DeleteItem(iPos);
			}
		
		while(iPos>0)									// Gibt es den Pfad bereits
			{
			iPos -= 1;
			iNum  = GetCbText(iPos,cName); 
			
			if(iNum<0)continue;

			if(iNum>0 && cName[iNum-1]=='\\')
				{
				iNum--;
				}

			if(iNum==iLen && !_tcsnicmp(cPath,cName,iNum))
				{
				m_cComboBox.DeleteItem(iPos);
				}
			}

		iNum			= GetLevel(sData.pszText,-1,&sData.iSelectedImage);
		sData.mask		= CBEIF_TEXT|CBEIF_IMAGE|CBEIF_SELECTEDIMAGE;
		sData.iImage	= sData.iSelectedImage;
		sData.pszText	= cPath;
		sData.iItem		= 0;

		m_cComboBox.InsertItem(&sData);
		}


	Set(cPath,NULL,0,TRUE);


return 3;
}

//*****************************************************************************
//*
//*		OnClose
//*
//*****************************************************************************
void CDateiView::OnClose()
{
	KillTimer(ID_STATUSBARSET);

	if(m_hSetThread)									// Thread beenden
		{
		TerminateThread(m_hSetThread,0);
		CloseHandle(m_hSetThread);
		m_hSetThread=0;
		}

	CWnd::OnClose();
}  

//*****************************************************************************
//*
//*		Delete
//*
//*****************************************************************************
// Lscht die ausgewhlten Dateien im Fenster
// Ergibt	0 : Wenn nichts verndert wurde
//			1 :	Wenn nur Dateien kopiert wurden
//			2 : Wenn auch Verzeichnisse verndert wurden
void CDateiView::OnDelete(){Delete();}
int  CDateiView::Delete()
{
int			  x,y;
CStringChain  m_sFiles;
CCopyDlg	  dlg;



	x=GetSelect(&m_sFiles);							// Ausgewhlte Dateien holen
	if(x<=0)return 0;

	y=dlg.DoModal(	m_pPath,&m_sFiles,0,
					CF_REMOVE|CF_FRAGE);			// Dateien lschen

					x=0;
	if(y&CF_DATEI)	x=1;
	if(y&CF_VERZ )  x=2;

	if(x)Set(0);									// Verzeichnisse erneuern


return x;
}

//*****************************************************************************
//*
//*		GetSelect
//*
//*****************************************************************************
// Kopriert die ausgewhlten Dateien in eine String Kette
// Art:		0 Aktuelles Fenster
//			1 TreeView
//			2 ListView
// Ergibt die Anzahl der Dateien
int CDateiView::GetSelect(CStringChain *Dateien,int Art)
{
char	 puffer[MAX_PATH+16];
int		 x,y,anz=0;
CWnd	*wnd;


	Dateien->Del();  						// Dateien lschen

	if(!Art)
		{
		wnd=GetFocus();
		if(!wnd)return 0;
		}
											// Im Treeview ?
	if((Art==1)||(!Art &&(wnd->m_hWnd==m_cTreeView.m_hWnd)))
		{
		y=GetPath(m_cTreeView.GetSelectedItem(),puffer,MAX_PATH);
		if((y>3) && puffer[y-1]=='\\')puffer[y-1]=0;
		Dateien->Add(puffer);

		return 1;
		}


	x=-1;									// Im Listview ?
	if((Art==2)||(!Art &&(wnd->m_hWnd==m_cListView.m_hWnd)))
	do	{									// Dateien einlesen
		x=m_cListView.GetNextItem(x,LVNI_SELECTED);
		if(x==-1)break;
		y=GetPath(x,puffer,MAX_PATH);
		if((y>3) && puffer[y-1]=='\\')puffer[y-1]=0;
		Dateien->Add(puffer);
		anz++;
		}while(1);


return anz;
}
//*****************************************************************************
//*
//*   OnMenu
//*
//*****************************************************************************
// Ansichts Men einstellen
void CDateiView::OnMenu(CCmdUI *pCmdUI)
{
int	m_iStyle,ein;


	m_iStyle=::GetWindowLong(m_cListView.m_hWnd,GWL_STYLE );
	m_iStyle&=LVS_TYPEMASK;

	switch(pCmdUI->m_nID)
			{
	case ID_SETICON:		ein=m_iStyle==LVS_ICON;		break;
	case ID_SETLIST:		ein=m_iStyle==LVS_LIST;		break;
	case ID_SETSMALLICON:	ein=m_iStyle==LVS_SMALLICON;	break;
	case ID_SETREPORT:		ein=m_iStyle==LVS_REPORT;		break;
			}

	pCmdUI->SetRadio(ein);
}

//*****************************************************************************
//*
//*		OnListview
//*
//*****************************************************************************
void CDateiView::OnListview(NMHDR *pNmHdr, LRESULT *pResult)
{
char			puffer[MAX_PATH+16],*name;
int				x,y,anz,nr,attr;
SysFindStruct  *info;
NM_LISTVIEW	   *lv;
LV_KEYDOWN     *lk;
LV_DISPINFO	   *ld;
SHFILEINFO		sfi;


	lv=(NM_LISTVIEW*)pNmHdr;

//****************** Return gedrckt *******************************************

	if(pNmHdr->code==NM_RETURN)
		{
		x=m_cListView.GetNextItem(-1,LVNI_FOCUSED);
		if(!m_sFiles.IsDir(x))return;

		Set(m_pPath,m_sFiles.Name(x),0,TRUE);
		return;
		}

//****************** Select nderung *******************************************

	if(pNmHdr->code==LVN_ITEMCHANGED)
		{
		x =lv->uNewState;
		x^=lv->uOldState;
		if(x&LVIS_SELECTED)m_iSetStatubar=1;
		}

//****************** Fenster hat Focus erhalten ********************************

	if(pNmHdr->code==NM_SETFOCUS)
		{
		m_iLastFocus = 2;
		}

//****************** Drag-Operation ********************************************

	if(pNmHdr->code==LVN_BEGINDRAG)
		{
		CPoint		 cp;

		if(!(m_iStyle&DVS_DRAGDROP))return;
		if(m_iDragState)return;				// Drag & Drop bereits aktiv ?

		m_cListView.UpdateWindow();
		GetCursorPos(&cp);					// Cursorpositon ermitteln

		anz=m_cListView.GetSelectedCount();
		if(m_pDragImages && m_iDragImgMode)delete m_pDragImages;
		if(anz<=1)
			{
			m_iDragImgMode =0;
			m_pDragImages=m_cListView.CreateDragImage(lv->iItem,&cp);
			}
		else{
			m_iDragImgMode =1;
			m_pDragImages=new CImageList();
			m_pDragImages->Create(MAKEINTRESOURCE(IDB_DRAGTHREE),95,1,RGB(255,255,255));
			}
		m_pDragImages->BeginDrag(0,CPoint(20,10));
		m_pDragImages->DragEnter(0,cp );

		m_hDropItem  = 0;					// DropTarget Tree-Item
		m_iDropItem  =-1;					// DropTarget List-Item
		m_iDragState= 1;					// Drag & Drop einschalten
		m_iDropEntry=-1;					// Drop Fenster
		m_iDropView	=-1;					// Drop Eintrag
		m_iDropMode	= 0;					// Drag Art = Move
		m_iDropFlags  = 0;					// Tasten Zustand

		if(!m_pDragPath)m_pDragPath=new char[MAX_PATH+16];
		if(m_sFiles.IsDir(lv->iItem) && (anz<=1))
			 GetPath(lv->iItem,m_pDragPath,MAX_PATH);
		else strncpy(m_pDragPath,m_pPath,MAX_PATH);
		m_iDragDrive  =strcspn(m_pDragPath,":")+1;

		if((anz<=1)&& m_sFiles.IsDir(lv->iItem))
			{
			m_iDropNext=strlen (m_pDragPath);
			for(m_iDropNext--;m_iDropNext>0;m_iDropNext--)
				if(m_pDragPath[m_iDropNext-1]=='\\')break;
			}
		else m_iDropNext=0;

		x=-1;
		m_sDragFiles.Del();  				// Darg-Dateien einlesen
		do	{
			x=m_cListView.GetNextItem(x,LVNI_SELECTED);
			if(x==-1)break;
			y=GetPath(x,puffer,MAX_PATH);
			if((y>3) && puffer[y-1]=='\\')puffer[y-1]=0;
			m_sDragFiles.Add(puffer);
			}while(1);

		SetCapture();
		return;
		}

//****************** Sortieren *************************************************

	if(pNmHdr->code==LVN_COLUMNCLICK)
		{
		if(m_hSetThread)									// Thread beenden
			{
			TerminateThread(m_hSetThread,0);
			CloseHandle(m_hSetThread);
			m_hSetThread=0;
			}

		if(lv->iSubItem==m_iSortMode)
				m_iSortDir=!m_iSortDir;
		else	m_iSortMode     =lv->iSubItem;

		Sort(m_iSortMode,m_iSortDir);
		return;
		}

//****************** Delete ****************************************************

	if(pNmHdr->code==LVN_KEYDOWN)
		{
		lk=(LV_KEYDOWN*)pNmHdr;

		if(lk->wVKey==VK_TAB)
			{
			if(GetAsyncKeyState(VK_SHIFT)&0x8000)			// Zum vorherigen Fenster springen
				{
				if(!(m_iStyle&DVS_NOTREEVIEW))
					{
					m_cTreeView.SetFocus();
					}
				else if(!(m_iStyle&DVS_NOCOMBOBOX))
					{
					m_cComboBox.SetFocus();
					}					
				else if(m_iStyle&DVS_TABEXIT)
					{
					GetParent()->SetFocus();
					}
				}
			else{											// Zum nchsten Fenster springen
				if(m_iStyle&DVS_TABEXIT)
					{
					GetParent()->SetFocus();
					}
				else if(!(m_iStyle&DVS_NOCOMBOBOX))
					{
					m_cComboBox.SetFocus();
					}					
				else if(!(m_iStyle&DVS_NOTREEVIEW))
					{
					m_cTreeView.SetFocus();
					}
				}

			*pResult = 1;

			return;
			}

		if(!(m_iStyle&DVS_DELETE))return;
		if(lk->wVKey==VK_DELETE)Delete();
		}

//****************** Unterverzeichnis ffnen ***********************************

	if(pNmHdr->code==NM_DBLCLK)
		{
		x=lv->iItem;
		if(!m_sFiles.IsDir(x))return;

		Set(m_pPath,m_sFiles.Name(x));
		return;
		}

//****************** Unterverzeichnis ffnen ***********************************

	if(pNmHdr->code==LVN_KEYDOWN)
		{
		lk=(LV_KEYDOWN*)pNmHdr;

		if(lk->wVKey!=VK_RETURN)return;		// Wurde Return-Taste gedrckt

		x=m_cListView.GetNextItem(-1,LVNI_FOCUSED);
		if(x==-1)return;
		if(!m_sFiles.IsDir(x))return;

		Set(m_pPath,m_sFiles.Name(x));
		return;
		}

//****************** Rename ****************************************************

	if(pNmHdr->code==LVN_BEGINLABELEDIT  )	// Datei umbennen
		{
		m_iDoRename|=2;
		}
	if(pNmHdr->code==LVN_ENDLABELEDIT  )	// Datei umbennen
		{
		if(!(m_iStyle&DVS_RENAME))return;

		ld=(LV_DISPINFO*)pNmHdr;
		m_iDoRename&=~2;

		if(!ld->item.pszText)return;
		nr=ld->item.iItem;
		x=GetPath(nr,puffer,MAX_PATH+2);
		if(Rename(puffer,ld->item.pszText))
			{
			m_sFiles.Rename(nr,ld->item.pszText);
			info=m_sFiles.Info(nr);
			name=m_sFiles.Name(nr,1);
			attr=(info->dwAttr&SYS_DIR)? FILE_ATTRIBUTE_DIRECTORY:0;
			SHGetFileInfo(name,attr,&sfi,sizeof(sfi),SHGFI_TYPENAME|SHGFI_SYSICONINDEX);

			m_cListView.SetItem    (nr,0, LVIF_IMAGE,0,sfi.iIcon,0,0,0);
			m_cListView.SetItemText(nr,0, ld->item.pszText);
			m_cListView.SetItemText(nr,2, sfi.szTypeName	);
			}
		return;
		}

}

//*****************************************************************************
//*
//*   OnTreeview
//*
//*****************************************************************************
void CDateiView::OnTreeview(NMHDR *pNmHdr, LRESULT *pResult)
{
char		  puffer[MAX_PATH+16];
int			  x;
NM_TREEVIEW	 *tv;
TV_DISPINFO	 *td;
TV_KEYDOWN	 *tk;
HTREEITEM	  next;



	tv=(NM_TREEVIEW*)pNmHdr;


//****************** Drag-Operation ********************************************

	if(pNmHdr->code==TVN_BEGINDRAG)
		{
		CPoint		 cp;

		if(!(m_iStyle&DVS_DRAGDROP))return;
		if(m_iDragState)return;

		m_cTreeView.UpdateWindow();
		GetCursorPos(&cp);

		m_pDragImages=m_cTreeView.CreateDragImage(tv->itemNew.hItem);
		m_pDragImages->BeginDrag(0,CPoint(20,10));
		m_pDragImages->DragEnter(0,cp );

		m_hDropItem  = 0;					// DropTarget Tree-Item
		m_iDropItem  =-1;					// DropTarget List-Item
		m_iDragState= 1;					// Drag & Drop einschalten
		m_iDropEntry=-1;					// Drop Fenster
		m_iDropView	=-1;					// Drop Eintrag
		m_iDropMode	= 0;					// Drag Art = Move
		m_iDropFlags  = 0;					// Tasten Zustand

		if(!m_pDragPath)m_pDragPath=new char[MAX_PATH+16];
		m_iDropNext=GetPath(tv->itemNew.hItem,m_pDragPath,MAX_PATH);

		if(!m_iDropNext)return;
		memcpy(puffer,m_pDragPath,m_iDropNext+1);
		if(m_iDropNext>3)  puffer[m_iDropNext  ]=0;

		m_iDragDrive  =strcspn(m_pDragPath,":")+1;
		for(m_iDropNext--;m_iDropNext>0;m_iDropNext--)
			if(m_pDragPath[m_iDropNext-1]=='\\')break;

		m_sDragFiles.Del();  				// Darg-Dateien einlesen
		m_sDragFiles.Add(puffer);

		SetCapture();
		return;
		}

//****************** Baumzweig aufklappen **************************************

	if(pNmHdr->code==TVN_ITEMEXPANDED)
		{
		Read("",1,tv->itemNew.hItem);
		return;
		}


//****************** Anderen Baumzweig auswhlen *******************************

	if(pNmHdr->code==TVN_SELCHANGED)
		{
		GetPath(tv->itemNew.hItem,puffer,MAX_PATH+2);
		Set(puffer,NULL,0,TRUE);
		}

//****************** Delete / Weiter mit TAB ***********************************

	if(pNmHdr->code==TVN_KEYDOWN)
		{
		tk=(TV_KEYDOWN*)pNmHdr;

		if(tk->wVKey==VK_TAB)
			{
			if(GetAsyncKeyState(VK_SHIFT)&0x8000)			// Zum vorherigen Fenster springen
				{
				if(!(m_iStyle&DVS_NOCOMBOBOX))
					{
					m_cComboBox.SetFocus();
					}					
				else if(m_iStyle&DVS_TABEXIT)
					{
					GetParent()->SetFocus();
					}
				else if(!(m_iStyle&DVS_NOLISTVIEW))
					{
					OnSelectFirst();
					}
				}
			else{											// Zum nchsten Fenster springen
				if(!(m_iStyle&DVS_NOLISTVIEW))
					{
					OnSelectFirst();
					}
				else if(m_iStyle&DVS_TABEXIT)
					{
					GetParent()->SetFocus();
					}
				else if(!(m_iStyle&DVS_NOCOMBOBOX))
					{
					m_cComboBox.SetFocus();
					}					
				}

			*pResult = 1;

			return;
			}
		if(!(m_iStyle&DVS_DELETE))return;
		if(tk->wVKey==VK_DELETE)Delete();
		}

//****************** Fenster hat Focus erhalten ********************************

	if(pNmHdr->code==NM_SETFOCUS)
		{
		m_iLastFocus = 1;
		}


//****************** Fenster hat Focus erhalten ********************************

	if(pNmHdr->code==NM_RCLICK)
		{
		TVHITTESTINFO	sInfo;
		HTREEITEM		hItem;

		GetCursorPos(&sInfo.pt);
		
		m_cTreeView.ScreenToClient (&sInfo.pt);
		hItem = m_cTreeView.HitTest(&sInfo);

		if(hItem && sInfo.flags&TVHT_ONITEM)
			{
			m_cTreeView.SelectItem(hItem);
			}
		}

//****************** Rename ****************************************************

	if(pNmHdr->code==TVN_BEGINLABELEDIT)	// Ebene 0 sperren
		{
		if(!(m_iStyle&DVS_RENAME))return;
		m_iDoRename|=1;
		td=(TV_DISPINFO*)pNmHdr;
		x=td->item.lParam&0xFFF;
		if(!x)*pResult=TRUE;
		return;
		}

	if(pNmHdr->code==TVN_ENDLABELEDIT  )	// Datei umbennen
		{
		td=(TV_DISPINFO*)pNmHdr;

		m_iDoRename&=~1;

		if(!td->item.pszText)return;

		x=GetPath(td->item.hItem,puffer,MAX_PATH+2);
		if(Rename(puffer,td->item.pszText))
			{
					m_cTreeView.SetItemText  (td->item.hItem,td->item.pszText);
			   next=m_cTreeView.GetParentItem(td->item.hItem);
			if(next)m_cTreeView.SortChildren(next);
			}
		if(!m_pPath)return;
		if(stricmp(m_pPath,puffer))return;
		   GetPath(td->item.hItem,puffer,MAX_PATH+2);
		   strncpy(m_pPath,puffer,MAX_PATH);
		return;
		}

}

//*****************************************************************************
//*
//*		DoDrop
//*
//*****************************************************************************
// Ruft die Drop Funktion auf
// Ergibt	0 : Wenn nichts verndert wurde
//			1 :	Wenn nur Dateien kopiert wurden
//			2 : Wenn auch Verzeichnisse verndert wurden
int CDateiView::DoDrop(char *Pfad,int Art)
{
char	puffer[MAX_PATH+16];
int		x,len;

	if(Art==-1)return 0;
	if(!m_pDropProc  )return 0;

	len=strlen(Pfad);
	if(len>MAX_PATH+2)len=MAX_PATH+2;

	memcpy(puffer,Pfad,len);						// Pfad ermitteln
	for(;len>0;len--)if(puffer[len]=='\\')break;
	if(len && puffer[len-1]==':'){puffer[len]='\\';len++;}
	puffer[len]=0;



	x=m_pDropProc(puffer,&m_sDragFiles,Art,&m_iDropEntry,m_pData);

	if(x)
	if(!stricmp(puffer,m_pPath) || (x==2))Set(0);

return x;
}

//*****************************************************************************
//*
//*		SetDrop
//*
//*****************************************************************************
// Setzt die Funktion die bei Drop-Ereignissen aufgerufen wird
//			Pfad    = ist das Ablageziel
//			Dateien	= sind  alle Dateien
//			Art     = Ablageart (0=Move 1=Copy)
void CDateiView::SetDrop(int(__cdecl *Drop_fnk)(const char *Pfad,CStringChain *Dateien,int Art,void *Element,void *Data),void *Data)
{
	m_pData = Data;
	m_pDropProc = Drop_fnk;
}

//*****************************************************************************
//*
//*		SetView
//*
//*****************************************************************************
// Setzt die Funktion fr externe Fenster die Drops akzebtieren
//		Extern_hit_test ergibt 1 wenn ein Fenster beim Punkt Point ist
//						Point bezieht sich auf die linke ober Bildschirmecke
//						In Element knnen Daten des Fensters gespeichert werden
//						Element ist 4 Byte gro
//						Data ist ein konstanter Zeiger
//		Extern_get_pfad hold den Pfad fr die Drop Operation
//						Puffer ist der Ziel-Puffer mit der Gre Len
//		Extern_get_mode ergibt den Ablage Modus fr das Fenster (*Elemnent)
//						(0=Move 1=Copy -1=nicht erlaubt)

void CDateiView::SetView(int(*Extern_hit_test)(CPoint Point ,void *Element	     ,void *Data),
						 int(*Extern_get_pfad)(void *Element,char *Puffer,int Len,void *Data),
						 int(*Extern_get_mode)(UINT  nFlags ,void *Element		 ,void *Data))
{
	m_pHitTestProc	=Extern_hit_test;
	m_pGetPathProc	=Extern_get_pfad;
	m_pGetModeProc	=Extern_get_mode;
}

//*****************************************************************************
//*
//*		StatusbarInit
//*
//*****************************************************************************
// Erzeugt eine neue Statuszeile
int CDateiView::StatusbarInit()
{
INT				brt[] =	{-150,-150};
INT				ind[] =	{   0,   0};
FRAME_CLASS	   *wnd;


	wnd=(FRAME_CLASS*)AfxGetMainWnd();
	wnd->StatusbarInit(ind,brt,2);

	m_iSetStatubar=1;

return 1;
}
//*****************************************************************************
//*
//*		StatusbarExit
//*
//*****************************************************************************
// Erzeugt eine neue Statuszeile
int CDateiView::StatusbarExit()
{
UINT			ind[] =	{0,0};
FRAME_CLASS	   *wnd;


	wnd=(FRAME_CLASS*)AfxGetMainWnd();
	wnd->StatusbarInit();


return 1;
}
//*****************************************************************************
//*
//*		StatusbarSet
//*
//*****************************************************************************
// Aktualisiert die Statuszeile
void CDateiView::OnStatusbarSet(){StatusbarSet();}
int  CDateiView::StatusbarSet()
{
int				x,art,anz,len=0;
char			puffer[256],*text;
CStatusBar	   *statusbar=0;
LV_ITEM			item;
FRAME_CLASS	   *wnd;


	if(!m_iInit)return 0;
	wnd=(FRAME_CLASS*)AfxGetMainWnd();

	len=0;
	anz=m_sFiles.Count();
	art=m_cListView.GetSelectedCount();

	if(!art)								// Dateigren addieren
		{
		for(x=0;x<anz;x++)len+=m_sFiles.Len(x);
		}
	else{
		item.mask     =LVIF_STATE;
		item.stateMask=LVIS_SELECTED;
		item.iSubItem =0;
		for(x=0;x<anz;x++)
			{
			item.iItem=x;
			m_cListView.GetItem(&item);
			if(item.state&LVIS_SELECTED)
				len+=m_sFiles.Len(x);
			}
		anz=art;
		}

	itoa  (anz,puffer,10);
	strcat(puffer,(art)? " Dateien markiert":" Dateien");
	wnd->StatusbarSet(0,puffer);

						art=0;text=" Byte";
	if(len>=0x00000400){art=1;text=" KByte";}
	if(len>=0x00100000){art=2;text=" MByte";}


	itoa(len>>(10*art),puffer,10);
	x=strlen(puffer);
	if(art)
		{
		puffer[x]=',';
		if(art==2)len>>=10;
		len &=0x03FF;
		len *=100;
		len>>=10;
		puffer[x+1]=len/10+'0';
		puffer[x+2]=len%10+'0';
		x+=3;
		}
	strcpy(puffer+x,text);
	wnd->StatusbarSet(1,puffer);

return 1;
}

//*****************************************************************************
//*
//*		ComboEditProc
//*
//*****************************************************************************
LRESULT __stdcall CDateiView::ComboEditProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
HWND		hParent;
WNDPROC		pProc;


	pProc = (WNDPROC)GetWindowLongPtr(hWnd,GWLP_USERDATA);

	switch(uMsg)
		{
	case WM_KEYDOWN:

		if(wParam==VK_TAB || wParam==VK_RETURN)
			{
			hParent	= ::GetParent(hWnd   );
			hParent	= ::GetParent(hParent);

			::PostMessage(hParent,WM_COMMAND,(wParam==VK_RETURN)? ID_RETURN:ID_TABULATOR,0);

			if(wParam==VK_TAB)
				{
				return 0;
				}
			}

		break;

	case WM_CHAR:

		if(wParam==VK_TAB)
			{
			return 0;
			}

		break;
		}


return CallWindowProc(pProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*     OnReturn
//*
//*****************************************************************************
//	RETURN wurde in der ComboBox gedrckt
void CDateiView::OnReturn()
{

	m_bComboSave  = 1;
	m_uComboTick  = 1;

	PostMessage(WM_TIMER,ID_COMBOUPDATE);

}

//*****************************************************************************
//*
//*     OnTabulator
//*
//*****************************************************************************
//	TAB wurde in der ComboBox gedrckt
void CDateiView::OnTabulator()
{

	if(GetAsyncKeyState(VK_SHIFT)&0x8000)			// Zum vorherigen Fenster springen
		{
		if(m_iStyle&DVS_TABEXIT)
			{
			GetParent()->SetFocus();
			}
		else if(!(m_iStyle&DVS_NOLISTVIEW))
			{
			OnSelectFirst();
			}
		else if(!(m_iStyle&DVS_NOTREEVIEW))
			{
			m_cTreeView.SetFocus();
			}
		}
	else{											// Zum nchsten Fenster springen
		if(!(m_iStyle&DVS_NOTREEVIEW))
			{
			m_cTreeView.SetFocus();
			}
		else if(!(m_iStyle&DVS_NOLISTVIEW))
			{
			OnSelectFirst();
			}
		else if(m_iStyle&DVS_TABEXIT)
			{
			GetParent()->SetFocus();
			}
		}

}

//*****************************************************************************
//*
//*     OnCbCloseUp
//*
//*****************************************************************************
void CDateiView::OnCbCloseUp()
{

	m_uComboFast = GetTickCount();

}


//*****************************************************************************
//*
//*     OnSelChanged
//*
//*****************************************************************************
void CDateiView::OnSelChanged()
{
unsigned	uDiff;

	
	uDiff = GetTickCount()-m_uComboFast;

	m_bComboSave = 0;
	m_uComboTick = (uDiff<500)? 1:5;

	if(!m_bComboTimer)
		{
		m_bComboTimer = TRUE;
		SetTimer(ID_COMBOUPDATE,200,NULL);
		}

}

//*****************************************************************************
//*
//*		OnCbSetFocus
//*
//*****************************************************************************
void CDateiView::OnCbSetFocus()
{

	m_iLastFocus = 3;

}

//*****************************************************************************
//*
//*		OnPathPrev
//*
//*****************************************************************************
void CDateiView::OnPathPrev()
{

	if(m_iPathPos!=m_iPathStart && m_iPathOk)
		{
		m_iPathPos = (m_iPathPos+DVS_MAX_PATHS-1)%DVS_MAX_PATHS;
		Set(m_aPaths[m_iPathPos],NULL,0,FALSE);

		m_cBtPrev.EnableWindow(m_iPathPos!=m_iPathStart);
		m_cBtNext.EnableWindow(m_iPathPos!=m_iPathEnd  );
		}


}

//*****************************************************************************
//*
//*		OnPathNext
//*
//*****************************************************************************
void CDateiView::OnPathNext()
{

	if(m_iPathPos!=m_iPathEnd && m_iPathOk)
		{
		m_iPathPos = (m_iPathPos+1)%DVS_MAX_PATHS;
		Set(m_aPaths[m_iPathPos],NULL,0,FALSE);

		m_cBtPrev.EnableWindow(m_iPathPos!=m_iPathStart);
		m_cBtNext.EnableWindow(m_iPathPos!=m_iPathEnd  );
		}

}

//*****************************************************************************
//*
//*		AddToHistory
//*
//*****************************************************************************
BOOL CDateiView::AddToHistory(LPCTSTR pPath)
{
int		iPos;


	if(pPath[0]==0)
		{
		return FALSE;
		}
	else if(m_iPathStart!=m_iPathEnd)
		{
		iPos = (m_iPathPos+DVS_MAX_PATHS-1)%DVS_MAX_PATHS;

		if(m_aPaths[iPos]==pPath)
			{
			return FALSE;
			}
		}

	if(!m_iPathOk)
		{
		m_aPaths[0]		=  pPath;
		m_iPathStart	=  0;
		m_iPathEnd		=  0;
		m_iPathPos		=  0;
		m_iPathOk		=  1;

		m_cBtPrev.EnableWindow(FALSE);
		m_cBtNext.EnableWindow(FALSE);
		}
	else{
		m_iPathPos		= (m_iPathPos+1)%DVS_MAX_PATHS;
		m_iPathEnd		=  m_iPathPos;
		m_aPaths[m_iPathPos] = pPath;

		if(m_iPathStart==m_iPathEnd)
			{
			m_iPathStart = (m_iPathEnd+1)%DVS_MAX_PATHS;
			}

		m_cBtPrev.EnableWindow(TRUE );
		m_cBtNext.EnableWindow(FALSE);
		}


return TRUE;
}

//*****************************************************************************
//*
//*		OnSelectAll
//*
//*****************************************************************************
void CDateiView::OnSelectAll()
{
LV_ITEM	    item;
int			x;


	item.mask      = LVIF_STATE;
	item.state     = LVIS_SELECTED;
	item.stateMask = LVIS_SELECTED;
	item.iSubItem  = 0;
	
	for(x=0;x<m_iCount;x++)
		{
		item.iItem = x;
		m_cListView.SetItem(&item);
		}
	
	m_cListView.SetFocus();

}

//*****************************************************************************
//*
//*     OnSelectFirst
//*
//*****************************************************************************
void CDateiView::OnSelectFirst()
{
POSITION	hPos;

	m_cListView.SetFocus();
	hPos = m_cListView.GetFirstSelectedItemPosition();

	if(!hPos || !m_cListView.GetNextSelectedItem(hPos))
		{
		m_cListView.SetItemState(0,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED); 
		}

}


//*****************************************************************************
//*
//*		OnNewDir
//*
//*****************************************************************************
// Erzeugt ein neues Verzeichnis
void CDateiView::OnNewDir()
{
	CreateNewFolder();
}

//*****************************************************************************
//*
//*		CreateNewFolder
//*
//*****************************************************************************
// Erzeugt ein neues Verzeichnis mit dem Verrzeichnissnamen Name
// Ist Name==0 so wird ein standard Name verwendet
// Ergibt	0 : Wenn Verzeichnis erzeugt wurde
//		   -1 :	Wenn Verzeichnis nicht erzeugt wurde
int CDateiView::CreateNewFolder(char *Name)
{
int		nr,len,pos,x;
char	puffer[MAX_PATH+64];
struct _finddata_t sFind;


	if(!m_pPath)return -1;
	len=strlen(m_pPath);
	if(len>MAX_PATH)return -1;
	memcpy(puffer,m_pPath,len);

	if(!Name)
		{
		nr=0;

		strcpy(puffer+len,"Neues Verzeichnis");
		pos=strlen(puffer);

		x=_findfirst(puffer,&sFind);			// freien Namen suchen
		while(x!=-1)
			{
			nr++;
			_findclose(x);
			puffer[pos]='(';
			itoa(nr,puffer+pos+1,10);
			strcat(puffer+pos,")");
			x=_findfirst(puffer,&sFind);
			}
		}
	else{
		x=strlen(Name);
		if(x+len>MAX_PATH)return -1;
		memcpy(puffer+len,Name,x+1);
		}

	x=mkdir(puffer);						// Verzeichnis erzeugen

	if(x==-1)
		{
		MessageBox("Kann Verzeichnis nicht erzeugen !.",0,MB_ICONERROR|MB_OK);
		return -1;
		}

	Set(0,0,1);
	Insert();

	if(!Name)								// Dateinamen bearbeiten
		{
		x=m_sFiles.Find(puffer+len);
		if(x>=0)
			{
			m_cListView.UpdateWindow();
			m_cListView.SetFocus();
			m_cListView.EditLabel(x);
			}
		}

return 0;
}

//*****************************************************************************
//*
//*		GetLevel
//*
//*****************************************************************************
//	Holt zu einem Pfad die Ebene und die Root-Nummer
int CDateiView::GetLevel(LPCTSTR pPath,int iLen,int *pIcon)
{
TCHAR		cName[MAX_PATH];
int			iData;
int			iOff;
int			iEnd;
SHFILEINFO	sSfi;

	
	if(iLen<0)iLen=_tcslen(pPath);
	if(iLen>0 && pPath[iLen-1]=='\\')iLen--;

	iData = 0;


	for(iEnd=0;iEnd<iLen;iEnd++)
		{
		if(pPath[iEnd]=='\\')break;
		}


	for(iOff=iEnd;iOff<iLen;iOff++)
		{
		if(pPath[iOff]=='\\')
			{
			iData++;
			}
		}

	if(pIcon && iOff<MAX_PATH)
		{
		memcpy(cName,pPath,iOff*sizeof(TCHAR));
		if(iData==0)
			{
			cName[iOff  ] = '\\';
			cName[iOff+1] = 0;
			}
		else{
			cName[iOff  ] = 0;
			}

		sSfi.iIcon = 0;
		SHGetFileInfo(cName,_A_SUBDIR,&sSfi,sizeof(sSfi),SHGFI_SYSICONINDEX);

		*pIcon = sSfi.iIcon;
		}
	else if(pIcon)
		{
		*pIcon = 0;
		} 
	

//	iOff	= m_sRoot.Find(iEnd,pPath,0,-1,0x01);
	iData  |= iOff<<16;
	iData  |= 0x55000000;


return iData;
}

//*****************************************************************************
//*
//*		GetComboList
//*
//*****************************************************************************
//	Die Combo-Liste mit aus der Registry fllen.
//	pRegName	: Ist der Names des Eintrages
//	pRegPath	: Ist der Pfad in der Registry (auch NULL)
//	Ergibt die Anzahl der gefundenen Eintrge.
int	CDateiView::GetComboList(LPCTSTR pRegName,LPCTSTR pRegPath)
{
LPTSTR		pList;
CRegKeys	sKey;
int			iPos;
int			iNum;

	
	sKey.Open();
	
	if(pRegPath)sKey.Up(pRegPath);


	if(!sKey.GetMulti(&pList,pRegName) || !pList)
		{
		return 0;
		}

	m_sCombo.KAdd(pList);	

	delete pList;

	
	if(IsWindow(m_cComboBox.m_hWnd) && m_cComboBox.GetCount()==0)
		{
		for(iPos=0;iPos<m_sCombo.Count();iPos++)
			{
			COMBOBOXEXITEM	sItem;

			iNum			= GetLevel(m_sCombo[iPos],-1,&sItem.iSelectedImage);
			sItem.mask		= CBEIF_TEXT|CBEIF_IMAGE|CBEIF_SELECTEDIMAGE;;
			sItem.iImage	= sItem.iSelectedImage;
			sItem.pszText	= m_sCombo[iPos];
			sItem.iItem		= iPos;

			m_cComboBox.InsertItem(&sItem);
			}
		}


return m_sCombo.Count();
}

//*****************************************************************************
//*
//*		SetComboList
//*
//*****************************************************************************
//	Die Combo-Liste mit in der Registry speichern.
//	pRegName	: Ist der Names des Eintrages
//	pRegPath	: Ist der Pfad in der Registry (auch NULL)
//	Ergibt die Anzahl der gefundenen Eintrge.
int	CDateiView::SetComboList(LPCTSTR pRegName,LPCTSTR pRegPath)
{
LPTSTR		pList;
CRegKeys	sKey;


	GetCbList();

	sKey.Open();
	
	if(pRegPath)sKey.Up(pRegPath);

	m_sCombo.Chain(&pList);

	if(!pList)return 0;


	if(!sKey.SetMulti(pList,pRegName))
		{
		delete pList;
		return 0;
		}

	delete pList;


return m_sCombo.Count();
}


//*****************************************************************************
//*
//*		GetCbList
//*
//*****************************************************************************
//	Holt alle Pfade aus der Listbox
int	CDateiView::GetCbList()	
{
TCHAR			cPath[MAX_PATH+16];
COMBOBOXEXITEM	sData;
int				iCount;
int				iPos;


	if(!IsWindow(m_cComboBox.m_hWnd))
		{
		return -1;
		}

	m_sCombo.Del();
	
	iCount = m_cComboBox.GetCount();

	for(iPos=0;iPos<iCount;iPos++)
		{
		sData.mask		  = CBEIF_TEXT;
		sData.cchTextMax  = MAX_PATH+16;
		sData.pszText	  = cPath;
		sData.iItem		  = iPos;

		if(!m_cComboBox.GetItem(&sData))
			{
			continue;
			}

		m_sCombo.Add(cPath);
		}


return m_sCombo.Count();
}


//*****************************************************************************
//*
//*		SetStyle
//*
//*****************************************************************************
//	ndert Aussehen und Verhalten des Fensters
//	Setzt  neue Style Attribute
//	Ergibt die  Style Attribute
//	Es werden nur die Bits die mit Maske Makiert sind gendert
//	Style:
//		DVS_NOLISTVIEW		0x0001		// ListView nicht anzeigen
//		DVS_NOTREEVIEW		0x0002		// TreeView nicht anzeigen
//		DVS_DRAGDROP		0x0010		// Drag und Drop aktivieren
//		DVS_NODROP			0x0020		// Kein Drop auf sich selbst
int CDateiView::SetStyle(int Style,int Maske)
{
RECT	rect;
int		diff;
int		alt;
int		bit;


		Style&= Maske;
	alt=m_iStyle       &0xFFFF;
		m_iStyle&=~Maske;
		m_iStyle|=Style&0xFFFF;
		diff = alt^m_iStyle;

	if(diff&(DVS_NOTREEVIEW|DVS_NOLISTVIEW|DVS_NOCOMBOBOX))
		{
		m_cTreeView.ShowWindow((m_iStyle&DVS_NOTREEVIEW)? SW_HIDE:SW_SHOW );
		m_cListView.ShowWindow((m_iStyle&DVS_NOLISTVIEW)? SW_HIDE:SW_SHOW );
		m_cComboBox.ShowWindow((m_iStyle&DVS_NOCOMBOBOX)? SW_HIDE:SW_SHOW);
		m_cBtPrev  .ShowWindow((m_iStyle&DVS_NOCOMBOBOX)? SW_HIDE:SW_SHOW);
		m_cBtNext  .ShowWindow((m_iStyle&DVS_NOCOMBOBOX)? SW_HIDE:SW_SHOW);
		m_cBtDoUp  .ShowWindow((m_iStyle&DVS_NOCOMBOBOX)? SW_HIDE:SW_SHOW);

		if(diff&DVS_NOCOMBOBOX)
			{
			CbUpdate();
			}

		bit = IsWindowVisible();

		if(bit)SetRedraw(FALSE);
		GetClientRect( &rect );
		OnSize(0,rect.right,rect.bottom);
		if(bit)SetRedraw(TRUE);
		RedrawWindow();
		
		if(diff&DVS_NOLISTVIEW)Set(0);
		}

	if((alt^m_iStyle)&(DVS_NODROP|DVS_DRAGDROP))
		{
		if(  m_iStyle&DVS_DRAGDROP)
		if(!(m_iStyle&DVS_NODROP ))DragAcceptFiles();
		}


return alt;
}

//*****************************************************************************
//*
//*		OnPathSelect
//*
//*****************************************************************************
//	Auf den N'ten in der Pfad-History
void CDateiView::OnPathSelect(UINT uId)
{
TCHAR		cPath[MAX_PATH];


	uId -= ID_PATHSEL;

	if(uId&0x10)
		{
		uId &= 0x0F;


		while(m_iPathPos!=m_iPathStart && m_iPathOk)
			{
			m_iPathPos = (m_iPathPos+DVS_MAX_PATHS-1)%DVS_MAX_PATHS;

			if(!uId)break;

			uId--;
			}
		}
	else{
		while(m_iPathPos!=m_iPathEnd && m_iPathOk)
			{
			m_iPathPos = (m_iPathPos+1)%DVS_MAX_PATHS;

			if(!uId)break;

			uId--;
			}
		}

	strlcpy(cPath,m_aPaths[m_iPathPos],MAX_PATH);
	SetPath(cPath);

	m_cBtPrev.EnableWindow(m_iPathPos!=m_iPathStart);
	m_cBtNext.EnableWindow(m_iPathPos!=m_iPathEnd  );

}


//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CDateiView::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
TCHAR				cName[MAX_PATH];
CMenu				sMenu;
CStringArray        sArray;
LPCTSTR				pPath;
int					iLen;
int					iAdd;
int					iPos;
int					iEnd;



	if(!pWnd || (pWnd->m_hWnd!=m_cBtPrev.m_hWnd && pWnd->m_hWnd!=m_cBtNext.m_hWnd))
		{
		GetParent()->SendMessage(WM_CONTEXTMENU,(WPARAM)((pWnd)? pWnd->m_hWnd:0),MAKELONG(sPoint.x,sPoint.y));
		return;
		}


												// Pfade vor oder zurck
	if(pWnd->m_hWnd==m_cBtPrev.m_hWnd)
		{
		iAdd = -1;
		iEnd = m_iPathStart;
		}
	else{
		iAdd = 1;
		iEnd = m_iPathEnd;
		}

	if(m_iPathPos==iEnd)return;

	sMenu.CreatePopupMenu();
	iPos = m_iPathPos;

	for(iLen=0;iLen<16;iLen++)
		{
		iPos += iAdd;

		while(iPos<             0)iPos+=DVS_MAX_PATHS;
		while(iPos>=DVS_MAX_PATHS)iPos-=DVS_MAX_PATHS;

		pPath=m_aPaths[iPos];
		if(pPath[0]=='/' && pPath[1] && pPath[2]==':')pPath++;
		CommpressFileName(pPath,cName,MAX_PATH,64);
		sMenu.AppendMenu(MF_STRING,ID_PATHSEL+iLen|(iAdd&0x10),cName);

		if(iPos==iEnd)break;
		}

	sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();


return;
}
