//*****************************************************************************
//*
//*
//*		KLASSE  CDateiView
//*
//*
//*****************************************************************************
// 	char *GetPath()							Ergibt den aktuellen Pfad
// 	char *SetPath(char *)					Ergibt den aktuellen Pfad
// 	int   Set (char*="C:\\",char*=0,int=0)	Neuen Pfad Setzen
//	int   Filter (char *,char *,int =1)		Neuen Datei-Filter einstellen
// 	void  OnSelectAll()						Alles auswhlen
// 	int   GetSelect(CStringChain *,int=0)	Ergibt die ausgewhlen Dateien
// 	int	  SetStyle(int,int Maske=0xFFFF)	ndert Aussehen
// 	int	  Delete()							Lscht ausgewhlten Dateien
// 	int	  CreateNewFolder(char *Name=0)		Erzeugt ein neues Verzeichnis
// 	int	  DoDrop(char *Pfad,int Art)		Dorp-Funktion ausfhren
// 	int   HitTest(CPoint,void *)			Ergibt Eintragnr. unter Cursor
// 	int   SetListView(int=LVS_REPORT)		ndert die Ansicht des Listviews
// 	int   Sort(int Art=0,int Richtung=0)	Sortiere ListView
//
//	Einstellen der Drop-Funktionen
//
// 	void  SetDrop(	int(*Drop_fnk)(char *Pfad,CStringChain *Dateien  ,int Art,void *Element,void *Data)=0,void *Data=0);
// 	void  SetView(	int(*Extern_hit_test)(CPoint Point ,void *Element	     ,void *Data)=0,
// 					int(*Extern_get_pfad)(void *Element,char *Puffer ,int Len,void *Data)=0,
// 					int(*Extern_get_mode)(UINT  nFlags ,void *Element	     ,void *Data)=0);
// 	HTREEITEM Read(char *Pfad,int Art=0,HTREEITEM Wurzel=0);
//
#ifndef		AFX_DATEIVIEW_H__3828DAEF_B14F_11D2_84E4_D45E733A360A__INCLUDED_
#define     AFX_DATEIVIEW_H__3828DAEF_B14F_11D2_84E4_D45E733A360A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

#include <string.h>
#include <afxcmn.h>
#include <afxole.h>
#include <afxcview.h>

#include "FileFinder.h"
#include "StringFunctions.h"

//*****************************************************************************
//*
//*		Styles fr das Fenster
//*
//*****************************************************************************

#define		DVS_NOLISTVIEW		0x0001		// ListView nicht anzeigen
#define		DVS_NOTREEVIEW		0x0002		// TreeView nicht anzeigen
#define		DVS_NOCOMBOBOX		0x0004		// ComboBox nicht anzeigen
#define		DVS_DELETE			0x0008		// Datei Lschen erlaubt
#define		DVS_DRAGDROP		0x0010		// Drag und Drop aktivieren
#define		DVS_NODROP			0x0020		// Kein Drop auf sich selbst
#define		DVS_TABEXIT			0x0040		// Bei TAB Focus an Elternfenster geben
#define		DVS_RENAME			0x0080		// Dateien knnen umbenannt werden

#define		DSN_PATHCHANGE		0x9701		// Nachricht Pfadwurde verndert
#define		DVS_SEPARATOR		200					// Startposition des Teiles
#define		DVS_MAX_PATHS		32			// Maximale Pfad in der History

class CDateiView : public CWnd
{
//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************

protected:


	CString		 m_aPaths[DVS_MAX_PATHS];	// Pfad-History
	int			 m_iPathStart;				// Erster Pfad in History
	int			 m_iPathEnd;				// Letzter Pfad in History
	int			 m_iPathPos;				// Aktueller Pfad in History
	int			 m_iPathOk;					// Gibt es Pfade in der History
	CListCtrl	 m_cListView;				// Fenster mit Dateiliste
	CTreeCtrl	 m_cTreeView;				// Fenster mit Verzeichnisbaum
	CComboBoxEx	 m_cComboBox;				// Fenster mit Namenszeile
	CButton		 m_cBtPrev;					// Zurck Taste	
	CButton		 m_cBtNext;					// Vortaste Taste	
	CButton		 m_cBtDoUp;					// Eine Ebenehher
	CFileFinder	 m_sFiles;					// Dateien fr das Listfenster
	BOOL		 m_bUbEnable;				// Ist OnPathUp mglich
	BOOL	 	 m_bSepChanged;				// Wurde der Teiler veschoben
	BOOL		 m_bComboTimer;				// Ist der Combo-Timer an
	BOOL		 m_bComboSave;				// Den Pfad in die Liste aufnehmen	
	UINT		 m_uComboFast;				// Beim Zuklappen der Liste schnell Einfgen
	UINT		 m_uComboTick;				// Wann Pfad aus ComboBox holen
	int			 m_iComboHight;				// Hhe des sichtbaren Bereiches der ComboBox
	int			 m_iComboAdd;				// Hhe des Drop-Down-Feldes der ComboBox
	int			 m_iComboEnd;				// Hhe des der Namenszeile
	int			 m_iSeparator;				// Teilung der Fenster
	int			 m_iStyle;					// Fenster Styles
	char	    *m_pPath;					// Speicher fr aktuellen Pfad
	char		*m_pPlus;					// Datei Filter
	char		*m_pMinus;					//		*
	int			 m_iDrives;					// Welche LW`s sind vorhanden
	HTREEITEM	 m_hTreeOpen;				// Offener Ordner fr Treefeld
	int			 m_iInit;					// Ist Fenster initilaisiert
	int			 m_iLastFocus;				// Wo war der Focus zulezt
	HANDLE		 m_hSetThread;				// Thread fr das Datei einlesen
	DWORD		 m_dwSetThreadId;			// Thread ID
	int			 m_iSetState;				// Thread Zustand
	int			 m_iSetStatubar;			// Statusbar setzen
	int			 m_iDoRename;				// Wird gerade eine Datei umbenannt
	int			 m_iCount;					// Anzahl der gefunden Dateien im Listview
	int			 m_iDragState;				// Darg Zustand
	CImageList	*m_pDragImages;				// Darg imageList
	int			 m_iDragImgMode;			// Speicher fr Imagelist freigeben
	int			 m_iSortMode;				// Sortier-Art
	int			 m_iSortDir;				// Sortier-Richtung
	int			 m_iDropView;				// Hit_Test Fensternummer
	int			 m_iDropEntry;				// Letztes Element
	HTREEITEM	 m_hDropItem;				// DropTarget Tree-Item
	int			 m_iDropItem;				// DropTarget List-Item
	int			 m_iDragDrive;				// Start-Laufwerk
	int			 m_iDropMode;				// Art des Drops 1=Copy 0=Move -1=Nicht erlaubt
	int			 m_iDropFlags;				// Art des Drops 1=Copy 0=Move -1=Nicht erlaubt
	int			 m_iDropNext;				// Oberer Pfad
	char		*m_pDragPath;				// Pfad des Anfangs-Elementes
	CStringChain m_sDragFiles;				// Dateienname fr Drag
	CStringChain m_sCombo;					// Eintrge fr die ComboBox		

	HCURSOR		 m_hCursorNull;				// Normaler-Cursor
	HCURSOR		 m_hCursorDis;				// Disable -Cursor
	HCURSOR		 m_hCursorWait;				// Wait    -Cursor
	HCURSOR		 m_hCursorCopy;				// Copy    -Cursor
	HCURSOR		 m_hCursorMove;				// Move    -Cursor
	HCURSOR		 m_hCursorSize;				// Gren  -Cursor
	int			 m_iCursorMode;				// Modi fr Cursor

	void		*m_pData;					// Datenspeicher fre externe Funktionen
	int	(*m_pDropProc)(const char *Pfad,CStringChain *Dateien,int Art,void *Element ,void *Data);//Funktion die Aufgerufen wird beim Drop
	int	(*m_pHitTestProc)(CPoint Point ,void *Element		 ,void *Data);
	int	(*m_pGetModeProc)(UINT nFlags  ,void *Element		 ,void *Data);
	int	(*m_pGetPathProc)(void *Element,char *Puffer,int Len,void *Data);

	const static int   m_sSortArray[4];		// Sortier-Modi


//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************

public:
	CDateiView();

public:

	// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CDateiView)
public:
	virtual BOOL Create( LPCTSTR pClassName, LPCTSTR pWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID,char *Plus=0,char *Minus=0, CCreateContext* pContext = NULL);
	virtual BOOL Create( DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID,char *Plus=0,char *Minus=0, CCreateContext* pContext = NULL);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	//}}AFX_VIRTUAL


// Implementierung
public:

	CWnd *SetFocus(int iMode=0);
	int   GetStyle();
	int	  SetStyle(int Style,int Maske=0xFFFF);
	int	  CreateNewFolder(char *Name=0);
	int   GetSelect(CStringChain *Dateien,int Art=0);
	int	  Delete();
	int	  DoDrop(char *Pfad,int Art);
	int   HitTest(CPoint Point,void *Element);
	int   HitTest(void *Element=NULL);
	int   Filter(char *Plus=0,char *Minus=0,int Art=1);			
	char *GetPath();
	char *SetPath(char *Pfad,char *Plus=0,char *Minus=0);
	int	  GetComboList(LPCTSTR pRegName,LPCTSTR pRegPath=0);
	int	  SetComboList(LPCTSTR pRegName,LPCTSTR pRegPath=0);
	BOOL  IsPathUpAlloed();	

	void  OnSelectAll();
	int   SetListView(int Art=LVS_REPORT);
	void  SetDrop(	int(__cdecl *Drop_fnk)(const char *Pfad,CStringChain *Dateien  ,int Art,void *Element,void *Data)=0,void *Data=0);
	void  SetView(	int(__cdecl *Extern_hit_test)(CPoint Point ,void *Element	     ,void *Data)=0,
					int(__cdecl *Extern_get_pfad)(void *Element,char *Puffer ,int Len,void *Data)=0,
					int(__cdecl *Extern_get_mode)(UINT  nFlags ,void *Element	     ,void *Data)=0);
	int   Sort(int Art=0,int Richtung=0);
	int   Set (const char *Pfad="C:\\",char *Unter=0,int Art=0,BOOL History=TRUE);
	virtual ~CDateiView();

protected:

 	HTREEITEM Read(const char *Pfad,int Art=0,HTREEITEM Wurzel=0);
	static	DWORD WINAPI StartThread(LPVOID datei_view);
	int	  StatusbarInit();
	int	  StatusbarExit();
	int	  StatusbarSet ();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

	int   Insert();
	int	  CbUpdate();
	int	  GetCbList();
	int   SetCursor(int Mode);
	int   ReadSubDirs(HTREEITEM Eintrag,char *Pfad=0,int Art=0);
	int   GetPath(HTREEITEM Eintrag,char *Puffer,int Len);
	int   GetPath(int       Eintrag,char *Puffer,int Len);
	int   Rename (char *Datei,char *Name);
	int	  GetLevel(LPCTSTR pPath,int iLen=-1,int *pIcon=0);
	int	  SetComboBox(LPCTSTR pPath,int iLen,int iLevel=-1);
	int	  GetCbText(int iPos,LPTSTR pBuffer);
	BOOL  AddToHistory(LPCTSTR pPath);

// Generierte Message-Map-Funktionen
protected:


	//{{AFX_MSG(CDateiView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint sPoint);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint sPoint);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp  (UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint sPoint);
	afx_msg void OnContextMenu(CWnd *pWnd,CPoint sPoint);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnMenu    (CCmdUI *pCmdUI);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnPathSelect(UINT uId);
	afx_msg void OnCbSetFocus();
	afx_msg void OnSelChanged();
	afx_msg void OnCbCloseUp();
	afx_msg void OnTabulator();
	afx_msg void OnPathPrev();
	afx_msg void OnPathNext();
	afx_msg void OnDestroy();
	afx_msg void OnReturn();
	afx_msg void OnClose();
	afx_msg void OnPaint();
	//}}AFX_MSG


	afx_msg void OnTreeview(NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListview(NMHDR *pNmHdr, LRESULT *pResult);

	static	LRESULT __stdcall ComboEditProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

public:

	afx_msg void OnPathUp		();
	afx_msg void OnIcon     	();
	afx_msg void OnSmallIcon	();
	afx_msg void OnList     	();
	afx_msg void OnReport   	();
	afx_msg void OnNewDir   	();
	afx_msg void OnDelete   	();
	afx_msg void OnSelectFirst	();
	afx_msg void OnStatusbarSet ();


	DECLARE_MESSAGE_MAP()
};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline  BOOL  CDateiView::IsPathUpAlloed(){return m_bUbEnable;}
inline  int   CDateiView::GetStyle      (){return m_iStyle;}

//{{AFX_INSERT_LOCATION}}
#endif
