//*****************************************************************************
//*
//*		
//*		MainFrm.cpp : Implementierung der Klasse CMainFrame
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include "Backup.h"
#include "MainFrm.h"
#include "BackupView.h"
#include "ProgressDlg.h"
#include "TaskbarTools.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_WM_CREATE()
	ON_MESSAGE(WM_HIDEWND					,OnHideWnd)
	ON_MESSAGE(WM_SETBREAK					,OnSetBreak)
	ON_COMMAND(ID_STATUS_BAR_FLAT			,OnFlatBar)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT	,OnFlatBarUI)
	//}}AFX_MSG_MAP
	ON_MENUICON_MODE()
	ON_MENUICON()
	ON_STATUSBAR()
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		Variabeln
//*
//*****************************************************************************

static UINT indicators[] =
	{
	ID_SEPARATOR,        
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
	};

STATUSBAR_PROC(CMainFrame)
MENUICON_PROC(CMainFrame)


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CMainFrame::CMainFrame()
{
CRegKeys	sKey;

	m_bFlatMode = TRUE;
	m_pProgress	= NULL;
	
	sKey.Open();
	sKey.Up("Settings");
	sKey.Get(m_bFlatMode,"FlatMode");
	sKey.Get(m_bMenuMode,"MenuMode");

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;

	sKey.Open();
	sKey.Up("Settings");
	sKey.Set(m_bFlatMode,"FlatMode");
	sKey.Set(m_bMenuMode,"MenuMode");
}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
DWORD	dwStyle;

	
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)return -1;
	
	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;
	
	if(!m_wndToolBar.CreateEx(this,dwStyle,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;   
		}
	
	if(!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;   
		}

	if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Failed to create status bar\n");
		return -1;   
		}
	
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle()|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	
	
	EnableDocking (CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	MenuIconsInit (IDR_MAINFRAME);


return 0;
}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	return CFrameWnd::PreCreateWindow(cs);
}


//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
 	CFrameWnd::Dump(dc);
}

#endif 


//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	dwStyle;


	dwStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(dwStyle,dwStyle^TBSTYLE_FLAT);
	m_bFlatMode=(dwStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}
	

}


//*****************************************************************************
//*
//*		OnHideWnd
//*
//*****************************************************************************
LRESULT CMainFrame::OnHideWnd(WPARAM wParam,LPARAM lParam)
{
	TaskbarHide(m_hWnd);
	SetTimer(WM_HIDEWND,300,NULL);

return 0;
}

//*****************************************************************************
//*
//*		OnSetBreak
//*
//*****************************************************************************
LRESULT CMainFrame::OnSetBreak(WPARAM wParam,LPARAM lParam)
{

	m_sSemaphore.Lock();
	m_pProgress	= (CProgressDialog*)lParam; 
	m_sSemaphore.Unlock();


return 0;
}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CMainFrame::OnTimer(UINT_PTR nIdEvent)
{

	if(nIdEvent!=WM_HIDEWND)
		{
		CFrameWnd::OnTimer(nIdEvent);
		return;
		}

	if(CBackupView::MessageBoxOn())return;
	
	SetWindowPos(&CWnd::wndBottom,-100,-100,90,90,SWP_NOACTIVATE|SWP_NOCOPYBITS);
	TaskbarHide(m_hWnd);
	ShowWindow(SW_HIDE);

}

//*****************************************************************************
//*
//*		OnClose
//*
//*****************************************************************************
void CMainFrame::OnClose()
{

	m_sSemaphore.Lock();
	if(m_pProgress)m_pProgress->Stop();
	m_sSemaphore.Unlock();

	CFrameWnd::OnClose();

}
