//*****************************************************************************
//*
//*
//*		ProgressDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************

#include	"StdAfx.h"
#include	"Resource.h"
#include	"ProgressDlg.h"


#ifdef		   _DEBUG
#define new		DEBUG_NEW
#undef			THIS_FILE
static char		THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CProgressDialog, CDialog)
	//{{AFX_MSG_MAP(CProgressDialog)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#define 	ID_SETPOS		0xFF00
#define 	ID_SETRANGE		0xFF01
#define 	ID_SETTITEL		0xFF02
#define 	ID_SETTEXT		0xFF03
#define 	ID_MESSAGE		0xFF04
#define 	ID_ENDDLG		0xFF05
#define 	ID_UPDATE		0xFF06
#define 	ID_TIMEPROC		0xFF07
#define 	ID_TIMEUPDATE	0xFF08

int	CProgressDialog::text_id[CPD_TEXT_COUNT+1]=			// Text-Felder ID's
				{
				IDC_TEXT1,
				IDC_TEXT2,
				IDC_TEXT3,
				0
				};


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CProgressDialog::CProgressDialog(CWnd *pParent) : CDialog(CProgressDialog::IDD,pParent)
{
	//{{AFX_DATA_INIT(CProgressDialog)
	//}}AFX_DATA_INIT

	run			= 0;
	pos			= 0;
	proc		= 0;
	shift		= 0;
	proc_param1 = 0;
	proc_param2 = 0;
	proc_param3 = 0;
	proc_param4 = 0;
	proc_param5 = 0;
	proc_breakp = 0;
	proc_timep  = 0;
	proc_timev  = 0;
	proc_break  = 0;
	proc_time   = 0;
	proc_exit   =-1;
	thread		= 0;
	range		= 100;

	memset(flag	,0,sizeof(flag ));
	memset(tick	,0,sizeof(tick ));
	memset(text ,0,sizeof(text ));
	memset(title,0,sizeof(title));

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CProgressDialog::~CProgressDialog()
{
	mb_semaphore.Unlock();
	while(run)Sleep(100);
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CProgressDialog::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgressDialog)
	//}}AFX_DATA_MAP
}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CProgressDialog::OnInitDialog()
{
HFONT	font;
CRect	rect;
CWnd   *wnd;	
int		x;

	CDialog::OnInitDialog();


	wnd = GetDlgItem(IDC_TEXT1);
	wnd->GetClientRect(&rect);
	width=rect.Width();
	
	font = (HFONT)wnd->SendMessage(WM_GETFONT,0,0);
	if(font)GetCharWidths(sizes,font);
	else	GetCharWidths(sizes);

	if(*title)SetWindowText(title);
	for(x=0;text_id[x];x++)
		{
		SetDlgItemText(text_id[x],text+CPD_TEXT_MAX*x);
		}


	pos  = 0;
	exit = 0;

	progress=(CProgressCtrl*)GetDlgItem(IDC_PROGRESS1);
	progress->SetRange(0,range);
	progress->SetPos(0);

	thread=AfxBeginThread(ThreadProc,this);

	if(proc_timev && proc_time)
		{
		SetTimer(ID_TIMEPROC,proc_timev,NULL);
		}

	SetTimer(ID_UPDATE,200,NULL);


return TRUE;
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CProgressDialog::OnCancel()
{

	if(!exit && proc_break)
		{
		proc_break(proc_breakp);
		}

	exit=1;

	GetDlgItem(IDCANCEL)->EnableWindow(FALSE);

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
//	Dummy Funktion
void CProgressDialog::OnOK()
{
}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CProgressDialog::OnTimer(UINT_PTR uEvent)
{
int		pos;

	if(uEvent==ID_TIMEPROC)
		{
		if(proc_time)proc_time(this,proc_timep);
		return;
		}

	if(uEvent==ID_UPDATE)
		{
		for(pos=0;pos<CPD_TEXT_COUNT;pos++)
			{
			if(!flag[pos])continue;
			flag[pos] = 0;
			tick[pos] = GetTickCount();
			SetDlgItemText(text_id[pos],text+CPD_TEXT_MAX*pos);
			}
		}

	CDialog::OnTimer(uEvent);

}

//*****************************************************************************
//*
//*		SetText
//*
//*****************************************************************************
void CProgressDialog::SetText(const char *Str,const char *Text,int Nr,int Compress,int NameLen,int Suffix)
{
char    tmp[1024];
char    txt[1024];
char   *out;
char   *end;
UINT	now;
UINT	dif;
int		off;
int		len;


	ASSERT(Nr>=0 && Nr<=CPD_TEXT_COUNT);

	out = text+CPD_TEXT_MAX*Nr;

	if(Compress>=0)
		{
		if(Str)
			{
			len=strlcpy(tmp,Str,sizeof(tmp));
			strlcpy(tmp+len,Text,sizeof(tmp)-len);
			Text=tmp;
			}

		end = (Suffix>0)? (char*)Text+Compress+NameLen:0;
		off = strlcpy(out,Text,CPD_TEXT_MAX,Compress);
		strlcpy(txt,Text+off,sizeof(txt),(NameLen>=0)? NameLen:strlen(Text+off));
		CommpressFileName(txt,out+off,CPD_TEXT_MAX-off,width-4,sizes,2,out,end);
		if(end)strlcat(out,end,CPD_TEXT_MAX);
		}
	else{
		len = (!Str)? 0:strlcpy(out,Str,CPD_TEXT_MAX);
		strlcpy(out+len,Text,CPD_TEXT_MAX-len);
		}

	now		 = GetTickCount();
	dif		 = now-tick[Nr];
	tick[Nr] = now;
	
	if(dif<100)
		{
		flag[Nr] = 1;
		return;
		}

	if(!IsWindow(m_hWnd))return;
	
	if(!PostMessage(WM_COMMAND,ID_SETTEXT,Nr))
		{
		flag[Nr] = 1;
		}

}

//*****************************************************************************
//*
//*		SetTitle
//*
//*****************************************************************************
void CProgressDialog::SetTitle(const char *Title)
{
	if(!Title)Title="";
	strlcpy(title,Title,sizeof(title));

	if(!IsWindow(m_hWnd))return;

	PostMessage(WM_COMMAND,ID_SETTITEL);
}

//*****************************************************************************
//*
//*		SetRange
//*
//*****************************************************************************
void CProgressDialog::SetRange(__int64 Range)
{

	if(Range<1)Range=1;
	if(Range>1024)Range+=Range/256;

	for(shift=0;shift<32;shift+=2)
		{
		if(Range<=0x7FFF)break;
		Range >>= 2;
		}

	if(range==(int)(Range))
		{
		return;
		}

	range = (int)(Range);

	if(!IsWindow(		   m_hWnd))return;
	if(!IsWindow(progress->m_hWnd))return;
	progress->PostMessage(PBM_SETRANGE,0,MAKELPARAM(0,range));
}

//*****************************************************************************
//*
//*		SetPos
//*
//*****************************************************************************
void CProgressDialog::SetPos(__int64 Pos)
{

	Pos >>= shift;
    pos   = (int)Pos;

	if(pos>range)
		{
		pos=range;
		}

	if(!IsWindow(          m_hWnd))return;
	if(!IsWindow(progress->m_hWnd))return;
	PostMessage(WM_COMMAND,ID_SETPOS,1);
}

//*****************************************************************************
//*
//*		SetPos
//*
//*****************************************************************************
void CProgressDialog::SetPos()
{
	   pos++;
	if(pos>range)pos=range;
	if(!IsWindow(m_hWnd))return;
	PostMessage(WM_COMMAND,ID_SETPOS,1);
}

//*****************************************************************************
//*
//*		Stop
//*
//*****************************************************************************
void CProgressDialog::Stop()
{
	exit=1;
	if(!IsWindow(m_hWnd))return;
	PostMessage(WM_COMMAND,IDCANCEL);
}


//*****************************************************************************
//*
//*		OnCommand
//*
//*****************************************************************************
BOOL CProgressDialog::OnCommand(WPARAM wParam, LPARAM lParam)
{

	if(wParam==ID_SETRANGE)
		{
		progress->SetRange(0,range);
		return TRUE;
		}

	if(wParam==ID_SETPOS)
		{
		progress->SetPos(pos);
		return TRUE;
		}

	if(wParam==ID_SETTITEL)
		{
		SetWindowText(title);
		return TRUE;
		}

	if(wParam==ID_SETTEXT)
		{
		SetDlgItemText(text_id[lParam],text+CPD_TEXT_MAX*lParam);
		tick[lParam] = GetTickCount();
		flag[lParam] = 0;
		return TRUE;
		}

	if(wParam==ID_TIMEUPDATE)
		{
		if(proc_timev && proc_time)
			{
			SetTimer(ID_TIMEPROC,proc_timev,NULL);
			}
		else{
			KillTimer(ID_TIMEPROC);
			}

		return TRUE;
		}

	if(wParam==ID_MESSAGE)
		{
		mb_retval=CDialog::MessageBox(mb_text,mb_titel,mb_type);
		mb_semaphore.Unlock();
		return TRUE;
		}

	if(wParam==ID_ENDDLG)
		{
		EndDialog((exit)? IDCANCEL:IDOK);
		return TRUE;
		}

return CDialog::OnCommand(wParam, lParam);
}


//*****************************************************************************
//*
//*		ThreadProc
//*
//*****************************************************************************
UINT CProgressDialog::ThreadProc(void *Param)
{
CProgressDialog	*dlg;

	   dlg=(CProgressDialog*)Param;
	   dlg->proc_exit=-1;
	   dlg->run=1;
	if(dlg->proc)
	   dlg->proc_exit=dlg->proc(dlg);
	   dlg->run=0;
	   dlg->thread=0;

	if(IsWindow(dlg->m_hWnd))dlg->PostMessage(WM_COMMAND,ID_ENDDLG);
	else 		dlg->run=0;

return 0;
}


//*****************************************************************************
//*
//*		SetProc
//*
//*****************************************************************************
void CProgressDialog::SetProc(int (_cdecl *Proc)(CProgressDialog *),const void *Param1,const void *Param2,const void  *Param3,const void  *Param4,const void  *Param5)
{
	proc_param5=(void *)Param5;
	proc_param4=(void *)Param4;
	proc_param3=(void *)Param3;
	proc_param2=(void *)Param2;
	proc_param1=(void *)Param1;
	proc=Proc;
}

//*****************************************************************************
//*
//*		SetBreak
//*
//*****************************************************************************
//	Setzt eine Prozetur die aufgerufen wird wenn CANCEL gedrckt wird
void CProgressDialog::SetBreak(void (_cdecl Proc)(void*),void *Param)
{
	proc_breakp = Param;
	proc_break  = Proc;
}

//*****************************************************************************
//*
//*		SetTime
//*
//*****************************************************************************
//	Setzt eine Prozetur die zyklisch aufgerufen wird. Time ist die Zykluszeit (0=aus)
void CProgressDialog::SetTime(void (_cdecl Proc)(CProgressDialog*,void*),unsigned Time,void *Param)
{

	proc_timep = Param;
	proc_timev = Time;
	proc_time  = Proc;

	if(IsWindow(m_hWnd))
		{
		PostMessage(WM_COMMAND,ID_TIMEUPDATE,0);
		}

}


//*****************************************************************************
//*
//*		MessageBox
//*
//*****************************************************************************
int CProgressDialog::MessageBox(LPCTSTR Text, LPCTSTR Titel,UINT Type)
{

	mb_text  = Text;
	mb_titel = Titel;
	mb_type  = Type;

	PostMessage(WM_COMMAND,ID_MESSAGE);
	mb_semaphore.Lock();

return mb_retval;
}
