//*****************************************************************************
//*
//*
//*		ProgressDlg.h : Header-Datei
//*
//*
//*****************************************************************************
//
//	Funftionen
//
//		void SetProc(int (_cdecl*)(CProgressDialog *),...)		Parameter setzen
//		void Stop()											Dialog abbrechen
//		void SetTitle(const char *Title=0)					berschrift setzen
//		void SetRange(int Range)							Schritte bei Prozenleiste einstellen
//		void SetPos(int Pos)								Aktuelle Position setzen
//		void SetPos()										Auf Nchste Position
//		void SetText(const char *Text,int Nr=0)				Einen Text setzen
//		BOOL IsBreak()										Gab es einen Abbruch
//		int  GetExitCode()									Rckgabewert abfragen
//		int  MessageBox(LPCTSTR Text, LPCTSTR Titel=0,UINT Type = MB_OK );
//
#ifndef AFX_PROGRESS_H__A4576578_3BE9_11D4_A6FB_F7F2B463262B__INCLUDED_
#define AFX_PROGRESS_H__A4576578_3BE9_11D4_A6FB_F7F2B463262B__INCLUDED_

#include	"SemaphoreEx.h"

#define 	CPD_TEXT_MAX	256
#define 	CPD_TEXT_COUNT	4

class		CProgressDialog;

typedef void (_cdecl *ProgresFuncVD)(CProgressDialog *,void *);
typedef void (_cdecl *ProgresFuncV )(CProgressDialog *);
typedef void (_cdecl *ProgresFuncVV)(void *);
typedef void (_cdecl *ProgresFuncVN)();

//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class CProgressDialog : public CDialog
{
public:

	void SetTitle(const char *Title=0);
	void SetProc(int (_cdecl *Proc)(CProgressDialog *),const void *Param1=0,const void *Param2=0,const void  *Param3=0,const void  *Param4=0,const void  *Param5=0);
	void Stop();
	void SetRange(__int64 Range);
	void SetPos  (__int64 Pos);
	void SetPos();
	void SetText(                const char *Text,int Nr=0,int Compress=-1,int NameLen=-1,int Suffix=-1);
	void SetText(const char *Str,const char *Text,int Nr=0,int Compress=-1,int NameLen=-1,int Suffix=-1);
	int  MessageBox(LPCTSTR Text, LPCTSTR Titel=0,UINT Type = MB_OK );
	void SetTime (ProgresFuncVD Proc,unsigned Time,void *Param);
	void SetBreak(ProgresFuncVV Proc,void *Param);
	void SetBreak(ProgresFuncVN Proc);
	void SetBreak(ProgresFuncV  Proc);
	void SetBreak();
	void SetTime ();

	BOOL IsBreak();
	int  GetExitCode();
	BOOL*GetCancelPtr();

	 CProgressDialog(CWnd *pParent = NULL);   // Standardkonstruktor
	~CProgressDialog();

	//{{AFX_DATA(CProgressDialog)
	enum { IDD = IDD_PROGRESSDLG };
	//}}AFX_DATA

	void  *proc_param1;
	void  *proc_param2;
	void  *proc_param3;
	void  *proc_param4;
	void  *proc_param5;
	void  *proc_breakp;
	void  *proc_timep;
	UINT   proc_timev;

	//{{AFX_VIRTUAL(CProgressDialog)
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);    // DDX/DDV-Untersttzung
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTimer(UINT_PTR uEvent);
	//}}AFX_VIRTUAL


protected:

	static UINT _cdecl ThreadProc(void *Param);
	static int		 text_id[];			// ID's der Text Felder

	int    			 exit;				// Gab es einen Abbruch
	int    			 pos;				// Verlaufts Position
	int	   			 range;				// Verlaufts maximal Position
	int				 proc_exit;			// Return Wert der Thread-Funktion

	char			 title[CPD_TEXT_MAX];
	char			 text [CPD_TEXT_COUNT*CPD_TEXT_MAX];
	char			 flag [CPD_TEXT_COUNT];
	unsigned		 tick [CPD_TEXT_COUNT];
	CWinThread      *thread;
	CProgressCtrl	*progress;
	int				 run;
	BYTE			 sizes[256];
	int				 width;
	int				 shift;

	LPCSTR			 mb_text;			// MessegeBox Daten
	LPCSTR			 mb_titel;
	UINT			 mb_type;
	UINT			 mb_retval;
	CSemaphoreNull	 mb_semaphore;

	void (_cdecl *proc_time )(CProgressDialog *,void *);
	int  (_cdecl *proc      )(CProgressDialog *);
	void (_cdecl *proc_break)(void *);

	//{{AFX_MSG(CProgressDialog)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline BOOL CProgressDialog::IsBreak()     {return  exit;}
inline BOOL*CProgressDialog::GetCancelPtr(){return &exit;}
inline int  CProgressDialog::GetExitCode (){return  proc_exit;}
inline void CProgressDialog::SetText(const char *Text,int Nr,int Compress,int NameLen,int Suffix){SetText(0,Text,Nr,Compress,NameLen,Suffix);}
inline void CProgressDialog::SetTime (                  ){SetTime ((ProgresFuncVD)NULL,0,NULL);}
inline void CProgressDialog::SetBreak(ProgresFuncVN Proc){SetBreak((ProgresFuncVV)Proc  ,NULL);}
inline void CProgressDialog::SetBreak(ProgresFuncV  Proc){SetBreak((ProgresFuncVV)Proc  ,this);}
inline void CProgressDialog::SetBreak(                  ){SetBreak((ProgresFuncVV)NULL  ,NULL);}


//{{AFX_INSERT_LOCATION}}


#endif
