//*****************************************************************************
//*
//*
//*		RegWnd.cpp
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include "Resource.h"
#include "RegWnd.h"



#ifdef     _DEBUG
#define new DEBUG_NEW
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define 	GETVAL(c,n,i)	(((int*)c.Data(n))[i])

//*****************************************************************************
//*
//*		Nachrichten Verarbeitung
//*
//*****************************************************************************

BEGIN_MESSAGE_MAP(CRegWnd, CTreeWnd)
	//{{AFX_MSG_MAP(CRegWnd)
	//}}AFX_MSG_MAP

END_MESSAGE_MAP()

//*****************************************************************************
//*
//*		Statische Variableln
//*
//*****************************************************************************

HKEY	CRegWnd::m_aRootKey[]=
			{
			HKEY_CLASSES_ROOT,
			HKEY_CURRENT_USER,
			HKEY_LOCAL_MACHINE,
			HKEY_USERS,
			HKEY_CURRENT_CONFIG,
			HKEY_DYN_DATA,
			0,0
			};

INT		CRegWnd::m_aRootLen[]={17,17,18,10,19,13,0,0};
LPCTSTR	CRegWnd::m_aRootTxt[]=
			{
			_T("HKEY_CLASSES_ROOT"),
			_T("HKEY_CURRENT_USER"),
			_T("HKEY_LOCAL_MACHINE"),
			_T("HKEY_USERS"),
			_T("HKEY_CURRENT_CONFIG"),
			_T("HKEY_DYN_DATA"),
			_T(""),
			_T("")
			};

//*****************************************************************************
//*
//*		Konstruktor ... Grundeinstellung der Variabeln
//*
//*****************************************************************************
CRegWnd::CRegWnd()
{

	m_cImgList.Create(MAKEINTRESOURCE(IDB_ICONSREG), 16, 6, RGB(255,0,0));
	m_pImgListN = &m_cImgList;
	m_pImgListS = &m_cImgList;
	m_pImgTreeS = &m_cImgList;

	#ifdef _DEBUG
	if(!m_cImgList.m_hImageList){MessageBox(_T("IDB_ICONSREG Bitmap Resourse fehlt"));ASSERT(0);}
	#endif

	m_iSeparator *= GetSystemMetrics(SM_CXICON);
	m_iSeparator /= 32;

}

//*****************************************************************************
//*
//*		Destruktor ...
//*
//*****************************************************************************
CRegWnd::~CRegWnd()
{
}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
//	Erzeugen eines Fensters
BOOL CRegWnd::Create(LPCTSTR pClassName,LPCTSTR pWindowName,DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID,CCreateContext *pContext)
{

	dwStyle |=   TWS_NOSUBDIR;
	dwStyle &= ~(TWS_RENAME|TWS_NOLISTICONS|TWS_NOTREEICONS|TWS_NOLISTVIEW|TWS_NOTREEVIEW);

return CTreeWnd::Create(pClassName,pWindowName,dwStyle,sRect,pParent,nID,pContext);
}

BOOL CRegWnd::Create(DWORD dwStyle,const RECT& sRect, CWnd* pParent, UINT nID, CCreateContext* pContext)
{
	
	dwStyle |= WS_VISIBLE|WS_CHILD;

return Create(NULL,_T("RegWnd"),dwStyle,sRect,pParent,nID,pContext);
}


//*****************************************************************************
//*
//*		CheckPath
//*
//*****************************************************************************
//	Prft ob ein Pfad existiert.
//	pPath		: Zeiger auf den Puffer mit dem Pfad. [TWS_MAX_NAME]
//	iLen		: Ist die Lnge des Pfades (-1 mit strlen() holen)
//	iLevel		: Sind die Level 
//	Ergibt die neue Lnge vom Pfad oder 0 wenn der Pfad nicht existiert
int	CRegWnd::CheckPath(LPTSTR pPath,int iLen,int &iLevel)
{
CStringChain	sEntries;
LPCTSTR			pRoot;
int				iSet;
int				iDel;
int				iNum;
int				iPos;


	if(iLen <0)iLen=_tcslen(pPath);
	
	if(iLen==0)
		{
		iLevel = -1;
		return 0;
		}

	iSet = 0;

	if(iLen>=4 && (pPath[4]=='\\' || pPath[4]==0))		// Pfade tauschen
		{
		if(!_tcsnicmp(pPath,_T("HKCR"),4))
			{
			pRoot = _T("HKEY_CLASSES_ROOT");
			iSet  = 17;
			}
		else if(!_tcsnicmp(pPath,_T("HKCU"),4))
			{
			pRoot = _T("HKEY_CURRENT_USER");
			iSet  = 17;
			}
		else if(!_tcsnicmp(pPath,_T("HKLM"),4))
			{
			pRoot = _T("HKEY_LOCAL_MACHINE");
			iSet  = 18;
			}
		else if(!_tcsnicmp(pPath,_T("HKCC"),4))
			{
			pRoot = _T("HKEY_CURRENT_CONFIG");
			iSet  = 19;
			}
		else{
			iLevel = -1;
			return 0;
			}
		
		iDel = 4;
		}
	else if(iLen>=12 && (pPath[0]=='C' || pPath[0]=='c') && !_tcsnicmp(pPath,_T("CLASSES_ROOT"),12))
		{
		pRoot = _T("HKEY_CLASSES_ROOT");
		iSet  = 17;
		iDel  = 12;
		}
	else if(iLen>=12 && (pPath[0]=='C' || pPath[0]=='c') && !_tcsnicmp(pPath,_T("CURRENT_USER"),12))
		{
		pRoot = _T("HKEY_CURRENT_USER");
		iSet  = 17;
		iDel  = 12;
		}
	else if(iLen>=7 && (pPath[0]=='M' || pPath[0]=='m') && !_tcsnicmp(pPath,_T("MACHINE"),7))
		{
		pRoot = _T("HKEY_LOCAL_MACHINE");
		iSet  = 18;
		iDel  = 7;
		}
	else if(iLen>=5 && (pPath[0]=='U' || pPath[0]=='u') && !_tcsnicmp(pPath,_T("USERS"),5))
		{
		pRoot = _T("HKEY_USERS");
		iSet  = 10;
		iDel  = 5;
		}
	else if(iLen>=6 && (pPath[0]=='C' || pPath[0]=='c') && !_tcsnicmp(pPath,_T("CONFIG"),6))
		{
		pRoot = _T("HKEY_CURRENT_CONFIG");
		iSet  = 19;
		iDel  = 6;
		}


	if(iSet)											// Suffix ndern
		{
		memmove(pPath+iSet,pPath+iDel,(iLen-iDel-1)*sizeof(TCHAR));
		memcpy (pPath     ,pRoot     ,(iSet       )*sizeof(TCHAR));

		iLen += iSet-iDel;
		}


	for(iPos=0;;iPos++)									// Welcher ROOT-Pfad ist es	
		{
		if(iPos>=8)
			{
			iLevel = -1;
			return 0;
			}

			iNum = m_aRootLen[iPos];
		if(!iNum)continue;

		if(iLen<iNum || (pPath[iNum]!='\\' && pPath[iNum]!=0))
			{
			continue;
			}

		if(!_tcsnicmp(pPath,m_aRootTxt[iPos],iNum))
			{
			break;
			}
		}	


	iLevel  = GetLevel(pPath,iLen)&0xF80000FF;
	iLevel |= iPos<<16;


return iLen;
}


//*****************************************************************************
//*
//*		ReadRoot
//*
//*****************************************************************************
//	Einlesen aller Root-Elemente in Tree-Fenster. 
//	pEntries		: String-Kette in der die Elemente gspeichert werden.
//					  Im Textbereich muss der der Name stehen
//				      Im Datenbereich wird die Icon-Nummer angegeben
//	Ergibt die Anzahl der gefundenen Eintrge.
int CRegWnd::ReadRoot(CStringChain *pEntries)
{
int		aData[]={5,5,5,2};
int		iPos;


	for(iPos=0;iPos<6;iPos++)
		{
		pEntries->Add(m_aRootTxt[iPos],iPos,aData);
		}


return iPos;
}

//*****************************************************************************
//*
//*		ReadDirs
//*
//*****************************************************************************
//	Einlesen aller Elemente eines Unterordners ins Tree-Fenster. 
//	pEntries		: String-Kette in der die Elemente gspeichert werden.
//					  Im Textbereich muss der der Name stehen
//					  Im Datenbereich CTW_ICON_S/CTW_ICON_N wird die Icon-Nummer angegeben
//					  Im Datenbereich CTW_ICON_A wird die Anzahl der Unter Gruppen
//					  Im Datenbereich CTW_IS_DIR wird auf 1 gesetzt
//					  Wenn pEntries==0 nur prfen ob Verzeichnisse vorhanden sind.
//	pPath			: Ist der Pfad des Unterordners.
//	iLevel			: Ist die Ebene des Unterordners.
//	Ergibt die Anzahl der gefundenen Eintrge.
int CRegWnd::ReadDirs(CStringChain *pEntries,LPCTSTR pPath,int iLevel)
{
INT			aData[]={3,3,-1,1};
LPCTSTR		pName;
HKEY		hKey;
CRegKeys	sKey;
int			iLen;
int			iCnt;
int			iNum;
int			iPos;


	iNum   = (iLevel>>16)&0x7;
	hKey   = m_aRootKey[iNum];
	pPath += m_aRootLen[iNum]+1;

	if(!hKey)return 0;

	if(!sKey.Open(hKey,pPath,CRK_READ))
		{
		return 0;
		}

	iCnt = sKey.KeyCount();
	
	if(!pEntries)return iCnt;

	for(iPos=0;iPos<iCnt;iPos++)
		{
		   pName=sKey.KeySubName(&iLen,iPos);
		if(pName)pEntries->Add(iLen,pName,-1,aData);
		}


return pEntries->Count();
}

//*****************************************************************************
//*
//*		ReadFiles
//*
//*****************************************************************************
//	Einlesen aller Elemente eines Ordners ins Listenfenster (nur Dateien ohne Ordner). 
//	pEntries		: String-Kette in der die Elemente gspeichert werden.
//					  Im Textbereich muss der der Name stehen
//					  Im Datenbereich CTW_ICON_S/CTW_ICON_N wird die Icon-Nummer angegeben
//					  Im Datenbereich CTW_ICON_A wird die Anzahl der Unter Gruppen
//					  Im Datenbereich CTW_IS_DIR wird auf 1 gesetzt
//	pPath			: Ist der Pfad des Unterordners.
//	iLevel			: Ist die Ebene des Unterordners.
//	Ergibt die Anzahl der gefundenen Eintrge.
int CRegWnd::ReadFiles(CStringChain *pEntries,LPCTSTR pPath,int iLevel)
{
INT			aData[]={2,2,0,0};
TCHAR		cText[512];
bool		bOk,bStdKey=0;
DWORD		dwType;
LPCTSTR		pName;
HKEY		hKey;
CRegKeys	sKey;
int			iLen;
int			iCnt;
int			iNum;
int			iPos;


	iNum   = m_iRootLevel&0x7;
	hKey   = m_aRootKey[iNum];
	pPath += m_aRootLen[iNum]+1;

	if(!sKey.Open(hKey,pPath,CRK_READ))
		{
		return 0;
		}

	bOk		= sKey.Get(&cText,0,0);
	dwType	= sKey.Type();

	if(!bOk)dwType=REG_SZ;

	if(dwType==REG_SZ || dwType==REG_MULTI_SZ)
		{
		aData[0] = 1;
		aData[1] = 1;
		aData[2] = 1;
		}
	else if(dwType==REG_DWORD || dwType==REG_QWORD)
		{
		aData[0] = 2;
		aData[1] = 2;
		aData[2] = 2;
		}


	iCnt = sKey.ValueCount();

	for(iPos=0;iPos<iCnt;iPos++)
		{
			pName=sKey.ValueName(&iLen,iPos);
		if(!pName || !*pName)
			{
			bOk     = sKey.Get(&cText,0,pName);
			pName   = _T("(Standard)");
			iLen    = 10;
			bStdKey = 1;
			}
		else{
			bOk = 1;
			}		  

		dwType = sKey.Type();
							
		if(!bOk)dwType=REG_SZ;	{aData[0]=0;aData[1]=0;aData[2]=0;}
		if(dwType==REG_MULTI_SZ){aData[0]=1;aData[1]=1;aData[2]=1;}
		if(dwType==REG_SZ      ){aData[0]=1;aData[1]=1;aData[2]=1;}
		if(dwType==REG_DWORD   ){aData[0]=2;aData[1]=2;aData[2]=2;}
		if(dwType==REG_QWORD   ){aData[0]=2;aData[1]=2;aData[2]=2;}
		
		pEntries->Add(iLen,pName,-1,aData);
		}

	if(!bStdKey)
		{
		aData[0] = 0;
		aData[1] = 0;
		aData[2] = 0;

		pEntries->Add(_T("(Standard)"),0,aData);
		}


return pEntries->Count();
}

//*****************************************************************************
//*
//*		InsertColumn
//*
//*****************************************************************************
//	Fgt die Spalten in das Listenfenster ein.
//	Ergibt die Anzahl der Spalten.
int CRegWnd::InsertColumn()
{
int		iSize;
	

	iSize = GetSystemMetrics(SM_CXICON);

	m_cListView.InsertColumn(0,_T("Name" ),LVCFMT_LEFT,(150*iSize)/32);
	m_cListView.InsertColumn(1,_T("Typ"  ),LVCFMT_LEFT,(130*iSize)/32);
	m_cListView.InsertColumn(2,_T("Daten"),LVCFMT_LEFT,500);


return 2;
}

//*****************************************************************************
//*
//*		GetIcon
//*
//*****************************************************************************
//	Das Inon zu einem Unterordner abfragen
//	pPath		: Pfad des Unterordners
//	pBuffer		: Textpuffer (unbenutzt)
//	iLevel		: Ist die Ebene im Tree-Fenster (0=Root-Ebene)
//	iMode		: Welches Icon soll abgefragt werden (CTW_ICON_S=normal CTW_ICON_O=Open)
//	Ergibt die Icon-Nummer.
int	CRegWnd::GetIcon(LPCTSTR pPath,LPTSTR pBuffer,int iLevel,int iMode)
{

	if(!iLevel)return 5;

return (iMode==CTW_ICON_O)? 4:3;
}

//*****************************************************************************
//*
//*		InsertItem
//*
//*****************************************************************************
int	CRegWnd::InsertItem(int  iItem)
{
TCHAR		cData[270];
TCHAR		cText[270];
LPVOID		pData;
LPCTSTR		pInfo;
LPCTSTR		pType;
LPCTSTR		pName;
LPCTSTR		pPath;
DWORD		dwType;
HKEY		hKey;
CRegKeys	sKey;
int			iPos;
int			iOff;
int			iNum;
int			iLen;
bool		bOk;


	if(iItem<0 || iItem>=m_iCount)
		{
		return 0;
		}

	pPath  = m_pPath;
	iNum   = m_iRootLevel&0x7;
	pPath += m_aRootLen[iNum]+1;
	hKey   = m_aRootKey[iNum];

	if(!hKey || !sKey.Open(hKey,pPath,CRK_READ))
		{
		return 0;
		}

	pName = m_sFiles.Get(iItem);

	if(*pName=='(' && !_tcscmp(pName,_T("(Standard)")))
		{
		pName = NULL;
		}

		bOk = sKey.Get(cData,260,pName);
	if(!bOk)										// Konnten die Daten geholt werden
		{
		if(sKey.Error()==ERROR_MORE_DATA)
			{
			   bOk=sKey.Get(&pData,pName);
			if(bOk)									
				{
				iLen = sizeof(cData);
				memcpy(cData,pData,iLen);			// Nur die ersten Byte bernehmen
				delete pData;
				}
			}
		
		if(!bOk)									// Konnte der Wert nicht geholt werden
			{
			pInfo = (pName)? _T("(Fehler beim Lesen)"):_T("(Wert nicht festgelegt)");
			pType = (pName)? _T("\?\?\?")             :_T("REG_SZ");
			
			m_cListView.SetItemText(iItem,1,pType);
			m_cListView.SetItemText(iItem,2,pInfo);

			return 0;
			}
		}

	dwType	= sKey.Type();
	iLen	= sKey.Len();
	
	if(!bOk)dwType=REG_SZ;							// Text fr Daten erstellen

	switch(dwType)		
		{
	case REG_MULTI_SZ:	if(iLen>=sizeof(TCHAR) && cData[iLen/sizeof(TCHAR)-1])
							{
							iLen -= sizeof(TCHAR);
							}

	case REG_SZ:		iLen /= sizeof(TCHAR);

						if(iLen<=1)
							{
							strlcpy(cText,_T("(Wert nicht gesetzt)"),64);
							break;		
							}
						
						iOff	 = 1;
						cText[0] = '\"';

						for(iPos=0;iPos<iLen;iPos++)
							{
							if(iOff>250)
								{
								strlcpy(cText+iOff,_T(" ..."),5,4);
								iOff += 4;
								break;
								}

							if(cData[iPos])
								{
								cText[iOff] = cData[iPos];
								iOff++;
								continue;
								}

							cText[iOff] = '\"';
							iOff += 1;

							if(iPos+1>=iLen)break;
							
							strlcpy(cText+iOff,_T("   \""),5,4);
							iOff += 4;
							}
						
						cText[iOff]=0;
						
						break;
	
	case REG_DWORD:		cText[ 0] = '0';
						cText[ 1] = 'x';
						cText[10] = ' ';
						cText[11] = '/';
						cText[12] = ' ';
						
						htostr(       cData,cText+ 2,4,HEX_INVERT);
						itostr(*(int*)cData,cText+13,0);
						
						break;
	
	case REG_QWORD:		cText[ 0] = '0';
						cText[ 1] = 'x';
						cText[18] = ' ';
						cText[19] = '/';
						cText[20] = ' ';
						
						htostr(           cData,cText+ 2,8,HEX_INVERT);
						qtostr(*(__int64*)cData,cText+21,10);
						
						break;
	
	default:			iPos = iLen;if(iPos>75)iPos=75;
						iOff = htostr(cData,cText,iPos);

						if(iLen<=75)break;
						strlcpy(cText+iOff,_T("..."),4,3);

						break;
		}



	switch(dwType)
		{
	case REG_NONE:							pType=_T("REG_NONE");						break;
	case REG_SZ:							pType=_T("REG_SZ");							break;
	case REG_EXPAND_SZ:						pType=_T("REG_EXPAND_SZ");					break;
	case REG_BINARY:						pType=_T("REG_BINARY");						break;
	case REG_DWORD:							pType=_T("REG_DWORD");						break;
	case REG_DWORD_BIG_ENDIAN:				pType=_T("REG_DWORD_BIG_ENDIAN");			break;
	case REG_LINK:							pType=_T("REG_LINK");						break;
	case REG_MULTI_SZ:						pType=_T("REG_LINK");						break;
	case REG_RESOURCE_LIST:					pType=_T("REG_RESOURCE_LIST");				break;
	case REG_FULL_RESOURCE_DESCRIPTOR:		pType=_T("REG_FULL_RESOURCE_DESCRIPTOR");	break;
	case REG_RESOURCE_REQUIREMENTS_LIST:	pType=_T("REG_RESOURCE_REQUIREMENTS_LIST");	break;
	case REG_QWORD:							pType=_T("REG_QWORD");						break;		
	default:								pType=_T("\?\?\?");							break;
		}
	
	m_cListView.SetItemText(iItem,1,pType);
	m_cListView.SetItemText(iItem,2,cText);


return 1;
}


//*****************************************************************************
//*
//*		Rname / DoRename
//*
//*****************************************************************************
int	CRegWnd::Rename  (LPCTSTR pPath,LPTSTR pBuffer,int iLevel){return 0;}
int	CRegWnd::DoRename(LPCTSTR pPath,LPTSTR pBuffer,int iLevel){return 0;}


//*****************************************************************************
//*
//*		DoDelete
//*
//*****************************************************************************
int	CRegWnd::DoDelete (LPCTSTR pPath,LPTSTR pBuffer,int iLevel)
{
TCHAR		cText[TWS_MAX_NAME+512];
LPCTSTR		pName;
CRegKeys	sKey;
HKEY		hKey;
int			iNum;
int			iLen;
bool		bOk;


	iNum   = m_iRootLevel&0x7;
	hKey   = m_aRootKey[iNum];
	pPath += m_aRootLen[iNum]+1;

	iLen   = strlcpy(cText,(iLevel&0x800)? _T("Registry Eintrag \n"):_T("Registry Key \n"),256);
	iLen  += strlcpy(cText+iLen,pPath				  ,TWS_MAX_NAME+512-iLen);
	iLen  += strlcpy(cText+iLen,"\nwirklich lschen ?",TWS_MAX_NAME+512-iLen);

	if(MessageBox(cText,0,MB_ICONQUESTION|MB_OKCANCEL)!=IDOK)
		{
		return 0;
		}


	iLen = strlcpy(cText,pPath,sizeof(cText));

	if(iLen && cText[iLen]=='\\')						
		{
		iLen--;
		}

	for(;iLen>=0;iLen--)
		{
		if(cText[iLen]=='\\')break;
		}

	if(iLen<0)
		{
		return 0;
		}

	cText[iLen]=0;

	if(!sKey.Open(hKey,cText,CRK_CREATE))
		{
		return 0;
		}

	if(iLevel&0x800)
		{ 
		pName = pBuffer;
		
		if(*pName=='(' && !_tcscmp(pName,_T("(Standard)")))
			{
			pName = 0;
			}
		
		bOk = sKey.Del(pName);	  
		}
	else{ 
		bOk = sKey.DelKey(pBuffer);
		}


return bOk;
}
