//*****************************************************************************
//*
//*
//*		RegWnd.h
//*
//*
//*****************************************************************************
#ifndef	AFX_REGWND_H__3828DAAF_B14F_11D2_84E4_D45E733A360A__INCLUDED_
#define AFX_REGWND_H__3828DAAF_B14F_11D2_84E4_D45E733A360A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif


#include 	"RegKeys.h"
#include	"TreeWnd.h"
#include 	"StringFunctions.h"


//*****************************************************************************
//*
//*		Styles fr das Fenster
//*
//*****************************************************************************

// #define	TWS_NOLISTVIEW		0x0001		// ListView nicht anzeigen
// #define	TWS_NOTREEVIEW		0x0002		// TreeView nicht anzeigen
// #define	TWS_RENAME			0x0004		// Dateien knnen umbenannt werden
// #define	TWS_DELETE			0x0008		// Datei Lschen erlaubt
// #define	TWS_DRAGDROP		0x0010		// Drag und Drop aktivieren
// #define	TWS_NODROP			0x0020		// Kein Drop auf sich selbst
// #define	TWS_TABEXIT			0x0040		// Bei TAB Focus an Elternfenster geben
// #define	TWS_NOSUBDIR		0x0080		// Keine Verzeichnisse im Listen Fenster
// #define	TWS_NOLISTICONS		0x0100		// Keine Icone im Listview anzeigen
// #define	TWS_NOTREEICONS		0x0200		// Keine Icone im Treeview anzeigen
// #define	TWS_NOSORT			0x0400		// Nicht nach Name sortieren
//
// #define	TWN_PATHCHANGE		0x9701		// Nachricht Pfadwurde verndert



//*****************************************************************************
//*
//*		Klasse CRegWnd	
//*
//*****************************************************************************
class CRegWnd : public CTreeWnd
{
protected:

		CImageList	m_cImgList;				// Icons fr das Listview
static	LPCTSTR		m_aRootTxt[8];			// Ausgangs Schlsselnamen
static	HKEY		m_aRootKey[8];			// Ausgangs Schlssel
static	INT 		m_aRootLen[8];			// Ausgangs Schlsselnamen-Lnge

//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************

public:

	 CRegWnd();
	~CRegWnd();

	//{{AFX_VIRTUAL(CRegWnd)
public:
 	virtual BOOL Create(LPCTSTR pClassName,LPCTSTR pWindowName,DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID,CCreateContext *pContext=NULL);
 	virtual BOOL Create(									   DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID,CCreateContext *pContext=NULL);
	//}}AFX_VIRTUAL

protected:

	virtual int	CheckPath(LPTSTR pPath,int iLen,int &iLevel);
	virtual int ReadRoot (CStringChain *pEntries);
	virtual int ReadDirs (CStringChain *pEntries,LPCTSTR pPath,int iLevel);
	virtual int ReadFiles(CStringChain *pEntries,LPCTSTR pPath,int iLevel);
	virtual int	Rename   (LPCTSTR pPath,LPTSTR pBuffer,int iLevel);
	virtual int	DoRename (LPCTSTR pPath,LPTSTR pBuffer,int iLevel);
	virtual int	DoDelete (LPCTSTR pPath,LPTSTR pBuffer,int iLevel);
	virtual int GetIcon  (LPCTSTR pPath,LPTSTR pBuffer,int iLevel,int iMode);
	virtual int	InsertItem(int  iNum);
	virtual int	InsertColumn();

protected:

	//{{AFX_MSG(CRegWnd)
	//}}AFX_MSG

public:

	DECLARE_MESSAGE_MAP()
};



//{{AFX_INSERT_LOCATION}}

#endif
