//*****************************************************************************
//*
//*
//*		SizeSynch.h
//*
//*
//*****************************************************************************
//
//	Mit der Klasse CSizeSynch knnen zwei Pfade ber ein Pufferverzeichniss
//	synchronisiert werden. Dabei kann die maximale Gre des Verzeichnisses
//	angegeben werden. Reich die Gre nicht aus, so wird nur ein Teil
//	synchronisiert.
//
#ifndef 	__SIZESYNCH_H__
#define 	__SIZESYNCH_H__


#if _MSC_VER >= 1000
#pragma once
#endif

typedef	int (_cdecl *SizeSynchProc)(void *pParam,int iType,const char *pText);

#define 	SSY_STOP	0
#define 	SSY_SCAN	1
#define 	SSY_COPY	2
#define 	SSY_DELETE	3
#define 	SSY_MESSAGE	4

//*****************************************************************************
//*
//*		Klasse CSizeSynch
//*
//*****************************************************************************
class CSizeSynch
{
protected:

	static char	m_cHostName[64];

public:

	CSizeSynch();

	int			CreateList(const char *pFileList,const char *pSource,const char *pPlus=0,const char  *pMinus=0,unsigned uSize=100*1024*1024);
	int			Synch     (const char *pFileList,const char *pSource,const char *pHostCheck=0,int iIstTarget=0,unsigned uSizeNew=0);
	const char *GetHostname(){return m_cHostName;}
	void		SetCallback(void *pParam,SizeSynchProc pProc);


protected:

	unsigned 		GetChecksum(const char *pFileName);
	SizeSynchProc   m_pCallback;
	void           *m_pCallParam;
	int				m_iStop;

};




#endif
