//*****************************************************************************
//*
//*
//*		TreeWnd.cpp
//*
//*
//*****************************************************************************
//
// 	char *GetPath()							Ergibt den aktuellen Pfad
// 	char *SetPath(char *)					Ergibt den aktuellen Pfad
// 	int   Set (char*="",char*=0,int=0)		Neuen Pfad Setzen
// 	int   SetListView(int=LVS_REPORT)		ndert die Ansicht des Listviews
// 	int	  SetStyle(int,int Maske=0xFFFF)	ndert Aussehen
// 	int   Sort(int Art=0,int Richtung=0)	Sortiere ListView
// 	int   GetSelect(CStringChain *,int=0)	Ergibt die ausgewhlen Dateien
// 	int	  CreateNewFolder(char *Name=0)		Erzeugt ein neues Verzeichnis
// 	int	  DoDrop(char *Pfad,int Art)		Dorp-Funktion ausfhren
// 	int   HitTest(CPoint,LPVOID )			Ergibt Eintragnr. unter Cursor
//
// 	void  OnSelectAll()						Alles auswhlen
// 	void  OnNewDir   ()						Neues Verzeichnis erzeugen
// 	void  OnPathUp   ()						Einen Pfad Aufwrts
// 	void  OnDelete   ()						Auswahl lschen
// 	void  OnSmallIcon()						Ansicht auf kleine Icons
// 	void  OnReport   ()						Ansicht auf Details
// 	void  OnList     ()						Ansicht auf Liste mit kleine Icons
// 	void  OnIcon     ()						Ansicht auf groe  Icons
//
//	Einstellen der Drop-Funktionen
//
// 	void  SetDrop(	int(*Drop_fnk)(char *Pfad,CStringChain *Dateien  ,int Art,LPVOID Element,LPVOID Data)=0,LPVOID Data=0);
// 	void  SetView(	int(*Extern_hit_test)(CPoint sPoint ,LPVOID Element	     ,LPVOID Data)=0,
// 					int(*Extern_get_pfad)(LPVOID Element,char *Puffer ,int Len,LPVOID Data)=0,
// 					int(*Extern_get_mode)(UINT  nFlags ,LPVOID Element	     ,LPVOID Data)=0);
//
//
//************** Zum berladen mit neuen Funktionen  ***************************
//
// 	virtual int ReadRoot (CStringChain *Eintaege);
// 	virtual int ReadDirs (CStringChain *Eintaege,char *Pfad,int Ebene);
// 	virtual int ReadFiles(CStringChain *Eintaege,char *Pfad,int Ebene);
// 	virtual int	Rename   (char *Pfad,char *Puffer,int Ebene);
// 	virtual int	DoRename (char *Pfad,char *Puffer,int Ebene);
// 	virtual int	DoDelete (char *Pfad,char *Puffer,int Ebene);
// 	virtual int GetIcon  (char *Pfad,char *Puffer,int Ebene,int Art);
//	virtual int CheckPath(char *Pfad,int iLen,int &Ebene);
// 	virtual int	InsertItem(int  Nr);
// 	virtual int	InsertColumn();
//
#include 	"StdAfx.h"
#include 	<winreg.h>
#include 	<AfxUtility.h>

#include 	"MainFrm.h"
#include 	"Resource.h"
#include 	"TreeWnd.h"


#ifndef		ID_PATHUP
#define		ID_PATHUP		0x6601
#endif
#ifndef		ID_SETICON
#define		ID_SETICON		0x6602
#endif
#ifndef		ID_SETLIST
#define		ID_SETLIST		0x6603
#endif
#ifndef		ID_SETSMALLICON
#define		ID_SETSMALLICON	0x6604
#endif
#ifndef		ID_SETREPORT
#define		ID_SETREPORT	0x6605
#endif
#ifndef		ID_SELECTALL
#define		ID_SELECTALL	0x6606
#endif
#ifndef		ID_NEWDIR
#define		ID_NEWDIR		0x6607
#endif
#ifndef		ID_DELETE
#define		ID_DELETE		0x6608
#endif
#ifndef		ID_SELECTALL
#define		ID_SELECTALL	0x6609
#endif
#ifndef		ID_RETURN
#define 	ID_RETURN		0x660A
#endif
#ifndef		ID_TABULATOR
#define 	ID_TABULATOR	0x660B
#endif
#ifndef		ID_PATHPREV
#define 	ID_PATHPREV		0x660C
#endif
#ifndef		ID_PATHNEXT
#define 	ID_PATHNEXT		0x660D
#endif
#ifndef		ID_FOLTERUP
#define 	ID_FOLTERUP		0x660E
#endif

#define 	ROOT_ID  		0x58000000				// ID    fr die Root-Nummer
#define 	ROOT_DATA		0x07FF0000				// Maske fr die Root-Nummer
#define 	ROOT_MASK		0xF8000000				// Maske fr die Root-ID
#define 	LEVEL_MASK		0x000000FF				// Maske fr die Ebene
#define		IDC_TREEVIEW	0x00006B00				// ID fr Treeview
#define		IDC_LISTVIEW	0x00006B01				// ID fr Listview
#define 	IDC_COMBOBOX	0x00006B02				// ID fr Listview
#define 	ID_PATHSEL		0x00006700				// ID fr um Pfad zu whlen
#define		ID_STATUSBARSET	0x12346666				// ID Stadusbarset
#define 	ID_COMBOUPDATE	0x12347777				// ID Pfad aus ComboBox holen
#define		FRAME_CLASS		CMainFrame				// Klasse mit StatusBar
#define 	COMBO_FRAME		3						// Breite des Ramens um die Combobox

#ifdef     _DEBUG
#define new DEBUG_NEW
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define 	GETVAL(c,n,i)	(((int*)c.Data(n))[i])
#define 	SETITEM(p,i)	*(LPVOID*)(p)=(LPVOID)(i)
#define 	NOITEM			((LPVOID)-1)


//*****************************************************************************
//*
//*   Nachrichten Verarbeitung
//*
//*****************************************************************************

BEGIN_MESSAGE_MAP(CTreeWnd, CWnd)
	//{{AFX_MSG_MAP(CTreeWnd)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_KEYUP()
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_WM_CREATE()
	ON_WM_KEYDOWN()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_MOUSEMOVE()
	ON_WM_DROPFILES()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	ON_CBN_CLOSEUP	(IDC_COMBOBOX,OnCbCloseUp )
	ON_CBN_SETFOCUS (IDC_COMBOBOX,OnCbSetFocus)
	ON_CBN_SELCHANGE(IDC_COMBOBOX,OnSelChanged)
	//}}AFX_MSG_MAP

	ON_COMMAND(ID_SETICON						, OnIcon)
	ON_COMMAND(ID_SETLIST						, OnList)
	ON_COMMAND(ID_RETURN						, OnReturn)
	ON_COMMAND(ID_PATHUP						, OnPathUp)
	ON_COMMAND(ID_NEWDIR						, OnNewDir)
	ON_COMMAND(ID_DELETE						, OnDelete)
	ON_COMMAND(ID_SETREPORT						, OnReport)
	ON_COMMAND(ID_STATUSBARSET					, OnStatusbarSet)
	ON_COMMAND(ID_SELECTALL						, OnSelectAll)
	ON_COMMAND(ID_SETSMALLICON					, OnSmallIcon)
	ON_COMMAND(ID_TABULATOR						, OnTabulator)
	ON_COMMAND(ID_PATHPREV						, OnPathPrev)
	ON_COMMAND(ID_PATHNEXT						, OnPathNext)
	ON_COMMAND(ID_FOLTERUP						, OnPathUp)

	ON_UPDATE_COMMAND_UI(ID_SETICON				, OnMenu)
	ON_UPDATE_COMMAND_UI(ID_SETLIST				, OnMenu)
	ON_UPDATE_COMMAND_UI(ID_SETSMALLICON		, OnMenu)
	ON_UPDATE_COMMAND_UI(ID_SETREPORT			, OnMenu)

	ON_NOTIFY(TVN_BEGINLABELEDIT, IDC_TREEVIEW	, OnTreeBeginEdit)
	ON_NOTIFY(TVN_ENDLABELEDIT	, IDC_TREEVIEW	, OnTreeEndEdit)
	ON_NOTIFY(TVN_ITEMEXPANDED	, IDC_TREEVIEW	, OnTreeExpanded)
	ON_NOTIFY(TVN_SELCHANGED	, IDC_TREEVIEW	, OnTreeSelChanged)
	ON_NOTIFY(TVN_BEGINDRAG		, IDC_TREEVIEW	, OnTreeBeginDrag)
	ON_NOTIFY(TVN_KEYDOWN		, IDC_TREEVIEW	, OnTreeKeyDown)
	ON_NOTIFY(NM_SETFOCUS		, IDC_TREEVIEW	, OnTreeFocus)
	ON_NOTIFY(NM_RCLICK			, IDC_TREEVIEW	, OnTreeClick)

	ON_NOTIFY(LVN_BEGINLABELEDIT, IDC_LISTVIEW	, OnListBeginEdit)
	ON_NOTIFY(LVN_ENDLABELEDIT	, IDC_LISTVIEW	, OnListEndEdit)
	ON_NOTIFY(LVN_ITEMCHANGED 	, IDC_LISTVIEW	, OnListItemChanged)
	ON_NOTIFY(LVN_COLUMNCLICK	, IDC_LISTVIEW	, OnListColumnClick)
	ON_NOTIFY(LVN_BEGINDRAG		, IDC_LISTVIEW	, OnListBeginDrag)
	ON_NOTIFY(LVN_KEYDOWN		, IDC_LISTVIEW	, OnListKeyDown)
	ON_NOTIFY(NM_DBLCLK			, IDC_LISTVIEW	, OnListDoubleClick)
	ON_NOTIFY(NM_RETURN			, IDC_LISTVIEW	, OnListReturn)
	ON_NOTIFY(NM_SETFOCUS		, IDC_LISTVIEW	, OnListFocus)

END_MESSAGE_MAP()

//*****************************************************************************
//*
//*     Statische Variableln
//*
//*****************************************************************************

const int CTreeWnd::m_sSortArray[4]=					// Sortier-Modi
	{
	CFF_SORT_NAME,										// Nach Namen sortieren
	CFF_SORT_LEN,										// Nach Datei lnge sortieren
	CFF_SORT_TYPE,										// Nach Typ sortieren
	CFF_SORT_WRITE										// Nach letztdem Schreibzugriff  sortieren
	};



//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CTreeWnd::CTreeWnd()
{

	m_iStyle		= 0;
	m_iPathOk		= 0;
	m_iPathEnd		= 0;
	m_iPathPos		= 0;
	m_iPathStart	= 0;
	m_iLastFocus	= 0;
	m_iDoRename		= 0;
	m_pPath			= 0;
	m_pDropProc		= 0;
	m_iInit			= 0;
	m_hTreeOpen		= 0;
	m_hSetThread	= 0;
	m_iSetState		= 0;
	m_iSetStatubar	= 0;
	m_iSortMode		= 0;								// Sortier-Art
	m_iSortDir		= 0;								// Sortier-Richtung
	m_iListLevel	= 0;
	m_iRootLevel	= 0;
	m_iDragState	= 0;
	m_pDragImages	= 0;
	m_iDragImgMode	= 0;
	m_pDragPath		= 0;
	m_iDropMode		=-1;
	m_hDropEntry	= NOITEM;
	m_bSepChanged	= FALSE;
	m_iSeparator	= TWS_SEPARATOR;

	m_pHitTestProc	= 0;
	m_pGetModeProc	= 0;
	m_pGetPathProc	= 0;
	m_pImgTreeS		= 0;
	m_pImgListS		= 0;
	m_pImgListN		= 0;
	m_iCursorMode	= 0;

	m_hCursorWait	= LoadCursor(0,IDC_WAIT  );
	m_hCursorSize	= LoadCursor(0,IDC_SIZEWE);
	m_hCursorNull	= LoadCursor(0,IDC_ARROW );
	m_hCursorDis 	= LoadCursor(0,IDC_NO    );
	m_hCursorCopy	= LoadCursor(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDC_CURSORCOPY));
	m_hCursorMove	= LoadCursor(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDC_CURSORMOVE));

	m_pStatusbarItems = 0;
	m_pStatusbarSizes = 0;
	m_uStatusbarCount = 0;

	m_sRoot .DataLength(CTW_MAX_CSC);
	m_sFiles.DataLength(CTW_MAX_CSC);



}
//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CTreeWnd::~CTreeWnd()
{

	if(m_hSetThread)									// Thread beenden
		{
		TerminateThread(m_hSetThread,0);
		CloseHandle(m_hSetThread);
		m_hSetThread = 0;
		}

	if(m_pStatusbarItems)
		{
		delete m_pStatusbarItems;
		m_pStatusbarItems = 0;
		}

	if(m_pStatusbarSizes)
		{
		delete m_pStatusbarSizes;
		m_pStatusbarSizes = 0;
		}

	if(m_iDragImgMode && m_pDragImages)					// Imagelist lschen
		{
		delete m_pDragImages;
		m_pDragImages = 0;
		}

	if(m_pPath)
		{
		delete m_pPath;
		m_pPath = 0;
		}

	if(m_pDragPath)
		{
		delete m_pDragPath;
		m_pDragPath = 0;
		}

}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
// Erzeugen eines neunen Fensters.
BOOL CTreeWnd::Create(LPCTSTR pClassName,LPCTSTR pWindowName,DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID,CCreateContext *pContext)
{
HIMAGELIST	 	hImageN;
HIMAGELIST	 	hImageS;
HTREEITEM	 	hNext;
SHFILEINFO	 	sSfi;
LPTSTR			pName;
RECT		 	sArea;
RECT		 	sTemp;
int			 	iBits;
int			 	iMode;
int			 	iIcon;
int			 	iPos;
int			 	iNum;
CWnd		   *pWnd;



	sArea.top    =  0;
	sArea.bottom =  0;
	sArea.left   = 10;
	sArea.right  = 10;

	m_iStyle	 = dwStyle;
	dwStyle     &= 0xFFFF0000;

	if(!CWnd::Create(pClassName,pWindowName,dwStyle,sRect,pParent,nID,pContext))
		{
		return FALSE;
		}

	SetClassLongPtr(m_hWnd,GCLP_HCURSOR      ,(LPARAM)m_hCursorSize             );
	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)GetStockObject(NULL_BRUSH));


//******************* Namenszeile **********************************************


	iMode = CBS_DROPDOWN|WS_CHILD;

	sTemp.top    = COMBO_FRAME;
	sTemp.left   = COMBO_FRAME;
	sTemp.bottom = 390;
	sTemp.right  = 210;

	m_cComboBox.Create(iMode,sTemp,this,IDC_COMBOBOX);

	if(!(m_iStyle&TWS_NOTREEICONS))
		{
		hImageS = 0;

		if(m_pImgTreeS)
			{
			hImageS = m_pImgTreeS->m_hImageList;
			}

		if(!hImageS)
			{
			hImageS = (HIMAGELIST)SHGetFileInfo(_T(""),0,&sSfi,sizeof(sSfi),SHGFI_PIDL|SHGFI_SMALLICON|SHGFI_SYSICONINDEX);
			}

		m_cComboBox.SetImageList(CImageList::FromHandle(hImageS));
		}

	m_cComboBox.GetWindowRect(&sTemp);
	m_cComboBox.SetExtendedStyle(CBES_EX_PATHWORDBREAKPROC,CBES_EX_PATHWORDBREAKPROC);

	m_iComboHight = sTemp.bottom-sTemp.top;
	m_iComboAdd	  = m_cComboBox.GetItemHeight(0)*16+4+m_iComboHight;
	m_iComboEnd	  = m_iComboHight+COMBO_FRAME*2+5;
	m_bComboTimer = FALSE;
	m_uComboTick  = 0;
	m_bComboSave  = 0;
	m_uComboFast  = 0;
	m_bUbEnable	  = 0;

	pWnd = m_cComboBox.GetEditCtrl();											   
	SubclassWnd(pWnd,ComboEditProc);												   

	m_cBtPrev.Create(_T(""),WS_CHILD|BS_PUSHBUTTON|BS_BITMAP,sRect,this,ID_PATHPREV);
	m_cBtNext.Create(_T(""),WS_CHILD|BS_PUSHBUTTON|BS_BITMAP,sRect,this,ID_PATHNEXT);
	m_cBtDoUp.Create(_T(""),WS_CHILD|BS_PUSHBUTTON|BS_BITMAP,sRect,this,ID_FOLTERUP);

	m_cBtPrev.EnableWindow(FALSE);
	m_cBtNext.EnableWindow(FALSE);
	m_cBtDoUp.EnableWindow(FALSE);

	SetButtonBitmap(m_cBtPrev,IDB_PATHPREV);
	SetButtonBitmap(m_cBtNext,IDB_PATHNEXT);
	SetButtonBitmap(m_cBtDoUp,IDB_FOLTERUP);

	if(!(m_iStyle&TWS_NOCOMBOBOX))
		{
		m_cComboBox.ShowWindow(SW_SHOW);
		m_cBtPrev  .ShowWindow(SW_SHOW);
		m_cBtNext  .ShowWindow(SW_SHOW);
		m_cBtDoUp  .ShowWindow(SW_SHOW);
		}


//******************* Tree-View ************************************************


	iMode = TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS|TVS_SHOWSELALWAYS|WS_VSCROLL;

	if(m_iStyle&TWS_RENAME)
		{
		iMode |= TVS_EDITLABELS;
		}

	m_cTreeView.Create(iMode,sArea,this,IDC_TREEVIEW);

	if(!(m_iStyle&TWS_NOTREEVIEW))
		{
		m_cTreeView.ShowWindow(SW_SHOW);
		}


//******************* List-View ************************************************


	iMode = LVS_REPORT;

	if(m_iStyle&TWS_RENAME)
		{
		iMode |= LVS_EDITLABELS;
		}

	m_cListView.Create(iMode,sArea,this,IDC_LISTVIEW);
	m_iColums = InsertColumn();

	if(!(m_iStyle&TWS_NOLISTVIEW))
		{
		m_cListView.ShowWindow(SW_SHOW);
		}


	if(!(m_iStyle&TWS_NOTREEICONS))
		{
		::SendMessage(m_cTreeView.m_hWnd,TVM_SETIMAGELIST,TVSIL_STATE ,(LPARAM)hImageS);
		::SendMessage(m_cTreeView.m_hWnd,TVM_SETIMAGELIST,TVSIL_NORMAL,(LPARAM)hImageS);
		}

	if(!(m_iStyle&TWS_NOLISTICONS))
		{
		hImageN = NULL;
		hImageS = NULL;

		if(m_pImgListS)hImageS=m_pImgListS->m_hImageList;
		if(m_pImgListN)hImageN=m_pImgListS->m_hImageList;

		if(!hImageS)hImageS=(HIMAGELIST)SHGetFileInfo(_T(""),0,&sSfi,sizeof(sSfi),SHGFI_PIDL|SHGFI_SMALLICON   |SHGFI_SYSICONINDEX);
		if(!hImageN)hImageN=(HIMAGELIST)SHGetFileInfo(_T(""),0,&sSfi,sizeof(sSfi),SHGFI_PIDL|SHGFI_SYSICONINDEX|SHGFI_SYSICONINDEX);

		::SendMessage(m_cListView.m_hWnd,LVM_SETIMAGELIST,LVSIL_SMALL ,(LPARAM)hImageS);
		::SendMessage(m_cListView.m_hWnd,LVM_SETIMAGELIST,LVSIL_NORMAL,(LPARAM)hImageN);
		}



//******************** Die ComboBox fllen ************************************


	for(iPos=0;iPos<m_sCombo.Count();iPos++)
		{
		COMBOBOXEXITEM	sItem;

		sItem.mask		  = CBEIF_TEXT;
		sItem.pszText	  = m_sCombo[iPos];
		sItem.iItem		  = iPos;

		if(!(m_iStyle&TWS_NOTREEICONS))
			{
			TCHAR	cName[TWS_MAX_NAME+16];

			iNum		  = GetLevel(sItem.pszText);
			sItem.mask	 |= CBEIF_IMAGE|CBEIF_SELECTEDIMAGE;
			sItem.iImage  =	GetIcon(sItem.pszText,cName,iNum,CTW_ICON_S);
			sItem.iSelectedImage = sItem.iImage;
			}

		m_cComboBox.InsertItem(&sItem);
		}


//********************** Laufwerke einlesen ************************************


	SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorWait);
	if(HitTest()==1)::SetCursor(m_hCursorWait);

	m_cTreeView.SetRedraw(FALSE);

	m_sRoot.Del();
	iNum = ReadRoot(&m_sRoot);
	if(iNum>256)iNum=256;


	for(iPos=0;iPos<iNum;iPos++)							// ROOT-Elemente einfgen
		{
		iIcon	= GETVAL(m_sRoot,iPos,CTW_ICON_S);
		pName	= m_sRoot.Get(iPos);
		iBits	= ROOT_ID|(iPos<<16);

		hNext	= m_cTreeView.InsertItem(TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,pName,iIcon,iIcon ,0,0,iBits,TVI_ROOT,TVI_LAST);
				  m_cTreeView.InsertItem(TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,_T("\\(null)"),0,0,0,0,iBits,hNext,TVI_SORT);

		if(!iPos)m_cTreeView.SelectItem(hNext);
		}


	SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);

	m_cTreeView.SetRedraw(TRUE);


	SetTimer(ID_STATUSBARSET,1000,0);

	m_iInit = 1;



return TRUE;
}

BOOL CTreeWnd::Create(DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID,CCreateContext *pContext)
{

	dwStyle|=WS_VISIBLE|WS_CHILD;

return Create(NULL,_T("TreeWnd"),dwStyle,sRect,pParent,nID,pContext);
}

//*****************************************************************************
//*
//*		SetCursor
//*
//*****************************************************************************
//	Stellt die Art des Cursor ein.
//	iMode	: Ist der neue Cursor-Modus
//				0 = Normaler Cursor
//				1 = Disable  Cursor
//				2 = Copy     Cursor
//				3 = Move     Cursor
// Ergibt den vorherigen Cursor-Modus.
int CTreeWnd::SetCursor(int iMode)
{
int	iOld;


	if(m_iCursorMode==iMode)
		{
		return iMode;
		}

	iOld = m_iCursorMode;

	switch(iMode)
		{
	case 0:	::SetCursor(m_hCursorNull);	m_iCursorMode=0; break;
	case 1:	::SetCursor(m_hCursorDis );	m_iCursorMode=1; break;
	case 2:	::SetCursor(m_hCursorCopy);	m_iCursorMode=2; break;
	case 3:	::SetCursor(m_hCursorMove);	m_iCursorMode=3; break;
	case 4:	::SetCursor(m_hCursorSize);	m_iCursorMode=4; break;
	case 5:	::SetCursor(m_hCursorWait);	m_iCursorMode=5; break;
		}


return iOld;
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
//	Zeichnen des Fensters
void CTreeWnd::OnPaint()
{
CPaintDC	sDc(this);
CRect		sRect;
CRect		sArea;
int			iTop;


	if(m_iStyle&TWS_NOCOMBOBOX)
		{
		iTop = 0;
		}
	else{
		iTop = m_iComboEnd;

		GetClientRect(&sRect);
		GetPosRect(&m_cComboBox,&sArea);

		sRect.bottom = iTop-7;

		SetBkColor   (sDc.m_hDC,GetSysColor(COLOR_MENU));
		DrawFrame    (sDc.m_hDC,&sRect,&sArea);
		DrawSeparator(sDc.m_hDC,iTop-7,sRect.right,TRUE);
		}


	if((m_iStyle&(TWS_NOLISTVIEW|TWS_NOTREEVIEW))==(TWS_NOLISTVIEW|TWS_NOTREEVIEW))
		{
		sDc.SelectStockObject(NULL_PEN);
		sDc.SelectObject(GetSysColorBrush(COLOR_WINDOW));
		sDc.Rectangle(0,iTop,10000,10000);
		}
	else{
		DrawSeparator(iTop,sDc.m_hDC,m_iSeparator,10000,FALSE);
		}
}

//*****************************************************************************
//*
//*		Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG

void CTreeWnd::AssertValid() const
{
	CWnd::AssertValid();
}

void CTreeWnd::Dump(CDumpContext &sDc) const
{
	CWnd::Dump(sDc);
}

#endif

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
//	Grennderung des Fensters
void CTreeWnd::OnSize(UINT nType,int iSizeX,int iSizeY)
{
int		iTop;


	if(!m_hWnd || iSizeX<=0 || iSizeY<=0)return;

	iTop = 0;

	if(m_bSepChanged==FALSE)
		{
		m_iSeparator = (iSizeX<TWS_SEPARATOR*4)? TWS_SEPARATOR:iSizeX/4;
		}

	if(IsWindow(m_cListView.m_hWnd) &&!(m_iStyle&TWS_NOCOMBOBOX))
		{
		if(m_iStyle&TWS_NOCOMBOBOX)
			{
			m_cComboBox.MoveWindow(iSizeX,0,0,0);
			}
		else{
			iTop = m_iComboEnd;
		
			m_cBtPrev  .MoveWindow(COMBO_FRAME                ,COMBO_FRAME,m_iComboHight,m_iComboHight);
			m_cBtNext  .MoveWindow(COMBO_FRAME+m_iComboHight  ,COMBO_FRAME,m_iComboHight,m_iComboHight);
			m_cBtDoUp  .MoveWindow(COMBO_FRAME+m_iComboHight*2,COMBO_FRAME,m_iComboHight,m_iComboHight);
			m_cComboBox.MoveWindow(COMBO_FRAME+m_iComboHight*3+COMBO_FRAME/2,COMBO_FRAME,iSizeX-COMBO_FRAME*2-COMBO_FRAME/2-m_iComboHight*3,m_iComboAdd);
			}
		}

	if(IsWindow(m_cListView.m_hWnd) &&!(m_iStyle&TWS_NOLISTVIEW))
		{
		if(m_iStyle&TWS_NOTREEVIEW)
			 m_cListView.MoveWindow(0             ,iTop,iSizeX               ,iSizeY-iTop);
		else m_cListView.MoveWindow(m_iSeparator+7,iTop,iSizeX-m_iSeparator-7,iSizeY-iTop);
		}

	if(IsWindow(m_cTreeView.m_hWnd) &&!(m_iStyle&TWS_NOTREEVIEW))
		{
		if(m_iStyle&TWS_NOLISTVIEW)
			 m_cTreeView.MoveWindow(0,iTop,iSizeX	   ,iSizeY-iTop);
		else m_cTreeView.MoveWindow(0,iTop,m_iSeparator,iSizeY-iTop);
		}

}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CTreeWnd::OnDestroy()
{
	
	GetCbList();

	// Die Image-Listen fr das Tree-View lschen
	::SendMessage(m_cTreeView.m_hWnd,TVM_SETIMAGELIST,TVSIL_NORMAL,(LPARAM)0);
	::SendMessage(m_cTreeView.m_hWnd,TVM_SETIMAGELIST,TVSIL_STATE ,(LPARAM)0);

	// Die Image-Listen fr das List-View lschen
	::SendMessage(m_cListView.m_hWnd,LVM_SETIMAGELIST,LVSIL_SMALL ,(LPARAM)0);
	::SendMessage(m_cListView.m_hWnd,LVM_SETIMAGELIST,LVSIL_NORMAL,(LPARAM)0);

	// Die Image-Listen fr die ComboBox lschen
	m_cComboBox.SetImageList(NULL);

	CWnd::OnDestroy();

}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
//	Speichert den Pfad eines Baum-Eintrages im einen Puffer.
//	Am Pfadende wird immer ein `\' angehngt.
//	hItem		: Handle vom Eintrags.
//	pBuffer		: Zeiger auf den Textpuffer.
//	iLen		: Ist die Gre des Textpuffers.
//	Ergibt die Lnge des Pfades bzw. 0 bei einem Fehler.
int CTreeWnd::GetPath(HTREEITEM hItem,LPTSTR pBuffer,int iLen)
{
TCHAR		 cName[MAX_PATH];
HTREEITEM	 aTree[36];
TV_ITEM		 sItem;
int			 iLevel;
int			 iNum;
int			 iOff;
int			 iCnt;
int			 iPos;



	if(iLen<=0)return 0;							// Prfe die Puffergre

	iLen--;

	sItem.mask	= TVIF_PARAM;						// Prfe ob hItem ok
	sItem.hItem = hItem;

	m_cTreeView.GetItem(&sItem);


	if((sItem.lParam&ROOT_MASK)!=ROOT_ID)
		{
		if(iLen>0)pBuffer[0]=0;
		return 0;
		}


	aTree[0] = hItem;

	for(iNum=1;iNum<36;iNum++)						// Baum durchsuchen
		{
		if((sItem.lParam&ROOT_MASK)!=ROOT_ID)
			{
			if(iLen>0)pBuffer[0]=0;
			return 0;
			}

		aTree[iNum] = m_cTreeView.GetNextItem(aTree[iNum-1],TVGN_PARENT);

		if(!aTree[iNum])break;
		}


	sItem.pszText	 = cName;
	sItem.cchTextMax = MAX_PATH;
	sItem.mask		 = TVIF_PARAM|TVIF_TEXT;
													// Den Pfad erzeugen
	for(iOff=iNum-1,iLevel=0,iPos=0;iOff>=0;iOff--,iLevel++)
		{
		sItem.hItem = aTree[iOff];

		m_cTreeView.GetItem(&sItem);				// Hole Name und Wert

		if(iLevel != (sItem.lParam&0x0FFF))			// Stimmt die Ebene
			{
			if(iLen>0)pBuffer[0]=0;
			return 0;
			}

		iCnt = _tcslen(cName);

		if(iPos+iCnt+1>=iLen)						// Ist die Lnge ok
			{
			if(iLen>0)pBuffer[0]=0;
			return 0;
			}

		memcpy(pBuffer+iPos,cName,iCnt*sizeof(TCHAR));

		iPos += iCnt;
		pBuffer[iPos]='\\',iPos++;
		}

	pBuffer[iPos]=0;


return iPos;
}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
//	Speichert den Pfad eines Listeneintrag in einem Puffer
//	iItem		: Handle vom Eintrags.
//	pBuffer		: Zeiger auf den Textpuffer.
//	iLen		: Ist die Gre des Textpuffers.
//	Ergibt die Lnge des Pfades bzw. 0 bei einem Fehler.
int CTreeWnd::GetPath(int iItem,LPTSTR pBuffer,int iLen)
{
TCHAR  *pPtr;
int		iDir;
int		iCnt;
int		iNum;


	if(iLen<=0)return 0;							// Prfe die Puffergre

	iLen--;

	if(!m_pPath || iItem<0 || iItem>=m_iCount)
		{
		pBuffer[0]=0;
		return 0;
		}

	pPtr = m_sFiles.Get(iItem);
	iNum = _tcslen(pPtr);
	iCnt = _tcslen(m_pPath);

	if(iCnt+iNum>=iLen)
		{
		pBuffer[0]=0;
		return 0;
		}

	memcpy(pBuffer     ,m_pPath,iCnt*sizeof(TCHAR));
	memcpy(pBuffer+iCnt,pPtr   ,iNum*sizeof(TCHAR));

	iCnt  += iNum;
	iDir   = GETVAL(m_sFiles,iItem,CTW_IS_DIR);

	if(iCnt<iLen && iDir)
		{
		pBuffer[iCnt] = '\\';
		iCnt++;
		}

	pBuffer[iCnt]=0;


return iCnt;
}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
//	Ergibt den aktuellen Pfad vom Listenfenster.
LPCTSTR CTreeWnd::GetPath()
{
return m_pPath;
}

//*****************************************************************************
//*
//*     SetPath
//*
//*****************************************************************************
//	Setzt einen neuen Pfad frs das ListView.
//	pPath		: Ist der neue Pfad
//	Ergibt den aktuellen Pfad
LPCTSTR CTreeWnd::SetPath(LPCTSTR pPath)
{

	Set(pPath);


return m_pPath;
}

//*****************************************************************************
//*
//*		Read
//*
//*****************************************************************************
//	Liest die Verzeichnisse eines Pfades ins Treelistfeld ein.
//	pPath		: Ist der Zeiger auf den Pfad.
//	iMode		: Wenn ungleich 0 dann wird der Pfad aufgeklappt.
//	hRoot		: Ist das Start Element von der die Suche ausgehen soll.
//				  Der Pfad wird dann an den Wurzelpfad angehngt.
//	Ergibt den Eintrag fr den Pfad bzw. 0 bei einem Fehler
HTREEITEM CTreeWnd::Read(LPCTSTR pPath,int iMode,HTREEITEM hRoot)
{
TCHAR		cText[TWS_MAX_NAME+16];
TCHAR		cTemp[TWS_MAX_NAME+16];
TCHAR		cFind[260];
TCHAR	   *pName;
TCHAR		cSign;
HTREEITEM	hNext;
HTREEITEM	hItem;
HTREEITEM	hRead;
TV_ITEM		sItem;
int			iLevel;
int			iLast;
int			iOff;
int			iNum;
int			iCnt;
int			iPos;
int			iLen;
int			iVal;
int			iOk;


	if(m_iStyle&TWS_NOTREEVIEW)return 0;				// TreeView ausgeblendet ?


	if(hRoot)											// Pfad aus Wurzel holen ?
		{
		iOff = GetPath(hRoot,cText,TWS_MAX_NAME+2);

		if(pPath && *pPath)
			{
			_tcsncat(cText+iOff,_T("\\"), MAX_PATH+2-iOff);
			_tcsncat(cText+iOff,pPath   , MAX_PATH+2-iOff);
			}

		iOff = _tcslen(cText);
		}
	else{
		cText[TWS_MAX_NAME+2]=0;
		_tcsncpy(cText,pPath,TWS_MAX_NAME+2);
		iOff = _tcslen(cText);
		}


	if(iOff>TWS_MAX_NAME)
		{
		iOff = TWS_MAX_NAME+1;
		cText[iOff] = 0;
		}

	if(iOff && cText[iOff-1]=='\\')
		{
		cText[iOff-1] = 0;
		iOff--;
		}


//**************** Treefeld auffllen ******************************************


	iLast			 = SetCursor(5);
	sItem.pszText	 = cFind;
	sItem.cchTextMax = 256;

	if(iMode)iMode=1;

	hRead	= 0;
	iLevel	= 0;
	iLen	= 0;
	iPos	= 0;
	iCnt	= 0;
	iPos	= 0;
	pName	= cText;
	hNext	= m_cTreeView.GetRootItem();			// Ersten Eintrag finden
	iLen	= strchar(cText+iPos,'\\');


//***************** Suche im Treefeld ******************************************


	for(;;)
		{
		iCnt		= 0;
		hItem		= 0;
		iLen		= strchar(pName,'\\');			// Lnge des aktuellen Verzeichnisses
		cSign		= pName[iLen];
		pName[iLen]	= 0;

		while(hNext)
			{
			iCnt++;

			sItem.hItem		= hNext;
			sItem.mask		= TVIF_PARAM|TVIF_TEXT|TVIF_STATE;
			sItem.stateMask = TVIS_EXPANDED;

			m_cTreeView.GetItem( &sItem);			// Hole Name und Wert

			iOk = (iLen)? _tcsicmp(pName,cFind):1;

			if(!iOk)
			do	{
				hItem = hNext;						// Eintrag fr nchste Ebene

				if(cSign && !(iMode&2))

				if(!(sItem.state&TVIS_EXPANDED))
					{
					m_cTreeView.Expand(hNext,TVE_EXPAND);
					}

				if(cSign || (iMode&2))
					{
					break;
					}

				hRead = hNext;						// Eintrag fr den Pfad

				if(!(sItem.lParam&0x8000))
					{
					break;
					}

				iNum = _tcslen(cText);
				memcpy(cTemp,cText,(iNum+1)*sizeof(TCHAR));
				iNum = ReadSubDirs(hNext,cTemp,1);	// Prfe ob Eintrge aktuell

				if(!iNum && !iLevel)
					{
					iOff=ROOT_ID|(sItem.lParam&ROOT_DATA);
					m_cTreeView.InsertItem(TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,_T("\\(null)"),0,0,0,0,iOff,hNext,TVI_LAST);
					m_cTreeView.Expand(hNext,TVE_COLLAPSE);
					}

				}while(0);


			//******************* Unter-Ortner einlesen ************************


			if(iLevel || !iOk)
				{
				iOff	= iPos;
				iNum	= _tcslen(cFind);

				memcpy(cTemp,cText,iPos*sizeof(TCHAR));

				if(iOff && (cTemp[iOff-1]!='\\'))
					{
					cTemp[iOff] = '\\';
					iOff++;
					}

				memcpy(cTemp+iOff,cFind,iNum*sizeof(TCHAR));
				iOff += iNum;

				if(!iLevel)
					{
					cTemp[iOff] = '\\';
					iOff++;
					}

				cTemp[iOff] = 0;

				iVal = (!cSign && (iMode==1 || !(m_iStyle&TWS_NOSUBDIR)))? 0:3;
				iNum = ReadSubDirs(hNext,cTemp,iVal);

				if((!iNum && !iLevel) || (iNum && iVal && !(sItem.lParam&0x8000)))
					{
					iOff=ROOT_ID|(sItem.lParam&ROOT_DATA);
					m_cTreeView.InsertItem(TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE,_T("\\(null)"),0,0,0,0,iOff,hNext,TVI_LAST);
					m_cTreeView.Expand(hNext,TVE_COLLAPSE);
					}
				}

			if(!iOk && iMode&1)break;

			hNext = m_cTreeView.GetNextItem(hNext,TVGN_NEXT);	// Nchster Eintrag
			}

		if(!hItem)break;


		//******************* Nchste Ebene ************************************


		hNext = m_cTreeView.GetNextItem(hItem,TVGN_CHILD);
		pName[iLen] = cSign;

		if(!cSign)
			{
			if(!(iMode&1))break;
			iMode|=2;iMode&=~1;
			}

		    pName += iLen;
		if(*pName=='\\')pName++;

		iPos += iLen;
		if(cText[iPos]=='\\')iPos++;

		if(iLen  >256)iLen=256;
		if(iLen  <=0)break;
		if(iLevel>32)break;
		   iLevel++;
		}

	SetCursor(iLast);


return hRead;
}

//*****************************************************************************
//*
//*		ReadSubDirs
//*
//*****************************************************************************
//	Liest fr eine Tree-Eintrag die Unterverzeichnisse ein.
//	hItem		: Handle des Tree-Eintrags
//	pPath		: Ist der Pfad fr die Suche. Ist Pfad gleich 0 so wird der
//				  Pfad von GetPath geholt.
//	iMode		: Bestimmt die Art des Einlsesens
//					0 = Eintrge nur erneuern wenn das Ok-Bit fehlt
//					1 = Eintrge nur erneuern wenn eine nderung gefunden wurde.
//					2 = Eintrge immer erneuert.
//					3 = Nur prfen ob Unterordner vorhanden sind
// Ergibt 1 wenn Eintrge gefunden bzw. eingelesen wurden.
int CTreeWnd::ReadSubDirs(HTREEITEM hItem,LPTSTR pPath,int iMode)
{
TCHAR		cText[TWS_MAX_NAME+16];
TCHAR		cName[260];
LPCTSTR		pName;
HTREEITEM	hNext;
HTREEITEM	hTemp;
TV_ITEM		sItem;
int			iLevel;
int			iChild;
int			iIcon;
int			iRoot;
int			iPos;
int			iOff;
int			iNum;
int			iCnt;


	sItem.hItem	= hItem;
	sItem.mask	= TVIF_PARAM|TVIF_CHILDREN;

	m_cTreeView.GetItem(&sItem);						// Hole Daten vom Eintrag

	iChild		= sItem.cChildren;

	if((iMode==0)&&(sItem.lParam&0x8000))return iChild;

	iRoot	= (sItem.lParam&0x00FF0FFF)+1;				// Root  Nummer
	iLevel  = (sItem.lParam&0x00000FFF)+1;				// Ebene prfen

	if(iLevel>=20)return 0;

	if(iMode==3)
		{
		if(sItem.lParam&0x8000)return iChild;
		iCnt = ReadDirs(0,pPath,iRoot-1);
		return iCnt!=0;
		}

	if(!pPath)											// Pfad vom Eintrag holen
		{
		iOff  = GetPath(hItem,cText,TWS_MAX_NAME+2);
		pPath = cText;
		}
	else{
		iOff = _tcslen(pPath);
		}

	if(iOff && pPath[iOff-1]!='\\')
		{
		pPath[iOff  ] = '\\';
		pPath[iOff+1] = 0;
		}
	else{
		iOff=0;
		}


	SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorWait);
	if(HitTest()==1)::SetCursor(m_hCursorWait);

	m_cTreeView.SetRedraw(FALSE);

	CStringChain sFolders(CTW_MAX_CSC);
	ReadDirs(&sFolders,pPath,iRoot-1);
	iCnt = sFolders.Count();

	if(iOff){pPath[iOff]=0;}


//******************* Prfe Eintrge *******************************************


	if(iMode==1)
	do	{
		if(!iChild)										// Keine Eintrge vorhanden
			{
			if(iCnt>0){iMode=2;break;}
			SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);
			m_cTreeView.SetRedraw(TRUE);
			return 0;
			}

		hNext = m_cTreeView.GetNextItem(hItem,TVGN_CHILD);

		sItem.mask		 = TVIF_TEXT;
		sItem.pszText	 = cName;
		sItem.cchTextMax = 256;

		for(iOff=0;hNext;iOff++)
			{
			sItem.hItem	 = hNext;
			m_cTreeView.GetItem(&sItem);				// Hole Dateiname

			iNum  = sFolders.Find(cName,0,-1,1);
			hNext = m_cTreeView.GetNextItem(hNext,TVGN_NEXT);

			if(iNum==-1)      							// Datei nicht gefunden
					m_cTreeView.DeleteItem(sItem.hItem);
			else	sFolders.Del(iNum);
			}


		SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);

		m_cTreeView.SetRedraw(TRUE);

		iCnt = sFolders.Count();

		if(!hNext && !iCnt)return iChild;
		iMode = 2;

		}while(0);


	//******************* Alles lschen ****************************************


	if(iChild)
		{
		hNext = m_cTreeView.GetNextItem(hItem,TVGN_CHILD);

		while(hNext)
			{
			hTemp = m_cTreeView.GetNextItem(hNext,TVGN_NEXT);
				    m_cTreeView.DeleteItem (hNext);

			if(hNext==m_hTreeOpen)m_hTreeOpen=0;

			hNext = hTemp;
			}
		}


	//******************* Alles neu einlesen ***********************************


	iCnt = sFolders.Count();

	for(iPos=0;iPos<iCnt;iPos++)
		{
		pName = sFolders.Get(iPos);
		iIcon = GETVAL(sFolders,iPos,CTW_ICON_S);

		m_cTreeView.InsertItem(TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_STATE,
								pName,
								iIcon,			 // int nImage,
								iIcon,			 // int nSelectedImage,
								0,				 // UINT nState,
								0,				 // UINT nStateMask,
								iRoot|ROOT_ID,	 // LPARAM lParam,
								hItem,
								TVI_SORT);

		}


	SetClassLongPtr(m_cTreeView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);

	m_cTreeView.SetRedraw(TRUE);


	sItem.mask   = TVIF_PARAM;					// Ok Bit setzen
	sItem.hItem  = hItem;
	sItem.lParam = (iLevel-1)|ROOT_ID|0x8000|(iRoot&ROOT_DATA);

	m_cTreeView.SetItem(&sItem);


return (iCnt!=0);
}

//*****************************************************************************
//*
//*     SetListView
//*
//*****************************************************************************
//	ndert die Ansicht des Listenfensters.
//	iMode	: Ist die neue Ansicht fr das  Listenfenster
//				LVS_ICON		: Groe  Icons
//				LVS_SMALLICON	: Kleine Icons
//				LVS_LIST		: Kleine Iconsliste
//				LVS_REPORT		: Kleine Iconsliste mit Deteils
//	Ergibt den vorherigen Zustand des ListViews.
int CTreeWnd::SetListView(int iMode)
{
int		iStyle;
int		iOld;



	iStyle	 = ::GetWindowLong(m_cListView.m_hWnd,GWL_STYLE );
	iOld	 = LVS_TYPEMASK & m_iStyle;
	iMode   &= LVS_TYPEMASK;

	if(iOld==iMode)return iOld;

	m_iStyle &= ~LVS_TYPEMASK;
	m_iStyle |=  iMode;

	::SetWindowLong(m_cListView.m_hWnd,GWL_STYLE,m_iStyle);
	m_cListView.UpdateWindow();

	if(iOld==LVS_ICON || iMode==LVS_ICON)
		{
		Set(0,0,2);
		}


return iOld;
}

//*****************************************************************************
//*
//*     OnIcon   OnSmallIcon  OnList  OnReport
//*
//*****************************************************************************
void CTreeWnd::OnIcon     (){SetListView(LVS_ICON     );}
void CTreeWnd::OnSmallIcon(){SetListView(LVS_SMALLICON);}
void CTreeWnd::OnList     (){SetListView(LVS_LIST     );}
void CTreeWnd::OnReport   (){SetListView(LVS_REPORT   );}

//*****************************************************************************
//*
//*		Insert
//*
//*****************************************************************************
//	Fgt alle in m_sFiles gefunden Dateien ins Listview ein.
//	Ergibt die Anzahl der gefundenen Dateien.
int CTreeWnd::Insert()
{
TCHAR		cText[TWS_MAX_NAME+16];
LPCTSTR		pName;
int			iIcon;
int			iData;
int			iDir;
int			iLen;
int			iCnt;
int			iSys;
int			iPos;


	iSys		= 0;
	m_iSetState = 1;

	   iLen = strlcpy(cText,m_pPath,TWS_MAX_NAME);		// Ist das Verzeichnis ein Sytem-Verzeichnis
	if(iLen && cText[iLen-1]=='\\')
		{
		iLen--;
		cText[iLen] = 0;
		}

	iCnt = m_sFiles.Count();

	SetClassLongPtr(m_cListView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorWait);
	if(HitTest()==2)::SetCursor(m_hCursorWait);

	m_cListView.SetRedraw(FALSE);
	m_cListView.DeleteAllItems();


	for(iPos=0;iPos<iCnt;iPos++)						// Alle Dateien einfgen
		{
		pName	= m_sFiles.Get(iPos);
		iData	= m_iStyle&LVS_TYPEMASK;
		iDir	= GETVAL(m_sFiles,iPos,CTW_IS_DIR);
		iIcon	= GETVAL(m_sFiles,iPos,(iData==LVS_ICON)?CTW_ICON_N:CTW_ICON_S);
		iData	= (iDir)? m_iListLevel+1:m_iListLevel|0x0800;
		iData   |= m_iRootLevel<<16;

		m_cListView.InsertItem (LVIF_TEXT|LVIF_IMAGE|LVIF_PARAM|LVIF_DI_SETITEM,iPos,pName,0,0,iIcon,iData);

		InsertItem(iPos);
		}

	SetClassLongPtr(m_cListView.m_hWnd,GCLP_HCURSOR,(LPARAM)m_hCursorNull);

	m_cListView.SetRedraw(TRUE);
	m_iSetState = 2;


return iCnt;
}

//*****************************************************************************
//*
//*		InsertThread
//*
//*****************************************************************************
//	Thread fr's einfgen in Liastenfenster
DWORD WINAPI CTreeWnd::InsertThread(LPVOID pView)
{
return ((CTreeWnd*)pView)->Insert();
}

//*****************************************************************************
//*
//*		SetComboBox
//*
//*****************************************************************************
//	Eintrag in ComboBox setzen
//	Setzt den aktuellen Eintrag in der ComboBox
//	pPath		: Ist der neue Pfad
//	iLen		: Ist die Lnge des Pfades
//	iLevel		: Ist die Ebene des Pfades (0=Root, -1=automatisch ermitteln)
int	CTreeWnd::SetComboBox(LPCTSTR pPath,int iLen,int iLevel)
{
TCHAR		 	cText[TWS_MAX_NAME+16];
COMBOBOXEXITEM	sData;



	if(m_iStyle&TWS_NOCOMBOBOX)
		{
		return -1;
		}

	if(iLevel<0)										// Level ermitteln
		{
		iLevel = GetLevel(pPath,iLen);
		}


	sData.mask		  =  CBEIF_TEXT;
	sData.pszText	  =  (LPTSTR)pPath;
	sData.iItem		  = -1;

	if(!(m_iStyle&TWS_NOTREEICONS))						// Auch Icon setzen
		{
		sData.mask	 |= CBEIF_IMAGE|CBEIF_SELECTEDIMAGE;
		sData.iImage  = GetIcon(pPath,cText,iLevel,CTW_ICON_S);
		sData.iSelectedImage = sData.iImage;
		}

	m_cComboBox.SetItem(&sData);


return 1;
}

//*****************************************************************************
//*
//*     Set
//*
//*****************************************************************************
//	Setzt den aktuellen Pfad fr das Listenfeld.
//	pPath		: Ist der Pfad der gesetzt werdenn soll.
//				  Bei NULL wird der aktuelle Pfad benutzt.
//	pSubPath	: Wenn dieser Zeiger ungleich NULL ist,  so wird dieser
//				  Zweig an den Pfad angehngt.
//	iMode		: Wie soll das Fenster aktualisiert werden
//					0 = Listenfenster aktualisieren bei Pfadnderungen.
//					1 = Listenfenster nicht aktualisieren.
//						Insert() muss dann extra aufgerufen werden.
//					2 = Listenfenster wird immer aktualisiert
//	bHistory	: Den Pfad in die History einfgen
//	Ergibt die Anzahl der gefunden Dateien bzw. -1 bei einem Fehler.
int CTreeWnd::Set(LPCTSTR pPath,LPCTSTR pSubPath,int iMode,BOOL bHistory)
{
TCHAR		 	cText[TWS_MAX_NAME+16];
TCHAR			cName[TWS_MAX_NAME+16];
HTREEITEM	 	hOpen;
HTREEITEM	 	hNext;
TV_ITEM		 	sItem;
int			 	iIcon;
int			 	iData;
int			 	iPos;
int			 	iCnt;
int			 	iNew;
int			 	iLen;



	hOpen = NULL;
	iNew  = (iMode==2);

	if(!pPath)										// Alten Pfad benutzen ?
		{
		pPath	= (m_pPath)? m_pPath:_T("");
		iLen	= strlcpy(cText,m_pPath,TWS_MAX_NAME);
		pSubPath= 0;
		iNew	= 1;
		}
	else{
		iLen	= strlcpy(cText,pPath,TWS_MAX_NAME);
		pPath	= cText;

		if(pSubPath)								// Unterverzeichnis anhngen
			{
			iLen += strlcpy(cText+iLen,pSubPath,TWS_MAX_NAME-iLen);
			}
		}


	m_iListLevel = 0;


	if(!(m_iStyle&TWS_NOTREEVIEW))					// TreeView ausgeblendet ?
		{
			hOpen=Read(pPath);						// Treefeld aktualisieren
		if(!hOpen)return -1;

		iData		 = m_cTreeView.GetItemData(hOpen);
		m_iRootLevel = (iData&ROOT_DATA)>>16;
		m_iListLevel = (iData)&0x0FFF;
		}


	if(iLen>0 && (cText[iLen-1]!='\\'))				// Backslash anhngen
		{
		cText[iLen] = '\\';	iLen++;
		cText[iLen] = 0;
		}


	if(m_pPath && !iNew && !_tcsicmp(m_pPath,cText))// Ist es der gleiche Pfad
		{
		return m_sFiles.Count();
		}


	if(m_pPath)delete m_pPath;						// Neuen Pfad speichern

	m_pPath = new TCHAR[TWS_MAX_NAME+16];
	memcpy(m_pPath,cText,(iLen+1)*sizeof(TCHAR));


//**************** OpenImage in Treefeld setzen ********************************


	if(m_hTreeOpen)									// Alten offenen Ordner
		{
		iPos = GetPath(m_hTreeOpen,cName,TWS_MAX_NAME+2);

		if(iPos>0 && cName[iPos-1]=='\\')			// Backslash entfernen
			{
			cName[iPos-1] = 0;
			}

		for(;iPos>=0;iPos--)if(cName[iPos]=='\\')break;

		iData				 = m_cTreeView.GetItemData(m_hTreeOpen)&LEVEL_MASK;
		iIcon				 = GetIcon(cName,cName+iPos+1,iData,CTW_ICON_S);

		sItem.hItem			 = m_hTreeOpen;
		sItem.iImage		 = iIcon;
		sItem.iSelectedImage = iIcon;
		sItem.mask			 = TVIF_SELECTEDIMAGE|TVIF_IMAGE;

		m_cTreeView.SetItem(&sItem);
		m_hTreeOpen = NULL;
		}


	iPos = (iLen)? iLen-1:0;

	memcpy(cName,cText,iPos*sizeof(TCHAR));
	cName[iPos] =  0;
	iData		= -1;


	if(iPos>0 && cName[iPos-1]=='\\')				// Backslash entfernen
		{
		cName[iPos-1] = 0;
		}


	if(hOpen)										// Neuen offenen Ordner
		{
		for(;iPos>=0;iPos--)
			{
			if(cName[iPos]=='\\')break;
			}

		iData				 = m_cTreeView.GetItemData(hOpen)&LEVEL_MASK;
		iIcon				 = GetIcon(cName,cName+iPos+1,iData,CTW_ICON_O);

		sItem.hItem			 = hOpen;
		sItem.iImage		 = iIcon;
		sItem.iSelectedImage = iIcon;
		sItem.mask           = TVIF_SELECTEDIMAGE|TVIF_IMAGE;

		m_hTreeOpen = hOpen;

		for(hNext=hOpen;;)
			{
				hNext = m_cTreeView.GetParentItem(hNext);
			if(!hNext)break;

			m_cTreeView.Expand(hNext,TVE_EXPAND);
			}

		m_cTreeView.SetRedraw(FALSE);

		m_cTreeView.SetItem      (&sItem);
		m_cTreeView.SelectItem   ( hOpen);
		m_cTreeView.EnsureVisible( hOpen);

		m_cTreeView.SetRedraw(TRUE);
		}


//******************** ComboBox einstellen *************************************


	SetComboBox(cName,iPos,iData);					

	if(bHistory)
		{
		AddToHistory(cName);
		}

	if(iLen>0 && cName[iLen-1]=='\\')
		{
		iLen--;
		}
	
	for(iCnt=0;iCnt<iLen;iCnt++)
		{
		if(cName[iCnt]=='\\')break;
		}


	m_bUbEnable = iCnt<iLen;
	m_cBtDoUp.EnableWindow(m_bUbEnable);


//**************** Listfeld auffllen ******************************************


	if(m_iStyle&TWS_NOLISTVIEW)						// ListView ausgeblendet ?
		{
		StatusbarSet();
		m_iCount = 0;
		return 0;
		}

	m_sFiles.Del();

	if(m_pPath && *m_pPath)							// Dateien einlesen
		{
		if(!(m_iStyle&TWS_NOSUBDIR))
			{
			iPos = m_iListLevel|(m_iRootLevel<<16);
			ReadDirs(&m_sFiles,m_pPath,iPos);
			}

		ReadFiles(&m_sFiles,m_pPath,iPos);
		}

	iCnt = m_sFiles.Count();

	if(m_hSetThread)								// Thread beenden
		{
		TerminateThread(m_hSetThread,0);
		CloseHandle(m_hSetThread);
		m_hSetThread = 0;
		}


	m_iSetState = 0;


	if(iMode==0 || iMode==2)						// Den Thread fr's Aktualisieren starten
		{
		m_hSetThread = CreateThread(0,0,InsertThread,this,0,&m_dwSetThreadId);
		}

	StatusbarSet();
	m_iCount = iCnt;

	PostMessage(WM_COMMAND,TWN_PATHCHANGE|0x10000,0);


return iCnt;
}

//*****************************************************************************
//*
//*     Sort
//*
//*****************************************************************************
//	Sortiert das Listenfenster.
//	iMode		: Ist die Spalte nach der sortiert werden soll.
//	iDir		: Ist die Sortierrichtung.
//	Ergibt 1 wenn Sortiert wurde
int  CTreeWnd::Sort(int iMode,int iDir)
{
int		iPos;
int		iOld;
int		iCnt;
int		iVal;


	if(iMode)return 0;

	iOld = m_iSortMode;
	iCnt = m_sFiles.Count();

	for(iPos=0;iPos<iCnt;iPos++)						// Zhle die Verzeichnisse am Anfang
		{
		    iVal = GETVAL(m_sFiles,iPos,CTW_IS_DIR);
		if(!iVal)break;
		}

	m_sFiles.Sort(0, iPos,CSC_SORT_CASE,iDir);
	m_sFiles.Sort(iPos,-1,CSC_SORT_CASE,iDir);

	if(m_hSetThread)									// Thread beenden
		{
		TerminateThread(m_hSetThread,0);
		CloseHandle(m_hSetThread);
		m_hSetThread = 0;
		}

	m_iSortDir	 = iDir;
	m_iSortMode  = iMode;
	m_hSetThread = CreateThread(0,0,InsertThread,this,0,&m_dwSetThreadId);



return 1;
}

//*****************************************************************************
//*
//*     HitTest
//*
//*****************************************************************************
//	Stellt fest auf welchem Eintrag im Listen- oder Tree-Fenster der Cursor steht.
//	sPoint		: Sind die Cursor-Koordinaten relativ zur linken oberen Bildschirmecke.
//				  Wenn sPoint nicht angeben ist wird die Cursor-Position benutzt.
//	pEntry		: Hier wird das Handle der betroffenen Eintrages gespeichert.
//					Ist ein Eintrag im Listview betroffen so wird sein Index  in *(int*)Element gespeichert.
//					Ist ein Eintrag im Listview betroffen so wird sein Zeiger in *(HTREEITEM*)Element gespeichert.
//				  Wenn pEntry nicht angeben ist muss der Cursor direkt ber dem
//				  Fenster sein, ohne berlagerung von anderen Fenstern.
//	Ergibt	0 wenn kein Eintrag gefunden wurde.
//			1 wenn ein  Eintrag aus dem Treefeld gefunden wurde.
//			2 wenn ein  Eintrag aus dem Listfeld gefunden wurde.
//			3 wenn ein  Eintrag auf der ComboBox gefunden wurde.
//		    4 wenn ein  Eintrag in einem zustzlichen Feld liegt
int CTreeWnd::HitTest(CPoint sPoint,LPVOID pEntry)
{
int			iIndex;
UINT		uFlags;
CPoint		sPlace;
CRect		sRect;
HTREEITEM	hItem;



//************** Ist Cursor im Treefeld ? **************************************

	m_cTreeView.GetWindowRect(&sRect);

	if(sRect.PtInRect(sPoint))
		{
		sPlace.x = sPoint.x-sRect.left;
		sPlace.y = sPoint.y-sRect.top;

		hItem = m_cTreeView.HitTest(sPlace,&uFlags);

		if(uFlags&(TVHT_ABOVE|TVHT_BELOW))hItem=0;

		SETITEM(pEntry,hItem);

		return (hItem)? 1:0;
		}


//************** Ist Cursor im Listfeld ? **************************************

	m_cListView.GetWindowRect(&sRect);

	if(sRect.PtInRect(sPoint))
		{
		sPlace.x = sPoint.x-sRect.left;
		sPlace.y = sPoint.y-sRect.top;

		iIndex = m_cListView.HitTest(sPlace,&uFlags);

		if(uFlags&(LVHT_ABOVE|LVHT_BELOW))iIndex=-1;

		SETITEM(pEntry,iIndex);

		return (iIndex!=-1)? 2:0;
		}


//************** Ist Cursor in ComboBox ? **************************************

	m_cComboBox.GetWindowRect(&sRect);

	if(sRect.PtInRect(sPoint))
		{
		sPlace.x = sPoint.x-sRect.left;
		sPlace.y = sPoint.y-sRect.top;

		SETITEM(pEntry,0);

		return 3;
		}


//************** Ist Cursor in einem Externen Feld ? ***************************

	SETITEM(pEntry,0);

	if(m_pHitTestProc)
		{
		if(m_pHitTestProc(sPoint,pEntry,m_pData))
			{
			return 4;
			}
		}



return 0;
}

int CTreeWnd::HitTest(LPVOID pEntry)
{
CPoint	sPoint;
HWND	hWnd;


	GetCursorPos(&sPoint);

	if(!pEntry)
		{
		hWnd = ::WindowFromPoint(sPoint);

		if(hWnd==m_cTreeView.m_hWnd)return 1;
		if(hWnd==m_cListView.m_hWnd)return 2;
		if(hWnd==m_cComboBox.m_hWnd)return 3;

		return 0;
		}


return HitTest(sPoint,pEntry);
}

//*****************************************************************************
//*
//*     OnKeyDown
//*
//*****************************************************************************
void CTreeWnd::OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags)
{
int		iFlags;

	if(m_iDragState && (nChar==0x10 || nChar==0x11))
		{
		iFlags  = m_iDropFlags;
		iFlags |= (nChar==0x10)? MK_SHIFT:MK_CONTROL;

		OnMouseMove(iFlags,CPoint(0,0));
		}

}

//*****************************************************************************
//*
//*     OnKeyUp
//*
//*****************************************************************************
void CTreeWnd::OnKeyUp(UINT nChar,UINT nRepCnt,UINT nFlags)
{
int		iFlags;


	if(m_iDragState && (nChar==0x10 || nChar==0x11))
		{
		iFlags  = m_iDropFlags;
		iFlags &= (nChar==0x10)? ~MK_SHIFT:~MK_CONTROL;

		OnMouseMove(iFlags,CPoint(0,0));
		}

}

//*****************************************************************************
//*
//*     OnMouseMove
//*
//*****************************************************************************
void CTreeWnd::OnMouseMove(UINT nFlags,CPoint sPoint)
{
TCHAR		cText[TWS_MAX_NAME];
CString		sString;
CPoint		sPlace;
HTREEITEM 	hItem;
LPCTSTR		pPtr;
LPVOID		hHit;
int			iNum;
int			iDir;
int			iSet;



	if(!m_iDragState)
		{
		if(!(m_iStyle&TWS_NOCOMBOBOX) && sPoint.y<m_iComboEnd)
			{
			::SetCursor(m_hCursorNull);					// Auf Namenszeile
			}

		return;
		}


	GetCursorPos(&sPlace);								// Cursor-Position holen
	m_pDragImages->DragMove(sPlace);					// ImageList verschieben
	iSet = HitTest(sPlace,&hHit);						// Eintrag holen

	if((m_iStyle&TWS_NODROP) && iSet<3)
		{
		iSet = 0;
		}

	nFlags &= MK_SHIFT|MK_CONTROL;

	if(!(m_iDropFlags^nFlags))
	if(  m_iDropView   ==iSet)
	if(  m_hDropEntry  ==hHit)							// Gab es eine Vernderung
		{
		return;
		}

	m_hDropEntry = hHit;
	m_iDropView  = iSet;
	m_iDropFlags = nFlags;


	//************** Alte Dropziele neuzeuchen *****************************


	if(m_hDropItem)										// DropTarget lschen
		{
		m_pDragImages->DragShowNolock(0);
		m_cTreeView   .SelectDropTarget (0);
		m_pDragImages->SetOverlayImage(0,0);
		m_pDragImages->DragShowNolock(1);
		m_hDropItem=0;
		}

	if(m_iDropItem!=-1)									// DropTarget lschen
		{
		m_pDragImages->DragShowNolock(0);
		m_cListView   .SetItem(m_iDropItem,0,LVIF_STATE,0,0,0,LVIS_DROPHILITED,0);
		m_cListView   .UpdateWindow();
		m_pDragImages->DragShowNolock(1);
		m_iDropItem = -1;
		}


	switch(iSet)
		{
	case 1:												// Cursor ist im Treefeld

		hItem = (HTREEITEM)hHit;

		m_pDragImages->DragShowNolock(0);				// DropTarget neu zeichnen
		m_cTreeView   .SelectDropTarget(hItem);
		m_pDragImages->DragShowNolock(1);
		m_hDropItem=hItem;

		GetPath(hItem,cText,TWS_MAX_NAME);				// Ablage erlaubt ?

		if(!_tcsicmp(m_pDragPath,cText) || (m_iDropNext  && !cText[m_iDropNext] && !strnicmp(m_pDragPath,cText,m_iDropNext)))
			{
			m_iDropMode = -1;
			SetCursor(1);
			return;
			}

		iDir =strnicmp(cText,m_pDragPath,m_iDragDrive);	// Move oder Copy ?

		if(nFlags&MK_SHIFT  )iDir=0;
		if(nFlags&MK_CONTROL)iDir=1;

		if(iDir)										// Copy
			{
			SetCursor(2);
			m_iDropMode = 0;
			}
		else{											// Move
			SetCursor(3);
			m_iDropMode = 1;
			}

		return;

	case 2:												// Cursor ist im Listfeld

		iNum = (int)hHit;

		m_pDragImages->DragShowNolock(0);				// DropTarget neu zeichnen

		if(m_iDropItem!=-1)
			{
			m_cListView.SetItem(m_iDropItem,0,LVIF_STATE,0,0,0,LVIS_DROPHILITED,0);
			}

		m_cListView.SetItem(iNum,0,LVIF_STATE,0,0,LVIS_DROPHILITED,LVIS_DROPHILITED,0);
		m_cListView.UpdateWindow();
		m_pDragImages->DragShowNolock(1);
		m_iDropItem = iNum;

			iDir = GETVAL(m_sFiles,iNum,CTW_IS_DIR);
		if(!iDir)
			{
			pPtr = m_pPath;
			}
		else{
			GetPath(iNum,cText,TWS_MAX_NAME);
			pPtr = cText;
			}
														// Ablage erlaubt ?
		if(pPtr)
			{
			if(!_tcsicmp(m_pDragPath,pPtr) || (m_iDropNext && !pPtr[m_iDropNext] && !strnicmp(m_pDragPath,pPtr,m_iDropNext)))
				{
				m_iDropMode = -1;
				SetCursor(1);
				return;
				}
			}

		iDir = strnicmp(cText,m_pDragPath,m_iDragDrive);// Move oder Copy ?
		if(nFlags&MK_SHIFT  )iDir=0;
		if(nFlags&MK_CONTROL)iDir=1;

		if(iDir)										// Copy
			{
			SetCursor(2);
			m_iDropMode = 0;
			}
		else{											// Move
			SetCursor(3);
			m_iDropMode = 1;
			}

		return;


	case 4:												// Cursor ist in externen Feld

		iDir = (m_pGetModeProc)? m_pGetModeProc(nFlags,&m_hDropEntry,m_pData):2;

		if(iDir==1)
			{
			SetCursor(2);
			m_iDropMode = 1;
			return;
			}

		if(iDir==2)
			{
			SetCursor(3);
			m_iDropMode = 0;
			return;
			}

	default: 											// Ablage sperren

		SetCursor(1);
		m_iDropMode = -1;
		return;
		}


}

//*****************************************************************************
//*
//*     OnLButtonDown
//*
//*****************************************************************************
void CTreeWnd::OnLButtonDown(UINT nFlags,CPoint sPoint)
{
CPoint	sPlace;
CRect	sRect;
int		iDif;



	GetRectView(sRect);

	if(!(m_iStyle&TWS_NOCOMBOBOX))
		{
		if(sPoint.y<m_iComboEnd)
			{
			::SetCursor(m_hCursorNull);
			return;
			}
		
		sRect.top += m_iComboEnd;
		}


	sPlace    = sPoint;
	sPlace.x -= m_iSeparator;

		iDif = Resize(this,TRUE,sRect,m_iSeparator,sPlace,7,5);
	if(!iDif)return;


	GetClientRect(&sRect);

	m_iSeparator += iDif;

	if(m_iSeparator>=sRect.right)
		{
		m_iSeparator = sRect.right-1;
		}

	if(m_iSeparator<0)
		{
		m_iSeparator = 0;
		}

	m_bSepChanged = TRUE;

	OnSize(0,sRect.right,sRect.bottom);

}

//*****************************************************************************
//*
//*     OnLButtonUp
//*
//*****************************************************************************
void CTreeWnd::OnLButtonUp(UINT nFlags,CPoint sPoint)
{
TCHAR		cText[TWS_MAX_NAME+16];
CPoint		sPlace;
LPVOID		hItem;
int			iSet;



	if(m_iDragState)
		{
		m_iDragState = 0;
		m_pDragImages->EndDrag();					// ImageList interne Puffer freigeben
		m_pDragImages->DragLeave(NULL);				// DragImage von Fenster entfernen

		delete m_pDragImages;
		m_pDragImages = NULL;

		ReleaseCapture();                           // Capture freigeben
		SetCursor(0);

		if(m_hDropItem)
			{
			m_cTreeView.SelectDropTarget(0);
			m_hDropItem=0;
			}

		if(m_iDropItem!=-1)
			{
			m_cListView.SetItem(m_iDropItem,0,LVIF_STATE,0,0,0,LVIS_DROPHILITED,0);
			m_cListView.UpdateWindow( );
			m_iDropItem=-1;
			}

		GetCursorPos(&sPlace);
		iSet = HitTest(sPlace,&hItem);				// Eintrag ermitteln

		if((m_iStyle&TWS_NODROP) && iSet<3)
			{
			iSet = 0;
			}

		if(iSet)
			{
			cText[0] = 0;

			if(iSet==3 && m_pGetPathProc)
				{
				m_pGetPathProc(&hItem,cText,TWS_MAX_NAME,m_pData);
				}

			if(iSet==1)GetPath((HTREEITEM)hItem,cText,TWS_MAX_NAME);
			if(iSet==2)GetPath((INT)      hItem,cText,TWS_MAX_NAME);

			DoDrop(cText,m_iDropMode);
			}
		}

}

//*****************************************************************************
//*
//*     OnCreate
//*
//*****************************************************************************
int CTreeWnd::OnCreate(LPCREATESTRUCT pCreate)
{

	if(CWnd::OnCreate(pCreate)==-1)
		{
		return -1;
		}

	if(  m_iStyle&TWS_DRAGDROP)
	if(!(m_iStyle&TWS_NODROP ))
		{
		DragAcceptFiles();
		}


return 0;
}

//*****************************************************************************
//*
//*     OnDropFiles
//*
//*****************************************************************************
void CTreeWnd::OnDropFiles(HDROP hDropInfo)
{
TCHAR		cText[TWS_MAX_NAME+16];
POINT		sPlace;
LPVOID		hItem;
int			iSet;
int			iCnt;


	if(!m_iDragState)
	do	{
		DragQueryPoint(hDropInfo,&sPlace);
		iSet = HitTest(sPlace,&hItem);				// Eintrag ermitteln

		if((m_iStyle&TWS_NODROP) && iSet<3)
			{
			iSet = 0;
			}

		if(iSet==0)break;
		if(iSet==1)GetPath((HTREEITEM)hItem,cText,TWS_MAX_NAME);
		if(iSet==2)GetPath((INT)      hItem,cText,TWS_MAX_NAME);

		m_sDragFiles.Del();  						// Darg-Dateien einlesen

		iCnt = DragQueryFile(hDropInfo,-1,cText,TWS_MAX_NAME);

		for(iSet=0;iSet<iCnt;iSet++)
			{
			iCnt = DragQueryFile(hDropInfo,iSet,cText,TWS_MAX_NAME);
			m_sDragFiles.Add(cText);
			}

		if(iCnt)DoDrop(cText,0);
		}while(1);


	DragFinish(hDropInfo);

}

//*****************************************************************************
//*
//*     OnPathUp
//*
//*****************************************************************************
// Der aktuelle Pfad wird um eins nach Oben durchlaufen.
void CTreeWnd::OnPathUp()
{
TCHAR	cPath[TWS_MAX_NAME+16];
int		iLen;


	if(!m_pPath)return;

	iLen = strlcpy(cPath,m_pPath,TWS_MAX_NAME);

	if(iLen && cPath[iLen-1]=='\\')iLen--;
	if(cPath[iLen]==':')return;

	while(iLen)
		{
		iLen--;
		if(cPath[iLen]=='\\')break;
		if(cPath[iLen]!=':' )continue;
		
		m_cBtDoUp.EnableWindow(FALSE);
		m_bUbEnable = FALSE;

		return;
		}

	if(iLen==0)
		{
		m_cBtDoUp.EnableWindow(FALSE);
		m_bUbEnable = FALSE;
		return;
		}

	if(iLen==1 && cPath[1]==':')
		{
		cPath[2] = '\\';
		cPath[3] = 0;
		iLen     = 2;
		}
	
	cPath[iLen+1]=0;
	
	Set(cPath,NULL,0,TRUE);

}

//*****************************************************************************
//*
//*     OnSetFocus
//*
//*****************************************************************************
void CTreeWnd::OnSetFocus(CWnd *pOldWnd)
{

	StatusbarInit();

	if(m_iLastFocus==1 && !(m_iStyle&TWS_NOTREEVIEW)){m_cTreeView.SetFocus();return;}
	if(m_iLastFocus==2 && !(m_iStyle&TWS_NOLISTVIEW)){m_cListView.SetFocus();return;}
	if(m_iLastFocus==3 && !(m_iStyle&TWS_NOCOMBOBOX)){m_cComboBox.SetFocus();return;}


	if(!(m_iStyle&TWS_NOTREEVIEW)){m_cTreeView.SetFocus();return;}
	if(!(m_iStyle&TWS_NOLISTVIEW)){m_cListView.SetFocus();return;}
	if(!(m_iStyle&TWS_NOCOMBOBOX)){m_cComboBox.SetFocus();return;}

}

//*****************************************************************************
//*
//*     OnTimer
//*
//*****************************************************************************
void CTreeWnd::OnTimer(UINT_PTR nIdEvent)
{

	if(nIdEvent==ID_STATUSBARSET)
		{
		if(m_iSetStatubar)
			{
			m_iSetStatubar=0;
			StatusbarSet();
			m_iSetStatubar=0;
			}
		}


	if(nIdEvent==ID_COMBOUPDATE)
		{
		if(!m_uComboTick)
			{
			m_bComboTimer = FALSE;
			KillTimer(ID_COMBOUPDATE);
			return;
			}

			m_uComboTick--;
		if(!m_uComboTick)
			{
			CbUpdate();
			}

		return;
		}


CWnd::OnTimer(nIdEvent);
}

//*****************************************************************************
//*
//*		GetCbText
//*
//*****************************************************************************
//	Holt den Text eines Eintrages aus der Combobox
//	iPos		: Ist die Position des Eintrages (-1 Edit-Zeile)
//	pBuffer		: Puffer wo der Text gespeichert wird
//	Ergibt die Textlnge oder -1 bei einem Fehler.
int CTreeWnd::GetCbText(int iPos,LPTSTR pBuffer)
{
COMBOBOXEXITEM	sData;


	sData.mask		  = CBEIF_TEXT;
	sData.cchTextMax  = TWS_MAX_NAME+16;
	sData.pszText	  = pBuffer;
	sData.iItem		  = iPos;

	if(!m_cComboBox.GetItem(&sData))
		{
		return -1;
		}


return _tcslen(pBuffer);
}

//*****************************************************************************
//*
//*		CbUpdate
//*
//*****************************************************************************
//	Holt den Pfad aus der ComboBox und aktalisiert Tree- und Listenfenster.
//	Erbibt eine Status-Code ber die Aktion:
//			0 =	ComboBox ist nicht sichtbar
//			1 = Der eingegebene Pfad existiert nicht
//			2 = Es wurde der aktuelle Pfad eingegeben
//			3 = Ein neuer Pfad wurde ausgewhlt
int	CTreeWnd::CbUpdate()
{
TCHAR		 	cPath[TWS_MAX_NAME+16];
TCHAR		 	cName[TWS_MAX_NAME+16];
CWnd		   *pFocus;
COMBOBOXEXITEM	sData;
BOOL			bFlag;
int				iData;
int				iLen;
int				iNum;
int				iPos;


	bFlag		 = m_bComboSave;
	m_bComboSave = FALSE;

	
	if(m_iStyle&TWS_NOCOMBOBOX)							// Keine ComboBox sichtbar
		{
		return 0;
		}

	   iLen = GetCbText(-1,cPath);
	if(iLen<0)
		{
		return 0;
		}

	iLen = _tcslen(cPath  );
	iNum = _tcslen(m_pPath);

	if(iLen>0 && cPath[iLen-1]=='\\')
		{
		iLen--;
		}

	if(iNum>0 && m_pPath[iNum-1]=='\\')
		{
		iNum--;
		}

	
	iLen  = CheckPath(cPath,iLen,iData);


	if(iLen==iNum && !_tcsnicmp(cPath,m_pPath,iLen))	// Ist der Pfad bereits gesetzt
		{
		return 2;
		}


	if(!iLen)											// Existiert der Pfad
		{
		   iData = m_cComboBox.GetCurSel();
		if(iData<0)
			{
			pFocus = GetFocus();

			if(pFocus && pFocus->m_hWnd==m_cComboBox.GetEditCtrl()->m_hWnd)
				{
				MessageBeep(MB_ICONASTERISK);
				return 1;
				}
			}

		SetComboBox(m_pPath,iNum);						// Alten Pfad wieder eintragen

		return 1;
		}


	if(bFlag)											// Den Eintrag in die Combo-Liste eintragen
		{
		cPath[iLen] = 0;

		
		iPos = m_cComboBox.GetCount();

		while(iPos>15)									// Gibt es zu viele Eintrge
			{
			iPos -= 1;
			m_cComboBox.DeleteItem(iPos);
			}
		
		while(iPos>0)									// Gibt es den Pfad bereits
			{
			iPos -= 1;
			iNum  = GetCbText(iPos,cName); 
			
			if(iNum<0)continue;

			if(iNum>0 && cName[iNum-1]=='\\')
				{
				iNum--;
				}

			if(iNum==iLen && !_tcsnicmp(cPath,cName,iNum))
				{
				m_cComboBox.DeleteItem(iPos);
				}
			}


		sData.mask		  = CBEIF_TEXT;
		sData.pszText	  = cPath;
		sData.iItem		  = 0;

		if(!(m_iStyle&TWS_NOTREEICONS))
			{
			TCHAR	cName[TWS_MAX_NAME+16];

			iNum		  = GetLevel(sData.pszText);
			sData.mask	 |= CBEIF_IMAGE|CBEIF_SELECTEDIMAGE;
			sData.iImage  =	GetIcon(sData.pszText,cName,iNum,CTW_ICON_S);
			sData.iSelectedImage = sData.iImage;
			}

		m_cComboBox.InsertItem(&sData);
		}


	Set(cPath,NULL,0,TRUE);


return 3;
}

//*****************************************************************************
//*
//*     OnClose
//*
//*****************************************************************************
void CTreeWnd::OnClose()
{

	KillTimer(ID_STATUSBARSET);

	if(m_hSetThread)								// Thread beenden
		{
		TerminateThread(m_hSetThread,0);
		CloseHandle(m_hSetThread);
		m_hSetThread = 0;
		}

	CWnd::OnClose();
}

//*****************************************************************************
//*
//*		GetSelect
//*
//*****************************************************************************
// Kopriert die ausgewhlten Dateien in eine String-Kette.
// Art:		0 Aktuelles Fenster
//			1 TreeView
//			2 ListView
// Ergibt die Anzahl der kopierten Dateien.
int CTreeWnd::GetSelect(CStringChain *pFiles,int iMode)
{
TCHAR	 cText[TWS_MAX_NAME+16];
CWnd	*pWnd;
int		 iItem;
int		 iLen;
int		 iCnt;


	iCnt = 0;
	pFiles->Del();  								// Dateien lschen

	if(!iMode)
		{
			pWnd=GetFocus();
		if(!pWnd)return 0;
		}
													// Im Treeview ?
	if(iMode==1 || (!iMode && pWnd->m_hWnd==m_cTreeView.m_hWnd))
		{
		   iLen = GetPath(m_cTreeView.GetSelectedItem(),cText,TWS_MAX_NAME);
		if(iLen>3 && cText[iLen-1]=='\\')
			{
			iLen--;
			cText[iLen] = 0;
			}

		pFiles->Add(iLen,cText);

		return 1;
		}


	iItem = -1;
													// Im Listview ?
	if(iMode==2 || (!iMode && pWnd->m_hWnd==m_cListView.m_hWnd))
		{
		for(;;)
			{										// Dateien einlesen
			   iItem = m_cListView.GetNextItem(iItem,LVNI_SELECTED);
			if(iItem==-1)break;

			   iLen = GetPath(iItem,cText,TWS_MAX_NAME);
			if(iLen>3 && cText[iLen-1]=='\\')
				{
				iLen--;
				cText[iLen] = 0;
				}

			pFiles->Add(iLen,cText);
			iCnt++;
			}
		}


return iCnt;
}

//*****************************************************************************
//*
//*     OnMenu
//*
//*****************************************************************************
// Ansichts Men einstellen
void CTreeWnd::OnMenu(CCmdUI *pCmdUI)
{
int		iStyle;
int		iFlag;


	iStyle	= ::GetWindowLong(m_cListView.m_hWnd,GWL_STYLE);
	iStyle &= LVS_TYPEMASK;

	switch(pCmdUI->m_nID)
		{
	case ID_SETICON:		iFlag=iStyle==LVS_ICON;			break;
	case ID_SETLIST:		iFlag=iStyle==LVS_LIST;			break;
	case ID_SETSMALLICON:	iFlag=iStyle==LVS_SMALLICON;	break;
	case ID_SETREPORT:		iFlag=iStyle==LVS_REPORT;		break;
		}

	pCmdUI->SetRadio(iFlag);

}

//*****************************************************************************
//*
//*     OnListItemChanged
//*
//*****************************************************************************
void CTreeWnd::OnListItemChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
NM_LISTVIEW	 *pList;
int	          iBits;


	pList   = (NM_LISTVIEW*)pNmHdr;
	iBits	= pList->uNewState;
	iBits  ^= pList->uOldState;

	if(iBits&LVIS_SELECTED)m_iSetStatubar=1;

}

//*****************************************************************************
//*
//*     OnListColumnClick
//*
//*****************************************************************************
void CTreeWnd::OnListColumnClick(NMHDR *pNmHdr,LRESULT *pResult)
{
NM_LISTVIEW	 *pList;
int	          iMode;
int	          iDir;


	if(m_iStyle&TWS_NOSORT)return;

	pList = (NM_LISTVIEW*)pNmHdr;
	iMode = m_iSortMode;
	iDir  = m_iSortDir;

	if(pList->iSubItem==m_iSortMode)
		{
		iDir  = !m_iSortDir;
		}
	else{
		iMode = pList->iSubItem;
		iDir  = 0;
		}

	if(!Sort(iMode,iDir))return;

	m_iSortMode = iMode;
	m_iSortDir  = iDir;

}

//*****************************************************************************
//*
//*     OnListKeyDown
//*
//*****************************************************************************
void CTreeWnd::OnListKeyDown(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR		cText[TWS_MAX_NAME+260];
LV_KEYDOWN *pKeyData;
INT			iLevel;
HTREEITEM	hItem;
LPCTSTR		pName;
int			iNum;
int			iPos;
int			iLen;
int			iDir;



	pKeyData = (LV_KEYDOWN*)pNmHdr;


	if(pKeyData->wVKey==VK_RETURN)					// Wurde Return-Taste gedrckt
		{
		   iPos=m_cListView.GetNextItem(-1,LVNI_FOCUSED);
		if(iPos==-1)return;

			iDir=GETVAL(m_sFiles,iPos,CTW_IS_DIR);
		if(!iDir)return;

		pName	= m_sFiles.Get(iPos,iNum);

		iLen  = strlcpy(cText     ,m_pPath,TWS_MAX_NAME+256);
		iLen += strlcpy(cText+iLen,pName  ,TWS_MAX_NAME+256-iLen,iNum);

		Set(cText,NULL,0,TRUE);

		return;
		}

	
	if(pKeyData->wVKey==VK_F5)						// Verzeichnis neu laden
		{
		hItem = m_cTreeView.GetNextItem(TVI_ROOT,TVGN_CARET);
		if(hItem)ReadSubDirs(hItem,NULL,1);
		Set(m_pPath,NULL,2,FALSE);
		return;
		}


	if(pKeyData->wVKey==VK_TAB)
		{
		if(GetAsyncKeyState(VK_SHIFT)&0x8000)		// Zum vorherigen Fenster springen
			{
			if(!(m_iStyle&TWS_NOTREEVIEW))
				{
				m_cTreeView.SetFocus();
				}
			else if(!(m_iStyle&TWS_NOCOMBOBOX))
				{
				m_cComboBox.SetFocus();
				}
			else if(m_iStyle&TWS_TABEXIT)
				{
				GetParent()->SetFocus();
				}
			}
		else{										// Zum nchsten Fenster springen
			if(m_iStyle&TWS_TABEXIT)
				{
				GetParent()->SetFocus();
				}
			else if(!(m_iStyle&TWS_NOCOMBOBOX))
				{
				m_cComboBox.SetFocus();
				}
			else if(!(m_iStyle&TWS_NOTREEVIEW))
				{
				m_cTreeView.SetFocus();
				}
			}

		*pResult = 1;

		return;
		}


	if(pKeyData->wVKey==VK_DELETE)					// Lschen mit Taste
		{
		if(!(m_iStyle&TWS_DELETE))					// Ist lschen erlaubt
			{
			return;
			}

		for(;;)										// Alle gewhlten Eintrge lschen
			{
			   iPos = m_cListView.GetNextItem(-1,LVNI_SELECTED);
			if(iPos==-1)break;

			iLen	= GetPath(iPos,cText,TWS_MAX_NAME+2);
			iLevel	= m_cListView.GetItemData(iPos)&0x0FFF;

			if(iLen && cText[iLen-1]=='\\')
				{
				iLen--;
				cText[iLen] = 0;
				}

			for(;iLen>=0;iLen--)
				{
				if(cText[iLen]=='\\')break;
				}

			if(!DoDelete(cText,cText+iLen+1,iLevel))
				{
				continue;
				}

			m_cListView.DeleteItem(iPos);
			m_sFiles.Del(iPos);

			if(iLevel&0x800)continue;

			Read(cText);
			}
		}

}


//*****************************************************************************
//*
//*     OnListEndEdit
//*
//*****************************************************************************
void CTreeWnd::OnListEndEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR		  cText[TWS_MAX_NAME+260];
INT	          iLevel;
LV_DISPINFO	 *pDisp;
int	          iItem;
int	          iLen;



	if(!(m_iStyle&TWS_RENAME))						// Ist Rename erlaubt
		{
		return;
		}

	pDisp = (LV_DISPINFO*)pNmHdr;

	m_iDoRename &= ~2;

	if(!pDisp->item.pszText)
		{
		return;
		}

	iItem	= pDisp->item.iItem;
	iLevel  = pDisp->item.lParam&0x0FFF;
	iLen	= GetPath(iItem,cText,TWS_MAX_NAME+2);

	if(iLen && cText[iLen-1]=='\\')					// Backslash entfernen
		{
		iLen--;
		cText[iLen] = 0;
		}

	if(Rename(cText,pDisp->item.pszText,iLevel))	// Umbenennen
		{
		m_cListView.SetItemText(iItem,0,pDisp->item.pszText);
		}

}



//*****************************************************************************
//*
//*     OnListBeginEdit
//*
//*****************************************************************************
void CTreeWnd::OnListBeginEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR			cText[TWS_MAX_NAME+260];
INT				iLevel;
LV_DISPINFO	   *pDisp;
int				iLen;



	*pResult = 1;

	if(!(m_iStyle&TWS_RENAME))						// Ist Umbenennen erlaubt
		{
		return;
		}

	pDisp	= (LV_DISPINFO*)pNmHdr;
	iLen	= GetPath(pDisp->item.iItem,cText,TWS_MAX_NAME+2);
	iLevel  = pDisp->item.lParam&0x0FFF;

	if(iLen && cText[iLen-1]=='\\')					// Backslash entfernen
		{
		cText[iLen-1] = 0;
		}

	if(!DoRename(cText,pDisp->item.pszText,iLevel))
		{
		return;
		}

	m_iDoRename |= 2;

	*pResult = 0;

}


//*****************************************************************************
//*
//*     OnListBeginDrag
//*
//*****************************************************************************
void CTreeWnd::OnListBeginDrag(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR		  cText[TWS_MAX_NAME+260];
CPoint		  sPlace;
NM_LISTVIEW	 *pList;
int	          iItem;
int	          iLen;
int	          iDir;
int	          iCnt;


	pList = (NM_LISTVIEW*)pNmHdr;


	return;											// REM AZ fehlt noch

	if(!(m_iStyle&TWS_DRAGDROP))					// Ist Drag erlaubt
		{
		return;
		}

	if(m_iDragState)return;			// Drag & Drop bereits aktiv ?

	m_cListView.UpdateWindow();
	GetCursorPos(&sPlace);				// Cursorpositon ermitteln

	iCnt = m_cListView.GetSelectedCount();

	if(m_pDragImages && m_iDragImgMode)
		{
		delete m_pDragImages;
		}

	if(iCnt<=1)
		{
		m_iDragImgMode = 0;
		m_pDragImages  = m_cListView.CreateDragImage(pList->iItem,&sPlace);
		}
	else{
		m_iDragImgMode =1;
		m_pDragImages  = new CImageList();
		m_pDragImages->Create(MAKEINTRESOURCE(IDB_DRAGTHREE),95,1,RGB(255,255,255));

		#ifdef _DEBUG
		if(!m_pDragImages->m_hImageList){MessageBox(_T("IDB_DRAGTHREE Bitmap Resourse fehlt"));ASSERT(0);}
		#endif
		}

	if(!m_pDragImages)return;

	m_pDragImages->BeginDrag(0,CPoint(20,10));
	m_pDragImages->DragEnter(0,sPlace);

	m_iDragState = 1;								// Drag & Drop einschalten
	m_iDropFlags = 0;								// Tasten Zustand
	m_hDropItem  = 0;								// DropTarget Tree-Item
	m_iDropMode	 = 0;								// Drag Art = Move
	m_iDropItem  =-1;								// DropTarget List-Item
	m_iDropView	 =-1;								// Drop Eintrag
	m_hDropEntry = NOITEM;							// Drop Fenster

	if(!m_pDragPath)
		{
		m_pDragPath = new TCHAR[TWS_MAX_NAME+16];
		}

	   iDir = GETVAL(m_sFiles,pList->iItem,CTW_IS_DIR);
	if(iDir && iCnt<=1)
		 iLen=GetPath(pList->iItem,m_pDragPath,TWS_MAX_NAME);
	else iLen=strlcpy(m_pDragPath ,m_pPath    ,TWS_MAX_NAME);

	m_iDragDrive = strchar(m_pDragPath,':')+1;

	if(iCnt<=1 && iDir)
		{
		m_iDropNext = iLen;

		for(m_iDropNext--;m_iDropNext>0;m_iDropNext--)
			{
			if(m_pDragPath[m_iDropNext-1]=='\\')break;
			}
		}
	else{
		m_iDropNext = 0;
		}

	iItem = -1;
	m_sDragFiles.Del();

	for(;;)											// Darg-Dateien einlesen
		{
		   iItem = m_cListView.GetNextItem(iItem,LVNI_SELECTED);
		if(iItem==-1)break;

		   iLen = GetPath(iItem,cText,TWS_MAX_NAME);
		if(iLen>3 && cText[iLen-1]=='\\')
			{
			iLen--;
			cText[iLen]=0;
			}

		m_sDragFiles.Add(iLen,cText);
		}

	SetCapture();

}


//*****************************************************************************
//*
//*     OnListDoubleClick
//*
//*****************************************************************************
void CTreeWnd::OnListDoubleClick(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR		  cText[TWS_MAX_NAME+260];
NM_LISTVIEW	 *pList;
LPCTSTR		  pName;
int			  iSize;
int	          iDir;
int			  iLen;


	pList = (NM_LISTVIEW*)pNmHdr;

	if(pList->iItem<        0)return;
	if(pList->iItem>=m_iCount)return;

		iDir=GETVAL(m_sFiles,pList->iItem,CTW_IS_DIR);
	if(!iDir)return;

	pName	= m_sFiles.Get(pList->iItem,iSize);
	iLen	= strlcpy(cText     ,m_pPath,TWS_MAX_NAME+260);
			  strlcpy(cText+iLen,pName  ,TWS_MAX_NAME+260-iLen,iSize);

	Set(cText);

}


//*****************************************************************************
//*
//*     OnListReturn
//*
//*****************************************************************************
void CTreeWnd::OnListReturn(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR			cText[TWS_MAX_NAME+260];
LPCTSTR			pName;
int				iItem;
int				iSize;
int				iLen;


	iItem	= m_cListView.GetNextItem(-1,LVNI_FOCUSED);
	pName	= m_sFiles.Get(iItem,iSize);

	if(!pName)return;

	iLen	= strlcpy(cText     ,m_pPath,TWS_MAX_NAME+260);
			  strlcpy(cText+iLen,pName  ,TWS_MAX_NAME+260-iLen,iSize);

	Set(cText);

}

//*****************************************************************************
//*
//*     OnListFocus
//*
//*****************************************************************************
void CTreeWnd::OnListFocus(NMHDR *pNmHdr,LRESULT *pResult)
{

	m_iLastFocus = 2;

}

//*****************************************************************************
//*
//*     OnTreeBeginDrag
//*
//*****************************************************************************
void CTreeWnd::OnTreeBeginDrag(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR		  cText[TWS_MAX_NAME+16];
CPoint		  sPlace;
NM_TREEVIEW	 *pTree;


	pTree = (NM_TREEVIEW*)pNmHdr;

	if(!(m_iStyle&TWS_DRAGDROP) || m_iDragState)
		{
		return;
		}

	m_cTreeView.UpdateWindow();
	GetCursorPos(&sPlace);

	if(m_pDragImages && m_iDragImgMode)delete m_pDragImages;

	m_iDragImgMode	= 0;
	m_pDragImages	= m_cTreeView.CreateDragImage(pTree->itemNew.hItem);

	if(!m_pDragImages)
		{
		m_iDragImgMode = 1;
		m_pDragImages  = new CImageList();
		m_pDragImages->Create(MAKEINTRESOURCE(IDB_DRAGONE),95,1,RGB(255,255,255));

		#ifdef _DEBUG
		if(!m_pDragImages->m_hImageList){MessageBox(_T("IDB_DRAGONE Bitmap Resourse fehlt"));ASSERT(0);}
		#endif
		}

	if(!m_pDragImages)return;

	m_pDragImages->BeginDrag(0,CPoint(20,10));
	m_pDragImages->DragEnter(0,sPlace );

	m_iDragState = 1;								// Drag & Drop einschalten
	m_iDropFlags = 0;								// Tasten Zustand
	m_hDropItem  = 0;								// DropTarget Tree-Item
	m_iDropMode	 = 0;								// Drag Art = Move
	m_iDropItem  =-1;								// DropTarget List-Item
	m_iDropView	 =-1;								// Drop Eintrag
	m_hDropEntry = NOITEM;							// Drop Fenster

	if(!m_pDragPath)
		{
		m_pDragPath = new TCHAR[TWS_MAX_NAME+16];
		}

		m_iDropNext = GetPath(pTree->itemNew.hItem,m_pDragPath,TWS_MAX_NAME);
	if(!m_iDropNext)
		{
		return;
		}

	memcpy(cText,m_pDragPath,(m_iDropNext+1)*sizeof(TCHAR));

	if(m_iDropNext>3)
		{
		cText[m_iDropNext]=0;
		}

	m_iDragDrive = strlchar(m_pDragPath,':');

	for(m_iDropNext--;m_iDropNext>0;m_iDropNext--)
		{
		if(m_pDragPath[m_iDropNext-1]=='\\')break;
		}

	m_sDragFiles.Del();  							// Darg-Dateien einlesen
	m_sDragFiles.Add(cText);

	SetCapture();

}


//*****************************************************************************
//*
//*     OnTreeBeginEdit
//*
//*****************************************************************************
void CTreeWnd::OnTreeBeginEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR			cText[TWS_MAX_NAME+16];
INT				iLevel;
NM_TREEVIEW	   *pTree;
TV_DISPINFO	   *pDisp;
int				iSize;



	pTree	 = (NM_TREEVIEW*)pNmHdr;
	*pResult = 1;

	if(!(m_iStyle&TWS_RENAME))return;

	pDisp	= (TV_DISPINFO*)pNmHdr;
	iSize	= GetPath(pDisp->item.hItem,cText,TWS_MAX_NAME+2);
	iLevel	= pDisp->item.lParam&0x0FFF;

	if(iSize && cText[iSize-1]=='\\')
		{
		cText[iSize-1] = 0;
		}

	if(!DoRename(cText,pDisp->item.pszText,iLevel))
		{
		return;
		}

	m_iDoRename |= 1;
	*pResult	 = 0;

}


//*****************************************************************************
//*
//*     OnTreeEndEdit
//*
//*****************************************************************************
void CTreeWnd::OnTreeEndEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR			cText[TWS_MAX_NAME+16];
INT				iLevel;
HTREEITEM		hNext;
NM_TREEVIEW	   *pTree;
int				iLen;



	pTree  = (NM_TREEVIEW*)pNmHdr;
	iLevel = pTree->itemNew.lParam&0x0FFF;

	m_iDoRename &= ~1;

	if(!pTree->itemNew.pszText)return;

	   iLen = GetPath(pTree->itemNew.hItem,cText,TWS_MAX_NAME+2);
	if(iLen && cText[iLen-1]=='\\')
		{
		iLen--;
		cText[iLen]=0;
		}

	if(Rename(cText,pTree->itemNew.pszText,iLevel))
		{
		m_cTreeView.SetItemText(pTree->itemNew.hItem,pTree->itemNew.pszText);

		   hNext=m_cTreeView.GetParentItem(pTree->itemNew.hItem);
		if(hNext)m_cTreeView.SortChildren(hNext);
		}


	if(!m_pPath)return;

	cText[iLen] = '\\';	iLen++;
	cText[iLen] = 0;


	if(_tcsicmp(m_pPath,cText))						// Wurde Pfadnamen verndert
		{
		return;
		}

	GetPath(pTree->itemNew.hItem,cText,TWS_MAX_NAME+2);
	strlcpy(m_pPath,cText,TWS_MAX_NAME);


}

//*****************************************************************************
//*
//*     OnTreeClick
//*
//*****************************************************************************
void CTreeWnd::OnTreeClick(NMHDR *pNmHdr,LRESULT *pResult)
{
TVHITTESTINFO	sInfo;
HTREEITEM		hItem;


	GetCursorPos(&sInfo.pt);
	
	m_cTreeView.ScreenToClient (&sInfo.pt);
	hItem = m_cTreeView.HitTest(&sInfo);

	if(hItem && sInfo.flags&TVHT_ONITEM)
		{
		m_cTreeView.SelectItem(hItem);
		}

}


//*****************************************************************************
//*
//*     OnTreeFocus
//*
//*****************************************************************************
void CTreeWnd::OnTreeFocus(NMHDR *pNmHdr,LRESULT *pResult)
{

	m_iLastFocus = 1;

}


//*****************************************************************************
//*
//*     OnTreeKeyDown
//*
//*****************************************************************************
void CTreeWnd::OnTreeKeyDown(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR			cText[TWS_MAX_NAME+16];
TV_KEYDOWN	   *pKeyData;
INT				iLevel;
HTREEITEM		hNext;
int				iLen;




	pKeyData=(TV_KEYDOWN*)pNmHdr;

	if(pKeyData->wVKey==VK_TAB)
		{
		if(GetAsyncKeyState(VK_SHIFT)&0x8000)		// Zum vorherigen Fenster springen
			{
			if(!(m_iStyle&TWS_NOCOMBOBOX))
				{
				m_cComboBox.SetFocus();
				}
			else if(m_iStyle&TWS_TABEXIT)
				{
				GetParent()->SetFocus();
				}
			else if(!(m_iStyle&TWS_NOLISTVIEW))
				{
				OnSelectFirst();
				}
			}
		else{										// Zum nchsten Fenster springen
			if(!(m_iStyle&TWS_NOLISTVIEW))
				{
				OnSelectFirst();
				}
			else if(m_iStyle&TWS_TABEXIT)
				{
				GetParent()->SetFocus();
				}
			else if(!(m_iStyle&TWS_NOCOMBOBOX))
				{
				m_cComboBox.SetFocus();
				}
			}

		*pResult = 1;

		return;
		}


	if(pKeyData->wVKey==VK_F5)						// Verzeichnis neu laden
		{
		hNext = m_cTreeView.GetNextItem(TVI_ROOT,TVGN_CARET);
		if(hNext)ReadSubDirs(hNext,NULL,1);
		Set(m_pPath,NULL,2,FALSE);
		return;
		}


	if(!(m_iStyle&TWS_DELETE))
		{
		return;
		}


	if(pKeyData->wVKey!=VK_DELETE)
		{
		return;
		}


		hNext=m_cTreeView.GetSelectedItem();
	if(!hNext)return;

	iLen	= GetPath(hNext,cText,TWS_MAX_NAME+2);
	iLevel	= m_cTreeView.GetItemData(hNext)&0x0FFF;

	if(iLen && cText[iLen-1]=='\\')
		{
		iLen--;
		cText[iLen] = 0;
		}

	for(;iLen>=0;iLen--)
		{
		if(cText[iLen]=='\\')break;
		}

	if(!DoDelete(cText,cText+iLen+1,iLevel))
		{
		return;
		}

	if(m_hTreeOpen==hNext)
		{
		m_hTreeOpen = 0;
		}

	m_cTreeView.DeleteItem(hNext);


}

//*****************************************************************************
//*
//*     OnTreeExpanded
//*
//*****************************************************************************
void CTreeWnd::OnTreeExpanded(NMHDR *pNmHdr,LRESULT *pResult)
{
NM_TREEVIEW	 *pTree;


	pTree = (NM_TREEVIEW*)pNmHdr;

	if(pTree->itemNew.state&TVIS_EXPANDED)
		{
		Read(_T(""),1,pTree->itemNew.hItem);
		}

}

//*****************************************************************************
//*
//*     OnTreeSelChanged
//*
//*****************************************************************************
void CTreeWnd::OnTreeSelChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
TCHAR		  cText[TWS_MAX_NAME+16];
NM_TREEVIEW	 *pTree;


	pTree=(NM_TREEVIEW*)pNmHdr;

	GetPath(pTree->itemNew.hItem,cText,TWS_MAX_NAME+2);
	Set(cText,NULL,0,TRUE);

}

//*****************************************************************************
//*
//*		DoDrop
//*
//*****************************************************************************
//	Ruft die Drop Funktion auf.
//	pPath	: Ist der Zielpfad fr's Drop
//	iMode	: Ist der Drop-Modus (0=Move 1=Copy)
//	Ergibt	0 = Wenn nichts verndert wurde
//			1 =	Wenn nur Dateien kopiert wurden
//			2 = Wenn auch Verzeichnisse verndert wurden
int CTreeWnd::DoDrop(LPCTSTR pPath,int iMode)
{
TCHAR	cText[TWS_MAX_NAME+16];
int		iRet;
int		iLen;


	if(iMode==-1 || !m_pDropProc)
		{
		return 0;
		}


	   iLen = _tcslen(pPath);
	if(iLen>TWS_MAX_NAME+2)
		{
		iLen = TWS_MAX_NAME+2;
		}

	memcpy(cText,pPath,iLen*sizeof(TCHAR));				// Pfad ermitteln

	for(;iLen>0;iLen--)
		{
		if(cText[iLen]=='\\')break;
		}

	if(iLen && cText[iLen-1]==':')
		{
		cText[iLen]='\\';
		iLen++;
		}

	cText[iLen]=0;


	   iRet = m_pDropProc(cText,&m_sDragFiles,iMode,&m_hDropEntry,m_pData);
	if(iRet && (!_tcsicmp(cText,m_pPath) || iRet==2))
		{
		Set(0);
		}


return iRet;
}

//*****************************************************************************
//*
//*     SetDrop
//*
//*****************************************************************************
//	Setzt die Callback-Funktion die bei Drop-Ereignissen aufgerufen wird.
//	pDropProc		: Zeiger auf die Callback-Funktion.
//						pPath   = Ist das Ablageziel
//						pFiles	= Sind  alle Dateien
//						iMode	= Ist die Ablageart (0=Move 1=Copy)
void CTreeWnd::SetDrop(int(*pDropProc)(LPCTSTR pPath,CStringChain *pFiles,int iMode,LPVOID pEntry,LPVOID pData),LPVOID pData)
{

	m_pData		= pData;
	m_pDropProc = pDropProc;

}

//*****************************************************************************
//*
//*     SetView
//*
//*****************************************************************************
//	Setzt die Callback-Funktionen fr externe Fenster die Drops akzebtieren.
//	pHitTestProc	: Ergibt 1 wenn ein Fenster beim Punkt sPoint ist.
//					  sPoint   = Bezieht sich auf die linke ober Bildschirmecke.
//					  pEntry   = Hier knnen Daten des Fensters gespeichert werden.
//					  pEntry   = Ist 4 Byte gro
//					  pData    = Ist ein konstanter Zeiger
//	pGetPathProc	: Hold den Pfad fr die Drop Operation
//					  pBuffer  = Ist der Ziel-Puffer mit der Gre iLen
//	pGetModeProc	: Ergibt den Ablage Modus fr das Fenster (*pEntry)
//						(0=Move 1=Copy -1=nicht erlaubt)
void CTreeWnd::SetView(int(*pHitTestProc)(CPoint sPoint,LPVOID pEntry	       ,LPVOID pData),
					   int(*pGetPathProc)(LPVOID pItem ,LPSTR  pBuffer,int iLen,LPVOID pData),
					   int(*pGetModeProc)(UINT   nFlags,LPVOID pEntry	       ,LPVOID pData))
{

	m_pHitTestProc	= pHitTestProc;
	m_pGetPathProc	= pGetPathProc;
	m_pGetModeProc	= pGetModeProc;

}

//*****************************************************************************
//*
//*     StatusbarInit
//*
//*****************************************************************************
// Erzeugt eine neue Statuszeile
int CTreeWnd::StatusbarInit()
{
INT			 aSize[]={-15,-10};
INT			 aItem[]={  0,  0};
FRAME_CLASS *pWnd;


	pWnd = (FRAME_CLASS*)AfxGetMainWnd();
	pWnd->StatusbarInit(aItem,aSize,2);

	m_iSetStatubar = 1;


return 1;
}

//*****************************************************************************
//*
//*     StatusbarExit
//*
//*****************************************************************************
//	Erzeugt eine neue Statuszeile
int CTreeWnd::StatusbarExit()
{
FRAME_CLASS   *pWnd;


	pWnd = (FRAME_CLASS*)AfxGetMainWnd();
	pWnd->StatusbarInit();


return 1;
}

//*****************************************************************************
//*
//*     StatusbarSet
//*
//*****************************************************************************
//	Aktualisiert die Statuszeile
void CTreeWnd::OnStatusbarSet(){StatusbarSet();}
int  CTreeWnd::StatusbarSet()
{
FRAME_CLASS	   *pWnd;


	if(!m_iInit)return 0;

	pWnd =(FRAME_CLASS*)AfxGetMainWnd();


return 1;
}

//*****************************************************************************
//*
//*		ComboEditProc
//*
//*****************************************************************************
LRESULT __stdcall CTreeWnd::ComboEditProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
HWND		hParent;
WNDPROC		pProc;


	pProc = (WNDPROC)GetWindowLongPtr(hWnd,GWLP_USERDATA);

	switch(uMsg)
		{
	case WM_KEYDOWN:

		if(wParam==VK_TAB || wParam==VK_RETURN)
			{
			hParent	= ::GetParent(hWnd   );
			hParent	= ::GetParent(hParent);

			::PostMessage(hParent,WM_COMMAND,(wParam==VK_RETURN)? ID_RETURN:ID_TABULATOR,0);

			if(wParam==VK_TAB)
				{
				return 0;
				}
			}

		break;

	case WM_CHAR:

		if(wParam==VK_TAB)
			{
			return 0;
			}

		break;
		}


return CallWindowProc(pProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*     OnReturn
//*
//*****************************************************************************
//	RETURN wurde in der ComboBox gedrckt
void CTreeWnd::OnReturn()
{
	
	m_bComboSave = 1;
	m_uComboTick = 1;

	PostMessage(WM_TIMER,ID_COMBOUPDATE);

}

//*****************************************************************************
//*
//*     OnTabulator
//*
//*****************************************************************************
//	TAB wurde in der ComboBox gedrckt
void CTreeWnd::OnTabulator()
{

	if(GetAsyncKeyState(VK_SHIFT)&0x8000)			// Zum vorherigen Fenster springen
		{
		if(m_iStyle&TWS_TABEXIT)
			{
			GetParent()->SetFocus();
			}
		else if(!(m_iStyle&TWS_NOLISTVIEW))
			{
			OnSelectFirst();
			}
		else if(!(m_iStyle&TWS_NOTREEVIEW))
			{
			m_cTreeView.SetFocus();
			}
		}
	else{											// Zum nchsten Fenster springen
		if(!(m_iStyle&TWS_NOTREEVIEW))
			{
			m_cTreeView.SetFocus();
			}
		else if(!(m_iStyle&TWS_NOLISTVIEW))
			{
			OnSelectFirst();
			}
		else if(m_iStyle&TWS_TABEXIT)
			{
			GetParent()->SetFocus();
			}
		}

}

//*****************************************************************************
//*
//*     OnCbCloseUp
//*
//*****************************************************************************
void CTreeWnd::OnCbCloseUp()
{

	m_uComboFast = GetTickCount();

}


//*****************************************************************************
//*
//*     OnSelChanged
//*
//*****************************************************************************
void CTreeWnd::OnSelChanged()
{
unsigned	uDiff;

	
	uDiff = GetTickCount()-m_uComboFast;

	m_bComboSave = 0;
	m_uComboTick = (uDiff<500)? 1:5;

	if(!m_bComboTimer)
		{
		m_bComboTimer = TRUE;
		SetTimer(ID_COMBOUPDATE,200,NULL);
		}

}

//*****************************************************************************
//*
//*		OnCbSetFocus
//*
//*****************************************************************************
void CTreeWnd::OnCbSetFocus()
{

	m_iLastFocus = 3;

}

//*****************************************************************************
//*
//*		OnPathPrev
//*
//*****************************************************************************
void CTreeWnd::OnPathPrev()
{

	if(m_iPathPos!=m_iPathStart && m_iPathOk)
		{
		m_iPathPos = (m_iPathPos+TWS_MAX_PATHS-1)%TWS_MAX_PATHS;
		Set(m_aPaths[m_iPathPos],NULL,0,FALSE);

		m_cBtPrev.EnableWindow(m_iPathPos!=m_iPathStart);
		m_cBtNext.EnableWindow(m_iPathPos!=m_iPathEnd  );
		}


}

//*****************************************************************************
//*
//*		OnPathNext
//*
//*****************************************************************************
void CTreeWnd::OnPathNext()
{

	if(m_iPathPos!=m_iPathEnd && m_iPathOk)
		{
		m_iPathPos = (m_iPathPos+1)%TWS_MAX_PATHS;
		Set(m_aPaths[m_iPathPos],NULL,0,FALSE);

		m_cBtPrev.EnableWindow(m_iPathPos!=m_iPathStart);
		m_cBtNext.EnableWindow(m_iPathPos!=m_iPathEnd  );
		}

}

//*****************************************************************************
//*
//*		AddToHistory
//*
//*****************************************************************************
BOOL CTreeWnd::AddToHistory(LPCTSTR pPath)
{
int		iPos;


	if(pPath[0]==0)
		{
		return FALSE;
		}
	else if(m_iPathStart!=m_iPathEnd)
		{
		iPos = (m_iPathPos+TWS_MAX_PATHS-1)%TWS_MAX_PATHS;

		if(m_aPaths[iPos]==pPath)
			{
			return FALSE;
			}
		}

	if(!m_iPathOk)
		{
		m_aPaths[0]		=  pPath;
		m_iPathStart	=  0;
		m_iPathEnd		=  0;
		m_iPathPos		=  0;
		m_iPathOk		=  1;

		m_cBtPrev.EnableWindow(FALSE);
		m_cBtNext.EnableWindow(FALSE);
		}
	else{
		m_iPathPos		= (m_iPathPos+1)%TWS_MAX_PATHS;
		m_iPathEnd		=  m_iPathPos;
		m_aPaths[m_iPathPos] = pPath;

		if(m_iPathStart==m_iPathEnd)
			{
			m_iPathStart = (m_iPathEnd+1)%TWS_MAX_PATHS;
			}

		m_cBtPrev.EnableWindow(TRUE );
		m_cBtNext.EnableWindow(FALSE);
		}


return TRUE;
}


//*****************************************************************************
//*
//*     OnSelectAll
//*
//*****************************************************************************
void CTreeWnd::OnSelectAll()
{
LV_ITEM	    sItem;
int			iPos;


	sItem.mask		= LVIF_STATE;
	sItem.state		= LVIS_SELECTED;
	sItem.stateMask	= LVIS_SELECTED;
	sItem.iSubItem	= 0;

	for(iPos=0;iPos<m_iCount;iPos++)
		{
		sItem.iItem = iPos;
		m_cListView.SetItem(&sItem);
		}

	m_cListView.SetFocus();

}

//*****************************************************************************
//*
//*     OnSelectFirst
//*
//*****************************************************************************
void CTreeWnd::OnSelectFirst()
{
POSITION	hPos;

	m_cListView.SetFocus();
	hPos = m_cListView.GetFirstSelectedItemPosition();

	if(!hPos || !m_cListView.GetNextSelectedItem(hPos))
		{
		m_cListView.SetItemState(0,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED);
		}

}

//*****************************************************************************
//*
//*     OnNewDir
//*
//*****************************************************************************
//	Erzeugt ein neues Verzeichnis
void CTreeWnd::OnNewDir()
{
	CreateNewFolder();
}

//*****************************************************************************
//*
//*     OnDelete
//*
//*****************************************************************************
//	Der aktuelle Pfad wird um eins nach Oben durchlaufen.
void CTreeWnd::OnDelete()
{
NMHDR	   *pNmHdr;
LV_KEYDOWN  sKey;
LRESULT		lRet;


	pNmHdr = (NMHDR*)&sKey;

	if(GetFocus()==(CWnd*)&m_cTreeView)
		{
		pNmHdr->code	= TVN_KEYDOWN;
		sKey.wVKey		= VK_TAB;
		sKey.flags		= 0;

		OnTreeKeyDown(pNmHdr,&lRet);
		}
	else{
		pNmHdr->code	= LVN_KEYDOWN;
		sKey.wVKey		= VK_TAB;
		sKey.flags		= 0;

		OnListKeyDown(pNmHdr,&lRet);
		}

}

//*****************************************************************************
//*
//*		CreateNewFolder
//*
//*****************************************************************************
//	Erzeugt ein neues Verzeichnis
//	pName		: Ist der Name fr das neue Verrzeichniss
//	Ergibt	0 : Wenn Verzeichnis erzeugt wurde
//		   -1 :	Wenn Verzeichnis nicht erzeugt wurde
int CTreeWnd::CreateNewFolder(LPCTSTR pName)
{
TCHAR	cText[TWS_MAX_NAME+64];
int		iSize;
int		iLen;
int		iPos;



	if(!m_pPath)return -1;

	   iLen = _tcslen(m_pPath);
	if(iLen>TWS_MAX_NAME)return -1;

	memcpy(cText,m_pPath,iLen*sizeof(TCHAR));

	if(!pName)
		{
		strlcpy(cText+iLen,_T("Neues Verzeichnis"),TWS_MAX_NAME+64-iLen);
		}
	else{
		   iSize = _tcslen(pName);
		if(iSize+iLen>TWS_MAX_NAME)return -1;

		memcpy(cText+iLen,pName,(iSize+1)*sizeof(TCHAR));
		}

	Set(0,0,1);
	Insert();

	if(!pName)											// Dateinamen bearbeiten
		{
		   iPos = m_sFiles.Find(cText+iLen,0,-1,1);
		if(iPos>=0)
			{
			m_cListView.UpdateWindow();
			m_cListView.SetFocus();
			m_cListView.EditLabel(iPos);
			}
		}


return 0;
}

//*****************************************************************************
//*
//*		SetFocus
//*
//*****************************************************************************
CWnd *CTreeWnd::SetFocus(int iMode)
{

	if(iMode==1 && !(m_iStyle&TWS_NOTREEVIEW))return m_cTreeView.SetFocus();
	if(iMode==2 && !(m_iStyle&TWS_NOLISTVIEW))return m_cListView.SetFocus();
	if(iMode==3 && !(m_iStyle&TWS_NOCOMBOBOX))return m_cComboBox.SetFocus();

	if(GetAsyncKeyState(VK_SHIFT)&0x8000)
		{
		if(!(m_iStyle&TWS_NOLISTVIEW))return m_cListView.SetFocus();
		if(!(m_iStyle&TWS_NOTREEVIEW))return m_cTreeView.SetFocus();
		if(!(m_iStyle&TWS_NOCOMBOBOX))return m_cComboBox.SetFocus();
		}
	else{
		if(!(m_iStyle&TWS_NOCOMBOBOX))return m_cComboBox.SetFocus();
		if(!(m_iStyle&TWS_NOTREEVIEW))return m_cTreeView.SetFocus();
		if(!(m_iStyle&TWS_NOLISTVIEW))return m_cListView.SetFocus();
		}


return NULL;
}

//*****************************************************************************
//*
//*     SetStyle
//*
//*****************************************************************************
//	ndert Aussehen und Verhalten des Fensters
//	Setzt  neue Style Attribute
//	Ergibt die  Style Attribute
//	Es werden nur die Bits die mit Maske Makiert sind gendert
//	Style:
//		TWS_NOLISTVIEW		0x0001		// ListView nicht anzeigen
//		TWS_NOTREEVIEW		0x0002		// TreeView nicht anzeigen
//		TWS_RENAME			0x0004		// Dateien knnen umbenannt werden
//		TWS_DELETE			0x0008		// Datei Lschen erlaubt
//		TWS_DRAGDROP		0x0010		// Drag und Drop aktivieren
//		TWS_NODROP			0x0020		// Kein Drop auf sich selbst
//		TWS_TABEXIT			0x0040		// Bei TAB Focus an Elternfenster geben
//		TWS_NOSUBDIR		0x0080		// Keine Verzeichnisse im Listen Fenster
//		TWS_NOICONS			0x0100		// Keine Icone anzeigen
//		TWS_NOSORT			0x0200		// Nicht nach Name sortieren
UINT CTreeWnd::SetStyle(UINT uStyle,UINT uMask)
{
RECT	sRect;
int		iDiff;
int		iOld;
int		iBit;


	iOld	 	=  m_iStyle&0xFFFF;
	uStyle	   &=  uMask;
	m_iStyle   &= ~uMask;
	m_iStyle   |=  uStyle&0xFFFF;
	iDiff		=  m_iStyle^iOld;	

	if(iDiff&(TWS_NOTREEVIEW|TWS_NOLISTVIEW|TWS_NOCOMBOBOX))
		{
		m_cTreeView.ShowWindow((m_iStyle&TWS_NOTREEVIEW)? SW_HIDE:SW_SHOW);
		m_cListView.ShowWindow((m_iStyle&TWS_NOLISTVIEW)? SW_HIDE:SW_SHOW);
		m_cComboBox.ShowWindow((m_iStyle&TWS_NOCOMBOBOX)? SW_HIDE:SW_SHOW);
		m_cBtPrev  .ShowWindow((m_iStyle&TWS_NOCOMBOBOX)? SW_HIDE:SW_SHOW);
		m_cBtNext  .ShowWindow((m_iStyle&TWS_NOCOMBOBOX)? SW_HIDE:SW_SHOW);
		m_cBtDoUp  .ShowWindow((m_iStyle&TWS_NOCOMBOBOX)? SW_HIDE:SW_SHOW);

		iBit = IsWindowVisible();

		if(iDiff&TWS_NOCOMBOBOX)
			{
			CbUpdate();
			}

		if(iBit)SetRedraw(FALSE);
		GetClientRect(&sRect);
		OnSize(0,sRect.right,sRect.bottom);
		if(iBit)SetRedraw(TRUE);
		RedrawWindow();
		
		if(iDiff&TWS_NOLISTVIEW)Set(0);
		}

	if((iOld^m_iStyle)&(TWS_NODROP|TWS_DRAGDROP))
		{
		if(  m_iStyle&TWS_DRAGDROP)
		if(!(m_iStyle&TWS_NODROP ))DragAcceptFiles();
		}

	if((iOld^m_iStyle)&(TWS_NOSUBDIR))
		{
		Read(m_pPath);
		}


return iOld;
}


//*****************************************************************************
//*
//*		CheckPath
//*
//*****************************************************************************
//	Prft ob ein Pfad existiert.
//	pPath		: Zeiger auf den Puffer mit dem Pfad. [TWS_MAX_NAME]
//	iLen		: Ist die Lnge des Pfades (-1 mit strlen() holen)
//	iLevel		: Sind die Level 
//	Ergibt die neue Lnge vom Pfad oder 0 wenn der Pfad nicht existiert
int	CTreeWnd::CheckPath(LPTSTR pPath,int iLen,int &iLevel)
{
CStringChain	sEntries;


	
	if(iLen<0)iLen=_tcslen(pPath);

	iLevel = GetLevel(pPath,iLen);

	if(!iLen || !ReadDirs(&sEntries,pPath,iLevel))		// Existiert der Pfad
		{
		return 0;
		}


return iLen;
}


//*****************************************************************************
//*
//*		ReadRoot
//*
//*****************************************************************************
//	Einlesen aller Root-Elemente in Tree-Fenster.
//	pEntries		: String-Kette in der die Elemente gspeichert werden.
//					  Im Textbereich muss der der Name stehen
//				      Im Datenbereich wird die Icon-Nummer angegeben
//	Ergibt die Anzahl der gefundenen Eintrge.
int CTreeWnd::ReadRoot(CStringChain *pEntries)
{
int		aData[]={0,0,0,2};


	pEntries->Add(_T("1:"),-1,aData);
	pEntries->Add(_T("2:"),-1,aData);
	pEntries->Add(_T("3:"),-1,aData);


return pEntries->Count();
}

//*****************************************************************************
//*
//*		ReadDirs
//*
//*****************************************************************************
//	Einlesen aller Elemente eines Unterordners ins Tree-Fenster.
//	pEntries		: String-Kette in der die Elemente gspeichert werden.
//					  Im Textbereich muss der der Name stehen
//					  Im Datenbereich CTW_ICON_S/CTW_ICON_N wird die Icon-Nummer angegeben
//					  Im Datenbereich CTW_ICON_A wird die Anzahl der Unter Gruppen
//					  Im Datenbereich CTW_IS_DIR wird auf 1 gesetzt
//					  Wenn pEntries==0 nur prfen ob Verzeichnisse vorhanden sind.
//	pPath			: Ist der Pfad des Unterordners.
//	iLevel			: Ist die Ebene des Unterordners.
//	Ergibt die Anzahl der gefundenen Eintrge.
int CTreeWnd::ReadDirs(CStringChain *pEntries,LPCTSTR pPath,int iLevel)
{
TCHAR	cName[]=_T("Ebene 0");
int		aData[]={0,0,0,1};


	if(iLevel>9   )return 0;
	if(pEntries==0)return 1;

	cName[6] += iLevel;
	pEntries->Add(cName,-1,aData);


return pEntries->Count();
}

//*****************************************************************************
//*
//*		ReadFiles
//*
//*****************************************************************************
//	Einlesen aller Elemente eines Ordners ins Listenfenster (Dateien und Ordner).
//	pEntries		: String-Kette in der die Elemente gspeichert werden.
//					  Im Textbereich muss der der Name stehen
//					  Im Datenbereich CTW_ICON_S/CTW_ICON_N wird die Icon-Nummer angegeben
//					  Im Datenbereich CTW_ICON_A wird die Anzahl der Unter Gruppen
//					  Im Datenbereich CTW_IS_DIR wird auf 1 gesetzt
//	pPath			: Ist der Pfad des Unterordners.
//	iLevel			: Ist die Ebene des Unterordners.
//	Ergibt die Anzahl der gefundenen Eintrge.
int CTreeWnd::ReadFiles(CStringChain *pEntries,LPCTSTR pPath,int iLevel)
{
int		aData[]={0,1,2,0};


	pEntries->Add(_T("<Hallo>"),-1,aData);
	pEntries->Add(_T("<Test>" ),-1,aData);


return pEntries->Count();
}

//*****************************************************************************
//*
//*		InsertColumn
//*
//*****************************************************************************
//	Fgt die Spalten in das Listenfenster ein.
//	Ergibt die Anzahl der Spalten.
int CTreeWnd::InsertColumn()
{

	m_cListView.InsertColumn(0,_T("Name" ),LVCFMT_LEFT,200);

return 1;
}

//*****************************************************************************
//*
//*		GetLevel
//*
//*****************************************************************************
//	Holt zu einem Pfad die Ebene und die Root-Nummer
int CTreeWnd::GetLevel(LPCTSTR pPath,int iLen)
{
int			iData;
int			iOff;
int			iEnd;


	if(iLen<0)iLen=_tcslen(pPath);
	if(iLen>0 && pPath[iLen-1]=='\\')iLen--;

	iData = 0;


	for(iEnd=0;iEnd<iLen;iEnd++)
		{
		if(pPath[iEnd]=='\\')break;
		}


	for(iOff=iEnd;iOff<iLen;iOff++)
		{
		if(pPath[iOff]=='\\')
			{
			iData++;
			}
		}

	iOff	= m_sRoot.Find(iEnd,pPath,0,-1,0x01);
	iData  |= iOff<<16;
	iData  |= ROOT_ID;


return iData;
}

//*****************************************************************************
//*
//*		GetComboList
//*
//*****************************************************************************
//	Die Combo-Liste mit aus der Registry fllen.
//	pRegName	: Ist der Names des Eintrages
//	pRegPath	: Ist der Pfad in der Registry (auch NULL)
//	Ergibt die Anzahl der gefundenen Eintrge.
int	CTreeWnd::GetComboList(LPCTSTR pRegName,LPCTSTR pRegPath)
{
LPTSTR		pList;
CRegKeys	sKey;
int			iPos;
int			iNum;

	
	sKey.Open();
	
	if(pRegPath)sKey.Up(pRegPath);


	if(!sKey.GetMulti(&pList,pRegName) || !pList)
		{
		return 0;
		}

	m_sCombo.KAdd(pList);	

	delete pList;

	
	if(IsWindow(m_cComboBox.m_hWnd) && m_cComboBox.GetCount()==0)
		{
		for(iPos=0;iPos<m_sCombo.Count();iPos++)
			{
			COMBOBOXEXITEM	sItem;

			sItem.mask		  = CBEIF_TEXT;
			sItem.pszText	  = m_sCombo[iPos];
			sItem.iItem		  = iPos;

			if(!(m_iStyle&TWS_NOTREEICONS))
				{
				TCHAR	cName[TWS_MAX_NAME+16];

				iNum		  = GetLevel(sItem.pszText);
				sItem.mask	 |= CBEIF_IMAGE|CBEIF_SELECTEDIMAGE;
				sItem.iImage  =	GetIcon(sItem.pszText,cName,iNum,CTW_ICON_S);
				sItem.iSelectedImage = sItem.iImage;
				}

			m_cComboBox.InsertItem(&sItem);
			}
		}


return m_sCombo.Count();
}

//*****************************************************************************
//*
//*		SetComboList
//*
//*****************************************************************************
//	Die Combo-Liste mit in der Registry speichern.
//	pRegName	: Ist der Names des Eintrages
//	pRegPath	: Ist der Pfad in der Registry (auch NULL)
//	Ergibt die Anzahl der gefundenen Eintrge.
int	CTreeWnd::SetComboList(LPCTSTR pRegName,LPCTSTR pRegPath)
{
LPTSTR		pList;
CRegKeys	sKey;


	GetCbList();

	sKey.Open();
	
	if(pRegPath)sKey.Up(pRegPath);

	m_sCombo.Chain(&pList);

	if(!pList)return 0;


	if(!sKey.SetMulti(pList,pRegName))
		{
		delete pList;
		return 0;
		}

	delete pList;


return m_sCombo.Count();
}


//*****************************************************************************
//*
//*		GetCbList
//*
//*****************************************************************************
//	Holt alle Pfade aus der Listbox
int	CTreeWnd::GetCbList()	
{
TCHAR			cPath[TWS_MAX_NAME+16];
COMBOBOXEXITEM	sData;
int				iCount;
int				iPos;


	if(!IsWindow(m_cComboBox.m_hWnd))
		{
		return -1;
		}

	m_sCombo.Del();
	
	iCount = m_cComboBox.GetCount();

	for(iPos=0;iPos<iCount;iPos++)
		{
		sData.mask		  = CBEIF_TEXT;
		sData.cchTextMax  = TWS_MAX_NAME+16;
		sData.pszText	  = cPath;
		sData.iItem		  = iPos;

		if(!m_cComboBox.GetItem(&sData))
			{
			continue;
			}

		m_sCombo.Add(cPath);
		}


return m_sCombo.Count();
}

//*****************************************************************************
//*
//*		OnPathSelect
//*
//*****************************************************************************
//	Auf den N'ten in der Pfad-History
void CTreeWnd::OnPathSelect(UINT uId)
{

	uId -= ID_PATHSEL;

	if(uId&0x10)
		{
		uId &= 0x0F;


		while(m_iPathPos!=m_iPathStart && m_iPathOk)
			{
			m_iPathPos = (m_iPathPos+TWS_MAX_PATHS-1)%TWS_MAX_PATHS;

			if(!uId)break;

			uId--;
			}
		}
	else{
		while(m_iPathPos!=m_iPathEnd && m_iPathOk)
			{
			m_iPathPos = (m_iPathPos+1)%TWS_MAX_PATHS;

			if(!uId)break;

			uId--;
			}
		}

	SetPath(m_aPaths[m_iPathPos]);

	m_cBtPrev.EnableWindow(m_iPathPos!=m_iPathStart);
	m_cBtNext.EnableWindow(m_iPathPos!=m_iPathEnd  );

}


//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CTreeWnd::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
TCHAR				cName[TWS_MAX_NAME];
CMenu				sMenu;
CStringArray        sArray;
LPCTSTR				pPath;
int					iLen;
int					iAdd;
int					iPos;
int					iEnd;



	if(!pWnd || (pWnd->m_hWnd!=m_cBtPrev.m_hWnd && pWnd->m_hWnd!=m_cBtNext.m_hWnd))
		{
		GetParent()->SendMessage(WM_CONTEXTMENU,(WPARAM)((pWnd)? pWnd->m_hWnd:0),MAKELONG(sPoint.x,sPoint.y));
		return;
		}


												// Pfade vor oder zurck
	if(pWnd->m_hWnd==m_cBtPrev.m_hWnd)
		{
		iAdd = -1;
		iEnd = m_iPathStart;
		}
	else{
		iAdd = 1;
		iEnd = m_iPathEnd;
		}

	if(m_iPathPos==iEnd)return;

	sMenu.CreatePopupMenu();
	iPos = m_iPathPos;

	for(iLen=0;iLen<16;iLen++)
		{
		iPos += iAdd;

		while(iPos<             0)iPos+=TWS_MAX_PATHS;
		while(iPos>=TWS_MAX_PATHS)iPos-=TWS_MAX_PATHS;

		pPath=m_aPaths[iPos];
		if(pPath[0]=='/' && pPath[1] && pPath[2]==':')pPath++;
		CommpressFileName(pPath,cName,TWS_MAX_NAME,64);
		sMenu.AppendMenu(MF_STRING,ID_PATHSEL+iLen|(iAdd&0x10),cName);

		if(iPos==iEnd)break;
		}

	sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();


return;
}

//*****************************************************************************
//*
//*		Rename  /  DoRename
//*
//*****************************************************************************
int	CTreeWnd::Rename  (LPCTSTR pPath,LPTSTR pBuffer,int iLevel){return 1;}
int	CTreeWnd::DoRename(LPCTSTR pPath,LPTSTR pBuffer,int iLevel){return 1;}
int	CTreeWnd::DoDelete(LPCTSTR pPath,LPTSTR pBuffer,int iLevel){return 1;}
int	CTreeWnd::GetIcon (LPCTSTR pPath,LPTSTR pBuffer,int iLevel,int iMode){return (iLevel)? 3+(iMode==CTW_ICON_O):(iMode==CTW_ICON_O);}
int	CTreeWnd::InsertItem(int iNum){return 0;}



