//*****************************************************************************
//*
//*
//*		TreeWnd.h
//*
//*
//*****************************************************************************
//
// 	char *GetPath()							Ergibt den aktuellen Pfad
// 	char *SetPath(char *)					Ergibt den aktuellen Pfad
// 	int   Set (char*="",char*=0,int=0)		Neuen Pfad Setzen
// 	int   SetListView(int=LVS_REPORT)		ndert die Ansicht des Listviews
// 	int	  SetStyle(UINT,UINT Maske=0xFFFF)	ndert Aussehen
// 	int   Sort(int Art=0,int Richtung=0)	Sortiere ListView
// 	int   GetSelect(CStringChain *,int=0)	Ergibt die ausgewhlen Dateien
// 	int	  CreateNewFolder(char *Name=0)		Erzeugt ein neues Verzeichnis
// 	int	  DoDrop(char *Pfad,int Art)		Dorp-Funktion ausfhren
// 	int   HitTest(CPoint,LPVOID )			Ergibt Eintragnr. unter Cursor
//
// 	void  OnSelectAll()						Alles auswhlen
// 	void  OnNewDir   ()						Neues Verzeichnis erzeugen
// 	void  OnPathup   ()						Einen Pfad Aufwrts
// 	void  OnDelete   ()						Auswahl lschen
// 	void  OnSmallIcon()						Ansicht auf kleine Icons
// 	void  OnReport   ()						Ansicht auf Details
// 	void  OnList     ()						Ansicht auf Liste mit kleine Icons
// 	void  OnIcon     ()						Ansicht auf groe  Icons
//
//	Einstellen der Drop-Funktionen
//
// 	void  SetDrop(	int(*Drop_fnk)(char *Pfad,CStringChain *Dateien  ,int Art,LPVOID pEntry,LPVOID Data)=0,LPVOID Data=0);
// 	void  SetView(	int(*Extern_hit_test)(CPoint sPoint ,LPVOID pEntry	     ,LPVOID Data)=0,
// 					int(*Extern_get_pfad)(LPVOID pEntry,char *Puffer ,int Len,LPVOID Data)=0,
// 					int(*Extern_get_mode)(UINT  nFlags ,LPVOID pEntry	     ,LPVOID Data)=0);
//
//************* Zum berladen mit neuen Funktionen  ***************************
//
// 	virtual int ReadRoot (CStringChain *Eintaege);
// 	virtual int ReadDirs (CStringChain *Eintaege,char *Pfad,int Ebene);
// 	virtual int ReadFiles(CStringChain *Eintaege,char *Pfad,int Ebene);
// 	virtual int	Rename   (char *Pfad,char *Puffer,int Ebene);
// 	virtual int	DoRename (char *Pfad,char *Puffer,int Ebene);
// 	virtual int	DoDelete (char *Pfad,char *Puffer,int Ebene);
// 	virtual int GetIcon  (char *Pfad,char *Puffer,int Ebene,int Art);
//	virtual int CheckPath(char *Pfad,int iLen,int &Ebene);
// 	virtual int	InsertItem(int  Nr);
// 	virtual int	InsertColumn();
//
#ifndef	AFX_TREEVIEW_H__38481AEF_B14F_11D2_84E4_D45E733A360A__INCLUDED_
#define AFX_TREEVIEW_H__38481AEF_B14F_11D2_84E4_D45E733A360A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

#include	<string.h>
#include 	<afxcmn.h>
#include 	<afxole.h>
#include 	<afxcview.h>

#include	"FileFinder.h"
#include	"StringFunctions.h"

//*****************************************************************************
//*
//*		Styles fr das Fenster
//*
//*****************************************************************************

#define		TWS_NOLISTVIEW		0x0001			// ListView nicht anzeigen
#define		TWS_NOTREEVIEW		0x0002			// TreeView nicht anzeigen
#define		TWS_NOCOMBOBOX		0x0004			// ComboBox nicht anzeigen
#define		TWS_DELETE			0x0008			// Datei Lschen erlaubt
#define		TWS_DRAGDROP		0x0010			// Drag und Drop aktivieren
#define		TWS_NODROP			0x0020			// Kein Drop auf sich selbst
#define		TWS_TABEXIT			0x0040			// Bei TAB Focus an Elternfenster geben
#define		TWS_RENAME			0x0080			// Dateien knnen umbenannt werden
#define		TWS_NOLISTICONS		0x0100			// Keine Icone im Listview anzeigen
#define		TWS_NOTREEICONS		0x0200			// Keine Icone im Treeview anzeigen
#define		TWS_NOSORT			0x0400			// Nicht nach Name sortieren
#define		TWS_NOSUBDIR		0x0800			// Keine Verzeichnisse im Listenfenster
#define		TWN_PATHCHANGE		0x9701			// Nachricht wenn Pfad verndert wurde 

#ifndef 	TWS_MAX_NAME
#define		TWS_MAX_NAME		1024			// Maximale Namenslnge
#endif 	

#ifndef 	TWS_SEPARATOR							
#define		TWS_SEPARATOR		200					// Startposition des Teiles
#endif 												

#ifndef 	TWS_MAX_PATHS
#define		TWS_MAX_PATHS		32				// Maximale Pfad in der History
#endif 	

#define 	CTW_ICON_N			0				// Nummer fr grosse Icons
#define 	CTW_ICON_S			1				// Nummer fr kleine Icons
#define 	CTW_ICON_O			2				// Nummer fr opened Icons
#define 	CTW_ICON_A			2				// Anzahl der Untergruppen
#define 	CTW_IS_DIR			3				// VerzeichnisFlag
#define 	CTW_MAX_CSC			(4*sizeof(int))	// Gre des Daten Bereiches

//*****************************************************************************
//*
//*		Klasse CTreeWnd
//*
//*****************************************************************************
class CTreeWnd : public CWnd
{
protected:

	CString		 m_aPaths[TWS_MAX_PATHS];		// Pfad-History
	int			 m_iPathStart;					// Erster Pfad in History
	int			 m_iPathEnd;					// Letzter Pfad in History
	int			 m_iPathPos;					// Aktueller Pfad in History
	int			 m_iPathOk;						// Gibt es Pfade in der History
	CListCtrl	 m_cListView;					// Fenster mit Dateiliste
	CTreeCtrl	 m_cTreeView;					// Fenster mit Verzeichnisbaum
	CComboBoxEx	 m_cComboBox;					// Fenster mit Namenszeile
	CImageList	*m_pImgTreeS;					// Icon Liste
	CImageList	*m_pImgListS;					// Icon Liste
	CImageList	*m_pImgListN;					// Icon Liste
	CStringChain m_sFiles;						// Dateien fr das Listfenster
	CStringChain m_sRoot;						// Dateienname fr Drag
	CStringChain m_sCombo;						// Dateienname fr Combobox
	CButton		 m_cBtPrev;						// Zurck Taste	
	CButton		 m_cBtNext;						// Vortaste Taste	
	CButton		 m_cBtDoUp;						// Eine Ebenehher
	int			 m_iStyle;						// Fenster Styles
	int			 m_iColums;						// Anzahl der Spalten im ListView
	int			 m_iListLevel;					// Ebene   des ListViews
	int			 m_iRootLevel;					// Rootnr. des ListViews
	int			 m_iSeparator;					// Teilung der Fenster
	LPTSTR		 m_pPath;						// Speicher fr aktuellen Pfad
	HTREEITEM	 m_hTreeOpen;					// Offener Ordner fr Treefeld
	int			 m_iInit;						// Ist Fenster initilaisiert
	HANDLE		 m_hSetThread;					// Thread fr das Datei einlesen
	DWORD		 m_dwSetThreadId;				// Thread ID
	BOOL		 m_bSepChanged;					// Wurde der Teiler veschoben
	BOOL		 m_bComboTimer;					// Ist der Combo-Timer an
	BOOL		 m_bComboSave;					// Den Pfad in die Liste aufnehmen
	BOOL		 m_bUbEnable;					// Ist OnPathUp mglich
	UINT		 m_uComboFast;					// Beim zuklappen der Liste schnell Einfgen
	UINT		 m_uComboTick;					// Wann Pfad aus ComboBox holen
	int			 m_iSetState;					// Thread Zustand
	int			 m_iSetStatubar;				// Statusbar setzen
	int			 m_iDoRename;					// Wird gerade eine Datei umbenannt
	int			 m_iCount;						// Anzahl der gefunden Dateien im Listview
	int			 m_iLastFocus;					// Wo war der Focus zulezt
	int			 m_iComboHight;					// Hhe des sichtbaren Bereiches der ComboBox
	int			 m_iComboAdd;					// Hhe des Drop-Down-Feldes der ComboBox
	int			 m_iComboEnd;					// Hhe des der Namenszeile
	int			 m_iDragState;					// Darg Zustand
	CImageList	*m_pDragImages;					// Darg imageList
	int			 m_iDragImgMode;				// Speicher fr Imagelist freigeben
	int			 m_iSortMode;					// Sortier-Art
	int			 m_iSortDir;					// Sortier-Richtung
	int			 m_iDropView;					// HitTest Fensternummer (0=None 1=Tree 2=List 3=Combo 4=Other)
	LPVOID		 m_hDropEntry;					// Letztes pEntry
	HTREEITEM	 m_hDropItem;					// DropTarget Tree-Item
	int			 m_iDropItem;					// DropTarget List-Item
	int			 m_iDragDrive;					// Start-Laufwerk
	int			 m_iDropMode;					// Art des Drops 1=Copy 0=Move -1=Nicht erlaubt
	int			 m_iDropFlags;					// Art des Drops 1=Copy 0=Move -1=Nicht erlaubt
	int			 m_iDropNext;					// Oberer Pfad
	LPTSTR		 m_pDragPath;					// Pfad des Anfangs-Elementes
	CStringChain m_sDragFiles;					// Dateienname fr Drag
	LPVOID		 m_pData;						// Datenspeicher fre externe Funktionen

	HCURSOR		 m_hCursorNull;					// Normaler-Cursor
	HCURSOR		 m_hCursorDis;					// Disable -Cursor
	HCURSOR		 m_hCursorCopy;					// Copy    -Cursor
	HCURSOR		 m_hCursorMove;					// Move    -Cursor
	HCURSOR		 m_hCursorWait;					// Warten  -Cursor
	HCURSOR		 m_hCursorSize;					// Gren  -Cursor
	int			 m_iCursorMode;					// Modi fr Cursor

	unsigned    *m_pStatusbarItems;				// Statusbar Eintrge
	unsigned    *m_pStatusbarSizes;				// Statusbar Breiten
	unsigned     m_uStatusbarCount;				// Statusbar Eintrgeanzahl

	const static int   m_sSortArray[4];			// Sortier-Modi

												// Funktion die aufgerufen wird beim Drop											
	int	(*m_pDropProc   )(LPCTSTR pPath ,CStringChain *pFiles,int iMode,LPVOID pEntry,LPVOID pData);
	int	(*m_pGetPathProc)(LPVOID  pEntry,LPTSTR pBuffer,int iLen,LPVOID pData);
	int	(*m_pHitTestProc)(CPoint  sPoint,LPVOID pEntry		    ,LPVOID pData);
	int	(*m_pGetModeProc)(UINT    nFlags,LPVOID pEntry	 	    ,LPVOID pData);

//*****************************************************************************
//*
//*		Funktionen
//*
//*****************************************************************************

public:

				CTreeWnd();
	virtual    ~CTreeWnd();

	//{{AFX_VIRTUAL(CTreeWnd)
	virtual BOOL Create(LPCTSTR pClassName,LPCTSTR pWindowName,DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID,CCreateContext *pContext=NULL);
	virtual BOOL Create(                                       DWORD dwStyle,const RECT &sRect,CWnd *pParent,UINT nID,CCreateContext *pContext=NULL);
	//}}AFX_VIRTUAL


	int			GetStyle     ();
	CWnd       *SetFocus	 (int iMode=0);
	int   		GetSelect	 (CStringChain *pFiles,int iMode=0);
	UINT		SetStyle	 (UINT    uStyle,UINT   uMaske=0xFFFF);
	int			HitTest		 (               LPVOID pEntry=NULL);
	int   		HitTest		 (CPoint  sPoint,LPVOID pEntry);
	int	  		DoDrop		 (LPCTSTR pPath,int iMode);
	int			GetComboList (LPCTSTR pRegName,LPCTSTR pRegPath=0);		
	int			SetComboList (LPCTSTR pRegName,LPCTSTR pRegPath=0);		
	LPCTSTR		SetPath		 (LPCTSTR pPath);
	LPCTSTR		GetPath		  ();
	BOOL		IsPathUpAlloed();


	int			Set			(LPCTSTR pPath=0,LPCTSTR pSubDir=0,int iMode=0,BOOL bHistory=FALSE);
	int			SetListView	(int iMode=LVS_REPORT);
	void		SetDrop		(int(*DropProc   )(LPCTSTR pPath ,CStringChain *pFiles,int iMode,LPVOID pEntry,LPVOID pData)=0,LPVOID pData=0);
	void		SetView		(int(*HitTestProc)(CPoint  sPoint,LPVOID pEntry          ,LPVOID pData)=0,
							 int(*GetPathProc)(LPVOID  pEntry,LPTSTR pBuffer,int iLen,LPVOID pData)=0,
							 int(*GetModeProc)(UINT    nFlags,LPVOID pEntry	         ,LPVOID pData)=0);

	virtual	int CreateNewFolder(LPCTSTR pName=0);
	virtual	int Sort(int iMode=0,int iDir=0);

protected:

	static DWORD WINAPI InsertThread(LPVOID pView);

 	HTREEITEM	Read(LPCTSTR pPath,int iMode=0,HTREEITEM hRoot=0);
		int		StatusbarInit();
		int		StatusbarExit();
virtual int		StatusbarSet ();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext &sDc) const;
#endif

protected:

	int			Insert	   	();
	int			CbUpdate   	();		
	int			GetCbList  	();
	int   		SetCursor  	(int iMode);
	int 		GetCbText	(int iPos,LPTSTR pBuffer);
	int   		ReadSubDirs	(HTREEITEM hItem,LPTSTR pPath=0,int iMode=0);
	int   		GetPath    	(HTREEITEM hItem,LPTSTR pBuffer,int iLen);
	int   		GetPath    	(int       iItem,LPTSTR pBuffer,int iLen);
	int			SetComboBox	(LPCTSTR   pPath,int iLen,int iLevel=-1);		
	int			GetLevel   	(LPCTSTR   pPath,int iLen=-1);		
	BOOL		AddToHistory(LPCTSTR   pPath);

protected:

	//*********** Zum berladen mit neuen Funktionen  *************************
	virtual int ReadRoot (CStringChain *pEntries);
	virtual int ReadDirs (CStringChain *pEntries,LPCTSTR pPath,int iLevel);
	virtual int ReadFiles(CStringChain *pEntries,LPCTSTR pPath,int iLevel);
	virtual int	Rename   (LPCTSTR pPath,LPTSTR pBuffer,int iLevel);
	virtual int	DoRename (LPCTSTR pPath,LPTSTR pBuffer,int iLevel);
	virtual int	DoDelete (LPCTSTR pPath,LPTSTR pBuffer,int iLevel);
	virtual int GetIcon  (LPCTSTR pPath,LPTSTR pBuffer,int iLevel,int iMode);
	virtual int CheckPath(LPTSTR  pPath,int iLen,int &iLevel);
	virtual int	InsertItem(int  iNum);
	virtual int	InsertColumn();

	static	LRESULT __stdcall ComboEditProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);


	//{{AFX_MSG(CTreeWnd)
	afx_msg void OnSize(UINT nType,int iSizeX, int iSizeY);
	afx_msg void OnMouseMove  (UINT nFlags, CPoint sPoint);
	afx_msg void OnLButtonUp  (UINT nFlags, CPoint sPoint);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint sPoint);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp  (UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnContextMenu(CWnd *pWnd,CPoint sPoint);
	afx_msg int  OnCreate (LPCREATESTRUCT pCreate);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnTimer(UINT_PTR nIdEvent);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnPathSelect(UINT uId);
	afx_msg void OnMenu(CCmdUI *pCmdUI);
	afx_msg void OnCbSetFocus();
	afx_msg void OnSelChanged();
	afx_msg void OnCbCloseUp();
	afx_msg void OnTabulator();
	afx_msg void OnPathPrev();
	afx_msg void OnPathNext();
	afx_msg void OnDestroy();
	afx_msg void OnReturn();
	afx_msg void OnClose();
	afx_msg void OnPaint();
	//}}AFX_MSG

	afx_msg void OnTreeSelChanged (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeExpanded	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeBeginDrag  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeBeginEdit  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeEndEdit	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeKeyDown	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeFocus      (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnTreeClick	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListItemChanged(NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListColumnClick(NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListKeyDown	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListEndEdit	  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListBeginEdit  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListBeginDrag  (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListDoubleClick(NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListReturn     (NMHDR *pNmHdr, LRESULT *pResult);
	afx_msg void OnListFocus      (NMHDR *pNmHdr, LRESULT *pResult);

public:

	afx_msg void OnStatusbarSet();
	afx_msg void OnSelectFirst ();
	afx_msg void OnSelectAll   ();
	afx_msg void OnPathUp      ();
	afx_msg void OnDelete      ();
	afx_msg void OnNewDir      ();
	afx_msg void OnSmallIcon   ();
	afx_msg void OnReport      ();
	afx_msg void OnList        ();
	afx_msg void OnIcon        ();

	DECLARE_MESSAGE_MAP()
};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline  BOOL  CTreeWnd::IsPathUpAlloed(){return m_bUbEnable;}
inline  int   CTreeWnd::GetStyle      (){return m_iStyle;}


//{{AFX_INSERT_LOCATION}}


#endif
