//*****************************************************************************
//*
//*
//*     CBackupView.cpp
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include <winver.h>
#include <winreg.h>
#include "Resource.h"
#include "MainFrm.h"
#include "BackupDlg.h"
#include "BackupDoc.h"
#include "BackupView.h"
#include "ProgressDlg.h"
#include "ModeCopyDlg.h"
#include "ModeListDlg.h"
#include "ModeHostDlg.h"
#include "ModePathDlg.h"
#include "ModeBuffDlg.h"
#include "ModeSizeDlg.h"
#include "TaskbarTools.h"
#include "VarTools.h"
#include "SizeSynch.h"
#include "AfxUtility.h"
#include <AfxInet.h>
#include <winbase.h>
#include <winsock2.h>



#define		FRAME_CLASS		CMainFrame		//Klasse mit StatusBar
#define 	IDC_COMBOBOX	0x3987
#define 	ID_FIELD_COPY	0x3988
#define 	ID_FULL_COPY	0x3989
#define 	ID_MAKE_REL		0x398A
#define 	ID_SET_PATH		0x398B
#define 	ID_SETTINGS		0x398C
#define 	ID_DOFILTER		0x398D
#define 	ID_FILTER		0x398E
#define 	ID_STOP			0x398F
#define 	ID_NONE			0x3990

#ifdef     _DEBUG
#define new DEBUG_NEW
#undef      THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



IMPLEMENT_DYNCREATE(CBackupView, CView)

BEGIN_MESSAGE_MAP(CBackupView, CView)
	//{{AFX_MSG_MAP(CBackupView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_KEYDOWN()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_DROPFILES()
	ON_WM_CONTEXTMENU()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP

	ON_COMMAND(ID_FIELD_COPY	,	OnFieldCopy )
	ON_COMMAND(ID_FULL_COPY		,	OnFullCopy  )
	ON_COMMAND(ID_MAKE_REL		,	OnMakeRel   )
	ON_COMMAND(ID_SET_PATH		,	OnSetPath   )
	ON_COMMAND(ID_EDIT_CLEAR	,	OnDelete	)
	ON_COMMAND(ID_EINFUEGEN		,	OnInsert	)
	ON_COMMAND(ID_SELECTALL		,	OnSelectAll	)
	ON_COMMAND(ID_ZEITPLAN		,	ZeitplanView)
	ON_COMMAND(ID_SETTINGS		,	OnSettings	)
	ON_COMMAND(ID_DOFILTER		,	OnDoFilter	)
	ON_COMMAND(ID_BACKUP		,	OnStart		)
	ON_COMMAND(ID_PATHUP		,	OnPathUp	)
	ON_COMMAND(ID_REGON			,	OnRegOn		)
	ON_COMMAND(ID_ITEMUP		,	OnItemUp	)
	ON_COMMAND(ID_ITEMDOWN		,	OnItemDown	)
	ON_COMMAND(ID_NEWENTRY		,	OnNewEntry	)
	ON_COMMAND(ID_SETCPP		,   OnSetCpp	)
	ON_COMMAND(ID_EDIT_UNDO		,   OnUndo      )
	ON_COMMAND(ID_STOP			,   OnStop		)
	ON_COMMAND(ID_START_EDIT	,   OnStartEdit )
	ON_COMMAND(ID_SETFILTER		,   OnSetFilter )
	ON_COMMAND(ID_PATHCTRL		,   OnPathCtrl  )

	ON_UPDATE_COMMAND_UI(ID_BACKUP		   , OnStartUI   )
	ON_UPDATE_COMMAND_UI(ID_PATHUP		   , OnPathUpUI  )
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO      , OnMenuUndo  )
	ON_UPDATE_COMMAND_UI(ID_ITEMUP		   , OnItemUpUI	 )
	ON_UPDATE_COMMAND_UI(ID_PATHCTRL	   , OnPathCtrlUI)
	ON_UPDATE_COMMAND_UI(ID_ITEMDOWN	   , OnItemDownUI)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR     , OnMenuSelect)
	ON_UPDATE_COMMAND_UI(ID_SETCPP		   , OnMenuSelect)
	ON_UPDATE_COMMAND_UI(ID_SETFILTER	   , OnMenuFilter)

	ON_NOTIFY(TVN_ENDLABELEDIT  , IDC_LISTVIEW , OnEndEdit)
	ON_NOTIFY(TVN_STARTEDIT		, IDC_LISTVIEW , OnStartEdit)
	ON_NOTIFY(TVN_ITEMSMOVED	, IDC_LISTVIEW,  OnItemsMoved)
	ON_NOTIFY(TVN_COLUMNCLICK	, IDC_LISTVIEW , OnColumnClick)
	ON_NOTIFY(TVN_KEYDOWN		, IDC_LISTVIEW , OnTreeKeyDown)

	ON_MESSAGE(TB_NOTIFYICON		,OnNotifyIcon)
	ON_UPDATE_COMMAND_UI(ID_REGON	,OnRegOn)

END_MESSAGE_MAP()

#define		MAX_X			7					// Spaltenanzahl fr list_view
#define 	LV_NO_IMAGE		0x70000000
#define 	ISBAK(p)		(((*(int*)(p))|0x20202000)==0x6B61622E)

typedef struct
	{
	WORD  wLength;
	WORD  wValueLength;
	WORD  wType;
	WCHAR szKey[1];
	WORD  Padding1[1];
	VS_FIXEDFILEINFO Value;
	WORD  Padding2[1];
	WORD  Children[1];
	}VS_VERSIONINFO;

typedef struct
	{
	int			only;
	int			size;
	time_t		time;
	}FtpFileData;

char	   *CBackupView::modi[]={"Copy","Copy Del","Copy File","Zip","Zip Add","Reg","Reg Add","Move","Del","Ftp","Ftp Del","Synch","Puffer","Update","Version","Shrink","Backup",0};
int			CBackupView::mb_isshown=0;


//*****************************************************************************
//*
//*		GetVersionOfExec
//*
//*****************************************************************************
//	Holt einen Versionstext aus einer EXE-Datei
//	Quelle		: Name der Textdatei
//	Type		: Ist der Ausgabetyp
//					0 = auto
//					1 = 1
//					2 = 1.1
//					3 = 1.1.1
//					4 = 1.1.1.1
//					5 = 1.12
//	Name		: Hier wird der Versionstext gespeichert
//	Size		: Gre des Textpuffers
//	Ergibt die Lnge des gefundenen Versionstexts bzw. -1 wenn nicht.
int GetVersionOfExec(const char *Quelle,int Type,char *Name,int Size)
{
VS_VERSIONINFO		*info;
VS_FIXEDFILEINFO	*ver;
char				*mem;
char				 text[256];
char				 temp[256];
int					 len;


	if(Size>0)*Name=0;


	if(!GetFileVersionInfo((char*)Quelle,0,sizeof(text),text))
		{
		return -1;
		}

	info = (VS_VERSIONINFO*)text;

	if(wcscmp(info->szKey,L"VS_VERSION_INFO"))
		{
		return -1;
		}

	mem = (char*)(&info->szKey+wcslen(info->szKey)+1);

	if(((unsigned)mem)&3)
		{
		mem += 4-((unsigned)mem)&3;
		}

	ver = (VS_FIXEDFILEINFO*)mem;

	if(ver->dwSignature!=0xFEEF04BD)
		{
		return -1;
		}

	if(Type==0)
		{
		if(ver->dwFileVersionLS&0xFFFF)
			{
			Type = 4;
			}
		else if(ver->dwFileVersionLS)
			{
			Type = 3;
			}
		else{
			Type = 5;
			}
		}


	switch(Type)
		{
	case 4:	len=sprintf(temp,"%i.%i.%i.%i",ver->dwFileVersionMS>>16,ver->dwFileVersionMS&0xFFFF,ver->dwFileVersionLS>>16,ver->dwFileVersionLS&0xFFFF);	break;
	case 3:	len=sprintf(temp,"%i.%i.%i"   ,ver->dwFileVersionMS>>16,ver->dwFileVersionMS&0xFFFF,ver->dwFileVersionLS>>16);								break;
	case 2:	len=sprintf(temp,"%i.%i"      ,ver->dwFileVersionMS>>16,ver->dwFileVersionMS&0xFFFF);														break;
	case 1:	len=sprintf(temp,"%i"         ,ver->dwFileVersionMS>>16);																					break;
	default:len=sprintf(temp,"%i.%02i"    ,ver->dwFileVersionMS>>16,ver->dwFileVersionMS&0xFFFF);														break;
		}


return strlcpy(Name,temp,Size,len);
}

//*****************************************************************************
//*
//*		GetVersionOfText
//*
//*****************************************************************************
//	Holt einen Versionstext aus einer Textdatei
//	Quelle		: Name der Textdatei
//	Filter		: Filter fr Texte  "Pre" "Version" "Post" (fr memycmp)
//	Name		: Hier wird der Versionstext gespeichert
//	Size		: Gre des Textpuffers
//	Ergibt die Lnge des gefundenen Versionstexts bzw. -1 wenn nicht.
int GetVersionOfText(const char *Quelle,const char *Filter,char *Name,int Size)
{
FILE   *file;
char	filter1[128];
char	filter2[128];
char	filter3[128];
char	text  [1024];
int		star;
int		null;
int		len1;
int		len2;
int		len3;
int		pos;


	if(Size>0)*Name=0;

		file = fopen(Quelle,"rb");
	if(!file)return -1;

	Filter += strwlen  (Filter,0xE0);
	Filter += strgetstr(filter1,Filter,sizeof(filter1));
	Filter += strwlen  (Filter,0xE0);
	Filter += strgetstr(filter2,Filter,sizeof(filter2));
	Filter += strwlen  (Filter,0xE0);
	Filter += strgetstr(filter3,Filter,sizeof(filter3));

	if(!filter3[0])strcpy(filter3,"*");

	text[sizeof(text)-1]=0;

	if(filter1[0]=='\\' && filter1[1]=='.')				// Beginn mit Leerbereich
			null = strwlen(filter1+2,0x1F);
	else	null = 0;

	if(filter1[0]=='*')									// Beginn mit variablen Bereich
			star = strwlen(filter1+1,0x1F);
	else	star = 0;


	while(fgets(text,sizeof(text)-1,file))
		{
		if(null)
			{
			pos = strwlen(text,0xA0);

			if(memicmp(text+pos,filter1+2,null))
				{
				len1=0;
				continue;
				}
			}
		else if(star)
			{
			if(strlifind(text,filter1+1,strlen(text),star)<0)
				{
				len1=0;
				continue;
				}
			}

		len1 = memycmp(filter1,text          ,strlen(text          ),0x05);
		len2 = memycmp(filter2,text+len1     ,strlen(text+len1     ),0x05);
		len3 = memycmp(filter3,text+len1+len2,strlen(text+len1+len2),0x05);

		if(len1 && len2 && len3)break;

		len1=0;
		}

	fclose(file);

	if(!len1)return -1;


return strlcpy(Name,text+len1,Size,len2);
}


//*****************************************************************************
//*
//*		GetShareName
//*
//*****************************************************************************
//	Holt den UNC-Pfad zu einem Netzlaufwerk via "net.exe USE".
//	pPath	: Ist das Netzlaufwerk (z.B. "Z:")
//	pBuffer	: Hier wird der UNC-Pfad gespeichert
//	iMax	: Ist die Gre des Puffers fr den UNC-Pfad
//	Ergibt die Lnge des UNC-Pfades oder 0 bei einem Fehler.
int GetShareName(LPCTSTR pPath,LPTSTR pBuffer,INT iMax)
{
SECURITY_ATTRIBUTES sAttr = {sizeof(SECURITY_ATTRIBUTES),NULL,TRUE};
static CHAR			cData[0x2000];
TCHAR				cNetPath[MAX_PATH]={'"'};
STARTUPINFO			sStart;
PROCESS_INFORMATION	sInfo;
static DWORD		dwSize;
static DWORD		dwLast;
DWORD				dwBytes;
DWORD				dwFlags;
HANDLE				hPipeRd;
HANDLE				hPipeWr;
BYTE				ucSign;
INT					iSize;
UINT				uDiff;
UINT				uPos;
UINT				uLen;


	if(iMax<=0 || !pBuffer)
		{
		return FALSE;
		}

	pBuffer[0] = 0;

	
	if(dwSize>0)										// Erst nach einer Minute aktualisieren
		{
		   uDiff = GetTickCount()-dwLast;	
		if(uDiff<60000)goto Next;
		}


//******************** Pfade holen ********************************************


	   iSize = GetSystemDirectory(cNetPath+1,MAX_PATH-8);
	if(iSize<=0)return 0;

	_tcscpy(cNetPath+1+iSize,_T("\\net.exe"));

	if(GetFileAttributes(cNetPath+1)==0xFFFFFFFF)		// Existiert "net.exe"
		{
		return 0;
		}
	
	_tcscpy(cNetPath+1+iSize,_T("\\net.exe\" use"));

	if(!CreatePipe(&hPipeRd,&hPipeWr,&sAttr,sizeof(cData)-1))
		{
		return 0;
		}

	memset(&sStart,0,sizeof(sStart));
	sStart.cb			= sizeof(sStart);
	sStart.dwFlags		= STARTF_USESTDHANDLES|STARTF_USESHOWWINDOW;
	sStart.wShowWindow 	= SW_HIDE;
	sStart.hStdOutput	= hPipeWr;
	sStart.hStdInput	= INVALID_HANDLE_VALUE;
	sStart.hStdError	= hPipeWr;

														// "net.exe" mit "use" starten
	if(!CreateProcess(NULL,cNetPath,NULL,NULL,TRUE,0,NULL,NULL,&sStart,&sInfo))
		{
		CloseHandle(hPipeRd);
		CloseHandle(hPipeWr);
		return 0;
		}
														// Warte bis das Programm beendet wurde
	if(WaitForSingleObject(sInfo.hProcess,10000)==WAIT_TIMEOUT)
		{
		CloseHandle(hPipeRd);
		CloseHandle(hPipeWr);

		CloseHandle(sInfo.hProcess);
		CloseHandle(sInfo.hThread );

		return 0;
		}

	

	   dwBytes = GetFileSize(hPipeRd,NULL);				// Byte-Count in der Pipe abfragen
	if(dwBytes>=sizeof(cData))
		{
		dwBytes = sizeof(cData)-1;
		}

	if(!ReadFile(hPipeRd,cData,dwBytes,&dwBytes,NULL))
		{
		dwBytes = 0;
		}

	cData[dwBytes] = 0;
	dwSize = dwBytes;
	dwLast = GetTickCount();

	CloseHandle(sInfo.hProcess);
	CloseHandle(sInfo.hThread );

	CloseHandle(hPipeRd);
	CloseHandle(hPipeWr);



//******************** Zeilen auswerten ***************************************
Next:

	
	uLen = _tcslen(pPath);

	for(uPos=0;;uPos++)
		{
		if(uPos>=dwSize)return 0;

		if(cData[uPos  ]=='-')
		if(cData[uPos+1]=='-')
		if(cData[uPos+2]=='-')
		if(cData[uPos+3]=='-')break;
		}


	for(;;uPos++)
		{
		if(uPos>=dwSize)return 0;

		if(cData[uPos  ]=='\n'){uPos++;break;}
		if(cData[uPos  ]=='\r'){uPos++;break;}
		}

	
	if(cData[uPos]=='\n')uPos++;


	for(;;uPos++)										// Zeilenweise auswerten
		{
		if(uPos>=dwSize)return 0;

		for(;;uPos++)									// Erstes Wort berspringen
			{
			if(uPos>=dwSize)return 0;
			
			if(cData[uPos]>='A' && cData[uPos]<='Z')continue;
			if(cData[uPos]>='a' && cData[uPos]<='z')continue;
			if(cData[uPos]>='0' && cData[uPos]<='1')continue;

			if(cData[uPos]==' ' && cData[uPos+1]>' ' && cData[uPos+2]!=':')
				{
				continue;
				}

			break;
			}

		for(;;uPos++)									// Leerraum berspringen
			{
			if(uPos>=dwSize)return 0;
			if(cData[uPos]!=' ' && cData[uPos]!='\t')
				{
				break;
				}
			}

		if(!_tcsnicmp(cData+uPos,pPath,uLen))
		if(cData[uPos+uLen]==' ' || cData[uPos+uLen]=='\t')
			{
			break;
			}
			
			
		for(;;uPos++)									// Zur nchsten Zeile
			{
			if(uPos>=dwSize)return 0;
			if(cData[uPos]=='\n')break;
			if(cData[uPos]=='\r')break;
			}

		if(cData[uPos+1]=='\n')uPos++;
		}
	

	
	for(uPos+=uLen;;uPos++)								// Vor zum UNC-Pfad
		{
		if(uPos>=dwSize)return 0;
		
		if(cData[uPos]!=' ' && cData[uPos]!='\t')
			{
			break;
			}
		}


	iMax--;

	for(uLen=0;uLen<(unsigned)iMax;uLen++)				// Vor zum UNC-Pfad
		{
		if(uPos>=dwSize)break;

		   ucSign = cData[uPos+uLen];
		if(ucSign<=' ')break;

		pBuffer[uLen] = ucSign;
		}
	

	pBuffer[uLen] = 0;

	dwFlags = GetFileAttributes(pBuffer);				// Den Pfad prfen

	if(dwFlags==0xFFFFFFFF || !(dwFlags&FILE_ATTRIBUTE_DIRECTORY))
		{
		pBuffer[0] = 0;
		return 0;
		}



return uLen;
}

//*****************************************************************************
//*
//*		FileCountRename
//*
//*****************************************************************************
//	Erhht alle Dateinamen mit dem Format Filename um 1
//	Filename	: Format fr Dateinamen
//				  z.B.  "Hallo#3#"	steht fr "Hallo???"
//						"Hallo#2#"	steht fr "Hallo??"
//						??? steht fr eine Zahl
//	Alle gefunden Dateien werden von 0 beginnend um 1 erhht bis eine
//	Lcke gefunden wird. (aus  "Hallo00" wird "Hallo01" usw. )
//	Ergibt :	Die Anzahl der durch gehenden Kette
//				-1 bei einem Fehler
//				-2 wenn die Kette zu lang ist
int FileCountRename(const char *Filename,char *Basename=0,int Size=0,int NotRename=0)
{
int		breite,pos,nr,end,x,y;
char	name[MAX_PATH+1024],name1[MAX_PATH+1024];



	for(pos=0;pos<sizeof(name)-10;pos++)		// Suche Format
		{
		if(Filename[pos]   != '#')continue;
		if(Filename[pos+1] <= '0')continue;
		if(Filename[pos+1] >= '5')continue;
		if(Filename[pos+2] != '#')continue;
		break;
		}

	if(pos>=sizeof(name)-10)return -1;			// Format wurde nicht gefunden

	breite = Filename[pos+1]-'0';
	end	   = pos+breite;

	memcpy (name,Filename,pos);
	memset (name+pos,'0',breite);
	strncpy(name+end,Filename+pos+3,sizeof(name)-end);

	name[sizeof(name)-1]=0;
	x=strlen(name);

	if(Basename && Size>0)						// Anfangsnamen kopieren
		{
		if(x+1<Size)
				memmove(Basename,name,x+1);
		else	Basename[0]=0;
		}


	if(NotRename)								// Nur namen erzeugen
		{
		if(!Basename || !(NotRename&0x80000000))
			{
			return 0;
			}

		sprintf(name,"%08i",NotRename&0x7FFFFFFF);
		memcpy(Basename+pos,name+8-breite,breite);

		return 0;
		}

	if(x>0)
	if(name[x-1]=='/' || name[x-1]=='\\')name[x-1]=0;

	nr=0;
	end--;

	for(;;) 									// Suche Lcke
		{
		if(!ExistFile(name))break;

		nr++;
		for(x=0;x<breite;x++)
			{
			   name[end-x]++;
			if(name[end-x]<='9')break;
			   name[end-x] ='0';
			}
		if(x>=breite)return -2;
		}

	if(nr==0)return 0;

	strncpy(name1,name,sizeof(name1));			// Neuen Namen erzeugen

	for(y=0;y<nr;y++)							// Kette umbenennen
		{
		for(x=0;x<breite;x++)
			{
			   name[end-x]--;
			if(name[end-x]>='0')break;
			   name[end-x] ='9';
			}

		if(!MoveFile(name,name1))return -1;

		for(x=0;x<breite;x++)
			{
			   name1[end-x]--;
			if(name1[end-x]>='0')break;
			   name1[end-x] ='9';
			}
		}


return nr;
}

//*****************************************************************************
//*
//*		FileDateRename
//*
//*****************************************************************************
//	Erzeugt einen Dateinamen mit Datumseintrag
//	Filename	: Format fr Dateinamen
//				  z.B.  "Hallo#D#"	steht fr "Hallo 16.Mai.2001 (Mo)"
//						"Hallo#d#"	steht fr "Hallo 1999-06-21 (So)"
//						??? steht fr eine Zahl
//	Ergibt die neue Lnge des Dateinamens bzw. 0 bei einem Fehler.
int FileDateRename(const char *Filename,char *Ziel,int Size)
{
int		pos,len,anz,ok=0;
char	datum[32];
time_t	zeit;
struct 	tm *g;



	len=strlen (Filename);
	pos=strchar(Filename,'#');						// Spezial Pfad


	if(pos+3<=len)									// Keine # gefunden
	if(Filename[pos+2]=='#')
		{
		if(Filename[pos+1]=='d')ok=1;
		if(Filename[pos+1]=='D')ok=2;
		}

	if(!ok)											// Keine Angabe gefunden
		{
		if(len+1>Size)return 0;
		memmove(Ziel,Filename,len+1);
		return len;
		}

	zeit=time(0);
	g=localtime(&zeit);

	if(ok==2)anz=sprintf(datum,"%u-%02u-%02u"       ,g->tm_year+1900,g->tm_mon+1,g->tm_mday);
	else	 anz=sprintf(datum,"%u-%02u-%02u (%.2s)",g->tm_year+1900,g->tm_mon+1,g->tm_mday,"SoMoDiMiDoFrSaSo"+(g->tm_wday&7)*2);


	if(Filename[pos+3]!='.' && Filename[pos+3]!='_')
	if(Filename[pos+3]!='0' && Filename[pos+3]!=' ')
		{
		datum[anz]=' ';
		anz++;
		}

	memmove(Ziel        ,Filename,pos            );
	memmove(Ziel+pos+anz,Filename+pos+3,len-pos-2);
	memmove(Ziel+pos	,datum		   ,anz      );


return len+anz-3;
}

//*****************************************************************************
//*
//*		FileVersionRename
//*
//*****************************************************************************
//	Erzeugt einen Dateinamen mit Versionseintrag
//	Filename	: Format fr Dateinamen
//				  z.B.  "Hallo#@#"	steht fr "Hallo 1.05"
//						"Hallo#@1#"	steht fr "Hallo 1"
//						"Hallo#@2#"	steht fr "Hallo 1.1"
//						"Hallo#@3#"	steht fr "Hallo 1.1.1"
//						"Hallo#@4#"	steht fr "Hallo 1.1.1.1"
//						"Hallo#@"AAA" "?.??" "BBB" #"	steht fr "Hallo ..."
//						... wird aus der Textdatei geholt zwischen AAA...BBB
//	From		: Ist die Datei die den Versiontext enthllt
//	Ergibt die neue Lnge des Dateinamens bzw. 0 bei einem Fehler.
int FileVersionRename(const char *Filename,char *Ziel,int Size,const char *From)
{
int		pos,len,add,anz=0,typ=0,ok=0;
char	filter[256];
char	text[32];



	len=strlen (Filename);
	pos=strchar(Filename,'#');						// Spezial Pfad
	filter[0] = 0;

	if(pos+3<=len)									// Keine # gefunden
	if(Filename[pos+1]=='@')
		{
		if(Filename[pos+2]>='0' && Filename[pos+2]<='9')
			{
			typ=Filename[pos+2]-'0';
			add=3;
			}
		else if(Filename[pos+2]=='#')
			{
			typ=0;
			add=2;
			}
		else{
			typ  = -1;
			add  = 2;
			add += strgetstr(filter,Filename+pos+add,sizeof(filter));
			add += strgetstr(filter,Filename+pos+add,sizeof(filter));
			add += strgetstr(filter,Filename+pos+add,sizeof(filter));
			add += strwlen(Filename+pos+2+add,0xE0);
			strlcpy(filter,Filename+pos+2,sizeof(filter),add-2);
			}

		if(Filename[pos+add]=='#')
		if(typ<0 || CmpFileType(From,"exe;dll;sys;ocx"))
			{
			ok=1;
			}
		}

	if(ok)											// Versionstext holen
		{
		if(typ>=0)
				anz=GetVersionOfExec(From,typ   ,text,sizeof(text));
		else	anz=GetVersionOfText(From,filter,text,sizeof(text));

		if(anz<=0)ok=0;
		}

	if(!ok)
		{
		if(len+1>Size)return 0;
		memmove(Ziel,Filename,len+1);
		return len;
		}


	if(Filename[pos+add+1]!='.' && Filename[pos+add+1]!='_')
	if(Filename[pos+add+1]!='0' && Filename[pos+add+1]!=' ')
		{
		text[anz]=' ';
		anz++;
		}

	memmove(Ziel        ,Filename,pos                  );
	memmove(Ziel+pos+anz,Filename+pos+add+1,len-pos-add);
	memmove(Ziel+pos	,text		       ,anz        );


return len+anz-3;
}

//*****************************************************************************
//*
//*     Konstruktor ... Grundeinstellung der Variabeln
//*
//*****************************************************************************
CBackupView::CBackupView()
{

	hide			= 0;
	reg_on			= 0;
	set_statubar	= 0;
	sort_art		= 0;						// Sortier-Art
	sort_richtung	= 0;						// Sortier-Richtung
	anzahl			= 0;
	geaendert		= 0;
	teilung			= 100;						// Teilung der Fenster
	kopie_anz		= 0;
	lock_escape		= 0;
	zeitplan_anz	= 1;
	zeitplan_art	= 0;
	zeitplan_letzte	= 0;
	size_offset		= 0;
	size_mode		= 0;
	size_max		= 0;
	size_now		= 0;
	dlg_view		= 0;
	lock			= 0;						// Lnge der Verzeichnisspeichers
	undo_ok			= 0;
	filter_on		= 0;
	filter_tick		= 0;
	ftp_conn		= 0;
	base_item		= TVI_ROOT;

	cursor_size		= LoadCursor(0,IDC_SIZENS);

}

//*****************************************************************************
//*
//*     Destruktor ...
//*
//*****************************************************************************
CBackupView::~CBackupView()
{

	if(ftp_conn)
		{
		delete ftp_conn;
		ftp_conn = NULL;
		}

	if(!call_bat.IsEmpty())
		{
		CStartProg	start;

		//start.SetShow(SW_HIDE);
		start.SetShow(SW_SHOW);
		start.Start(call_bat,CSP_NOWAIT|CSP_NOHANLES);
		}
}

//*****************************************************************************
//*
//*     ExtDrop
//*
//*****************************************************************************
//	Drop-Funktion fr CDateiView
int __cdecl CBackupView::ExtDrop(const char *Pfad,CStringChain *Dateien,int Art,void *Element,void *Data)
{
CBackupView	*bu_view;
char		*name;
int			 pos,nr;
int			 x,anz;
int			 col;



	if(!Data)return 0;								// Klassen Zeiger ok ?
	bu_view=(CBackupView*)Data;
	anz=Dateien->Count();
	if(!anz)return 0;
	nr  = *(int*)Element&0xFFFF;
	col	= *(int*)Element>>16;
	pos = -1;

	if(Art==1)
		{
		for(x=0;x<anz;x++)
		pos=bu_view->Insert(-1,nr,Dateien->Get(x));
			bu_view->SetGeaendert(1);
		return 0;
		}

	if(pos>=0)
		{
		bu_view->list_view.ListEnsureVisible(pos);
		}

	name=Dateien->Get(0);
	if(!strnicmp(name,"HKEY_",5))return 0;

	bu_view->SetText(name,nr,(col!=0)? 1:0);
	bu_view->SetGeaendert(1);
	bu_view->SetIcon(nr,0);


return 0;
}

//*****************************************************************************
//*
//*     ExtGetMode
//*
//*****************************************************************************
//	DropMode-Funktion fr CDateiView
//	nFlags	: Sind die Tastatur-Flags
//	Ergibt	0 : wenn Ablage nicht erlaubt
//			1 : Ablage mit [+]-Zeichen
//			2 : Ablage mit [^]-Zeichen
int CBackupView::ExtGetMode(UINT  nFlags ,void *Element,void *Data)
{


	if(!Data)return   0;
	if(*(int*)Element<0)		 return 1;				// Auf keinem Element
	if(*(int*)Element&0xFFFF0000)return 2;				// Rechts von erster Spalte
	if(nFlags&8)return 2;								// Crtl gedrckt


return 1;
}

//*****************************************************************************
//*
//*     ExtHitTest
//*
//*****************************************************************************
//	Prft ob Point ein Drop-Ziel ist. Fr CDateiView
//	Ergibt  1 wenn Ablage erlaubt sonst 0
int CBackupView::ExtHitTest(CPoint Point ,void *Element,void *Data)
{
CBackupView	*bu_view;
int			 x,y,z;


	if(!Data)return 0;								// Klassen Zeiger ok ?

	bu_view=(CBackupView*)Data;

	z=bu_view->HitTest(Point,&x,&y);
	if(z==-1)					return 0;			// Treffer ?
	if(z==-2){*(int*)Element=-1;return 1;}
	if(x>= 2)					return 0;

	*(int*)Element=(x<<16)|y;						// Zeile speichern

return 1;
}

//*****************************************************************************
//*
//*		DiffSecs
//*
//*****************************************************************************
//	Berechnet die Differnz von FILRTIME's in Sekunden.
int CBackupView::DiffSecs(FILETIME &Time1,FILETIME &Time2)
{
__int64		diff;


	diff	= *(__int64*)&Time1;
	diff   -= *(__int64*)&Time2;
	diff   /=  10000000;

	if(diff> 0x7000000)return  0x7000000;
	if(diff<-0x7000000)return -0x7000000;


return (int)diff;
}

//*****************************************************************************
//*
//*		DiffDays
//*
//*****************************************************************************
//	Berechnet die Differnz von FILRTIME's in Tagen.
int CBackupView::DiffDays(FILETIME &Time1,FILETIME &Time2)
{
__int64		diff;


	diff	= *(__int64*)&Time1;
	diff   -= *(__int64*)&Time2;
	diff   /=  864000000000;

	if(diff> 0x7000000)return  0x7000000;
	if(diff<-0x7000000)return -0x7000000;


return (int)diff;
}

//*****************************************************************************
//*
//*     SortList
//*
//*****************************************************************************
//	Sortierfunktion fr List Feld
//	Funktioniert nicht Ursache unbekannt
int CALLBACK CBackupView::SortList(HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1, LPARAM lParam2,LPARAM lParamSort)
{
TV_ITEM		 item1,item2;
char		 puffer1[MAX_PATH+1024+16];
char		 puffer2[MAX_PATH+1024+16];
int			 x;
SortData    *data=(SortData*)lParamSort;


	item1.mask		 = TVIF_TEXT|TVIF_CHILDREN;			// Erster Text
	item1.hItem		 = data->list->GetItemOfRow(lParam1);
	item1.cChildren	 = data->nr;
	item1.pszText	 = puffer1;
	item1.cchTextMax = MAX_PATH+1024;
	data->list->GetItem(&item1);

	item2.mask		 = TVIF_TEXT|TVIF_CHILDREN;			// Zweiter Text
	item2.hItem		 = data->list->GetItemOfRow(lParam2);
	item2.cChildren	 = data->nr;
	item2.pszText	 = puffer2;
	item2.cchTextMax = MAX_PATH+1024;
	data->list->GetItem(&item2);


	x = stricmp(puffer1,puffer2);


return (data->richtung)? -x:x;
}

//*****************************************************************************
//*
//*     PreCreateWindow
//*
//*****************************************************************************
//	Aufruf bevor Fenster sichtbar wird
BOOL CBackupView::PreCreateWindow(CREATESTRUCT& cs)
{

return CView::PreCreateWindow(cs);
}

//*****************************************************************************
//*
//*     Create  Fenstererzeugung
//*
//*****************************************************************************
// Erzeugen eines Fensters
BOOL CBackupView::Create( LPCTSTR pClassName, LPCTSTR pWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{
HIMAGELIST	 hImageList;
CFileFinder  laufwerke;
SHFILEINFO	 sfi;
RECT		 rec;
BOOL		 x;


	rec.top   = 0;
	rec.bottom= 0;
	rec.left  =10;
	rec.right =10;


	x=CView::Create(pClassName,pWindowName,dwStyle,rect,pParentWnd,nID,pContext);
	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)GetStockObject(NULL_BRUSH));
	SetClassLongPtr(m_hWnd,GCLP_HCURSOR      ,(LPARAM)cursor_size);

//******************* List-View ************************************************
// Die Abteilungen einfgen

	x = GetSystemMetrics(SM_CXICON);

	list_view.Create(WS_CHILD|WS_CLIPSIBLINGS|TVS_EDITLABELS|TVS_FULLROWSELECT|TVS_NONEVENHEIGHT|TVS_AUTODRAGMOVE,rec,this,IDC_LISTVIEW);
	list_view.InsertColumn(0,"Quelle"		,TVCFMT_LEFT  ,-35);
	list_view.InsertColumn(1,"Ziel"			,TVCFMT_LEFT  ,-25);
	list_view.InsertColumn(2,"Plus Filter"  ,TVCFMT_LEFT  ,-12);
	list_view.InsertColumn(3,"Minus Filter"	,TVCFMT_LEFT  ,-12);
	list_view.InsertColumn(4,"Unter"		,TVCFMT_CENTER, 45);
	list_view.InsertColumn(5,"Modus"		,TVCFMT_LEFT  ,(70*x)/32);
	list_view.InsertColumn(6,"Zusatz"		,TVCFMT_LEFT  ,-15);
	list_view.SetExtendedStyle(TVS_EX_FULLROWMARK|TVS_EX_ALTERNATECOLOR|TVS_EX_HOMEENDSELECT|TVS_EX_ITEMLINES|TVS_EX_MULTISELECT|TVS_EX_SUBSELECT|TVS_EX_EDITCLICK|TVS_EX_ALLOWITEMHIDE|TVS_EX_TABEXIT);
	list_view.SetDragMoveFlags(TVDM_NOTOCHILDS|TVDM_SAMELEVEL|TVDM_SAMEPARENT|TVDM_NOFIXEDITEMS);
	list_view.ShowWindow( SW_SHOW );

	// Sytem-Image-Listen mit List-View verbinden.
	hImageList = (HIMAGELIST)SHGetFileInfo("",0,&sfi,sizeof(sfi),SHGFI_PIDL|SHGFI_SMALLICON|SHGFI_SYSICONINDEX);
	list_view.SetImageList(hImageList,TVSIL_NORMAL);


//******************* Datei-View ***********************************************

	datei_view.Create(DVS_DRAGDROP|DVS_NODROP|DVS_TABEXIT,rec,this,IDC_DATEIVIEW);
	datei_view.SetView(ExtHitTest,0,ExtGetMode);
	datei_view.SetDrop(ExtDrop,this);
	datei_view.GetComboList("FileList");

	reg_view.Create(DVS_DRAGDROP|DVS_NODROP|DVS_TABEXIT,rec,this,IDC_REGVIEW);
	reg_view.SetView(ExtHitTest,0,ExtGetMode);
	reg_view.SetDrop(ExtDrop,this);
	reg_view.GetComboList("RegList");



return x;
}

//*****************************************************************************
//*
//*     OnDraw    Fenster neuzeichnen
//*
//*****************************************************************************
//	Neu zeichnen des Fensters
void CBackupView::OnDraw(CDC *pDC)
{

	CBackupDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

}

//*****************************************************************************
//*
//*     OnSize
//*
//*****************************************************************************
//	Gren nderung des Fensters
void CBackupView::OnSize(UINT nType, int cx, int cy)
{
CWnd	*wnd;

	if(hide)
		{
		wnd = AfxGetMainWnd();
		if(wnd)TaskbarHide(wnd->m_hWnd);
		}

	CView::OnSize(nType, cx, cy);

	if(!m_hWnd   )return;
	if(!list_view)return;


	if(list_view)
		{
		list_view.MoveWindow(0,0,cx,teilung);
		list_view.UpdateWindow();
		}


	if(reg_on)
		{
		datei_view.ShowWindow(SW_HIDE);
		datei_view.MoveWindow(0,0,0,0);

		  reg_view.MoveWindow(0,teilung+7,cx,cy-teilung-7);
		  reg_view.ShowWindow(SW_SHOW);
		}
	else{
		  reg_view.ShowWindow(SW_HIDE);
		  reg_view.MoveWindow(0,0,0,0);

		datei_view.MoveWindow(0,teilung+7,cx,cy-teilung-7);
		datei_view.ShowWindow(SW_SHOW);
		}


}

//*****************************************************************************
//*
//*		OnNewEntry
//*
//*****************************************************************************
void CBackupView::OnNewEntry()
{

	Insert(-1,"");

}

//*****************************************************************************
//*
//*		OnRegOn
//*
//*****************************************************************************
void CBackupView::OnRegOn()
{
RECT	rect;


	reg_on=!reg_on;

	GetClientRect(&rect);
	OnSize(0,rect.right-rect.left,rect.bottom-rect.top);

}

//*****************************************************************************
//*
//*		NewView
//*
//*****************************************************************************
//	Lscht die ausgewhlten Eintrge
//	Ergibt die Anzahl der gelschten Eintrge
void CBackupView::NewView()
{

	list_view.DeleteAllItems();

	sort_art		= 0;			// Sortier-Art
	sort_richtung	= 0;			// Sortier-Richtung
	anzahl			= 0;
	geaendert		= 0;
	kopie_anz		= 0;
	zeitplan_anz	= 1;
	zeitplan_art	= 0;
	zeitplan_letzte	= 0;

}

//*****************************************************************************
//*
//*     Debug Funktionen
//*
//*****************************************************************************
#ifdef _DEBUG
void CBackupView::AssertValid() const
{
	CView::AssertValid();
}

void CBackupView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBackupDoc* CBackupView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBackupDoc)));
	return (CBackupDoc*)m_pDocument;
}
#endif

//*****************************************************************************
//*
//*     OnDestroy
//*
//*****************************************************************************
void CBackupView::OnDestroy()
{

	datei_view.SetComboList("FileList");
	reg_view  .SetComboList("RegList" );

	// Die Image-Listen fr das List-View lschen
	list_view.SetImageList((HIMAGELIST)0,LVSIL_SMALL);


CView::OnDestroy();

}

//*****************************************************************************
//*
//*     SetIcon
//*
//*****************************************************************************
//	Setzt das Icon fr die Zeile Nummer
//	Ergibt 0 wenn Datei gefunden sonst 0
int CBackupView::SetIcon(int Nr,int Warnung)
{
char			temp  [MAX_PATH+1024+16];
char			puffer[MAX_PATH+1024+16],*ptr;
SysFindStruct	find;
TV_ITEM			item;
int				icon;
int				max;
SysFind			f;
int 			y;
int				x;


	if((Nr>>24)==0x71)
		{
		item.hItem = (HTREEITEM)(Nr&0x00FFFFFF);
		}
	else{
		max = (filter_on)? anzahl+1:anzahl;

		if(Nr>=max)return -1;
		if(Nr<   0)return -1;
		if(Nr==  0 && filter_on)return -1;

		item.hItem		= list_view.GetItemOfRow(Nr);
		}


	for(x=1;x>=0;x--)
		{
		item.mask		= TVIF_TEXT|TVIF_SUBITEM;		// Hole Pfad
		item.cChildren	= x;
		item.pszText	= puffer;
		item.cchTextMax	= MAX_PATH+1024;
		list_view.GetItem(&item);

		ptr = VarConvert(puffer,sizeof(puffer));

		DelBackSlash(ptr);

		if(x==0 && !strcmp(ptr,"DATE"))
			{
			   icon = GetIconNr("date.bku",SHGFI_SMALLICON|SHGFI_USEFILEATTRIBUTES);
			if(icon<0)icon=LV_NO_IMAGE;

			list_view.ListSetItemImage(Nr,icon,icon);
			continue;
			}
														// Ftp Server ?
		if(!strnicmp(ptr,"ftp://",6) || !strnicmp(ptr,"sftp://",7) || !strnicmp(ptr,"smb://",6) || !strnicmp(ptr,"ssh://",6))
			{
			   icon = GetIconNr("xxx.htm",SHGFI_SMALLICON|SHGFI_USEFILEATTRIBUTES);
			if(icon<0)icon=LV_NO_IMAGE;

			if(x==0)
				{
				list_view.ListSetItemImage(Nr,icon,icon);
				return 0;
				}

			list_view.ListSetItemImageEx(Nr,icon,x);
			continue;
			}


		if(!strnicmp(ptr,"disk://",7))					// Disk Server ?
			{
			   icon = GetIconNr("xxx.bin",SHGFI_SMALLICON|SHGFI_USEFILEATTRIBUTES);
			if(icon<0)icon=LV_NO_IMAGE;

			if(x==0)
				{
				list_view.ListSetItemImage(Nr,icon,icon);
				return 0;
				}

			list_view.ListSetItemImageEx(Nr,icon,x);
			continue;
			}

		if(!strnicmp(ptr,"HKEY_",5))					// Registry Schlssel ?
			{
			   icon = GetIconNr("xxx.reg",SHGFI_SMALLICON|SHGFI_USEFILEATTRIBUTES);
			if(icon<0)icon=LV_NO_IMAGE;

			if(x==0)
				{
				list_view.ListSetItemImage(Nr,icon,icon);
				return 0;
				}

			list_view.ListSetItemImageEx(Nr,icon,x);
			continue;
			}

		PathCompress(temp,ptr,sizeof(temp));
		PathConvert (temp,'\\');
		ptr = temp;

		if(ptr[0]>='a' && ptr[0]<='z')ptr[0]-=32;

		y=GetLogicalDrives();

		do	{											// Prfe Pfad
			if(!(y&(1<<(ptr[0]-'A'))))
			if(ptr[0]!='\\' || ptr[1]!='\\')
				{
				y=-1;break;
				}

			y=strcspn(ptr,":\\");
			if(ptr[y]==':')
				{
				y++;
				if(ptr[y]=='\\')y++;
				if(ptr[y]== 0  )break;
				}

			f=SysFindFirst(ptr,&find);
			if(f)SysFindClose(f);
			else y=-1;
			}while(0);

		if(y==-1)
			{
			   icon=GetIconNr(ptr,SHGFI_SMALLICON|SHGFI_USEFILEATTRIBUTES);
			if(icon<0)icon=GetIconNr(ptr,SHGFI_SMALLICON);
			}
		else{
			icon=GetIconNr(ptr,SHGFI_SMALLICON);
			}

		if(icon<0 || !*ptr)icon=LV_NO_IMAGE;

		if(x==0)
			{
			list_view.ListSetItemImage(Nr,icon,icon);
			}
		else{
			list_view.ListSetItemImageEx(Nr,icon,x);
			}
		}


	if(y==-1 && Warnung)
		{
		MessageBox("Pfad/Datei existiert nicht !",0,MB_OK|MB_ICONWARNING);
		}



return (y==-1)? -1:0;
}

//*****************************************************************************
//*
//*     Insert
//*
//*****************************************************************************
//	Fgt einen Eintrag bei einer Position ein.
//	Ist Position==-1 wird der Eintrag am Ende angefgt
//	Die Position wo der Eintrag eingefgt wurde.
int CBackupView::Insert(int Pos,char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,int Modus,char *Zusatz)
{
char		puffer[MAX_PATH+1024];
int			x;


	if(Ziel)
		{
		if(!strncmp (Ziel,"HKEY_"  ,5)                                         )Modus=MODE_REG;
		if(!strnicmp(Ziel,"smb://" ,6) && Modus!=MODE_FTP && Modus!=MODE_BACKUP)Modus=MODE_FTP;
		if(!strnicmp(Ziel,"ssh://" ,6) && Modus!=MODE_FTP && Modus!=MODE_BACKUP)Modus=MODE_FTP;
		if(!strnicmp(Ziel,"ftp://" ,6) && Modus!=MODE_FTP && Modus!=MODE_BACKUP)Modus=MODE_FTP;
		if(!strnicmp(Ziel,"disk://",7) && Modus!=MODE_FTP && Modus!=MODE_BACKUP)Modus=MODE_FTP;
		if(!strnicmp(Ziel,"sftp://",7) && Modus!=MODE_FTP && Modus!=MODE_BACKUP)Modus=MODE_FTP;
		}

	if(strncmp(Quelle ,"HKEY_" ,5) && strnicmp(Quelle,"ftp://",6) && strnicmp(Quelle,"sftp://",7) && strnicmp(Quelle,"smb://",6) && strnicmp(Quelle,"disk://",7) && strnicmp(Quelle,"ssh://",6))
		{
		if(strcmp(Quelle,"DATE") && !strstr(Quelle,"$("))
			{
			_fullpath(puffer,Quelle,MAX_PATH+1024);
			}
		else{
			strlcpy(puffer,Quelle,sizeof(puffer));
			}
		}
	else{
			strncpy (puffer,Quelle,sizeof(puffer));
		if(!strnicmp(Quelle,"HKEY_"  ,5)                   )Modus=MODE_REG;
		if(!strnicmp(Quelle,"smb://" ,6) && Modus!=MODE_FTP)Modus=MODE_FTP;
		if(!strnicmp(Quelle,"ssh://" ,6) && Modus!=MODE_FTP)Modus=MODE_FTP;
		if(!strnicmp(Quelle,"ftp://" ,6) && Modus!=MODE_FTP)Modus=MODE_FTP;
		if(!strnicmp(Quelle,"disk://",7) && Modus!=MODE_FTP)Modus=MODE_FTP;
		if(!strnicmp(Quelle,"sftp://",7) && Modus!=MODE_FTP)Modus=MODE_FTP;
		}

	if(Modus==MODE_REG || Modus==MODE_REGADD)
		{
		Plus  = "";
		Minus = "";
		Unter = 1;
		}

	x=strlen  (puffer);
	if((x>3)&&(puffer[x-1]=='\\'))puffer[x-1]=0;

	if(Pos>anzahl)Pos=anzahl;
	if(Pos<0     )Pos=anzahl;
	if(Pos==0 && filter_on)Pos=1;

			  list_view.ListInsertItem (Pos, puffer );
	if(Ziel  )list_view.ListSetItemText(Pos, Ziel ,1);
	if(Plus  )list_view.ListSetItemText(Pos, Plus ,2);
	if(Minus )list_view.ListSetItemText(Pos, Minus,3);
			  list_view.ListSetItemText(Pos,(Unter)? "Ja":"Nein",4);
			  list_view.ListSetItemText(Pos, modi[Modus],5);
	if(Zusatz)list_view.ListSetItemText(Pos, Zusatz,6);

	anzahl++;
	SetIcon(Pos);


return  Pos;
}
int CBackupView::Insert(int Pos,int Filter,char *Quelle)
{
char	ziel[MAX_PATH+1024+16],plus[MAX_PATH+1024+16],minus[MAX_PATH+1024+16],unter[33],modus[33],zusatz[MAX_PATH+1024+16];
int		mod;


	if(Filter>=anzahl)Filter=anzahl-1;
	if(Filter<      0)Filter=anzahl-1;
	if(Filter<      0)Filter=0;

	*ziel	= 0;
	*plus	= 0;
	*minus	= 0;
	*unter  = 0;
	*modus  = 0;
	*zusatz = 0;

	if(anzahl)							// Filter holen
		{
		list_view.ListGetItemText(Filter,ziel  ,MAX_PATH+1024,1);
		list_view.ListGetItemText(Filter,plus  ,MAX_PATH+1024,2);
		list_view.ListGetItemText(Filter,minus ,MAX_PATH+1024,3);
		list_view.ListGetItemText(Filter,unter ,           32,4);
		list_view.ListGetItemText(Filter,modus ,           32,5);
		list_view.ListGetItemText(Filter,zusatz,MAX_PATH+1024,6);
		}

	for(mod=0;modi[mod];mod++)
		{
		if(!stricmp(modus,modi[mod]))break;
		}

	if(!modi[mod])mod=MODE_COPY;



return Insert(Pos,Quelle,ziel,plus,minus,stricmp(unter,"Nein"),mod,zusatz);
}

//*****************************************************************************
//*
//*     OnCreate
//*
//*****************************************************************************
int CBackupView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{

	if(CView::OnCreate(lpCreateStruct) == -1)return -1;

	DragAcceptFiles();


return 0;
}

//*****************************************************************************
//*
//*		OnDropFiles
//*
//*****************************************************************************
void CBackupView::OnDropFiles(HDROP hDropInfo)
{
char		puffer[MAX_PATH+1024+16];
int			x,anz,pos;
UINT		flags;
HTREEITEM	item;
POINT		pt;


	DragQueryPoint(hDropInfo,&pt);

	if(GetAsyncKeyState(VK_CONTROL)&0x8000)			// Cltr-Taste gedrckt
		{
		   item  = list_view.HitTest(pt,&flags);
		if(item && TVHT_SUBTOCOL(flags)<=1)
			{
			anz = DragQueryFile(hDropInfo,-1,puffer,MAX_PATH+1024);
			pos = list_view.GetRowOfItem(item);

			if(pos>0 || !filter_on)
				{
				for(x=0;x<anz;x++)					// Droped Dateien holen
					{
					DragQueryFile(hDropInfo,x,puffer,MAX_PATH+1024);
					list_view.ListSetItemText(pos,puffer,TVHT_SUBTOCOL(flags));
					SetIcon(pos,0);
					SetGeaendert(1);
					break;
					}
				}

			DragFinish(hDropInfo);
			return;
			}
		}

	anz=DragQueryFile(hDropInfo,-1,puffer,MAX_PATH+1024);
	pos=-1;

	for(x=0;x<anz;x++)								// Droped Dateien holen
		{
		DragQueryFile(hDropInfo,x,puffer,MAX_PATH+1024);
		pos=Insert(-1,-1,puffer);
		}

	DragFinish(hDropInfo);

	if(pos>=0)list_view.ListEnsureVisible(pos);

}

//*****************************************************************************
//*
//*     OnSetFocus
//*
//*****************************************************************************
void CBackupView::OnSetFocus(CWnd *pOldWnd)
{

	StatusbarInit();

	if(!pOldWnd || pOldWnd->m_hWnd!=list_view.m_hWnd)
		{
		if(!list_view.GetFocusItem())
			{
			list_view.SelectItem(list_view.GetFirstItem());
			}

		list_view.SetFocus();
		}
	else if(reg_on)
		{
		reg_view.SetFocus();
		}
	else{
		datei_view.SetFocus();
		}

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CBackupView::OnTimer(UINT_PTR nIDEvent)
{

	if(nIDEvent==ID_STATUSBARSET)
		{
		if(set_statubar)
			{
			set_statubar=0;
			StatusbarSet();
			set_statubar=0;
			}

		return;
		}

	if(nIDEvent==ID_FILTER)
		{
		if(filter_tick)
			{
				filter_tick--;
			if(!filter_tick)UpdateFilters(1);
			}

		return;
		}

	CView::OnTimer(nIDEvent);
}

//*****************************************************************************
//*
//*     OnClose
//*
//*****************************************************************************
void CBackupView::OnClose()
{

	KillTimer(ID_STATUSBARSET);


CView::OnClose();
}

//*****************************************************************************
//*
//*     StatusbarInit
//*
//*****************************************************************************
//	Erzeugt eine neue Statuszeile
int CBackupView::StatusbarInit()
{
CStatusBar *statusbar;
CDC		   *dc;
TEXTMETRIC  metrics;
UINT		ind[] =	{ID_SEPARATOR,0,0};



//***** Anmerkung FRAME_CLASS.m_wndStatusBar muss als public definiert sein.

		statusbar=&((FRAME_CLASS*)AfxGetMainWnd())->m_wndStatusBar;
	if(!statusbar)return 0;
	if(!statusbar->m_hWnd)return 0;

	dc =statusbar->GetDC();
	dc->GetTextMetrics(&metrics);
		statusbar->ReleaseDC(dc);

	statusbar->SetIndicators(ind,3);
	statusbar->SetPaneInfo( 1, SBPS_NORMAL, 0 , metrics.tmAveCharWidth*15);
	statusbar->SetPaneInfo( 2, SBPS_NORMAL, 0 , metrics.tmAveCharWidth*10);

	set_statubar=1;

return 1;
}

//*****************************************************************************
//*
//*     StatusbarExit
//*
//*****************************************************************************
//	Erzeugt eine neue Statuszeile
int CBackupView::StatusbarExit()
{
CStatusBar *statusbar;
UINT		ind[] =	{	ID_SEPARATOR,
						ID_INDICATOR_CAPS,
						ID_INDICATOR_NUM,
						ID_INDICATOR_SCRL };

//***** Anmerkung FRAME_CLASS.m_wndStatusBar muss als public definiert sein.

		statusbar=&((FRAME_CLASS*)AfxGetMainWnd())->m_wndStatusBar;
	if(!statusbar)return 0;
	if(!statusbar->m_hWnd)return 0;

	statusbar->SetIndicators(ind,4);
	statusbar->RedrawWindow();

return 1;
}

//*****************************************************************************
//*
//*		StatusbarSet
//*
//*****************************************************************************
//	Aktualisiert die Statuszeile
int CBackupView::StatusbarSet()
{
CStatusBar *statusbar=0;


	//if(!init)return 0;
	//***** Anmerkung FRAME_CLASS.m_wndStatusBar muss als public definiert sein.
		statusbar=&((FRAME_CLASS*)AfxGetMainWnd())->m_wndStatusBar;
	if(!statusbar)return 0;
	if(!statusbar->m_hWnd)return 0;

	//strcpy(puffer+x,text);
	//statusbar->SetPaneText( 2, puffer );


return 1;
}

//*****************************************************************************
//*
//*		OnSelectAll
//*
//*****************************************************************************
void CBackupView::OnSelectAll()
{
int			x;
TV_ITEM	    item;


	if(&list_view!=GetFocus())
		{
		::SendMessage(datei_view.m_hWnd,WM_COMMAND,0x10000|ID_SELECTALL,0);
		return;
		}

	item.mask      = TVIF_STATE;
	item.state     = TVIS_SELECTED;
	item.stateMask = TVIS_SELECTED;
	item.cChildren = 0;

	for(x=(filter_on)? 1:0;x<anzahl;x++)
		{
		item.hItem = list_view.GetItemOfRow(x);
		list_view.SetItem(&item);
		}

	list_view.SetFocus();

}

//*****************************************************************************
//*
//*		OnSetCpp
//*
//*****************************************************************************
void CBackupView::OnSetCpp()
{
char *cpp="*.exe;*.obj;*.aps;*.idb;*.aps;*.ncb;*.opt;*.plg;*.pdb;*.aps;*.pch;*.res;*.ilk;*.sbr;*.map;*.lib;*.mp3;*.wav;*.bsc;*.gid;*.lib;*.dll;*.fts;*.ftg;*.sav;*.00*;*.tmp;*.enc;*.tlb;*.tli;*.tlh;*.dat;*.mdb;*.gid;*.exp;*.ftg;*.aps;*.cfd;*.exd;*.am;*.asp;*.rtb;*.sup;*.loc;*.log;*.cnv;*.jar;*.icu;*.stub;*.policy;*.suo;*.old;*.mak;*.bak;BuildLog.htm;ReadMe.txt;*.;*.pbd;*.tlog;*.lst;*.o;*.d;*.i;*.crf;*.browse;*.cout;*.ccp;*.psp;*.zip.bin;*buildstate;*.hdr.scr;RCA0*;Monitor*.bin;*.ipch;*.pch*";
int	  pos;

	   pos=list_view.ListGetFocusItem();
	if(pos<0 || (pos==0 && filter_on))return;

	list_view.ListSetItemText(pos,"*",2);
	list_view.ListSetItemText(pos,cpp,3);

}

//*****************************************************************************
//*
//*		OnUndo
//*
//*****************************************************************************
//	Letze Lschung rckgngig machen
void CBackupView::OnUndo()
{
int		x,y,num;


	if(!undo_ok || !undo_str.Count())
		{
		return;
		}


	for(num=0;num<undo_str.Count();num+=MAX_X)	// Zeilen einfgen
		{
		x = undo_str.DataGet(num);if(filter_on)x++;
		x = list_view.ListInsertItem(x,undo_str[num]);

		for(y=1;y<MAX_X;y++)
			{
			list_view.ListSetItemText(x,undo_str[num+y],y);
			}

		anzahl++;
		SetIcon(x);
		}

	SetGeaendert(1);

	undo_ok = 0;

}

//*****************************************************************************
//*
//*		OnMenuUndo
//*
//*****************************************************************************
void CBackupView::OnMenuUndo(CCmdUI *pCmdUI)
{

	pCmdUI->Enable(undo_ok && undo_str.Count()>0);

}

//*****************************************************************************
//*
//*		OnStartEdit
//*
//*****************************************************************************
void CBackupView::OnStartEdit()
{
HTREEITEM	item;
int			col;

	item = list_view.GetFocusItem();
	col  = list_view.GetFocusColumn();

	if(item && (col<4 || col>=5))
		{
		list_view.StartEdit(item,col);
		}

}

//*****************************************************************************
//*
//*     Delete
//*
//*****************************************************************************
//	Lscht die ausgewhlten Eintrge
//	Ergibt die Anzahl der gelschten Eintrge
void CBackupView::OnDelete(){Delete();}
int  CBackupView::Delete(BOOL Undo)
{
int		x,y,z,first=1,last=-1,anz=0;


	if(!Undo)
		{
		undo_ok = 0;
		}


	x = list_view.ListGetFirstSelected();

	if(x==0 && filter_on)
		{
		list_view.ListSetItemState(0,0,TVIS_SELECTED);
		x = list_view.ListGetFirstSelected();
		}


	while(x>=0)									// Dateien einlesen
		{
		if(Undo)
			{
			if(first)
				{
				first=0;
				undo_str.Del();
				undo_str.DataLength(sizeof(int));
				}

			for(y=0;y<MAX_X;y++)
				{
				z = (filter_on)? x-1:x;
				undo_str.Add(list_view.ListGetItemText(x,y),CSC_END,&z);
				}

			undo_ok = 1;
			}


		if(list_view.ListDeleteItem(x))
			{
			anzahl--;
			geaendert|=1;
			last=x;
			}

		x = list_view.ListGetFirstSelected();
		}

	if(last>=0)
		{
		if(last>=anzahl)last--;
		if(last>=0)list_view.ListSelectItem(last);
		}


	return anz;
}

//*****************************************************************************
//*
//*		OnPathCtrl
//*
//*****************************************************************************
void CBackupView::OnPathCtrl()
{
int		style;


	style = datei_view.GetStyle()&DVS_NOCOMBOBOX;

	datei_view.SetStyle((style)?0:DVS_NOCOMBOBOX,DVS_NOCOMBOBOX);
	  reg_view.SetStyle((style)?0:TWS_NOCOMBOBOX,TWS_NOCOMBOBOX);


}

//*****************************************************************************
//*
//*		OnPathCtrlUI
//*
//*****************************************************************************
void CBackupView::OnPathCtrlUI(CCmdUI *pCmdUI)
{
int		style;


	style = datei_view.GetStyle()&DVS_NOCOMBOBOX;
	pCmdUI->SetCheck(style==0);


}

//*****************************************************************************
//*
//*		OnItemUpUI
//*
//*****************************************************************************
void CBackupView::OnItemUpUI(CCmdUI *pCmdUI)
{
int		x;

	x = list_view.ListGetFirstSelected();
	pCmdUI->Enable(x>0);


}


//*****************************************************************************
//*
//*		OnItemDownUI
//*
//*****************************************************************************
void CBackupView::OnItemDownUI(CCmdUI *pCmdUI)
{
int x,y;

	y = list_view.GetCount();
	x = list_view.ListGetFirstSelected();

	pCmdUI->Enable(x+1<y);

}

//*****************************************************************************
//*
//*		OnMenuSelect
//*
//*****************************************************************************
void CBackupView::OnMenuSelect(CCmdUI *pCmdUI)
{
int x;

	x = list_view.ListGetFirstSelected();
	pCmdUI->Enable(x>=0);

}

//*****************************************************************************
//*
//*     OnStartUI
//*
//*****************************************************************************
void CBackupView::OnStartUI(CCmdUI *pCmdUI)
{
int x;

	x = list_view.GetCount();
	pCmdUI->Enable(x>0);

}

//*****************************************************************************
//*
//*     Insert
//*
//*****************************************************************************
//	Fgt Eintrge ber einen Dialog ein
//	Ergibt die Anzahl der eingefgten Eintrge
void CBackupView::OnInsert(){Insert();}
int  CBackupView::Insert()
{
TV_ITEM			item;
int				x,y,nr,anz=0;
char			puffer[MAX_PATH+1024+16];
SysFindStruct	find;
SysFind			f;


	   nr=list_view.ListGetFocusItem();
	if(nr==-1)nr=anzahl-1;
	if(nr==0 && filter_on)nr=1;

	if(anzahl)							// Letzten Eintrag holen
		{
		item.mask		= TVIF_TEXT;
		item.hItem		= list_view.GetItemOfRow(nr);
		item.cChildren	= 0;
		item.pszText	= puffer;
		item.cchTextMax	= MAX_PATH+1024;
		list_view.GetItem(&item);
		}
	else{
		nr=0;
		strcpy(puffer,"C:\\");
		}

	x=strlen(puffer);					// Pfad prfen

	if(x>3)
	do	{
		f=SysFindFirst(puffer,&find);
		if(!f){strcpy(puffer,"C:\\");break;}
		SysFindClose(f);

		if(!(find.dwAttr&SYS_DIR))
			{
			for(;x>0;x--)if(puffer[x])break;
			puffer[x+1]=0;
			}

		}while(0);

	x=strlen(puffer);
	y=(x && (puffer[x-1]=='\\'))? 1:0;
	  strcpy(puffer+x,"\\*"+y);


	char	memory[8192];
	CFileDialog dlg(TRUE,0,puffer,OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_ALLOWMULTISELECT);

	strcpy(memory,dlg.m_ofn.lpstrFile);
	dlg.m_ofn.lpstrFile = memory;
	dlg.m_ofn.nMaxFile  = sizeof(memory);

	x=dlg.DoModal();


	if(x==IDCANCEL)return 0;

	POSITION pos=dlg.GetStartPosition();
	CString	 text;

	while(pos)
		{
		text=dlg.GetNextPathName(pos);
		Insert(-1,nr,text.GetBuffer(MAX_PATH+1024));
		}


return anz;
}

//*****************************************************************************
//*
//*		OnEndEdit
//*
//*****************************************************************************
void CBackupView::OnEndEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO   *pItem = (NMTVDISPINFO*)pNmHdr;
LPCSTR			pText;
int				iRow;

	lock_escape = 0;

	if(!(pItem->item.mask&TVIF_TEXTCHANGED))			// Hat sich der Text verndert
		{
		*pResult = 1;
		return;
		}

	iRow  = list_view.GetRowOfItem(pItem->item.hItem);

	if(iRow>0 || !filter_on)
		{
		geaendert |= 1;
		}

	if(pItem->item.cChildren<=1 || (iRow==0 && filter_on))
		{
		pText = pItem->item.pszText;
		if(!pText)pText="";
		list_view.SetItemText(pItem->item.hItem,pText,pItem->item.cChildren);
		if(iRow>0 || !filter_on)SetIcon(iRow,0);
		}

	if(iRow==0 && filter_on)
		{
		filter_tick = 3;
		}

}

//*****************************************************************************
//*
//*		OnItemsMoved
//*
//*****************************************************************************
void CBackupView::OnItemsMoved(NMHDR *pNmHdr,LRESULT *pResult)
{
NM_TREEVIEW  *pNotify = (NM_TREEVIEW*)pNmHdr;


    if(pNotify->action&0x80000000)
		{
		if(filter_on && pNotify->itemOld.hItem==base_item)
			{
			list_view.MoveItem(pNotify->itemNew.hItem,base_item,1);
			return;
			}

		if(filter_on && pNotify->itemNew.hItem==base_item)
			{
			list_view.MoveItem(base_item,TVI_ROOT,2);
			return;
			}

		geaendert |= 1;
		}

}


//*****************************************************************************
//*
//*		OnColumnClick
//*
//*****************************************************************************
void CBackupView::OnColumnClick(NMHDR *pNmHdr,LRESULT *pResult)
{
NMHEADER	   *pHeader = (NMHEADER*)pNmHdr;
TVSORTEX		sSort;
SortData		sData;


	if(pHeader->iItem==sort_art)
			sort_richtung = !sort_richtung;
	else	sort_art      =  pHeader->iItem;


	sData.list			= &list_view;
	sData.nr			= sort_art;
	sData.richtung		= sort_richtung;

	sSort.hParent		= TVI_ROOT;
	sSort.lParam		= (LPARAM)&sData;
	sSort.lpfnCompare	= SortList;

	//list_view.SortChildrenEX(&sSort);

}

//*****************************************************************************
//*
//*		OnTreeKeyDown
//*
//*****************************************************************************
void CBackupView::OnTreeKeyDown(NMHDR *pNmHdr,LRESULT *pResult)
{
TV_KEYDOWN	 *lk;



	lk=(TV_KEYDOWN*)pNmHdr;



	if(lk->wVKey==VK_TAB)
		{
		datei_view.SetFocus();
		return;
		}

	if(lk->wVKey==VK_DELETE)
		{
		Delete();
		return;
		}


}

//*****************************************************************************
//*
//*		OnStartEdit
//*
//*****************************************************************************
void CBackupView::OnStartEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
static char	  puffer[MAX_PATH+1024];
int	          y,nr,len,pos;
TV_STARTEDIT *lk;



	lk = (TV_STARTEDIT*)pNmHdr;

	nr = list_view.ListGetFocusItem();
	y  = lk->item.cChildren;

	if(nr<0)return;



	if(y==4)
		{
		if(lk->uAction!=VK_DBLCLK && lk->uAction!=VK_RETURN)
			{
			return;
			}

		list_view.ListGetItemText(nr,puffer,10,y);

		if(nr==0 && filter_on)
			{
			     if(!stricmp(puffer,"Ja"  ))list_view.ListSetItemText(nr,"Nein",y);
			else if(!stricmp(puffer,"Nein"))list_view.ListSetItemText(nr,""    ,y);
			else                            list_view.ListSetItemText(nr,"Ja"  ,y);

			if(filter_on)filter_tick=3;
			}
		else{
			list_view.ListSetItemText(nr,stricmp(puffer,"Nein")? "Nein":"Ja",y);
			SetGeaendert(1);
			}

		return;
		}

	lock_escape = 1;

	if(y==5)
		{
		if(nr==0 && filter_on)
			{
			puffer[0]='|';
			len = 1;
			}
		else{
			len = 0;
			}

		for(pos=0;modi[pos];pos++)
			{
			len += sprintf(puffer+len,"%s|",modi[pos]);
			}

        lk->pTextEntries = puffer;
		*pResult = TVIR_EDITCOMBOBOX|TVIR_EDITCOMBOLIST|TVIR_EDITFULL|TVIR_EDITCOMBODOWN|TVIR_EDITCOMBOCHAR('|');
		return;
		}


	*pResult = TVIR_EDITFULL;

}

//*****************************************************************************
//*
//*     OnPaint
//*
//*****************************************************************************
void CBackupView::OnPaint()
{
CPaintDC	 pDC(this);


	pDC.SelectStockObject(NULL_PEN                   );
	pDC.SelectObject(GetSysColorBrush(COLOR_3DLIGHT) );
	pDC.Rectangle	(0,teilung  ,10000,teilung+2     );
	pDC.SelectStockObject(WHITE_BRUSH                );
	pDC.Rectangle	(0,teilung+1,10000,teilung+3     );
	pDC.SelectObject(GetSysColorBrush(COLOR_3DFACE)  );
	pDC.Rectangle	(0,teilung+2,10000,teilung+8     );
	pDC.SelectObject(GetSysColorBrush(COLOR_3DSHADOW));
	pDC.Rectangle	(0,teilung+5,10000,teilung+7     );
	pDC.SelectStockObject(BLACK_BRUSH                );
	pDC.Rectangle	(0,teilung+6,10000,teilung+8     );
}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CBackupView::OnLButtonDown(UINT nFlags, CPoint point)
{
CRect	rect;
CPoint	pt;
int		x;

	GetRectView(rect);

	pt   =point;
	pt.y-=teilung;

	x=Resize(this,FALSE,rect,teilung,pt,7,5);

	if(!x)return;

	GetClientRect(&rect);
	   teilung+=x;
	if(teilung>=rect.bottom)teilung=rect.bottom-1;
	if(teilung<           0)teilung=0;

	OnSize(0,rect.right,rect.bottom);
}

//*****************************************************************************
//*
//*		OnRegOn
//*
//*****************************************************************************
void CBackupView::OnRegOn(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(reg_on);
}

//*****************************************************************************
//*
//*      HitTest
//*
//*****************************************************************************
//	Prft ob eine Bildschirmkoordinate auf ein Listenfeld zeigt.
//	Point		: Ist die Bildschirmkoordinate.
//	X_pos/Y_pos	: Hier werden Zeile und Spalte gespeichert.
//				  Die Zeiger knnen auch 0 sein.
//	Ergibt die Zeilennummer des gefundenen Feldes oder:
//					-1 wenn Punkt nicht im Feld
//					-2 wenn Punkt im Feld aber nicht auf einem Eintrag
int CBackupView::HitTest(CPoint Point,int *X_pos,int *Y_pos)
{
HTREEITEM	item;
UINT		flags;
CRect		rect;
int			x,y;
CPoint		pt;


	list_view.GetWindowRect(&rect);
	if(!rect.PtInRect(Point))return -1;

	pt.x = Point.x-rect.left;				// Koordinaten umrechnen
	pt.y = Point.y-rect.top;

	item = list_view.HitTest(pt,&flags);	// Treffer ?
	y    = list_view.GetRowOfItem(item);
	x    = TVHT_SUBTOCOL(flags);

	if(y<=-1)return -2;


	if(X_pos)*X_pos=x;						// Koordinaten speichern
	if(Y_pos)*Y_pos=y;


return y;
}

//*****************************************************************************
//*
//*      SetGeaendert
//*
//*****************************************************************************
int CBackupView::SetGeaendert(int Geaendert)
{
int	alt=geaendert&1;


	if(Geaendert)
		 geaendert |=  1;
	else geaendert &= ~1;


return alt;
}

//*****************************************************************************
//*
//*		GetGeaendert
//*
//*****************************************************************************
int CBackupView::GetGeaendert()
{
return geaendert&1;
}

//*****************************************************************************
//*
//*     SetText
//*
//*****************************************************************************
//	Speichert einen Text aus dem ListView
//	X-pos/Y_pos	ist die Position in der Tabelle
//	Ergibt -1 bei einem Fehler ansonsten 0
int CBackupView::SetText(char *Text,int Y_pos,int X_pos)
{

	if(Y_pos>=anzahl)return -1;
	if(Y_pos<      0)return -1;
	if(X_pos>= MAX_X)return -1;
	if(X_pos<      0)return -1;

	list_view.ListSetItemText(Y_pos,Text,X_pos);

return 0;
}

//*****************************************************************************
//*
//*     GetText
//*
//*****************************************************************************
//	Holt einen Text aus dem ListView
// 	Len			: Ist die Gre des Text-Puffers
// 	X-pos/Y_pos	: Ist die Position in der Tabelle
// 	Ergibt -1 bei einem Fehler ansonsten 0
int CBackupView::GetText(char * Text,int Len,int Y_pos,int X_pos)
{
int		max;

	max = (filter_on)? anzahl+1:anzahl;

	if(Y_pos>=   max)return -1;
	if(Y_pos<      0)return -1;
	if(X_pos>= MAX_X)return -1;
	if(X_pos<      0)return -1;
	if(Len  <=     0)return -1;

	list_view.ListGetItemText(Y_pos,Text,Len-1,X_pos);
	Text[Len-1] = 0;



return 0;
}

//*****************************************************************************
//*
//*     GetText
//*
//*****************************************************************************
//	Holt einen Text aus dem ListView
// 	Len			: Ist die Gre des Text-Puffers
//	Item		: Ist der Eintrag
// 	X-pos		: Ist die Position in der Tabelle
// 	Ergibt -1 bei einem Fehler ansonsten 0
int CBackupView::GetText(char *Text,int Len,HTREEITEM Item,int X_pos)
{

	if(!Item)return -1;

	if(X_pos>= MAX_X)return -1;
	if(X_pos<      0)return -1;
	if(Len  <=     0)return -1;

	list_view.GetItemText(Item,Text,Len-1,X_pos);
	Text[Len-1] = 0;



return 0;
}


//*****************************************************************************
//*
//*     GetTextEx
//*
//*****************************************************************************
//	Holt einen Text aus dem ListView
// 	Len			: Ist die Gre des Text-Puffers
//	Y_pos		: Ist die Zeile absolut
// 	X-pos		: Ist die Position in der Tabelle
// 	Ergibt -1 bei einem Fehler ansonsten 0
int CBackupView::GetTextEx(char *Text,int Len,int Y_pos,int X_pos)
{
HTREEITEM	item;


	item = list_view.GetFirstItem();

	if(filter_on)item=list_view.GetNextSiblingItem(item);

	while(Y_pos>0)
		{
		Y_pos--;
		item=list_view.GetNextSiblingItem(item);
		if(!item)return -1;
		}

	if(!item)return -1;

	if(X_pos>= MAX_X)return -1;
	if(X_pos<      0)return -1;
	if(Len  <=     0)return -1;

	list_view.GetItemText(item,Text,Len-1,X_pos);
	Text[Len-1] = 0;



return 0;
}

//*****************************************************************************
//*
//*     LetzteSpeicherung
//*
//*****************************************************************************
void CBackupView::LetzteSpeicherung(time_t Letzte)
{

	zeitplan_letzte = Letzte;

}

//*****************************************************************************
//*
//*     GetInfo
//*
//*****************************************************************************
int CBackupView::GetInfo(int Art)
{

	switch(Art)
		{
	case BKU_ANZAHL:			return anzahl;
	case BKU_FILTER:			return filter_on;
	case BKU_ZEITPLAN_ART:		return zeitplan_art;
	case BKU_ZEITPLAN_ANZ:		return zeitplan_anz;
	case BKU_ZEITPLAN_LETZTE:	return zeitplan_letzte;
		}

return 0;
}

//*****************************************************************************
//*
//*		OnItemDown
//*
//*****************************************************************************
void CBackupView::OnItemDown()
{
int item;

	item=list_view.ListGetFocusItem();

	if(item>0 || !filter_on)
		{
		ItemMove(item,1);
		}

}

//*****************************************************************************
//*
//*		OnItemUp
//*
//*****************************************************************************
void CBackupView::OnItemUp()
{
int item;

	item=list_view.ListGetFocusItem();

	if(item>1 || !filter_on)
		{
		ItemMove(item,-1);
		}

}

//*****************************************************************************
//*
//*		ItemMove
//*
//*****************************************************************************
int CBackupView::ItemMove(int Item,int Dir)
{
int		x,nr,count;
char	puf1[1024];
char	puf2[1024];



	count = list_view.GetRowCount();
	nr	  = (Dir<0)? Item-1:Item+1;

	if(Item<0 || Item>=count)return 0;
	if(nr  <0 || nr  >=count)return 0;

	for(x=0;x<MAX_X;x++)
		{
		GetText(puf1,sizeof(puf1),Item,x);
		GetText(puf2,sizeof(puf2),nr  ,x);
		SetText(puf2,             Item,x);
		SetText(puf1,             nr  ,x);
		}

	SetIcon(Item);
	SetIcon(nr  );


	if(Item==list_view.ListGetFocusItem())
		{
		x = list_view.GetFocusColumn();
		list_view.ListSetItemState(nr  ,TVIS_SELECTED,TVIS_SELECTED);
		list_view.ListSetItemState(Item,0            ,TVIS_SELECTED);
		list_view.ListSetFocusItem(nr,x);
		list_view.ListEnsureVisible(nr);
		}

	geaendert |= 1;


return 1;
}

//*****************************************************************************
//*
//*     OnPathUp
//*
//*****************************************************************************
void CBackupView::OnPathUp()
{

	if(reg_on)reg_view.OnPathUp();
	else	datei_view.OnPathUp();

}

//*****************************************************************************
//*
//*     OnPathUpUI
//*
//*****************************************************************************
void CBackupView::OnPathUpUI(CCmdUI *pCmdUI)
{
BOOL	bFlag;


	if(reg_on)
			bFlag  =   reg_view.IsPathUpAlloed();
	else	bFlag  = datei_view.IsPathUpAlloed();


	pCmdUI->Enable(bFlag);
}

//*****************************************************************************
//*
//*		OnStart
//*
//*****************************************************************************
//	Fhrt das  Backup des Fensters aus
void CBackupView::OnStart()
{
int art=0x02;


	if(zeitplan_art&0x8000)art|=0x01;
	if(zeitplan_art&0x4000)art|=0x08;
	if(zeitplan_art&0x2000)art|=0x20;

	Run(art);

}

//*****************************************************************************
//*
//*     ZeitplanView
//*
//*****************************************************************************
//	Kopiert die Serien aller Eintrge
void CBackupView::ZeitplanView()
{
CBackupZeitDlg	dlg(this);
int				art,anz;

	art=zeitplan_art;
	anz=zeitplan_anz;

	dlg.DoModal(&zeitplan_art,&zeitplan_anz,zeitplan_letzte);

	if(art!=zeitplan_art)SetGeaendert(1);
	if(anz!=zeitplan_anz)SetGeaendert(1);

}

//*****************************************************************************
//*
//*     Zeitplan
//*
//*****************************************************************************
void CBackupView::Zeitplan(int Art, int Anz)
{

	if(Art!=zeitplan_art)SetGeaendert(1);
	if(Anz!=zeitplan_anz)SetGeaendert(1);

	zeitplan_art=Art;
	zeitplan_anz=Anz;
}



//*****************************************************************************
//*
//*		ZipProc
//*
//*****************************************************************************
//	Progress Funktion fr Zip Dateien
//	Submit	ist der User-Parameter
//	Art		ist die Art der Nachricht
//	Sub		ist die Nummer In der Liste
//	Zip		ist der Zeiger auf die Zip-Klasse
//	Text	ist der Ausgabe Text
int	__cdecl CBackupView::ZipProc(void *Submit,int Art,int Sub,CArchiveFile *Zip,char *Text)
{
__int64			 pos,max;
int				 x,y;
CBackupView	    *bv;
char			*ptr,name[MAX_PATH];
static unsigned  last_tick=0,delta,zeit;


	bv=(CBackupView*)Submit;


	if(Art==CAF_PROG_QUERY)							// Nachfragen ob Datei auslassen
		{
		if(bv->dlg_break)return 1;

		ptr=Zip->Name(Sub);
		strlcpy(name,ptr,sizeof(name));
		PathConvert(name,'\\');


		if(Zip->IsDir(Sub))
				y=strlen(name);
		else	y=FilePathLen(name);

		if(bv->IsLockLast(name))					// Verzeichnisse auslassen
			{
			return 1;
			}

		if(bv->IsLockPath(name,y))					// Verzeichnisse auslassen
			{
			return 1;
			}

		return 0;
		}

	if(Art==CAF_PROG_ERROR)
		{
		x=MB_OK;
		y=Zip->Error();

		if(y==CAF_ERROR_BREAK  )return 1;
		if(y==CAF_ERROR_FOPEN  )y=MB_RETRYCANCEL;
		if(y==CAF_ERROR_FREAD  )y=MB_RETRYCANCEL;
		if(y==CAF_ERROR_FWRITE )y=MB_RETRYCANCEL;
		if(y==CAF_ERROR_FCREATE)y=MB_RETRYCANCEL;

		if(bv->dlg_view)x=bv->dlg_view->MessageBox(Text,0,MB_ICONERROR|x);
		return		    x=bv->          MessageBox(Text,0,MB_ICONERROR|x);

		if(x!=IDRETRY){bv->dlg_break=1;return 1;}
		return 0;
		}

	if(bv->dlg_view && bv->dlg_view->IsBreak())
		{
		bv->dlg_break=1;
		}


	if(Art==CAF_PROG_COMPRESS)
		{
		bv->kopie_anz++;
		return bv->dlg_break;
		}

	if(Art==CAF_PROG_EXTRACT)
		{
		bv->kopie_anz++;
		return bv->dlg_break;
		}

	if(bv->dlg_view && Text)
		{
		zeit  = GetTickCount();
		delta = zeit-last_tick;

		if(delta>100)
			{
			last_tick=zeit;
			strlcpy(bv->prog_text,Text+1,sizeof(bv->prog_text));
			bv->dlg_view->SetText(bv->prog_text,1,Zip->m_iProgPos-1,Zip->m_iProgLen,Zip->m_iProgAdd);

			pos = Zip->Done(&max);

			bv->dlg_view->SetRange(max);
			bv->dlg_view->SetPos  (pos);
			}
		}

return bv->dlg_break;
}


//*****************************************************************************
//*
//*		IsLockPath
//*
//*****************************************************************************
//	Prfen ob ein Verzeichnis auszulassen ist.
//	Path		: Ist der Pfad der zu prfen ist.
//	Len			: Ist die maximale Lnge von Path.
//	Ergbibt 1 wenn der Pfad ausgelassen werden muss, ansonsten 0;
int CBackupView::IsLockPath(const char *Path,int Len)
{
char	path[256];
char   *str;
int		cnt;
int		num;
int		len;
int		cmp;


	if(*Path=='/' || *Path=='\\')
		{
		Path++;
		Len--;
		}

	len = strlcpy(path,Path,sizeof(path),Len);

	if(len<=0)
		{
		lock = 0;
		return 0;
		}

	PathConvert(path,'/');

	for(num=0;num<lock_str.Count();num++)
		{
		str = lock_str.Get(num);
		cnt = lock_str.Len(num);
		cmp = memxcmp(str,cnt,path,len,0x05);

		if(cmp>len)
			{
			continue;
			}

		if(path[cmp]==0 || path[cmp]=='/')
			{
			lock_mem = str;
			lock     = cnt;
			return 1;
			}
		}

	lock = 0;


return 0;
}

//*****************************************************************************
//*
//*		IsLockLast
//*
//*****************************************************************************
//	Prfen ob ein Verzeichnis auszulassen ist, mit dem letzten gleichen	Fund.
//	Path		: Ist der Pfad der zu prfen ist.
//	Ergbibt 1 wenn der Pfad ausgelassen werden muss, ansonsten 0;
int CBackupView::IsLockLast(const char *Path)
{
char	sign;
int		pos;


	if(lock<=0)return 0;

	if(*Path=='/' )Path++;
	if(*Path=='\\')Path++;

	for(pos=0;pos<lock;pos++)							// Vergleiche Pfade
		{
		sign = Path[pos];

		if(sign<='Z' && sign>='A')
			{
			sign += 32;
			}
		else if(sign=='\\')
			{
			sign='/';
			}

		if(sign!=lock_mem[pos])
			{
			return 0;
			}
		}

	if(Path[pos]== 0  )return 1;						// Ist das Pfadende erreicht
	if(Path[pos]=='/' )return 1;
	if(Path[pos]=='\\')return 1;

	lock = 0;


return 0;
}

//*****************************************************************************
//*
//*		SetLockPath
//*
//*****************************************************************************
//	Erstellt eine Liste mit auszulassenten Verzeichnissen.
//	Path		: Liste mit Pfaden (z.B.: "abc/xxx;\Temp\xx*yy;nn??mm*"
//	Mode		: Diverse Einstellungen
//					Bit0 = Einen "*;" bzw. "*" Bereich am Anfang auslassen.
//	Ergibt 1 wenn ein "*;" bzw. "*" Bereich gefunden wurde.
int	CBackupView::SetLockPath(const char *List,int Mode)
{
int		len;
int		num;
int		ret;
int		sub;



	ret  = 0;
	lock = 0;

	lock_str.Del();

	if(List==0)return 0;

												// Einen "*;" bzw. "*" Bereich auslassen.
	if(Mode&1)
		{
		if(List[0]=='*' && List[1]==0)
			{
			List += 1;
			ret   = 1;
			}
		else if(List[0]=='*' && List[1]==';')
			{
			List += 2;
			ret   = 1;
			}
		}



	while(*List)								// Liste mit auslassenten Verzeichnissen erstellen
		{
		if(*List=='/' || *List=='\\')
			{
			List++;
			if(!*List)break;
			}

		len = strchar (List,';');
		sub = strbwlen(List+len,0x00300000,len-1);

		if(len-sub>0)
			{
			num = lock_str.Add(len-sub,List);

			PathConvert(lock_str[num],'/');
			strlwr     (lock_str[num]);
			}

		List+=len;

		if(*List)List++;
		}


return ret;
}

//*****************************************************************************
//*
//*		CheckLocal
//*
//*****************************************************************************
//	Prft ob eine lokale Datei berschrieben werden darf
//	Path		: Pfad der lokalen Datei.
//	Time		: nderungszeit der Remote-Datei
//	Art			: Eingestllte Flags:
//					Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//					Bit1!=0 werden Fehlermeldungen ausgegeben
//  				Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  				Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  				Bit8!=0 werden ber zhlige Dateien am FTP Server gelscht
//	Ergibt 0 wenn die Datei nicht berschrieben werden darf oder:
//					0 = Nicht berschreiben
//					1 = Datei existiert nicht
//					2 =	Bestehende Datei berschreiben
//					3 =	Datei ist ein Verzeichnis
int CBackupView::CheckLocal(const char *Path,time_t Time,int Art)
{
FILETIME	sFileTime;


	UtcTimeToFileTime(Time,&sFileTime);


return CheckLocal(Path,&sFileTime,Art);
}


//*****************************************************************************
//*
//*		CheckLocal
//*
//*****************************************************************************
//	Prft ob eine lokale Datei berschrieben werden darf
//	Path		: Pfad der lokalen Datei.
//	Time		: nderungszeit der Remote-Datei
//	Art			: Eingestllte Flags:
//					Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//					Bit1!=0 werden Fehlermeldungen ausgegeben
//  				Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  				Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  				Bit8!=0 werden ber zhlige Dateien am FTP Server gelscht
//	Ergibt 0 wenn die Datei nicht berschrieben werden darf oder:
//					0 = Nicht berschreiben
//					1 = Datei existiert nicht
//					2 =	Bestehende Datei berschreiben
//					3 =	Datei ist ein Verzeichnis
int CBackupView::CheckLocal(const char *Path,const FILETIME *Time,int Art)
{
WIN32_FILE_ATTRIBUTE_DATA data;


													// Existiert die Datei
	if(!GetFileAttributesEx(Path,GetFileExInfoStandard,&data))
		{
		return 1;
		}
													// Ist es ein Verzeichnis
	if(data.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
		{
		return 3;
		}

	if(Art&0x08)									// Nie berschreiben
		{
		return 0;
		}

	if(Art&0x20)									// Schreibgeschtzte nicht berschreiben
	if(data.dwFileAttributes&FILE_ATTRIBUTE_READONLY)
		{
		return 0;
		}

	if(Art&0x01)									// Prfe Zeit
	if(CmpFileTime(Time,&data.ftLastWriteTime,3)<=0)
		{
		return 0;
		}
													// Den Schreibschutz aufheben
	if(data.dwFileAttributes&FILE_ATTRIBUTE_READONLY)
		{
		SetFileAttributes(Path,FILE_ATTRIBUTE_NORMAL);
		}



return 2;
}

//*****************************************************************************
//*
//*		ErrorToText
//*
//*****************************************************************************
char *CBackupView::ErrorToText(unsigned Error,char *Default)
{

	switch(Error)
		{
	case ERROR_INVALID_PARAMETER:				return "Fehlerhafter Parameter";
	case ERROR_CALL_NOT_IMPLEMENTED:			return "Die Funktion ist nicht implementiert";
	case ERROR_OPEN_FAILED:						return "Fehler beim ffnen der Datei";
	case ERROR_GRACEFUL_DISCONNECT:				return "Die Verbindung wurde abgebrochen";
	case ERROR_LOGON_FAILURE:					return "Es gab einen Fehler bein Login";
	case ERROR_WRONG_PASSWORD:					return "Falsches Passwort";
	case ERROR_OPERATION_ABORTED:				return "Es gab einen User-Abbruch";
	case ERROR_DISK_FULL:						return "Die  Festplatte ist voll";
	case ERROR_TIMEOUT:							return "Es gab einen Timeout";
	case ERROR_WRITE_FAULT:						return "Es gab eine Fehler beim Schreiben";
	case ERROR_BAD_NETPATH:						return "Der Hostnamen ist ungltig";
	case ERROR_HOST_UNREACHABLE:				return "Der Host ist nicht erreichbar";
	case ERROR_FILE_NOT_FOUND:					return "Eine Datei wurde nicht gefunden";
	case ERROR_CANNOT_MAKE:						return "Die lokale Datei konnte nicht erzeugt werden";
	case ERROR_PROTOCOL_UNREACHABLE:			return "Die Datenverbindung konnte nicht geffnet werden";
	case ERROR_INVALID_TIME:					return "Falsche Zeitangabe";
	case ERROR_READ_FAULT:						return "Es gab einen Fehler beim Lesen";
	case ERROR_NET_WRITE_FAULT:					return "Die Daten konnten nicht zum Host versand werden";
	case ERROR_OUTOFMEMORY:						return "Zuwenig Speicher";
	case ERROR_DEVICE_REINITIALIZATION_NEEDED:	return "Das Gert ist nicht initialisliert";
	case ERROR_INVALID_HANDLE:					return "Falsches Handle";
	case ERROR_CONTINUE:						return "Der Vorgang ist noch aktiv";
	case ERROR_ALREADY_ASSIGNED:				return "Die Verbindung ist noch aktiv";
	case ERROR_NOT_CONNECTED:					return "Es ist keine Verbindung vorhanden";
	case ERROR_CANCELLED:						return "Benutzerabbruch";
	case ERROR_TOO_MANY_SESS:					return "Es sind zuviele Instanzen offen";
	case ERROR_NETWORK_UNREACHABLE:				return "Das Netzwerk ist heruntergefahren";
	case ERROR_BUSY:							return "Das Gert ist beschftigt";
	case ERROR_RESOURCE_DISABLED:				return "Das Gert ist ist blockiert";
	case ERROR_INTERNAL_ERROR:					return "Interner Fehler";
	case ERROR_CRC:								return "CRC Fehler";
	case ERROR_SERVICE_REQUEST_TIMEOUT:			return "Timeout beim Request";
	case ERROR_HANDLE_EOF:						return "Das Ende der Datei wurde erreicht";
	case ERROR_ACCESS_DENIED:					return "Der Zugriff wurde verweigert";
	case ERROR_DEVICE_NOT_CONNECTED:			return "Dar Gert ist nicht verbunden";
	case ERROR_PATH_NOT_FOUND:					return "Der Pfad wurde nicht gefunden";
	case ERROR_REQ_NOT_ACCEP:					return "Die Anfrage wurde nicht akzeptiert";
	case ERROR_INVALID_DLL:						return "Die DLL konnte nicht geladen werden.";
	case ERROR_MOD_NOT_FOUND:					return "Eine DLL wurde nicht gedunden.";
		}

return Default;
}

//*****************************************************************************
//*
//*		FindBreak
//*
//*****************************************************************************
//	Callback um eine Dateisuche abzubrechen
void _cdecl CBackupView::FindBreak(void *Param)
{
CFileFinder *find=(CFileFinder*)Param;


	find->Break();

}


//*****************************************************************************
//*
//*		FtpBreak
//*
//*****************************************************************************
//	Callback um den FTP Server abzubrechen
void _cdecl CBackupView::FtpBreak(void *Param)
{
CFtpBase *ftp=(CFtpBase*)Param;


	ftp->Abort();

}


//*****************************************************************************
//*
//*		CopyPos
//*
//*****************************************************************************
//	Callback um den Verlauf auszugeben
void _cdecl CBackupView::CopyPos(CProgressDialog *Dlg,void *Param)
{
CBackupView	*bv;
CFtpBase    *ftp;
char		 temp[32];
DWORD		 vals[2];
DWORD		 off;
__int64		 pos;
__int64		 max;



	bv	= (CBackupView*)Dlg->proc_param1;

	switch(bv->size_mode)								// Anzeige Modus
		{
	case 5:		off = sizeof(vals);vals[0]=0;vals[1]=0;
				pos = bv->ftp_conn->QueryOption(INTERNET_OPTION_PROGRESS2,vals,&off);
				Dlg->SetPos(((GetTickCount()-bv->time_from)/512)%32);

				if(vals[1]>0x10000 && vals[0]>0x4000)
					{
					if(vals[0]>=0x02000000){vals[0]/=128;vals[1]/=128;}
					sprintf(temp,"Kopiere: (%i%%) ",(vals[0]*100)/vals[1]);
					Dlg->SetText(temp,bv->prog_text,2);
					}

				break;

	case 4:		pos = bv->zip.Done(&max);				// Zip
				Dlg->SetRange(max);
				Dlg->SetPos  (pos);
				break;

	case 3:		off = bv->size_now;						// Offset und Copy-Offset
				if((int)off>bv->size_max)off=bv->size_max;
				Dlg->SetPos(bv->size_offset+off);
				break;

	case 2:		off = 0;								// Offset und FTP-Offset
				ftp = (CFtpBase*)Param;
				ftp->QueryOption(INTERNET_OPTION_PROGRESS,off);
				if((int)off>bv->size_max)off=bv->size_max;
				Dlg->SetPos(bv->size_offset+off);
				break;

	case 1:		Dlg->SetPos(bv->size_offset);			// Nur Offset
				break;
		}



}

//*****************************************************************************
//*
//*		OnStop
//*
//*****************************************************************************
void CBackupView::OnStop()
{
	dlg_break = 1;
}

//*****************************************************************************
//*
//*		OnNotifyIcon
//*
//*****************************************************************************
void CBackupView::OnNotifyIcon(WPARAM wParam,LPARAM lParam)
{

	switch(lParam)
		{
	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:

			CMenu	menu;
			CPoint	point;

			GetCursorPos(&point);

			menu.CreatePopupMenu();
			menu.AppendMenu(MF_STRING,ID_STOP,"Abbechen");
			menu.AppendMenu(MF_STRING,ID_NONE,"Weitermachen");
			menu.TrackPopupMenu(TPM_LEFTALIGN,point.x,point.y,this);
			menu.DestroyMenu();

		}

}

//*****************************************************************************
//*
//*		Run
//*
//*****************************************************************************
//  Kopiert eine Serie von Dateien ausgehent von einem Eintrag Nummer
//  Ist bei Art Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::Run(int Nummer,int Art)
{
HTREEITEM	item;
HTREEITEM	next;
HTREEITEM	past;
int			type,flags,len;
int			mod,x,unter,pos;
char		q[MAX_PATH+1024+16];
char		z[MAX_PATH+1024+16];
char		p[MAX_PATH+1024+16];
char		m[MAX_PATH+1024+16];
char		u[		        32];
char		i[              32];
char		s[MAX_PATH+1024+16];
char		b[MAX_PATH+1024+16];
char		n[MAX_PATH];
char		d[3];
char	   *ptr;


	if(filter_on)
		{
		if(Nummer<0)
			{
			item = 0;
			}
		else{
			item = list_view.GetFirstItem();

			for(x=0;x<=Nummer;x++)
				{
					item = list_view.GetNextSiblingItem(item);
				if(!item)break;
				}
			}
		}
	else{
		item = list_view.GetItemOfRow(Nummer);
		}

	next = list_view.GetNextSiblingItem(item);
	past = list_view.GetPrevSiblingItem(item);


	GetText(b,MAX_PATH+1024,item,0);ptr=VarConvert(b,sizeof(b));strlcpy(q,ptr,MAX_PATH+1024);
	GetText(b,MAX_PATH+1024,item,1);ptr=VarConvert(b,sizeof(b));strlcpy(z,ptr,MAX_PATH+1024);
	GetText(b,MAX_PATH+1024,item,2);ptr=VarConvert(b,sizeof(b));strlcpy(p,ptr,MAX_PATH+1024);
	GetText(b,MAX_PATH+1024,item,3);ptr=VarConvert(b,sizeof(b));strlcpy(m,ptr,MAX_PATH+1024);
	GetText(u,32           ,item,4);
	GetText(i,32           ,item,5);
	GetText(s,MAX_PATH+1024,item,6);


	for(mod=0;modi[mod];mod++)
		{
		if(!stricmp(modi[mod],i))break;
		}


	if(!modi[mod])mod =0;
	if( mod!=3 && mod!=5)							// Prfe Pfade
	if(!*z)return -1;
	if(!*q)return -1;


	pos=strchar(q,'#');								// Spezial Pfad

	if(q[pos] && q[pos+2]=='#')
		{
		if(q[pos+1]=='D' || q[pos+1]=='d')			// Pfad mit Datum
			{
			FileDateRename(q,q,sizeof(q));
			}
		}


	pos=strchar(z,'#');								// Spezial Pfad

	if(z[pos])
		{											// Pfad mit Version
		if(z[pos+1]=='@' && z[pos+strchar(z+pos,'#')])
			{
			x=FileVersionRename(z,z,sizeof(z),q);
			if(x<0)
				{
				if(!(Art&2))return -1;

				strcpy (s,"Die Version aus:\n");
				strlcat(s,q,MAX_PATH+1024);
				strlcat(s,"\nkonnte nicht gelesen werden !",MAX_PATH+1024);

				if(dlg_view)x=dlg_view->MessageBox(s,0,MB_ICONERROR|MB_OKCANCEL);
				else		x=          MessageBox(s,0,MB_ICONERROR|MB_OKCANCEL);

				if(x==IDCANCEL)
					{
					dlg_break=1;
					return -2;
					}

				return -1;
				}
			}
													// Pfad mit Datum
		if(z[pos+2]=='#' && (z[pos+1]=='D' || z[pos+1]=='d') && mod!=MODE_SHRINK)
			{
			FileDateRename(z,z,sizeof(z));
			}
													// Nummerierte Pfadkette
		if(z[pos+2]=='#' && z[pos+1]>='1' && z[pos+1]<='5' && mod!=MODE_SHRINK)
			{
			x=FileCountRename(z,z,sizeof(z));
			if(x<0)
				{
				if(!(Art&2))return -1;

				strcpy (s,"Der Kettepfad:\n");
				strlcat(s,z,MAX_PATH+1024);
				strlcat(s,"\nhat zuviele Eintrge !",MAX_PATH+1024);

				if(dlg_view)x=dlg_view->MessageBox(s,0,MB_ICONERROR|MB_OKCANCEL);
				else		x=          MessageBox(s,0,MB_ICONERROR|MB_OKCANCEL);

				if(x==IDCANCEL)
					{
					dlg_break=1;
					return -2;
					}

				return -1;
				}
			}
		}

	unter = stricmp(u,"Nein");
	flags = 0;

	d[0]  = q[0]&~0x20;

	if(d[0]>='A' && d[0]<='Z' && q[1]==':')				// Netzlaufwerke fr Quelle auflsen
		{
		d[1] = ':';
		d[2] = 0;

		type = GetDriveType(d);

		if(type!=DRIVE_FIXED && type!=DRIVE_REMOVABLE && type!=DRIVE_CDROM && type!=DRIVE_RAMDISK)
			{
			   len = GetShareName(d,n,sizeof(n));
			if(len)
				{
				strinsert(q,0,2,n,sizeof(q),len);
				}
			}
		}


	d[0]  = z[0]&~0x20;

	if(d[0]>='A' && d[0]<='Z' && z[1]==':')				// Netzlaufwerke fr Ziel auflsen
		{
		d[1] = ':';
		d[2] = 0;

		type = GetDriveType(d);

		if(type!=DRIVE_FIXED && type!=DRIVE_REMOVABLE && type!=DRIVE_CDROM && type!=DRIVE_RAMDISK)
			{
			   len = GetShareName(d,n,sizeof(n));
			if(len)
				{
				strinsert(z,0,2,n,sizeof(z),len);
				}
			}
		}



	
	


	switch(mod)
		{
	case  MODE_COPY    : x=CopyPath   (q,z,p,m,unter,s,Art);								break;
	case  MODE_COPYDEL : x=CopyCpDel  (q,z,p,m,unter,s,Art);								break;
	case  MODE_COPYFILE: x=CopySingle (q,z,p,m,unter,s,Art);		if(!x)SetIcon(item,0);	break;
	case  MODE_REG     : x=CopyReg    (q,z,p,m,unter,s,Art);								break;
	case  MODE_REGADD  : x=CopyReg    (q,z,p,m,unter,s,Art|0x10);							break;
	case  MODE_MOVE    : x=CopyMove   (q,z,p,m,unter,s,Art);		if(!x)SetIcon(item,0);	break;
	case  MODE_DEL     : x=CopyDel    (q,z,p,m,unter,s,Art);								break;
	case  MODE_FTP     : x=CopyFtp    (q,z,p,m,unter,s,Art);								break;
	case  MODE_FTPDEL  : x=CopyFtp    (q,z,p,m,unter,s,Art|0x100);							break;
	case  MODE_SYNCH   : x=CopySynch  (q,z,p,m,unter,s,Art);								break;
	case  MODE_BUFFER  : x=CopyBuffer (q,z,p,m,unter,s,Art);								break;
	case  MODE_UPDATE  : x=CopyUpdate (q,z,p,m,unter,s,Art);								break;
	case  MODE_VERSION : x=CopyVersion(q,z,p,m,unter,s,Art);								break;
	case  MODE_SHRINK  : x=CopyShrink (q,z,p,m,unter,s,Art);								break;
	case  MODE_BACKUP  :
						if(next)
						if(strcmp(list_view.GetItemText(next,5),"Backup")==0)
							{
							char		host1[64];
							char		host2[64];
							char		user1[64];
							char		user2[64];
							char		pass1[64];
							char		pass2[64];
							char		prot1[16];
							char		prot2[16];
							unsigned	port1;
							unsigned	port2;

							strparseurl(list_view.GetItemText(item,1),host1,sizeof(host1),user1,pass1,&port1,prot1);
							strparseurl(list_view.GetItemText(next,1),host2,sizeof(host2),user2,pass2,&port2,prot2);

							if(port1==port2 && !strcmp(host1,host2) && !strcmp(user1,user2) && !strcmp(pass1,pass2) && !strcmp(prot1,prot2))
								{
								flags |= 0x0400;						// Nicht schlieen
								}
							}

						if(past)
						if(strcmp(list_view.GetItemText(past,5),"Backup")==0)
							{
							char		host1[64];
							char		host2[64];
							char		user1[64];
							char		user2[64];
							char		pass1[64];
							char		pass2[64];
							char		prot1[16];
							char		prot2[16];
							unsigned	port1;
							unsigned	port2;

							strparseurl(list_view.GetItemText(item,1),host1,sizeof(host1),user1,pass1,&port1,prot1);
							strparseurl(list_view.GetItemText(past,1),host2,sizeof(host2),user2,pass2,&port2,prot2);

							if(port1==port2 && !strcmp(host1,host2) && !strcmp(user1,user2) && !strcmp(pass1,pass2) && !strcmp(prot1,prot2))
								{
								flags |= 0x0800;						// Nicht schlieen
								}
							}


						x = CopyBackup(q,z,p,m,unter,s,Art|flags);

						if(!(flags&0x0400) && ftp_conn)
							{
							delete ftp_conn;
							ftp_conn = NULL;
							}

						break;

	case  MODE_ZIPADD  : flags = 0x10;
	case  MODE_ZIP     :

						if(next)
						if(strcmp(list_view.GetItemText(next,5),"Zip Add")==0)
						if(strcmp(list_view.GetItemText(next,1),list_view.GetItemText(item,1))==0)
							{
							flags |= 0x0400;							// Nicht schlieen
							}

						if(past)
						if(strncmp(list_view.GetItemText(past,5),"Zip",3)==0)
						if(strcmp (list_view.GetItemText(past,1),list_view.GetItemText(item,1))==0)
							{
							flags |= 0x0800;							// Nicht neu ffen
							}

						x=CopyZip(q,z,p,m,unter,s,Art|flags);									break;


	default: x=0;
		}


return x;
}

//*****************************************************************************
//*
//*		Copy
//*
//*****************************************************************************
//  Kopiert die Serien aller Eintrge
//  Ist bei Art Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit2!=0 wird auch der Zeitplan berprft
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::Run(int Art)
{
int					x,error=0,exit=0;
char				mem[MAX_PATH+1024+16];
CProgressDialog		dlg(this);
CWnd			   *main;



	main = AfxGetMainWnd();

	if(main && IsWindow(main->m_hWnd))
		{
		main->SendMessage(WM_SETBREAK,0,(LPARAM)&dlg);
		}


	kopie_anz=0;
	if(!anzahl)return 0;


	if(zeitplan_art&0x4000)Art|=8;
	if(zeitplan_letzte && (Art &4))		// Zeitplan prfen
	do	{
		  						 Art&=~1;
		if(  zeitplan_art&0x8000)Art|= 1;
		if(  zeitplan_art&0x4000)Art|= 8;
		if(!(zeitplan_art&0x00FF))break;

		switch(zeitplan_art&0xFF)
			{
		case 1:	x=zeitplan_anz*3600*24;		break;
		case 2:	x=zeitplan_anz*3600*24*7;	break;
		case 3:	x=zeitplan_anz*3600*24*30;	break;
		default:x=0;
			}

		time_t zeit;
		time(&zeit);
		if(zeit>zeitplan_letzte+x)return 0;

		zeitplan_letzte=zeit;

		if(!(zeitplan_art&0x1000))		// Zeit speichern
			{
			SetGeaendert(1);
			}

		}while(0);


	if(Art&2)							// Dialog starten
		{
		dlg_view   =0;
		dlg_break  =0;

		dlg.SetProc(RunProc,this,(void*)Art);
		dlg.DoModal();
		dlg_break=1;
		exit=dlg.GetExitCode();
		}
	else{
		dlg_view =0;
		dlg_break=0;

		for(x=0;x<anzahl;x++)
			{
			   exit=Run(x,Art);
			if(exit==-2){error= -2;break;}
			if(exit==-1) error= -1;
			if(dlg_break)break;
			}
		}


	if(Art&2)
		{
		sprintf(mem,"Es wurden %i Dateien kopiert!",kopie_anz);
		x=MessageBox(mem,0,MB_OK);
		}

	if(error!=-2)
		{
		zeitplan_letzte=time(&zeitplan_letzte);
		if(!(zeitplan_art&0x1000))		// Zeit speichern
			{
			SetGeaendert(1);
			}
		}



	if(main && IsWindow(main->m_hWnd))
		{
		main->SendMessage(WM_SETBREAK,0,0);
		}


return error;
}

//*****************************************************************************
//*
//*		RunProc
//*
//*****************************************************************************
//	Dlg->proc_param1	ist das aufrufende BackupView
//	Dlg->proc_param2	ist die Art fr das Ausfhren
//  Ist bei Art Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit2!=0 wird auch der Zeitplan berprft
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::RunProc(CProgressDialog *Dlg)
{
CBackupView	*bv;
char		*text;
int			 error=0;
int			 exit;
int			 art;
int			 x;



	bv	= (CBackupView*)Dlg->proc_param1;
	art	= (int)         Dlg->proc_param2;

	bv->dlg_view=Dlg;
	bv->dlg_break=0;

	for(x=0;x<bv->anzahl;x++)
		{
		   exit=bv->Run(x,art);
		if(exit==-2){error= -2;break;}
		if(exit==-1) error= -1;

		if(bv->dlg_break)break;							// User abbruch
		}

	if(bv->zip.GetMode()!=CAF_CLOSED)
		{
		   x = bv->zip.Close();
		if(x!=CAF_ERROR_OK)
			{
			text = bv->zip.ErrorText();strcat(text,"\n\n");
			Dlg->MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);
			}
		}


return error;
}

//*****************************************************************************
//*
//*		CopyDel
//*
//*****************************************************************************
//  Lscht eine Serie von Dateien.
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht gelscht
//  Die Klassen-Variabel kopie_anz wir bei jeder Lschung erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyDel(char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art)
{
CFileFinder		 suche;
CStringChain	 verzeichnisse;
char			*name,mem[MAX_PATH+1024+16];
int				 x,pos,error=0,snr=0;




	if(!ExistFile(Quelle))return 0;


			 x =CFF_FIND_ALL;
	if(Unter)x|=CFF_FIND_SUBDIR|CFF_FIND_ADDDIR;


		 suche.Set(Quelle,x,Plus,Minus);
	name=suche.Next(1);
	mem[0] = 0;


	if(dlg_view)									// Ausgabe in Dialog ?
		{
		dlg_view->SetText(Quelle,0,0);
		dlg_view->SetRange(suche.Count());
		dlg_view->SetPos(0);
		dlg_view->SetText("Lschen",1);
		}


	for(pos=0,snr=0;name;snr++)						// Dateien lschen
		{
		if(dlg_view)
			{
			if(dlg_view->IsBreak())dlg_break=1;
			   dlg_view->SetPos(pos);
			}

		if(dlg_break)break;							// Benutzer Abbruch ?


		name=suche.Name(-1,1);

		if(suche.IsDir())							// Ist der Pfad ein Verzeichnis
			{
			verzeichnisse.Add(name);
			name=suche.Next(1);
			continue;
			}

		if(Art&0x20)								// Schreibgeschtzte nicht lschen
			{
			if(suche.IsReadOnly())continue;
			}


			x=RemoveFile(name);						// Datei lschen
		if(!x && (Art&2))
			{
			strcpy (mem,"Fehler beim Lschen von:\n\n");
			strlcat(mem,name,MAX_PATH+1024);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);

			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		if(!x)error=1;
		else  kopie_anz++;

		if(dlg_view)								// Dateinamen anzeigen
			{
			dlg_view->SetText(name,0,0);
			}

		pos++;

		if(dlg_view)dlg_view->SetPos(pos);
		name=suche.Next(1);
		}

	if(!Unter)										// Basis Verzeichnis lschen
	if(!Plus  || !*Plus )
	if(!Minus || !*Minus)
	if(ExistFile(Quelle)==2)
		{
		verzeichnisse.Add(Quelle);
		}


	verzeichnisse.Sort(0,-1,CSC_SORT_LENCU,1);

	for(snr=0;snr<verzeichnisse.Count();snr++)		// Verzeichnisse lschen
		{
		if(dlg_view)
			{
			if(dlg_view->IsBreak())dlg_break=1;
			   dlg_view->SetPos(pos);
			}

		if(dlg_break)break;							// Benutzer Abbruch ?

		name=verzeichnisse[snr];
		x=RemoveDirectory(name);


		if(!x && (Art&2))
			{
			strcpy (mem,"Fehler beim Lschen von:\n\n");
			strlcat(mem,name,MAX_PATH+1024);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);

			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		if(!x)error=1;
		else  kopie_anz++;

		if(dlg_view)								// Dateinamen anzeigen
			{
			dlg_view->SetText(name,0,0);
			}

		kopie_anz++;
		pos++;

		if(dlg_view)dlg_view->SetPos(pos);
		}

	if(error)return -1;



	   x=suche.Error();								// Fehler beim Suchen
	if(x!=CFF_ERROR_NULL && x!=CFF_ERROR_OK)
		{
		if(Art&2)
			{
			strcpy (mem,"Es gab einen Fehler beim Lschen von:\n\n");
			strlcat(mem,name,MAX_PATH+1024);
			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);
			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}
		return -1;
		}

return 0;
}

//*****************************************************************************
//*
//*		CopyReg
//*
//*****************************************************************************
//  Kopiert einen Registry Schlssen in /bzw. aus einer Datei
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit4!=0 wird die Registry angehngt
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyReg(char *Quelle, char *Ziel, char *Plus, char *Minus, int Unter,char *Zusatz,int Art)
{
WIN32_FILE_ATTRIBUTE_DATA	find;
char			puffer[MAX_PATH+1024];
CRegText		key;
int				mem_len=-1;
int				error=0;
int				x;


	if(dlg_view)									// Dialog Ausgabe ?
		{
		dlg_view->SetRange(1);
		dlg_view->SetPos(0);
		dlg_view->SetText(Quelle,0,0);
		dlg_view->SetText(Ziel  ,1,0);
		}


	if(!strnicmp(Quelle,"HKEY_",5))
		{											// Vorhandene und schreibgeschtzte nie berrschreiben
		if((Art&0x28) && GetFileAttributesEx(Ziel,GetFileExInfoStandard,&find))
			{
			if(Art&0x08)return 0;
			if(Art&0x20)
			if(find.dwFileAttributes&FILE_ATTRIBUTE_READONLY)return 0;
			}

		if(!key.Export(Ziel,Quelle,Art&0x10))
			{
			if(!(Art&2))return -1;
			strcpy(puffer,"Kann Registry Schlssel :\n");
			strcat(puffer,Quelle);
			strcat(puffer,"\nnicht nach :\n");
			strcat(puffer,Ziel);
			strcat(puffer,"\nexportieren !");

			if(dlg_view)x=dlg_view->MessageBox(puffer,0,MB_ICONERROR|MB_OKCANCEL);
			else		x=          MessageBox(puffer,0,MB_ICONERROR|MB_OKCANCEL);
			if(x==IDCANCEL)return -2;
			return -1;
			}

		kopie_anz++;
		if(dlg_view && dlg_view->IsBreak())dlg_break=1;
		if(dlg_break)return -2;

		return 0;
		}

	//*****************************************************************************
	if(!CmpFileType(Quelle,"reg;crg"))
		{
		return CopyPath(Quelle,Ziel,Plus,Minus,Unter,Zusatz,Art);
		}

	GetFilePath(puffer,Quelle,sizeof(puffer));
	DelBackSlash(puffer);
	VarSet("CURRENT_PATH",puffer);
	VarSet("CURRENT_FILE",Quelle);

	if(!key.Import(Quelle))
		{
		if(!(Art&2))return -1;
		strcpy(puffer,"Kann Registry Datei :\n");
		strcat(puffer,Quelle);
		strcat(puffer,"\nnicht importieren !");

		if(dlg_view)x=dlg_view->MessageBox(puffer,0,MB_ICONERROR|MB_OKCANCEL);
		else		x=          MessageBox(puffer,0,MB_ICONERROR|MB_OKCANCEL);
   		if(x==IDCANCEL)return -2;
		return -1;
		}
	kopie_anz++;

	if(dlg_view && dlg_view->IsBreak())dlg_break=1;
	if(dlg_break)return -2;


return 0;
}
//*****************************************************************************
//*
//*		CopyMove
//*
//*****************************************************************************
//  Verschiebt die Datei Quelle nach Ziel
//  Ist bei Art Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyMove(char *Quelle, char *Ziel, char *Plus, char *Minus, int Unter,char *Zusatz,int Art)
{
int							x,mode,mem_len=-1,error=0;
char						puffer[MAX_PATH+1024];
WIN32_FILE_ATTRIBUTE_DATA	find1,find2;
CRegText					key;
BOOL						ok;




	if(dlg_view)								// Ausgabe in Dialog ?
		{
		dlg_view->SetRange(1);
		dlg_view->SetPos  (0);
		dlg_view->SetText(Quelle,0,0);
		dlg_view->SetText(Ziel  ,1,0);
		}


	if(!stricmp(Quelle,Ziel))return 0;


	if(ExistFile(Quelle)>=2)					// Ist die Quelle ein Verzeichnis
		{
		if(!(Art&2))return -1;
		strcpy(puffer,"Die Datei :\n");
		strcat(puffer,Quelle);
		strcat(puffer,"\nist ein Verzeichnis und kann nicht verschoben werden !");

		if(dlg_view)x=dlg_view->MessageBox(puffer,0,MB_ICONERROR|MB_OKCANCEL);
		else		x=          MessageBox(puffer,0,MB_ICONERROR|MB_OKCANCEL);

		if(x==IDCANCEL)return -2;
		return -1;
		}

	if(Art&0x29)								// Prfe Dateizeit und Attribute
	do	{
		if(!GetFileAttributesEx(Ziel,GetFileExInfoStandard,&find2))
			{
			break;
			}
												// Schreibgeschtzte nicht berschrieben
		if(Art&0x20 && (find2.dwFileAttributes&FILE_ATTRIBUTE_READONLY))
			{
			return 0;
			}

		if(Art&0x08)							// Vorhandene nie berschreiben
			{
			return 0;
			}

		if(!GetFileAttributesEx(Quelle,GetFileExInfoStandard,&find1))
			{
			break;
			}
												// Nur wenn neuer kopieren
		if((Art&0x01) && CmpFileTime(&find1.ftLastWriteTime,&find2.ftLastWriteTime,3)<=0)
			{
			return 0;
			}

		}while(0);


	mode = (Art&0x08)? 0:CFP_FAILIFEXIST|CFP_FORCEMOVE|CFP_DELETEPATH;
	ok   = CopyFileProgress(Quelle,Ziel,&size_now,0,(dlg_view)? dlg_view->GetCancelPtr():0,CFP_TEMPRENAME|CFP_COPYTIME|CFP_READONLY|CFP_CREATEPATH|CFP_MOVEFILE|mode);

	if(ok==0 && dlg_view)						// Gab es einen Benutzterabbruch
		{
		if(dlg_view->IsBreak())dlg_break=1;
		}


	if(ok<=0 && !dlg_break)						// Gab es einen Fehler ?
		{
		if(!(Art&2))return -1;
		strcpy(puffer,"Kann Datei :\n");
		strcat(puffer,Quelle);
		strcat(puffer,"\nnicht nach :\n");
		strcat(puffer,Ziel);
		strcat(puffer,"\nverschieben !");

		if(dlg_view)x=dlg_view->MessageBox(puffer,0,MB_ICONERROR|MB_OKCANCEL);
		else		x=          MessageBox(puffer,0,MB_ICONERROR|MB_OKCANCEL);

		if(x==IDCANCEL)return -2;
		return -1;
		}

	kopie_anz++;

	if(dlg_view && dlg_view->IsBreak())dlg_break=1;
	if(dlg_break)return -2;


return 0;
}

//*****************************************************************************
//*
//*		CopyZip
//*
//*****************************************************************************
//  Kopiert eine Serie von Dateien in oder aus ZipFile
//  Ist bei Art Bit  0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit  1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit  3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit  4!=0 wird eine vorhandene Zip-Datei nie berschrieben (ZIP_ADD)
//  Ist bei Art Bit  5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Ist bei Art Bit 10!=0 wird die Zip-Datei nicht geschlossen
//  Ist bei Art Bit 11!=0 wird die Zip-Datei nicht neu geffnet
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyZip(char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art)
{
char			*text,zusatz[MAX_PATH],puffer[MAX_PATH+1024+16];
int				 x,y,anz,mem_len=-1,error=0;



	if(!(Art&0x10) && !stricmp(GetFileType(Quelle),"ZIP"))
		{
		SetLockPath(Zusatz);

		   x=zip.Open(Quelle,CAF_READ);
		if(x!=CAF_ERROR_OK)
			{
			if(!(Art&2))return -1;
			text=zip.ErrorText();strcat(text,"\n\n");

			if(dlg_view)x=dlg_view->MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);
			return	    x=          MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);

			if(x==IDCANCEL)return -2;
			return -1;
			}

		if(dlg_view && dlg_view->IsBreak())dlg_break=1;
		if(dlg_break)return -2;

				 x =0;
		if(Art&0x01)x|=CAF_FLAG_NEW;					// Flags setzen
		if(Art&0x08)x|=CAF_FLAG_NOEXIST;
		if(Art&0x20)x|=CAF_FLAG_NOREADONLY;

		zip.Flags(x);

		  strncpy(puffer,Ziel,MAX_PATH+1024);
		y=strlen (puffer);
		if(y  &&  puffer[y-1]!='\\')strcpy(puffer+y,"\\");

		anz=zip.Count();

		if(dlg_view)
			{
			dlg_view->SetRange(anz);
			dlg_view->SetPos  (0);
			dlg_view->SetText(Quelle,0,0);
			dlg_view->SetText(Ziel  ,1,0);
			}

		  zip.Progress(this,ZipProc);
		  zip.ProgressDel(-1,1);

		if(lock_str.Count())							// Sind Verzeichnisse zum auslassen
			{
			zip.ProgressAdd(CAF_PROG_QUERY);
			}

		  zip.ProgressAdd(CAF_PROG_READ);
		  zip.ProgressAdd(CAF_PROG_ERROR);
		  zip.ProgressAdd(CAF_PROG_EXTRACT);
		x=zip.ExtractAll(puffer);

		if(x!=CAF_ERROR_OK   )error=-1;
		if(x==CAF_ERROR_BREAK)error=-2;
		return error;
		}


//*****************************************************************************


	if(stricmp(GetFileType(Ziel),"ZIP"))
		{
		if(zip.GetMode()!=CAF_CLOSED)
			{
			   x = zip.Close();
			if(x!=CAF_ERROR_OK)
				{
				text = zip.ErrorText();strcat(text,"\n\n");

				if(dlg_view)x=dlg_view->MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);
				else        x=          MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);
				}
			}

		return CopyPath(Quelle,Ziel,Plus,Minus,Unter,Zusatz,Art);
		}

	if(Zusatz && *Zusatz)								// Unterverzeichniss fr ZIP-Datei
		{
		x=strchar(Zusatz,';');
		strlcpy(zusatz,Zusatz,sizeof(zusatz),x);
		Zusatz+=x;
		if(*Zusatz)Zusatz++;

		SetLockPath(Zusatz);							// Verzeichnisse auslassen
		}
	else{
		zusatz[0] = 0;
		}



		 Zusatz=zusatz;
	if(!*Zusatz)Zusatz=0;								// Kein Unterverzeichniss fr ZIP-Datei


														// Zip-Datei neu ffnen
	if(!(Art&0x0800) || zip.GetMode()==CAF_CLOSED || zip.GetMode()==CAF_READ)
		{
		   x=zip.Open(Ziel,(Art&0x19)? CAF_WRITE:CAF_CREATE);
		if(x!=CAF_ERROR_OK)
			{
			GetFilePath(puffer,Ziel,sizeof(puffer));
			CreatePath (puffer);
			x=zip.Open (Ziel,(Art&0x19)? CAF_WRITE:CAF_CREATE);
			}

		if(x!=CAF_ERROR_OK)
			{
			if(!(Art&2))return -1;
			text=zip.ErrorText();strcat(text,"\n\n");

			if(dlg_view)x=dlg_view->MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);

			if(x==IDCANCEL)return -2;
						   return -1;
			}
		}



	x=(Unter)?  CAF_FLAG_SUBDIR:0;
	if(Art&1)x|=CAF_FLAG_NEW;
	if(Art&8)x|=CAF_FLAG_NOEXIST;

	size_mode = 4;

	if(dlg_view)
		{
		dlg_view->SetRange(256);
		dlg_view->SetPos(0);
		dlg_view->SetTime(CopyPos,300,this);
		dlg_view->SetText(Quelle,0,0);
		dlg_view->SetText("Suche Dateien",1);
		}


	    zip.ProgressDel(-1,1);
	if(lock_str.Count())								// Verzeichnisse auslassen
	    zip.ProgressAdd(CAF_PROG_QUERY);
	    zip.ProgressAdd(CAF_PROG_COMPRESS);
	    zip.ProgressAdd(CAF_PROG_ERROR);
	    zip.ProgressAdd(CAF_PROG_WRITE);
	    zip.Progress(this,ZipProc);
		zip.Flags(x);
	anz=zip.Add(Quelle,Plus,Minus,Zusatz);



	if(!(Art&0x0400))									// Zip-Datei schlieen
		{
		x = zip.Close();
		}
	else{
		x = CAF_ERROR_OK;
		}


	size_mode = 0;


	if(dlg_view)										// Dialoganzeige zurck setzen
		{
		dlg_view->SetTime();
		dlg_view->SetPos(0);
		dlg_view->SetRange(anz);
		dlg_view->SetText(Quelle,0,0);
		dlg_view->SetText(Ziel  ,1,0);
		}

	if(x!=CAF_ERROR_OK)									// Gab es einen Fehler
		{
		if(!(Art&2))return -1;

		text = zip.ErrorText();strcat(text,"\n\n");

		if(dlg_view)x=dlg_view->MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);
		else        x=          MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);

		if(x==IDCANCEL)
			{
			zip.Break();
			return -2;
			}

		return -1;
		}


return 0;
}

//*****************************************************************************
//*
//*		CopyPath
//*
//*****************************************************************************
//  Kopiert eine Serie von Dateien
//  Ist bei Art Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//	Ist bei Art Bit9!=0 wird eine einzelne Datei kopiert
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyPath(char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art)
{
CFileFinder		 suche;
unsigned		 len_max=0,len_pos=0;
char			*name,*ptr,*text;
char			 puffer[MAX_PATH+1024+16];
char			 mem   [MAX_PATH+1024+16];
int				 single,error=0,snr=0;
int				 x,y,pos,mem_len=-1;
SysFind			 f;
SysFindStruct	*find1;
SysFindStruct	 find;
SysUtc 			 zeit1;
SysUtc 			 zeit;




	if(!CheckHost(&Zusatz))							// Hostnamen prfen
		{
		return 0;
		}

	puffer[0] = 0;
	mem   [0] = 0;

			 x =CFF_FIND_ALL;
	if(Unter)x|=CFF_FIND_SUBDIR|CFF_FIND_ADDDIR;



		 suche.Set(Quelle,x,Plus,Minus);
 	name=suche.Next(1);


	len_max     = (unsigned)suche.GetSizeAll();		// Gesamt Lnge berechnen
	size_offset = 0;

	if(dlg_view)									// Ausgabe in Dialog ?
		{
		dlg_view->SetTime(CopyPos,300,this);
		dlg_view->SetText(Quelle,0,0);
		dlg_view->SetRange(len_max);
		dlg_view->SetPos(0);
		}

	if(Art&0x200)									// Einzelne Datei kopieren
		{
		pos    = strlcpy(puffer,Ziel,sizeof(puffer)-16);
		single = 1;
		}
	else{											// In Verzeichnise kopieren
		pos    = strlcpy(puffer,Ziel,sizeof(puffer)-16);
		pos    = AddBackSlash(puffer,pos);
		single = 0;
		}

	if(SetLockPath(Zusatz,1))						// Verzeichnisse auslassen
	if(ExistFile(Ziel)==0)
		{
		return 0;									// Wenn Ziel nicht existiert, dann nicht kopieren
		}



	for(snr=0,len_pos=0;name;snr++)					// Einzel Dateischleife
		{
		if(dlg_view)
			{
			if(dlg_view->IsBreak())dlg_break=1;
			   dlg_view->SetPos(len_pos);
			}

		if(dlg_break)break;							// Benutzer Abbruch ?

		ptr = suche.Name   (-1,2);
		y   = suche.NameLen(-1,2);


		if(!suche.IsDir())
			{
			y-=suche.NameLen(-1,0);
			if(y>0 && ptr[y-1]=='\\')y--;
			}


		if(IsLockPath(ptr,y))						// Verzeichnis auslassen
			{
			name=suche.Next(1);
			continue;
			}

		if(!single)									// Relativen Pfad an Zielpad anhngen
			{
			strlcpy(puffer+pos,ptr,MAX_PATH+1024-pos);
			}

		if(Art&0x29)								// Prfe Zeit und Attribute
			{
			   f=SysFindFirst(puffer,&find);
			if(f)SysFindClose(f);

			if((Art&0x20) && f)						// Schreibgeschtzte nie berschreiben
			if(!(find.dwAttr&SYS_WRITE))
				{
				name=suche.Next(1);
				continue;
				}

			if((Art&0x08) && f)						// Dateien nie berschreiben
				{
				name=suche.Next(1);
				continue;
				}

			if((Art&0x01) && f)						// Prfe ob Datei neuer
				{
				zeit=0;zeit1=0;
				find1=suche.Info();

				if(find  .dwTimeWrite>zeit )zeit =find  .dwTimeWrite;
				if(find1->dwTimeWrite>zeit1)zeit1=find1->dwTimeWrite;

				if(zeit>=zeit1)
					{
					len_pos+=suche.Len(snr);
					if(dlg_view)dlg_view->SetPos(len_pos);
					name=suche.Next(1);
					continue;
					}
				}
			}

		if(dlg_view)								// Dateinamen anzeigen
			{
			dlg_view->SetText(name  ,0,0);
			dlg_view->SetText(puffer,1,0);
			}

		if(suche.IsDir())							// Pfad erzeugen
			{
			x = CreatePath(puffer);
			}
		else{
			size_max	 = suche.Len();				// Datei kopieren
			size_offset  = len_pos;
			size_now	 = 0;
			size_mode    = 3;

			x            = CopyFileProgress(name,puffer,&size_now,0,(dlg_view)? dlg_view->GetCancelPtr():0,CFP_TEMPRENAME|CFP_COPYTIME|CFP_READONLY|CFP_CREATEPATH|CFP_DELETEPATH);
			size_offset += size_max;
			size_mode    = 1;

			if(x==0 && dlg_view)					// Gab es einen Benutzterabbruch
				{
				if(dlg_view->IsBreak())dlg_break=1;
				   dlg_view->SetPos(len_pos);

				break;
				}
			}

		if(x==1)kopie_anz++;
		else if(x<=0)
			{
			if(x==-2 && strifind(puffer,"Backup.exe")>=0)
				{
				GetExeName(mem,sizeof(mem));

				if(!stricmp(puffer,mem))
					{
					char		bat[256];

					CreateTempPath(bat,sizeof(bat),"?backup.bat");
					sprintf(mem,"timeout /t 2\ncopy /Y \"%s\"  \"%s\"\n",suche.NameFull(-1),puffer);

					if(SaveMemory(bat,mem))
						{
						call_bat = bat;
						goto Next;
						}
					}
				}

			if((Art&2) && !dlg_break)
				{
				text=ErrorToText(GetLastError(),"");
				strcpy (mem,"Fehler beim Kopieren von:\n");
				strlcat(mem,name       ,MAX_PATH+1024);
				strlcat(mem,"\nnach:\n",MAX_PATH+1024);
				strlcat(mem,puffer     ,MAX_PATH+1024);

				if(*text)
					{
					strlcat(mem,"\n("  ,MAX_PATH+1024);
					strlcat(mem,text   ,MAX_PATH+1024);
					strlcat(mem,")"    ,MAX_PATH+1024);
					}

				if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				if(x==IDCANCEL)
					{
					dlg_break=1;
					return -2;
					}
				}

			error=1;
			}
Next:
		len_pos+=suche.Len(snr);
		if(dlg_view)dlg_view->SetPos(len_pos);
		name=suche.Next(1);
		}


	if(dlg_view)									// Zeitfunktion lschen
		{
		dlg_view->SetTime();
		}

	if(error)return -1;



	   x=suche.Error();								// Fehler beim Suchen
	if(x!=CFF_ERROR_NULL && x!=CFF_ERROR_OK)
		{
		if(Art&2)
			{
			strcpy (mem,"Es gab einen Fehler beim kopieren von:\n\n");
			strlcat(mem,name,MAX_PATH+1024);
			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);
			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}
		return -1;
		}

return 0;
}

//*****************************************************************************
//*
//*		CopySingle
//*
//*****************************************************************************
//  Kopiert eine einzelne Datei
//  Ist bei Art Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopySingle(char *Quelle,char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art)
{
int		ret;


	ret = CopyPath(Quelle,Ziel,"","",0,Zusatz,Art|0x200);


return ret;
}

//*****************************************************************************
//*
//*     CopyCpDel
//*
//*****************************************************************************
//  Kopiert eine Serie von Dateien und lscht alle berzhligen
//  Ist bei Art Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyCpDel(char *Quelle, char *Ziel,char *Plus, char *Minus, int Unter,char *Zusatz,int Art)
{
CFileFinder		 suche;
CStringChain	 folders;
unsigned		 len_max=0,len_pos=0;
char			*name,*ptr;
char			 puffer[MAX_PATH+1024+16];
char			 mem   [MAX_PATH+1024+16];
int				 x,y,pos,mem_len=-1,error=0,snr=0;



	x = CopyPath(Quelle,Ziel,Plus,Minus,Unter,Zusatz,Art);

	if(dlg_break)
		{
		return x;
		}


	if(!CheckHost(&Zusatz))							// Hostnamen prfen
		{
		return 0;
		}

	puffer[0] = 0;
	mem   [0] = 0;

			 x =CFF_FIND_ALL;
	if(Unter)x|=CFF_FIND_SUBDIR|CFF_FIND_ADDDIR;



		 suche.Set(Ziel,x,Plus,Minus);
 	name=suche.Next(1);

	len_max = (unsigned)suche.GetSizeAll();			// Gesamt Lnge berechnen

	if(dlg_view)									// Ausgabe in Dialog ?
		{
		dlg_view->SetText(Ziel,0,0);
		dlg_view->SetRange(len_max);
		dlg_view->SetPos(0);
		}


	pos = strlcpy(puffer,Quelle,sizeof(puffer)-16);	// Zielverzeichnis
	pos = AddBackSlash(puffer);

	if(SetLockPath(Zusatz,1))						// Verzeichnisse auslassen
	if(ExistFile(Ziel)==0)
		{
		return 0;									// Wenn Verzeichnis nicht existiert, dann nicht kopieren
		}



	for(snr=0,len_pos=0;name;snr++)					// Dateien lschen
		{
		if(dlg_view)
			{
			if(dlg_view->IsBreak())dlg_break=1;
			   dlg_view->SetPos(len_pos);
			}

		if(dlg_break)break;							// Benutzer Abbruch ?

		ptr=suche.Name(-1,2);

		if(IsLockLast(ptr))							// Verzeichnisse lock_str
			{
			name=suche.Next(1);
			continue;
			}

		y=suche.NameLen(-1,2);
		if(!suche.IsDir())
			{
			y-=suche.NameLen(-1,0);
			if(y>0 && ptr[y-1]=='\\')y--;
			}

		if(IsLockPath(ptr,y))						// Verzeichnisse auslassen
			{
			name=suche.Next(1);
			continue;
			}

		strlcpy(puffer+pos,ptr,MAX_PATH+1024-pos);

		if(dlg_view)								// Dateinamen anzeigen
			{
			dlg_view->SetText(name  ,0,0);
			dlg_view->SetText(puffer,1,0);
			}

		if(suche.IsDir())							// Pfad erzeugen
			{
			if(ExistFile(puffer)>=2)				// Existiert der Pfad nur im Ziel
				{
				len_pos+=suche.Len(snr);
				if(dlg_view)dlg_view->SetPos(len_pos);
				name=suche.Next(1);
				continue;
				}

			folders.Add(name);
			}
		else{
			if(ExistFile(puffer)==1)				// Existiert die Datei nur im Ziel
				{
				len_pos+=suche.Len(snr);
				if(dlg_view)dlg_view->SetPos(len_pos);
				name=suche.Next(1);
				continue;
				}


				x=DeleteFile(name);					// Datei kopieren
			if(!x && GetLastError()==ERROR_ACCESS_DENIED)
				{
				if(Art&0x20)						// Schreibgeschtzte nie berschreiben
					{
					len_pos+=suche.Len(snr);
					if(dlg_view)dlg_view->SetPos(len_pos);
					name=suche.Next(1);
					continue;
					}

				RemoveFile(name);
				}
			}

		if(x)kopie_anz++;
		else{
			if(Art&2)
				{
				strcpy (mem,"Fehler beim Lschen von:\n");
				strlcat(mem,name,MAX_PATH+1024);
				if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				if(x==IDCANCEL)
					{
					dlg_break=1;
					return -2;
					}
				}
			error=1;
			}

		len_pos+=suche.Len(snr);
		if(dlg_view)dlg_view->SetPos(len_pos);
		name=suche.Next(1);
		}


	for(pos=0;pos<folders.Count();pos++)			// Verzeichnisse lschen
		{
		if(dlg_break)break;							// Benutzer Abbruch ?

		name = folders[pos];
		x = RemovePath(name);

		if(x)continue;

		if(Art&2)
			{
			strcpy (mem,"Fehler beim Lschen von:\n");
			strlcat(mem,name,MAX_PATH+1024);
			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			}

		if(x==IDCANCEL)
			{
			dlg_break=1;
			return -2;
			}

		error=1;
		}


	if(error)return -1;



	   x=suche.Error();							// Fehler beim Suchen
	if(x!=CFF_ERROR_NULL && x!=CFF_ERROR_OK)
		{
		if(Art&2)
			{
			strcpy (mem,"Es gab einen Fehler beim Lschen von:\n\n");
			strlcat(mem,name,MAX_PATH+1024);
			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);
			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		return -1;
		}

return 0;
}

//*****************************************************************************
//*
//*		CopyUpdate
//*
//*****************************************************************************
//  Kopiert eine Serie von Dateien wenn sie im Zielverzeichnis vorhanden sind
//  Ist bei Art Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyUpdate(char *Quelle, char *Ziel, char *Plus, char *Minus, int Unter,char *Zusatz,int Art)
{
CFileFinder		 suche;
unsigned		 len_max=0;
unsigned		 len_pos=0;
char			*name,*ptr;
char			 puffer[MAX_PATH+1024+16];
char			 mem   [MAX_PATH+1024+16];
int				 mem_len=-1,error=0,snr=0;
int				 x,y,pos,mode;
SysFind			 f;
SysFindStruct	*find1;
SysFindStruct	 find;
SysUtc 			 zeit1;
SysUtc 			 zeit;



			 x =CFF_FIND_ALL;
	if(Unter)x|=CFF_FIND_SUBDIR|CFF_FIND_ADDDIR;

	puffer[0] = 0;
	mem   [0] = 0;

		 suche.Set(Quelle,x,Plus,Minus);
 	name=suche.Next(1);

	pos =strlcpy(puffer,Ziel,sizeof(puffer)-16);	// Zielverzeichnis
	pos =AddBackSlash(puffer);

	for(len_max=0,x=0;x<suche.Count();x++)			// Gesamt Lnge berechnen
		{
		ptr=suche.Name(x,2);
		strlcpy(puffer+pos,ptr,MAX_PATH+1024-pos);

		if(!ExistFile(puffer))
			{
			suche.Del(x);
			x--;
			continue;
			}

		len_max += suche.Len(x);
		}


	size_offset = 0;

	if(dlg_view)									// Ausgabe in Dialog ?
		{
		dlg_view->SetTime(CopyPos,300,this);
		dlg_view->SetText(Quelle,0,0);
		dlg_view->SetRange(len_max);
		dlg_view->SetPos(0);
		}

	     suche.Reset();
	name=suche.Next(1);


	SetLockPath(Zusatz);							// Auszulassende Verzeichnisse scannen




	for(snr=0,len_pos=0;name;snr++)					// Dateien kopieren
		{
		if(dlg_view)
			{
			if(dlg_view->IsBreak())dlg_break=1;
			   dlg_view->SetPos(len_pos);
			}

		if(dlg_break)break;							// Benutzer Abbruch ?

		ptr=suche.Name(-1,2);

		if(IsLockLast(ptr))							// Verzeichnisse lock_str
			{
			name=suche.Next(1);
			continue;
			}

		y = suche.NameLen(-1,2);
		if(!suche.IsDir())
			{
			y-=suche.NameLen(-1,0);
			if(y>0 && ptr[y-1]=='\\')y--;
			}

		if(IsLockPath(ptr,y))
			{
			name=suche.Next(1);
			continue;
			}

		strlcpy(puffer+pos,ptr,MAX_PATH+1024-pos);

		if(Art&0x29)								// Prfe Zeit und Attribute
			{
			   f=SysFindFirst(puffer,&find);
			if(f)SysFindClose(f);

			if((Art&0x20) && f)						// Schreibgeschtzte nie berschreiben
			if(!(find.dwAttr&SYS_WRITE))
				{
				name=suche.Next(1);
				continue;
				}
			if((Art&0x08) && f)						// Dateien nie berschreiben
				{
				name=suche.Next(1);
				continue;
				}
			if((Art&0x01) && f)						// Prfe ob Datei neuer
				{
				zeit=0;zeit1=0;
				find1=suche.Info();

				if(find  .dwTimeWrite>zeit )zeit =find  .dwTimeWrite;
				if(find1->dwTimeWrite>zeit1)zeit1=find1->dwTimeWrite;

				if(find1->dwSize==find.dwSize)
				if(zeit>=zeit1)
					{
					len_pos+=suche.Len(snr);
					if(dlg_view)dlg_view->SetPos(len_pos);
					name=suche.Next(1);
					continue;
					}
				}
			}

		if(dlg_view)								// Dateinamen anzeigen
			{
			dlg_view->SetText(name  ,0,0);
			dlg_view->SetText(puffer,1,0);
			}

		if(suche.IsDir())							// Pfad erzeugen
			{
			x = CreatePath(puffer);
			}
		else{										// Datei kopieren
			size_max	 = suche.Len();
			size_offset  = size_max;
			size_now	 = 0;
			size_mode    = 3;
			mode		 = (Art&0x08)? 0:CFP_DELETEPATH;
			x			 = CopyFileProgress(name,puffer,&size_now,0,(dlg_view)? dlg_view->GetCancelPtr():0,CFP_TEMPRENAME|CFP_COPYTIME|CFP_READONLY|CFP_CREATEPATH|mode);
			size_mode    = 1;

			if(x==0 && dlg_view)					// Gab es einen Benutzterabbruch
				{
				if(dlg_view->IsBreak())dlg_break=1;
				}
			}

		if(x==1)kopie_anz++;
		else if(x<=0 && !dlg_break)
			{
			if(Art&2)
				{
				strcpy (mem,"Fehler beim Kopieren von:\n");
				strlcat(mem,name,MAX_PATH+1024);
				strlcat(mem,"\nnach:\n",MAX_PATH+1024);
				strlcat(mem,puffer,MAX_PATH+1024);
				if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				if(x==IDCANCEL)
					{
					if(dlg_view)dlg_view->SetTime();
					dlg_break=1;
					return -2;
					}
				}

			error=1;
			}

		len_pos+=suche.Len(snr);
		if(dlg_view)dlg_view->SetPos(len_pos);
		name=suche.Next(1);
		}

	if(dlg_view)								// Verlaufsfunktion entfernen
		{
		dlg_view->SetTime();
		}

	if(error)return -1;



	   x=suche.Error();							// Fehler beim Suchen
	if(x!=CFF_ERROR_NULL && x!=CFF_ERROR_OK)
		{
		if(Art&2)
			{
			strcpy (mem,"Es gab einen Fehler beim kopieren von:\n\n");
			strlcat(mem,name,MAX_PATH+1024);
			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);
			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}
		return -1;
		}


return 0;
}

//*****************************************************************************
//*
//*		DeleteFtp
//*
//*****************************************************************************
//	Lscht Dateien auf einem FTP Server
int CBackupView::DeleteFtp(CFtpBase *Ftp,char *Path,CStringChain &List,int Art,int *Pos)
{
int		x,pos,len;



	if(List.Count()<=0)return 0;

	len = strlen(Path);
	len = AddBackSlash('/',Path,len);


	if(dlg_view)							// Ausgabe in Dialog ?
		{
		dlg_view->SetText("Lsche am FTP Server",0,0);
		}


	for(pos=0;pos<List.Count();pos++)
		{
		if(dlg_break)return 1;

		strlcpy(Path+len,List[pos],256-len);

		if(dlg_view)						// Ausgabe in Dialog ?
			{
			if(dlg_view->IsBreak())
				{
				dlg_break=1;
				break;
				}

			if(Pos)							// Verlaufsanzeige erhhen
				{
				Pos[0]++;
				dlg_view->SetPos(*Pos&0x0F);
				}

			dlg_view->SetText(Path,1,0);
			}

		if(Ftp->Remove(Path))continue;

		if(Art&2)
			{
			CString	msg;
			msg.Format("Fehler beim Lschen von:\n%s",List[pos]);
			if(dlg_view)x=dlg_view->MessageBox(msg,0,MB_ICONERROR|MB_OKCANCEL);
			else		x=          MessageBox(msg,0,MB_ICONERROR|MB_OKCANCEL);
			if(x==IDCANCEL)return 1;
			}
		}

return 0;
}

//*****************************************************************************
//*
//*		CopyFtp
//*
//*****************************************************************************
//  Kopiert eine Serie von Dateien auf/von einem Ftp Server
//  Ist bei Art Bit  0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit  1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit  3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit  5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Ist bei Art Bit  8!=0 werden ber zhlige Dateien am FTP Server gelscht
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyFtp(char *Quelle, char *Ziel, char *Plus, char *Minus, int Unter,char *Zusatz,int Art)
{
char				 temp   [512];
char				 path   [512];
char				 server [256];
char				 username[64];
char				 passwd  [64];
char				 exedata [16];
CFtpBase   			*ftp_s;
CFtpBase			*ftp_t;
CFtpBaseFind		*find;
CFileFinder			 suche;
CStringChain		 dirs;
CStringChain		 list;
CString				 msg;
CString				 name;
CString				 s_url;
CString				 t_url;
char				*text,*txt,*ptr,*fpath,*fname;
char				 s_dir[MAX_PATH+1024+16];
char				 t_dir[MAX_PATH+1024+16];
int					 t_len,t_off,s_mode;
int					 s_len,s_off,t_mode;
int					 size,tick,exit,flags;
int					 x,ok,pos,ignore,attr;
int 				 size_all;
int					 arch;
int					 diff;
unsigned			 port;
FtpFileData			 data;
FILETIME			 zeit;




	s_mode		= GetFtpConnType(Quelle,TRUE);
	t_mode		= GetFtpConnType(Ziel  ,TRUE);
	arch		= s_mode==FTP_MODE_ARCH;
	size_mode	= 0;
	size_offset	= 0;
	ignore		= 0;
	text		= 0;
	tick		= 0;
	exit		= 0;
	find		= 0;
	ftp_s		= 0;
	ftp_t		= 0;

	SetLockPath(Zusatz);


//*****************************************************************************

if(s_mode!=FTP_MODE_NONE && t_mode!=FTP_MODE_NONE)
do	{												// FTP-Verbindung ffnen
	s_mode |= FTP_MODE_RECONN|FTP_MODE_RETRY;
	t_mode |= FTP_MODE_RECONN|FTP_MODE_RETRY;

	try	{
		server  [0] = 0;
		passwd  [0] = 0;
		username[0] = 0;
		port        = 0;

		strparseurl(Quelle,server,sizeof(server),username,passwd,&port,0,path,sizeof(path)|STR_NOROOTSIGN);

		if(!arch)
			{
			if(!server  [0])throw "Falscher FTP-Server-Name";
			if(!username[0])throw "Falscher User-Namen";
			}

		if(dlg_view)								// Ausgabe in Dialog ?
			{
			dlg_view->SetRange(16);
			dlg_view->SetPos  (0);
			dlg_view->SetText(server,0,0);
			dlg_view->SetText(Ziel  ,1,0);
			}

		ftp_s = GetFtpConnectionEx(server,username,passwd,port,s_mode,path);

													// Ab lokalen Pfad
		if(path[0]=='.' && (path[1]==0 || path[1]=='/' || path[1]=='\\'))
			{
			if(!ftp_s->GetCurrentDirectory(name))throw "Kann aktuelles Verzeichnis nicht abfragen";
			if(path[1]){AddBackSlash(name,'/');name+=path+2;}
			strlcpy(path,name,sizeof(path));
			}

		s_url  = ftp_s->GetProtocol();
		s_url += ftp_s->GetServerName();

		server  [0] = 0;
		passwd  [0] = 0;
		username[0] = 0;
		port        = 0;

		strparseurl(Ziel,server,sizeof(server),username,passwd,&port,0,temp,sizeof(temp)|STR_NOROOTSIGN);

		if(!server  [0])throw "Falscher FTP-Server-Name";
		if(!username[0])throw "Falscher User-Namen";

		ftp_t = GetFtpConnectionEx(server,username,passwd,port,t_mode,path);

		if(arch && !server[0])
			{
			strncpy(server,path,sizeof(server));
			path[0] = 0;
			}
													// Ab lokalen Pfad
		if(temp[0]=='.' && (temp[1]==0 || temp[1]=='/' || temp[1]=='\\'))
			{
			if(!ftp_t->GetCurrentDirectory(name))throw "Kann aktuelles Verzeichnis nicht abfragen";
			if(temp[1]){AddBackSlash(name,'/');name+=temp+2;}
			strlcpy(temp,name,sizeof(temp));
			}

		t_url  = ftp_t->GetProtocol();
		t_url += ftp_t->GetServerName();
		}
	catch(char *error)
		{
		text = error;
		exit = -1;
		break;
		}
	catch(CInternetException *error)
		{
		text = ErrorToText(error->m_dwError,"Keine Verbindung zum FTP-Server");
		exit = -1;
		break;
		}
	catch(...)
		{
		text = "Keine Verbindung zum FTP-Server";
		exit = -1;
		break;
		}


	if(dlg_view && dlg_view->IsBreak())dlg_break=1;
	if(dlg_break){exit=-2;break;}
	if(dlg_view )dlg_view->SetBreak(FtpBreak,ftp_s);

	s_dir[0] = '/';
	t_dir[0] = '/';
	s_off    = strlcpy(s_dir+1,path,sizeof(s_dir)-1)+1;
	t_off    = strlcpy(t_dir+1,temp,sizeof(t_dir)-1)+1;
	dirs.Add("");
	tick++;

	PathConvert(t_dir,'/');
	PathConvert(s_dir,'/');

	GetTempPath(sizeof(path),path);
	GetTempFileName(path,".tmp",0,temp);


	while(dirs.Count()>0 && exit!=-2)				// Verzeichnis Schleife
		{
		if(dlg_view && dlg_view->IsBreak())dlg_break=1;
		if(dlg_break){exit=-2;break;}

		ptr  = dirs[0];

		if(*ptr== '/')ptr++;
		if(*ptr=='\\')ptr++;

		s_len = AddBackSlash('/',s_dir,s_off);		// "/root/"
		t_len = AddBackSlash('/',t_dir,t_off);		// "D:/temp/"

		t_len = strlcpy(t_dir+t_len,ptr,sizeof(t_dir)-t_len)+t_len;
		s_len = strlcpy(s_dir+s_len,ptr,sizeof(s_dir)-s_len)+s_len;

		s_len = AddBackSlash('/',s_dir,s_len);		// "/root/.../"
		t_len = AddBackSlash('/',t_dir,t_len);		// "D:/temp/.../"

		dirs.Del(0);

		if(!ftp_t->SetCurrentDirectory(t_dir))
		if(!ftp_t->CreatePath         (t_dir))
			{
			text = "Kann FTP-Verzeichnis nicht erzeugen";
			exit = -1;
			break;
			}


		if(Art&0x129)								// Dateien am Ziel-FTP-Server einlesen
			{
			list.Del();
			list.DataLength(sizeof(FtpFileData));
			find = new CFtpBaseFind(ftp_t);

			if(dlg_view)dlg_view->SetBreak(FtpBreak,ftp_s);
			ok = find->FindFile(t_dir,Plus,Minus,INTERNET_FLAG_NO_DIRS);
			if(dlg_view)dlg_view->SetBreak();

			while(ok)
				{
				ok        = find->FindNextFile();
				name      = find->GetFileName();
				data.size = find->GetLength();
				data.time = find->GetLastWriteTime();
				data.only = find->IsReadOnly();
				list.Add(name,CSC_END,&data);
				}

			find->Close();
			delete find;
			find = 0;

			list.Sort(0,-1,CSC_SORT_CASE);
			}


		     find=new CFtpBaseFind(ftp_s);			// Dateien am Quell-FTP-Server einlesen
		ok = find->FindFile(s_dir,Plus,Minus,INTERNET_FLAG_NO_DOTS|INTERNET_FLAG_ALL_DIRS);


		t_len = AddBackSlash('/',t_dir,t_len);
		s_len = AddBackSlash('/',s_dir,s_len);


		while(ok && exit!=-2)						// Einzelne Datei-Kopier-Schleife
			{
			if(dlg_view && dlg_view->IsBreak())dlg_break=1;
			if(dlg_break){exit=-2;break;}

			ok   = find->FindNextFile ();
			name = find->GetFileName  ();
			attr = find->GetAttributes()>>16;
			size = strlcpy(s_dir+s_len,name,sizeof(s_dir)-s_len);
				   strlcpy(t_dir+t_len,name,sizeof(t_dir)-t_len);

			if(find->IsDirectory())					// Verzeichnis gefunden
				{
				if(Unter==0)continue;
				if(IsLockPath(t_dir+t_off,size))	// Verzeichnis auslassen
					{
					continue;
					}

				dirs.Add(s_dir+s_off);
				continue;
				}

			if(Art&0x129)							// Datum und Attribute prfen
				{
				   pos = list.FindFast(name,0,-1,0x01);
				if(pos>=0)
					{
					data = *(FtpFileData*)list.Data(pos);
					diff = find->GetLastWriteTime()-data.time;
					list.Del(pos);

					if((Art&0x08)             )continue;	// Vorhandene Dateien nie berschreiben
					if((Art&0x20) && data.only)continue;	// Schreibgeschtzte nicht berschreiben
					if((Art&0x01) && diff>-59 )continue;	// Prfe Zeit
					}
				}

			if(dlg_view)							// Ausgabe in Dialog ?
				{
				dlg_view->SetPos (tick&0x0F);
				dlg_view->SetText(s_url,s_dir,0,0);
				dlg_view->SetText(t_url,t_dir,1,0);
				tick++;
				}

			if(dlg_view)dlg_view->SetBreak(FtpBreak,ftp_s);
			x = ftp_s->GetFile(s_dir,temp,0);		// Datei herunterladen
			if(dlg_view)dlg_view->SetBreak();

			if(!x)									// Gab es einen Fehler
				{
				if(Art&2)
					{
					msg.Format("Fehler beim Herunterladen von:\n%s",s_dir);
					if(dlg_view)x=dlg_view->MessageBox(msg,0,MB_ICONERROR|MB_OKCANCEL);
					else		x=          MessageBox(msg,0,MB_ICONERROR|MB_OKCANCEL);
					if(x==IDCANCEL){exit=-2;break;}
					}

 				exit=-1;
				continue;
				}

			if(dlg_view)dlg_view->SetBreak(FtpBreak,ftp_s);
			x = ftp_t->PutFile(temp,t_dir);			// Datei hinaufladen
			if(dlg_view)dlg_view->SetBreak();

			if(!x)
				{
				if(Art&2)
					{
					msg.Format("Fehler beim Hinaufladen von:\n%s",t_dir);
					if(dlg_view)x=dlg_view->MessageBox(msg,0,MB_ICONERROR|MB_OKCANCEL);
					else		x=          MessageBox(msg,0,MB_ICONERROR|MB_OKCANCEL);
					if(x==IDCANCEL){exit=-2;break;}
					}

				exit=-1;
				continue;
				}

			kopie_anz++;

			if(!attr && !CmpFileType(name,"so"))	// Execute Flags setzen
				{
				x = LoadMemory(temp,exedata,8);

				if(x>=4 && (!memcmp(exedata,"\177ELF",4) || !memcmp(exedata,"#!",2)))
					{
					attr = (0755<<16)|FILE_ATTRIBUTE_EXEC;
					}
				}

			if(attr)								// Attribute setzen
				{
				ftp_t->SetAttributes(t_dir,attr);
				}
			}


		if(Art&0x100)								// berzhlige Dateien aus FTP-Verzeichnis lschen
			{
			if(DeleteFtp(ftp_t,t_dir,list,Art,&tick))exit=-2;
			}

		find->Close();
		delete find;
		find = 0;
		}

	RemoveFile(temp);

	}while(0);

//*****************************************************************************

else if(s_mode!=FTP_MODE_NONE)
do	{
	s_mode |= FTP_MODE_RECONN|FTP_MODE_RETRY;

	try	{											// FTP-Verbindung ffnen
		server  [0] = 0;
		passwd  [0] = 0;
		username[0] = 0;
		port        = 0;

		strparseurl(Quelle,server,sizeof(server),username,passwd,&port,0,path,sizeof(path)|STR_NOROOTSIGN);

		if(!server  [0])throw "Falscher FTP-Server-Name";
		if(!username[0])throw "Falscher User-Namen";

		if(dlg_view)								// Ausgabe in Dialog ?
			{
			dlg_view->SetRange(16);
			dlg_view->SetPos  (0);
			dlg_view->SetText(server,0,0);
			dlg_view->SetText(Ziel  ,1,0);
			}


		ftp_s = GetFtpConnectionEx(server,username,passwd,port,s_mode|FTP_MODE_RECONN,path);

													// Ab lokalen Pfad
		if(path[0]=='.' && (path[1]==0 || path[1]=='/' || path[1]=='\\'))
			{
			if(!ftp_s->GetCurrentDirectory(name))throw "Kann aktuelles Verzeichnis nicht abfragen";
			if(path[1]){AddBackSlash(name,'/');name+=path+2;}
			strlcpy(path,name,sizeof(path));
			}

		if(path[0]!='/' && path[1]!='\\')			// Slash an den Anfang
			{
			strpre(path,"/");
			}

		PathConvert (path,'/');
		DelBackSlash(path);

		s_url  = ftp_s->GetProtocol  ();			// Pfad als URL holen "ftp://192.168.0.1
		s_url += ftp_s->GetServerName();
		}
	catch(char *error)
		{
		text = error;
		exit = -1;
		break;
		}
	catch(CInternetException *error)
		{
		text = ErrorToText(error->m_dwError,"Keine Verbindung zum FTP-Server");
		exit = -1;
		break;
		}
	catch(...)
		{
		text = "Keine Verbindung zum FTP-Server";
		exit = -1;
		break;
		}

	if(dlg_view && dlg_view->IsBreak())dlg_break=1;
	if(dlg_break){exit=-2;break;}
	if(dlg_view )dlg_view->SetBreak(FtpBreak,ftp_s);

	dirs.Add(path);

	s_off	= dirs.Len(0);
	t_off   = strlcpy(t_dir,Ziel,sizeof(t_dir));	// Lokalen Basispfad erzeugen
	t_off   = DelBackSlash(t_dir,t_off);

	tick++;


	while(dirs.Count()>0 && exit!=-2)				// Verzeichnis Schleife
		{
		if(dlg_view && dlg_view->IsBreak())dlg_break=1;
		if(dlg_break){exit=-2;break;}

		fpath = dirs.Get(0);
		size  = dirs.Len(0);

		s_len = strlcpy(s_dir      ,fpath      ,sizeof(s_dir),size);
		t_len = strlcpy(t_dir+t_off,fpath+s_off,sizeof(t_dir)-t_off)+t_off;

		s_len = AddBackSlash('/',s_dir,s_len);		// "/root/"
		t_len = AddBackSlash(    t_dir,t_len);		// "D:/temp/"

		list.Del( );
		dirs.Del(0);

		PathConvert(t_dir+t_off);
		CreatePath (t_dir);

		find  = new CFtpBaseFind(ftp_s);			// Dateien im FTP-Verzeichnis suchen
		ok    = find->FindFile(s_dir,Plus,Minus,INTERNET_FLAG_NO_DOTS|INTERNET_FLAG_ALL_DIRS);

		while(ok && exit!=-2)
			{
			if(dlg_view && dlg_view->IsBreak())dlg_break=1;
			if(dlg_break){exit=-2;break;}

			ok   = find->FindNextFile();
			name = find->GetFileName();

			strlcpy(s_dir+s_len,name,sizeof(s_dir)-s_len);
			strlcpy(t_dir+t_len,name,sizeof(t_dir)-t_len);


			if(find->IsDirectory())					// Verzeichnis gefunden
				{
				if(Unter && !IsLockPath(s_dir+s_off))
					{
					dirs.Add(s_dir);				// Im diesem Verzeichnis weitersuchen
					}

				continue;
				}


			if(Art&0x100)list.Add(name);			// List mit gefundenen Dateien

			find->GetLastWriteTime(&zeit);

			if(!CheckLocal(t_dir,&zeit,Art))		// Lokale Dateien berschreiben ?
				{
				continue;
				}

			if(dlg_view)							// Ausgabe in Dialog ?
				{
				if(dlg_view->IsBreak()){dlg_break=1;exit=-2;break;}
				dlg_view->SetPos (tick&0x0F);
				dlg_view->SetText(s_url,s_dir,0,0);
				dlg_view->SetText(t_dir     ,1,0);
				tick++;
				}

		Retry2:

			if(!ftp_s->GetFile(s_dir,t_dir,0))		// Datei kopieren
				{
				if(dlg_view && dlg_view->IsBreak())	// Prfen auf Benutzerabbruch
					{
					RemoveFile(t_dir);
					dlg_break =  1;
					exit      = -2;
					break;
					}

				if(Art&2)
					{
					msg.Format("Fehler beim Herunterladen von:\n%s",s_dir);
					if(dlg_view)x=dlg_view->MessageBox(msg,0,MB_ICONERROR|MB_ABORTRETRYIGNORE);
					else		x=          MessageBox(msg,0,MB_ICONERROR|MB_ABORTRETRYIGNORE);
					if(x==IDABORT){exit=-2;break;}
					if(x==IDRETRY){goto   Retry2;}
					}

 				exit=-1;
				}
			else{
				kopie_anz++;
				}
			}


		if(Art&0x100)								// berzhlige Dateien lokal lschen
			{
			t_dir[t_len] = 0;

			suche.Set (t_dir,0,Plus,Minus);
			list .Sort(0,-1,CSC_SORT_CASE);

			while(!dlg_break && suche.Next())
				{
				if(list.FindFast(suche.Name(),0,-1,1)>=0)
					{
					continue;
					}

				if(dlg_view)						// Ausgabe in Dialog ?
					{
					if(dlg_view->IsBreak())dlg_break=1;
					dlg_view->SetPos (tick&0x0F);
					dlg_view->SetText("Lsche Dateien",0,0);
					dlg_view->SetText(suche.Name(-1,1),1,0);
					tick++;
					}

				if(RemoveFile(suche.Name(-1,1)))continue;

				if(Art&2)
					{
					msg.Format("Fehler beim Lschen von:\n%s",suche.Name(-1,1));
					if(dlg_view)x=dlg_view->MessageBox(msg,0,MB_ICONERROR|MB_OKCANCEL);
					else		x=          MessageBox(msg,0,MB_ICONERROR|MB_OKCANCEL);
					if(x==IDCANCEL){exit=-2;break;}
					}
				}
			}

		find->Close();
		delete find;
		find = 0;
		}

	}while(0);

//*****************************************************************************

else if(t_mode!=FTP_MODE_NONE)
do	{
	t_mode |= FTP_MODE_RECONN|FTP_MODE_RETRY;

			 flags =CFF_FIND_ALL;
	if(Unter)flags|=CFF_FIND_SUBDIR;

	if(dlg_view)									// Ausgabe in Dialog
		{
		dlg_view->SetText("Suche lokale Dateien in",0,0);
		dlg_view->SetText(Quelle,1,0);
		dlg_view->SetBreak(FindBreak,&suche);
		}

	suche.Read(Quelle,flags,Plus,Minus);			// Suche Dateien im lokalen Verzeichnis
	size_all = (int)suche.GetSizeAll();

	if(dlg_view)									// Prfen auf Benutzerabbruch
		{
		   dlg_view->SetRange((int)size_all);
		   dlg_view->SetBreak();
		if(dlg_view->IsBreak())
			{
			dlg_break =  1;
			exit      = -2;
			goto Done;
			}
		}

	try	{											// FTP-Verbindung ffnen
		server  [0] = 0;
		passwd  [0] = 0;
		username[0] = 0;
		port        = 0;

		strparseurl(Ziel,server,sizeof(server),username,passwd,&port,0,path,sizeof(path)|STR_NOROOTSIGN);

		if(!server  [0])throw "Falscher FTP-Server-Name";
		if(!username[0])throw "Falscher User-Namen";

		if(dlg_view)								// Ausgabe in Dialog ?
			{
			dlg_view->SetPos  (0);
			dlg_view->SetText(Quelle,0,0);
			dlg_view->SetText(server,1,0);
			}

		ftp_t = GetFtpConnectionEx(server,username,passwd,port,t_mode|FTP_MODE_RECONN,path);

													// Ab lokalen Pfad
		if(path[0]=='.' && (path[1]==0 || path[1]=='/' || path[1]=='\\'))
			{
			if(!ftp_t->GetCurrentDirectory(name))throw "Kann aktuelles Verzeichnis nicht abfragen";
			if(path[1]){AddBackSlash(name,'/');name+=path+2;}
			strlcpy(path,name,sizeof(path));
			}

		if(path[0]!='/' && path[1]!='\\')			// Slash an den Anfang
			{
			strpre(path,"/");
			}

		PathConvert (path,'/');
		DelBackSlash(path);

		t_url  = ftp_t->GetProtocol  ();			// Pfad als URL holen "ftp_t://192.168.0.1
		t_url += ftp_t->GetServerName();
		}
	catch(char*)
		{
		text = "Falsche Ftp-Server-Name";
		exit = -1;
		break;
		}
	catch(CInternetException *error)
		{
		text = ErrorToText(error->m_dwError,"Keine Verbindung zum FTP-Server");
		exit = -1;
		break;
		}
	catch(...)
		{
		text = "Keine Verbindung zum FTP-Server";
		exit = -1;
		break;
		}


	if(dlg_view && dlg_view->IsBreak())dlg_break=1;
	if(dlg_break){exit=-2;break;}
	if(dlg_view)dlg_view->SetBreak(FtpBreak   ,ftp_t);
	if(dlg_view)dlg_view->SetTime (CopyPos,300,ftp_t);


	t_off   = strlcpy(t_dir,path,sizeof(t_dir));
	t_off   = AddBackSlash('/',t_dir,t_off);
	t_len	= t_off;
	PathConvert(t_dir,'/');
	path[0] = '*';
	path[1] = 0;
	ignore	= 1;
	tick   += 1;


	if(!ftp_t->SetCurrentDirectory(t_dir))			// FTP-Verzeichnis erstellen
	if(!ftp_t->CreatePath         (t_dir))
		{
		text = "Kann FTP-Verzeichnis nicht erzeugen";
		exit = -1;
		break;
		}

	while(exit!=-2)									// Datei Schleife
		{
		if(dlg_view && dlg_view->IsBreak())dlg_break=1;
		if(dlg_break){exit=-2;break;}


			ptr=suche.Next(1);						// z.B.  "D:/Temp/Data/Test.txt"
		if(!ptr)									// Wurden alle lokalen Dateien verarbeitet
			{
			if(!(Art&0x100) || ignore)break;
			t_dir[t_len]=0;
			if(DeleteFtp(ftp_t,t_dir,list,Art))		// Lscht berzhlige Dateien am FTP-Server
				{
				exit = -2;
				}

			break;
			}

		fname = suche.Name();						// z.B.  "Test.txt"
		fpath = suche.Path(-1,1);					// z.B.  "Temp/Data/"

		if(strcmp(path,fpath))						// Hat sich das Verzeichnis verndert
			{
			if((Art&0x100) && !ignore)				// Lscht berzhlige Dateien am FTP-Server
				{
				t_dir[t_len]=0;
				if(DeleteFtp(ftp_t,t_dir,list,Art))exit=-2;
				}

			x  =  strlcpy     (path       ,fpath,sizeof(path));
			x  =  strlcpy     (t_dir+t_off,fpath,sizeof(t_dir)-t_off,x);
			x  =  DelBackSlash(t_dir+t_off, x );
				  PathConvert (t_dir+t_off,'/');

			if(IsLockPath(t_dir+t_off,x-1))			// Verzeichnis auslassen
				{
				ignore = 1;
				continue;
				}
													// z.B.: "/root/xxx/"
			ignore = 0;
			t_len  = AddBackSlash('/',t_dir,t_off+x);

			if(!ftp_t->SetCurrentDirectory(t_dir))	// Verzeichnis am FTP-Server erstellen
			if(!ftp_t->CreatePath         (t_dir))
				{
				text = "Kann FTP-Verzeichnis nicht ffnen";
				exit = -1;
				break;
				}

			if(Art&0x129)							// Dateien am FTP-Server einlesen
				{
				list.Del();
				list.DataLength(sizeof(FtpFileData));
				find = new CFtpBaseFind(ftp_t);
				ok   = find->FindFile(t_dir,Plus,Minus,INTERNET_FLAG_NO_DIRS);

				while(ok)
					{
					ok        = find->FindNextFile();
					name      = find->GetFileName();
					data.size = find->GetLength();
					data.time = find->GetLastWriteTime();
					data.only = find->IsReadOnly();
					list.Add(name,CSC_END,&data);
					}

				find->Close();
				delete find;
				find=0;

				list.Sort(0,-1,CSC_SORT_CASE);
				}
			}

		if(ignore)continue;							// Wird das Verzeichnis ausgelassen



		if(Art&0x129)								// Datum und Attribute prfen
			{
			   pos = list.FindFast(fname,0,-1,0x01);
			if(pos>=0)
				{
				data = *(FtpFileData*)list.Data(pos);
				list.Del(pos);

				if((Art&0x08)                           )continue;	// Vorhandene Dateien nie berschreiben
				if((Art&0x20) && data.only              )continue;	// Schreibgeschtzte nicht berschreiben
				if((Art&0x01) && suche.Time()<=data.time)continue;	// Zeit prfen
				}
			}


		strlcpy(t_dir+t_len,fname,sizeof(t_dir)-t_len);

		if(dlg_view)								// Ausgabe in Dialog ?
			{
			sprintf(temp,"%s%s",(LPCSTR)t_url,t_dir);
			dlg_view->SetText(ptr  ,0,0);
			dlg_view->SetText(temp ,1,0);
			tick++;
			}

Retry3:
		size_max	 = suche.Len();
		size_mode    = 2;
		x = ftp_t->PutFile(ptr,t_dir);				// Datei hinaufladen
		size_offset += suche.Len();
		size_mode    = 1;


		if(!x)										// Fehler beim Hinaufladen
			{
			if(dlg_view && dlg_view->IsBreak())
				{
				dlg_break =  1;
				exit      = -2;
				break;
				}

			if(Art&2)
				{
				txt=ErrorToText(GetLastError(),"");
				msg.Format("Fehler beim Hinaufladen von:\n%s%s%s%s",t_dir,(*txt)? "\n(":"",txt,(*txt)? ")":"");
				if(dlg_view)x=dlg_view->MessageBox(msg,0,MB_ICONERROR|MB_ABORTRETRYIGNORE);
				else		x=          MessageBox(msg,0,MB_ICONERROR|MB_ABORTRETRYIGNORE);
				if(x==IDABORT){exit=-2;break;}
				if(x==IDRETRY)
					{
					size_offset -= suche.Len();
					goto Retry3;
					}
				}

			exit=-1;
			continue;
			}

		kopie_anz++;

		if(!CmpFileType(fname,"so"))				// Execute Flags setzen
			{
			x = LoadMemory(ptr,temp,8);

			if(x>=4 && (!memcmp(temp,"\177ELF",4) || !memcmp(temp,"#!",2)))
				{
				ftp_t->SetAttributes(t_dir,(0755<<16)|FILE_ATTRIBUTE_EXEC);
				}
			}
		}

	}while(0);


//*****************************************************************************
Done:


	size_mode	= 0;
	size_offset	= 0;


	if((Art&2) && text)
		{
		if(dlg_view)x=dlg_view->MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);
		else		x=          MessageBox(text,0,MB_ICONERROR|MB_OKCANCEL);

		if(x==IDCANCEL)exit=-2;
		else		   exit=-1;
		}

	if(dlg_view)
		{
		dlg_view->SetBreak();
		dlg_view->SetTime ();
		}

	if(ftp_t)
		{
		ftp_t->Close();
		delete ftp_t;
		}

	if(ftp_s)
		{
		ftp_s->Close();
		delete ftp_s;
		}


return exit;
}

//*****************************************************************************
//*
//*     CopySynch
//*
//*****************************************************************************
//  Synchonisiert eine Serie von Dateien
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopySynch(char *Quelle, char *Ziel, char *Plus, char *Minus, int Unter,char *Zusatz,int Art)
{
CFileFinder		*suche,suche1,suche2;
unsigned		 len_max=0,len_pos=0;
char			*name,puffer[MAX_PATH+1024+16],mem[MAX_PATH+1024+16];
int				 x,y,pos,mem_len=-1,error=0,snr=0,dir=0;
SysFind			 f;
SysFindStruct   *find1;
SysFindStruct	 find;
SysUtc 			 zeit,zeit1;
int				 attr,attr1;
int				 diff;


	if(!Quelle || !*Quelle)return -1;
	if(!Ziel   || !*Ziel  )return -1;


//******************** Einzelne Datei synchronisieren *************************


	if(!CheckHost(&Zusatz))							// Hostnamen prfen
		{
		return 0;
		}

	x = ExistFile(Quelle);
	y = ExistFile(Ziel);

	size_offset	= 0;

	puffer[0] = 0;
	mem   [0] = 0;


	if(x==0 && y==0)								// Verzeichnisse existieren nicht
		{
		if(Zusatz && *Zusatz=='*')
			{
			return 0;
			}

		if(Art&2)
			{
			strcpy (mem,"Das Verzeichnis:\n");
			strlcat(mem,Quelle,MAX_PATH+1024);
			strlcat(mem,"\nkann nicht mit dem Verzeichnis:\n",MAX_PATH+1024);
			strlcat(mem,Ziel,MAX_PATH+1024);
			strlcat(mem,"\nsynchronisiert werden.",MAX_PATH+1024);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);
			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		return -1;
		}

	if(x==1 && y>1)									// Datei-Verzeichnis Fehler
		{
		if(Art&2)
			{
			strcpy (mem,"Die Datei:\n");
			strlcat(mem,Quelle,MAX_PATH+1024);
			strlcat(mem,"\nkann nicht mit dem Verzeichnis:\n",MAX_PATH+1024);
			strlcat(mem,Ziel,MAX_PATH+1024);
			strlcat(mem,"\nsynchronisiert werden.",MAX_PATH+1024);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);
			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		return -1;
		}

	if(x>1 && y==1)									// Verzeichnis-Datei Fehler
		{
		if(Art&2)
			{
			strcpy (mem,"Das Verzeichnis:\n");
			strlcat(mem,Quelle,MAX_PATH+1024);
			strlcat(mem,"\nkann nicht mit der Datei:\n",MAX_PATH+1024);
			strlcat(mem,Ziel,MAX_PATH);
			strlcat(mem,"\nsynchronisiert werden.",MAX_PATH+1024);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);
			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		return -1;
		}


//*****************************************************************************


	if(x==1 && y==1)								// Zwei einzelne Dateien
		{
		   f=SysFindFirst(Quelle,&find);
		if(f==0)x=0;								// Prfe ob Datei neuer
		else{
			SysFindClose(f);
			zeit=find.dwTimeWrite;
			attr=find.dwAttr;

			   f=SysFindFirst(Ziel,&find);
			if(f==0)y=0;
			else{
				SysFindClose(f);
				if(Art&0x08)return 0;				// Nie berschreiben

				zeit1 = find.dwTimeWrite;
				attr1 = find.dwAttr;
				diff  = zeit-zeit1;

				if(diff<2    && diff>   -2)return 0;// FAT-NTFS zwei Sekunden Sprung
				if(diff<3602 && diff>-3598)return 0;// FAT-NTFS Sommerzeitsprung
				if(diff<3598 && diff>-3602)return 0;//			*

				if(zeit< zeit1){x=0;if(Art&0x20 && !(attr &SYS_WRITE))return 0;}
				if(zeit> zeit1){y=0;if(Art&0x20 && !(attr1&SYS_WRITE))return 0;}
				}
			}
		}

	if(x==1 && y==0)								// Eine Datei kopieren
		{
		size_max = LengthFile(Quelle);

		if(dlg_view)								// Dateinamen anzeigen
			{
			dlg_view->SetTime(CopyPos,300,this);
			dlg_view->SetText(Quelle,0,0);
			dlg_view->SetText(Ziel  ,1,0);
			dlg_view->SetRange(size_max);
			}

		size_mode   = 3;							// Datei kopieren
		x = CopyFileProgress(Quelle,Ziel,&size_now,0,(dlg_view)? dlg_view->GetCancelPtr():0,CFP_TEMPRENAME|CFP_COPYTIME|CFP_READONLY|CFP_CREATEPATH);

		if(x==0 && dlg_view)						// Gab es einen Benutzterabbruch
			{
			if(dlg_view->IsBreak())dlg_break=1;
			}

		if(x<=0 && (Art&2) && !dlg_break)
			{
			strcpy (mem,"Fehler beim kopieren von:\n");
			strlcat(mem,Quelle     ,MAX_PATH+1024);
			strlcat(mem,"\nnach:\n",MAX_PATH+1024);
			strlcat(mem,Ziel       ,MAX_PATH+1024);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);

			if(x==IDCANCEL)
				{
				if(dlg_view)dlg_view->SetTime();
				dlg_break=1;
				return -2;
				}

			return -1;
			}

		if(dlg_view)dlg_view->SetTime();
		if(x>0)kopie_anz++;

		return (x)? 0:-1;
		}

	if(x==0 && y==1)								// Eine Datei kopieren (verkerhrt)
		{
		size_max = LengthFile(Ziel);

		if(dlg_view)								// Dateinamen anzeigen
			{
			dlg_view->SetTime(CopyPos,300,this);
			dlg_view->SetText(Ziel  ,0,0);
			dlg_view->SetText(Quelle,1,0);
			dlg_view->SetRange(size_max);
			}

		size_mode   = 3;							// Datei kopieren
		x = CopyFileProgress(Ziel,Quelle,&size_now,0,(dlg_view)? dlg_view->GetCancelPtr():0,CFP_TEMPRENAME|CFP_COPYTIME|CFP_READONLY|CFP_CREATEPATH);

		if(x==0 && dlg_view)						// Gab es einen Benutzterabbruch
			{
			if(dlg_view->IsBreak())dlg_break=1;
			}

		if(x<=0 && (Art&2) && !dlg_break)
			{
			strcpy (mem,"Fehler beim kopieren von:\n");
			strlcat(mem,Ziel       ,MAX_PATH+1024);
			strlcat(mem,"\nnach:\n",MAX_PATH+1024);
			strlcat(mem,Quelle     ,MAX_PATH+1024);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);

			if(x==IDCANCEL)
				{
				if(dlg_view)dlg_view->SetTime();
				dlg_break=1;
				return -2;
				}

			return -1;
			}

		if(dlg_view)dlg_view->SetTime();
		if(x>0)kopie_anz++;

		return (x)? 0:-1;
		}



//******************** Verzeichnisse synchronisieren **************************


	if((x==0 || y==0) && *Zusatz=='*')				// Nur existierene Verzeichnisse synchronisieren
		{
		return 0;
		}

	if(x==0 && !CreatePath(Quelle))					// Quellverzeichnis erstellen
		{
		if(Art&2)
			{
			strcpy (mem,"Das Verzeichnis:\n");
			strlcat(mem,Quelle,MAX_PATH+1024);
			strlcat(mem,"\nkonnte nicht erzeugt werden !",MAX_PATH+1024);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);
			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		return -1;
		}

	if(y==0 && !CreatePath(Ziel))					// Zielverzeichnis erstellen
		{
		if(Art&2)
			{
			strcpy (mem,"Das Verzeichnis:\n");
			strlcat(mem,Ziel,MAX_PATH+1024);
			strlcat(mem,"\nkonnte nicht erzeugt werden !",MAX_PATH+1024);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);

			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		return -1;
		}

			 x =CFF_FIND_ALL;
	if(Unter)x|=CFF_FIND_SUBDIR;

	suche2.Read(Ziel  ,x,Plus,Minus);
	suche1.Read(Quelle,x,Plus,Minus);


	len_max	= 0;									// Gesamtlnge berechnen

	for(x=0;x<suche1.Count();x++)len_max+=suche1.Len(x);
	for(x=0;x<suche2.Count();x++)len_max+=suche2.Len(x);


	if(dlg_view)									// Ausgabe in Dialog ?
		{
		dlg_view->SetTime(CopyPos,300,this);
		dlg_view->SetText(Quelle,0,0);
		dlg_view->SetRange(len_max);
		dlg_view->SetPos(0);
		}

	pos   = strlcpy(puffer,Ziel,sizeof(puffer)-16);	// Zielverzeichnis
	pos   = AddBackSlash(puffer);
	suche = &suche1;

	for(snr=0;;snr++)								// Dateien kopieren
		{
			name=suche->Next(1);
		if(!name)
			{
			if(dir)break;
			dir=1;
			suche=&suche2;
			name=suche->Next(1);
			if(!name)break;
			pos=strlcpy(puffer,Quelle,sizeof(puffer)-16);
			pos=AddBackSlash(puffer);
			}

		if(dlg_view)
			{
			if(dlg_view->IsBreak())dlg_break=1;
			   dlg_view->SetPos(size_offset);
			}

		if(dlg_break)break;							// Benutzer Abbruch ?


		strlcpy(puffer+pos,suche->Name(-1,2),MAX_PATH+1024-pos);

		   f=SysFindFirst(puffer,&find);
		if(f)										// Prfe ob Datei neuer
			{
			SysFindClose(f);
			find1 = suche->Info();
			diff  = find.dwTimeWrite-find1->dwTimeWrite;

			if((diff<2    && diff>   -2) ||			// FAT-NTFS zwei Sekunden Sprung
			   (diff<3602 && diff>-3598) ||			// FAT-NTFS Sommerzeitsprung
			   (diff<3598 && diff>-3602) ||			//			*
			   (find.dwTimeWrite>=find1->dwTimeWrite))
				{
				size_offset+=suche->Len(snr);
				if(dlg_view)dlg_view->SetPos(size_offset);
				continue;
				}
			}


		if(dlg_view)								// Dateinamen anzeigen
			{
			dlg_view->SetText(name  ,0,0);
			dlg_view->SetText(puffer,1,0);
			}

		   x=suche->IsDir();
		if(x)										// Pfad erzeugen
			{
			x=CreatePath(puffer);

			if(x<=0 && (Art&2) && !dlg_break)
				{
				strcpy (mem,"Der folgende Pfad konnte nicht erzeugt werden:\n\n");
				strlcat(mem,puffer,MAX_PATH+1024);
				if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				if(x==IDCANCEL)
					{
					dlg_break=1;
					return -2;
					}
				}
			}
		else{
			if(f)
				{
				if(Art&0x20 && !(attr&SYS_WRITE))continue;
				SetFileAttributes(puffer,FILE_ATTRIBUTE_NORMAL);
				}

			size_max     = suche->Len(snr);
			size_mode    = 3;						// Datei kopieren
			x            = CopyFileProgress(name,puffer,&size_now,0,(dlg_view)? dlg_view->GetCancelPtr():0,CFP_TEMPRENAME|CFP_COPYTIME|CFP_READONLY|CFP_CREATEPATH);

			if(x==0 && dlg_view)					// Gab es einen Benutzterabbruch
				{
				if(dlg_view->IsBreak())dlg_break=1;
				}

			if(x<=0 && (Art&2) && !dlg_break)
				{
				strcpy (mem,"Fehler beim Kopieren von:\n\n");
				strlcat(mem,puffer     ,MAX_PATH+1024);
				strlcat(mem,"\nnach:\n",MAX_PATH+1024);
				strlcat(mem,Quelle     ,MAX_PATH+1024);

				if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);

				if(x==IDCANCEL)
					{
					if(dlg_view)dlg_view->SetTime();
					dlg_break=1;
					return -2;
					}
				}
			}

		if(x>0)kopie_anz++;
		else   error=1;

		size_offset += suche->Len(snr);
		size_mode    = 1;

		if(dlg_view)dlg_view->SetPos(size_offset);
		}

	if(dlg_view)									// Verlaufsfukltion entferen
		{
		dlg_view->SetTime();
		}

	if(error)return -1;




return 0;
}

//*****************************************************************************
//*
//*     CopyBuffer
//*
//*****************************************************************************
//  Synchonisiert eine Serie von Dateien ber einen Zwischenpuffer.
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler
// 			-1	 bei einem Fehler
// 			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyBuffer(char *Quelle, char *Ziel, char *Plus, char *Minus, int Unter,char *Zusatz,int Art)
{
CSizeSynch	sync;
char		host[64];
char		mem[1024];
int			x,size;


	if(ExistFile(Ziel)!=2)							// Gibt es das Zielverzeichnis
		{
		sprintf(mem,"Das Verzeichnis:\n%s\nexistiert nicht !",Ziel);

		if(Art&2)
			{
			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);

			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		return -1;
		}

	sync.SetCallback(dlg_view,BufferProc);

	x = strchar(Zusatz,':');
	strlcpy(host,Zusatz,sizeof(host),x);
	if(Zusatz[x])x++;
	size=strtoi(Zusatz+x);


	if(!host[0])
		{
		sprintf(mem,"Es ist kein Hostname im Zusatz angegeben !\nFromat:   [Host:Gre]");

		if(Art&2)
			{
			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);

			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		return -1;
		}

	if(!stricmp(host,sync.GetHostname()))				// Ist man beim Quell-Rechner
		{
		if(ExistFile(Quelle)==1)
			{
			x=sync.Synch(Quelle,Ziel,host);
			}
		else{
			x=sync.CreateList(Quelle,Ziel,Plus,Minus,size);
			if(x>=0)x=sync.Synch(Quelle,Ziel,host);
			}
		}
	else{												// Am Zielrechner
		x=0;
		if(ExistFile(Quelle)==1)
			{
			x=sync.Synch(Quelle,Ziel,sync.GetHostname(),1);
			if(x==-2)
				{
				sprintf(mem,"Der Host %s ist noch nicht in der Backup-Liste\nSoll er eingefgt werden ?",sync.GetHostname());
				if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_YESNO);
				else		x=          MessageBox(mem,0,MB_ICONERROR|MB_YESNO);
				if(x==IDYES)x=sync.Synch(Quelle,Ziel);
				else	    x=0;
				}
			}
		}


	if(x<0)
		{
		sprintf(mem,"Es gab einen Fehler bei\n%s",Quelle);

		if(Art&2)
			{
			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OK);

			if(x==IDCANCEL)
				{
				dlg_break=1;
				return -2;
				}
			}

		return -1;
		}



	kopie_anz+=x;


return 0;
}


//*****************************************************************************
//*
//*		BufferProc
//*
//*****************************************************************************
//	Callback fr synchronisierung ber einen Puffer.
//	Ergibt 1 bei einem User-Abbruch.
int _cdecl CBackupView::BufferProc(void *Param,int Mode,const char *Text)
{
CProgressDialog	   *dlg=(CProgressDialog*)Param;
char				text[1024];


	if(!dlg)return 0;

	switch(Mode)
		{
	case SSY_STOP:										break;
	case SSY_SCAN:		sprintf(text,"Scanne %s" ,Text);break;
	case SSY_COPY:		sprintf(text,"Kopiere %s",Text);break;
	case SSY_DELETE:	sprintf(text,"Lsche %s" ,Text);break;
	case SSY_MESSAGE:	sprintf(text,"%s",Text);		break;
	default:			sprintf(text,"%s",Text);		break;
		}


return dlg->IsBreak();
}

//*****************************************************************************
//*
//*		CopyVersion
//*
//*****************************************************************************
//  Kopiert eine Versionsnummer von einer Quelldatei in eine Zieldatei
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyVersion(char *Quelle, char *Ziel, char *Plus, char *Minus, int Unter,char *Zusatz,int Art)
{
FILE   *file;
char   *ptr;
char	name   [256];
char	temp   [128];
char	filter1[128];
char	filter2[128];
int		len1;
int		len2;
int		len3;
int		num;
int		ret;




	if(!strcmp(Quelle,"DATE"))
		{
		switch(*Plus)
			{
		case 'a':	strtimeset(temp,time(0),		    STR_ALL_ISO);				Plus++;	break;
		case 'A':	strtimeset(temp,time(0),STR_WEEKDAY|STR_ALL_ISO);				Plus++;	break;
		case 'i':	strtimeset(temp,time(0),            STR_LONG|STR_DATE_ISO);		Plus++;	break;
		case 'I':	strtimeset(temp,time(0),STR_WEEKDAY|STR_LONG|STR_DATE_ISO);		Plus++;	break;
		case 'd':	strtimeset(temp,time(0),            STR_LONG|STR_DATE|STR_ABC);	Plus++;	break;
		case 'D':	strtimeset(temp,time(0),STR_WEEKDAY|STR_LONG|STR_DATE|STR_ABC);	Plus++;	break;
 		default:	strtimeset(temp,time(0),STR_WEEKDAY|STR_LONG|STR_DATE|STR_ABC);			break;
			}

		strcut(temp);

			Plus += strlchar(Plus,':');
		if(*Plus)
			{
			strtomem(name,sizeof(name)-1,Plus,&num);
			name[num]=0;
			strreplace(name,"%s",temp,sizeof(name));
			}
		else{
			strcpy(name,temp);
			}

		ret = 1;
		}
	else if(CmpFileType(Quelle,"exe;dll;sys;ocx"))
		{
		ret = GetVersionOfExec(Quelle,0,name,sizeof(name));
		}
	else{
		ret = GetVersionOfText(Quelle,Plus,name,sizeof(name));
		}

	if(ret<=0)return -1;

	Minus += strwlen  (Minus,0xE0);
	Minus += strgetstr(filter1,Minus,sizeof(filter1));
	Minus += strwlen  (Minus,0xE0);
	Minus += strgetstr(filter2,Minus,sizeof(filter2));

	if(!filter1[0])return -1;
	if(!filter2[0])return -1;

	   len1 = LengthFile(Ziel);
	if(len1<=0)return -1;

	ptr = new char[len1+2];


	if(LoadMemory(Ziel,ptr,len1+2)!=len1)
		{
		delete ptr;
		return -1;
		}


	   len2 = strlifind(ptr,filter1,len1);
	if(len2<0)
		{
		delete ptr;
		return -1;
		}


	   len2 += strlen(filter1);
	   len3  = strlifind(ptr+len2,filter2,len1-len2);
	if(len3<0 || len3>256)
		{
		delete ptr;
		return -1;
		}

	num = strlen(name);

	if(num==len3 && !memcmp(ptr+len2,name,num))
		{
		return 0;
		}


		file = fopen(Ziel,"wb");
	if(!file)
		{
		delete ptr;
		return -1;
		}


	fwrite(ptr,len2,1,file);
	fprintf(file,"%s",name);
	fwrite(ptr+len2+len3,len1-len2-len3,1,file);
	fclose(file);

	delete ptr;


	kopie_anz++;


return -1;
}

//*****************************************************************************
//*
//*     CopyShrink
//*
//*****************************************************************************
//  Kopiert eine Serie von Dateien und lscht alle ber zeligen
//  Ist bei Art Bit0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit3!=0 wird eine vorhandene Datei nie berschrieben
//  Ist bei Art Bit5!=0 wird eine schreibgeschtzte Datei nicht berschrieben
//	In Zusatz werden die Intervalle und Startpunkte in Tagen festgelegt:
//		"int1,day2,int2,day3,int3 ... ;<weiter zu SubCopy>"
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyShrink(char *Quelle, char *Ziel,char *Plus, char *Minus, int Unter,char *Zusatz,int Art)
{
CFileFinder		 suche;
SysFindStruct	 find;
SysFind			 f;
char			*name;
char			 target[MAX_PATH+1024+16];
char			 puffer[MAX_PATH+1024+16];
char			 mem   [MAX_PATH+1024+16];
unsigned		 ok,now,ftime,off,max,last;
int				 len,dir,list[10],list_size;
int				 x,y,level,pos,ret,high;
int				 end,val,diff,step;




	target[0] = 0;
	puffer[0] = 0;
	list  [0] = 0;
	mem   [0] = 0;

	for(list_size=1;;)								// Verdichtungsparamteter holen
		{
		y = strtoi(Zusatz,0,&x);

		if(list_size<10 && x>0)
			{
			list[list_size]=y;
			list_size++;
			}

		Zusatz += x;
		Zusatz += strwlen(Zusatz,0x02);
		if(*Zusatz>='0' && *Zusatz<='9')continue;
		if(*Zusatz==','){Zusatz++;continue;}
		break;
		}


	if(list_size==1)
		{
		list[1]= 7;
		list[2]=28;
		list[3]=28;
		list[4]=28*3;
		list[5]=28*3;
		list[6]=365;
		list[7]=365;
		list_size = 8;
		}
	else{
		if(list_size<=1){list[1]= 7;list_size++;}
		if(list_size<=2){list[2]=28;list_size++;}
		if(list_size<=3){list[3]=28;list_size++;}
		}

	if(list_size&1)
		{
		list_size--;
		}


	for(x=2;x<list_size;x+=2)					// Prfe die Startwerte
		{
		if(list[x]<=0)list[x]=1;
		if(list[x]<list[x-2])
			{
			list[x] = list[x-2];
			}
		}

	for(x=1;x<list_size;x+=2)					// Prfe die Intervalle
		{
		if(list[x]<=0)list[x]=1;
		if(x>1 && list[x]<list[x-2])
			{
			list[x] = list[x-2]*2;
			}
		}

	Zusatz += strwlen(Zusatz,0x02);
	if(*Zusatz==';')Zusatz++;


	   dir = ExistFile(Quelle);					// Quelle prfen
	if(dir<=0)
		{
		if(Art&2)
			{
			sprintf(mem,"Die Datei '%s' wurde nicht gefunden !",Quelle);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			}

		return -1;
		}
	else if(dir>=3)
		{
		if(Art&2)
			{
			sprintf(mem,"Das Laufwerk '%s' kann nicht verdnnt werden !",Quelle);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			}

		return -1;
		}

	dir--;

	off=strchar(Ziel,'#');						// Spezialpfad

	if(Ziel[off+1]>='1' && Ziel[off+1]<='5')
		{
		ok = Ziel[off+1]-'0';
		}
	else if(Ziel[off+1]=='D' || Ziel[off+1]=='d')
		{
		ok = 16;
		}
	else{
		ok = 0;
		}
												// Ist der Spezialpfad
	if(Ziel[off]!='#' || Ziel[off+2]!='#' || !ok)
		{
		if(Art&2)
			{
			sprintf(mem,"Es wurde kein Spezialpfad in '%s' gefunden !",Ziel);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			}

		return -1;
		}


//******************** Suche vorhandene Dateien/Ordner ************************

	now  = time(0);
	now /= 24*3600;
	max  = 0;
	last = 0;

	len  = strcwlen(Ziel+off,0x00300000)+off;
	strlcpy(mem,Ziel,sizeof(mem),len);

	x   = strlcpy(puffer,mem,sizeof(puffer)-8,off);
	puffer[x] = '*'; x++;
	x  += strlcpy(puffer+x,mem+off+3,sizeof(puffer)-x);

	   pos = off-FilePathLen(mem);
	if(pos<0)
		{
		if(Art&2)
			{
			sprintf(mem,"Falsche Pfadangebe '%s' !",mem);

			if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
			}

		return -1;
		}


	if(dlg_view)
		{
		dlg_view->SetText("Suche vorhandene Eintrge.");
		}

	if(CmpFileType(Ziel,"zip"))				// Zu ZIP-Datei komprimieren
		{
		dir = 1;
		suche.Set(puffer,CFF_FIND_ALL);
		}
	else{
		suche.Set(puffer,(dir)? CFF_FIND_DIR|CFF_FIND_ALL:CFF_FIND_ALL);
		}


	for(;;)
		{
			name = suche.Next();
		if(!name)break;

		if(ok==16)							// Aus Dateinamen
			{
			ftime  = strtoutc(name+pos,STR_DATE);
			}
		else{								// Aus Dateizeit
			ftime  = suche.Info()->dwTimeCreate;
			}

		if(ftime==0 || ftime>0xFFFF0000)
			{
			suche.SetData(-1);
			continue;
			}

		ftime /= 24*3600;
		x	   = now-ftime;

		suche.SetData(x);					// Speichere Differenz

		if(ftime>max)						// Jngstes Datum
			{
			max = ftime;
			}
		}


//******************** Neue Datei bzw. Ordner erzeugen ************************


	if(ok==16)
		{
		FileDateRename(Ziel,target,sizeof(target));
		}
	else{
		FileCountRename(Ziel,target,sizeof(target),0x80000000);

		   f=SysFindFirst(target,&find);
		if(f)
			{
			SysFindClose(f);
			find.dwTimeCreate /= 24*3600;

			if(find.dwTimeCreate+list[1]<=now)
				{
				FileCountRename(Ziel,target,sizeof(target));
				}
			}
		}


	if(max+list[1]<now)
		{
		if(dir)										// Verzeichnis
			{
			if(CmpFileName(Quelle,target))
			if(ExistFile(target)!=2)
				{
				if(CmpFileType(target,"zip"))		// Zu ZIP-Datei
					{
					x   = CopyZip(Quelle,target,Plus,Minus,Unter,Zusatz,Art&0xFFFFF3FF);
					dir = 0;
					}
				else{
						  CreatePath(target);
						  AddBackSlash(target);
					x   = CopyPath(Quelle,target,Plus,Minus,Unter,Zusatz,Art);
					}

				if(x<0)return x;
				last=now;
				}
			}
		else{										// Datei
			if(CmpFileName(Quelle,target))
			if(ExistFile(target)!=1)
				{
				x = CopySingle(Quelle,target,Plus,Minus,Unter,Zusatz,Art);
				if(x<0)return x;
				last=now;
				}
			}
		}


//******************** berzhlige Dateien/Ordner lschen *********************


	suche.Sort(CFF_SORT_DATA,CFF_SORT_NODIR);
	suche.Reset();


	   ret = 0;
	   end = (last)? 0:1;
	   pos = suche.Count()-1;
	if(pos<=1)return 0;


	high = suche.GetData(pos);


	for(pos--;pos>end;pos--)
		{
		if(dlg_view && dlg_view->IsBreak())			// User-Abbruch
			{
			ret = -1;
			break;
			}

			name = suche.NameFull(pos);
		if(!name)break;

		val	= suche.GetData(pos);

		for(level=0;level<list_size/2-1;level++)
			{
			if(val<list[level*2+2])break;
			}

		step  = list[level*2+1];
		diff  = high-val;

		if(diff>=step)								// Abstand ist gro genug
			{
			high = val;
			continue;
			}

		if(dlg_view)
			{
			sprintf(puffer,"Lsche '%s'",name);
			dlg_view->SetText(puffer,0,0);
			}

		for(;;)
			{
			if(suche.IsDir())						// Lsche die Datei bzw. den Pfad
					x=RemovePath(name);
			else	x=RemoveFile(name);


			if(x)
				{
				kopie_anz++;
				break;
				}

			if(Art&2)
				{
				sprintf(mem,"Fehler beim Lschen von '%s'",name);

				if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_ABORTRETRYIGNORE);
				else		x=          MessageBox(mem,0,MB_ICONERROR|MB_ABORTRETRYIGNORE);

				if(x==IDRETRY ){		 continue;}
				if(x==IDIGNORE){ret = -1;continue;}

				ret = -2;
				break;
				}
			}
		}



return ret;
}

//*****************************************************************************
//*
//*		OnFieldCopy
//*
//*****************************************************************************
//	Ein Feld in der Dateiliste kopieren
void CBackupView::OnFieldCopy()
{
HTREEITEM	hItem;
LPCTSTR		pText;
int			iCol;



		hItem = list_view.GetFocusItem();
	if(!hItem)return;

	iCol = list_view.GetFocusColumn();

		pText = list_view.GetItemText(hItem,iCol);
	if(!pText)return;

	SetClipboardText(pText);


}

//*****************************************************************************
//*
//*		OnFullCopy
//*
//*****************************************************************************
//	Einen Pfad der Dateiliste kopieren, und $(...) auf lsen
void CBackupView::OnFullCopy()
{
CHAR		cBuffer[1024];
CString		sPath;
HTREEITEM	hItem;
LPCTSTR		pText;
CDocument  *pDoc;
int			iCol;


		pDoc = GetDocument();
	if(!pDoc)return;

	   sPath = pDoc->GetPathName();
	if(sPath.IsEmpty())
		{
		MessageBox("Die Backup-Datei hat noch keinen Dateinamen !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	GetFilePath(cBuffer,sPath,sizeof(cBuffer));
	DelBackSlash(cBuffer);

		hItem = list_view.GetFocusItem();
	if(!hItem)return;

	iCol = list_view.GetFocusColumn();

		pText = list_view.GetItemText(hItem,iCol);
	if(!pText)return;


	strlcpy(cBuffer,pText,sizeof(cBuffer));
	pText=VarConvert(cBuffer,sizeof(cBuffer));

	SetClipboardText(pText);


}

//*****************************************************************************
//*
//*		OnMakeRel
//*
//*****************************************************************************
//	Einen Pfad zu einem relativen Pfad machen
void CBackupView::OnMakeRel()
{
CHAR		cTarget[1024]="$(BKU_PATH)\\";
CHAR		cBuffer[1024];
CString		sPath;
HTREEITEM	hItem;
LPCTSTR		pText;
CDocument  *pDoc;
int			iCol;
int			iRet;



		pDoc = GetDocument();
	if(!pDoc)return;

	   sPath = pDoc->GetPathName();
	if(sPath.IsEmpty())
		{
		MessageBox("Die Backup-Datei hat noch keinen Dateinamen !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	GetFilePath(cBuffer,sPath,sizeof(cBuffer));
	DelBackSlash(cBuffer);

		hItem = list_view.GetFocusItem();
	if(!hItem)return;

	iCol = list_view.GetFocusColumn();

		pText = list_view.GetItemText(hItem,iCol);
	if(!pText)return;

	if(!strwchar(pText[0],0x06) || pText[1]!=':' || !strwchar(pText[2],0x00300000))
		{
		MessageBox("Der gewhlte Pfad ist kein absoluter Pfad !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(memicmp(pText,cBuffer,1))
		{
		MessageBox("Der gewhlte Pfad ist auf dem falschen Laufwerk !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	   iRet = PathOffset(cTarget+11,cBuffer,pText,sizeof(cTarget)-11);
	if(iRet<0)
		{
		MessageBox("Der gewhlte Pfad konnte nicht konvertiert werden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	list_view.SetItemText(hItem,cTarget,iCol);
	geaendert |= 1;

}

//*****************************************************************************
//*
//*		OnSetPath
//*
//*****************************************************************************
//	Ein Feld in der Dateiliste kopieren
void CBackupView::OnSetPath()
{
char		cText[MAX_PATH];
LPCTSTR		pName;
HTREEITEM	hItem;
int			iCol;
int			iOff;
int			iAdd;
int			iLen;


		hItem = list_view.GetFocusItem();
	if(!hItem)return;

	   iCol = list_view.GetFocusColumn();
	if(iCol>=2)return;

	if(!list_view.GetItemText(hItem,cText,sizeof(cText),iCol))
		{
		return;
		}

	pName = VarConvert(cText,sizeof(cText));
	iLen  = strlcpy(cText,pName,sizeof(cText));
	iOff  = strchar(cText,'#');								// Spezialpfad

	if((cText[iOff+1]>='1' && cText[iOff+1]<='5') ||
	   (cText[iOff+1]=='D' || cText[iOff+1]=='d') || cText[iOff+1]=='@')
		{
		if(cText[iOff+1]=='@')
			{
			iAdd  = strlchar(cText+iOff+1     ,'#');
			iAdd += strchar (cText+iOff+1+iAdd,'#');
			}
		else{
			iAdd = strchar(cText+iOff+1,'#');
			}

		if(cText[iOff+1+iAdd]=='#')
			{
			memmove(cText+iOff+1,cText+iOff+iAdd,iLen-iAdd+1);
			}
		}


	DelBackSlash(cText);

	if(ExistFile(cText)<2)
		{
		SubFileName(cText);
		}

	if(ExistFile(cText)<2)
		{
		return;
		}

	datei_view.SetPath(cText);



}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CBackupView::OnContextMenu(CWnd *pWnd, CPoint sPoint)
{
int			iFlags;
CMenu		sMenu;
HTREEITEM	hItem;
int			iCol;



	if(!pWnd)return;




	if(pWnd->m_hWnd!=list_view.m_hWnd)					// Im Dateilisten-Fenster
		{
		return;
		}

	sMenu.CreatePopupMenu();

	iCol   = list_view.GetFocusColumn();
	hItem  = list_view.GetFirstSelected();
	iFlags = (hItem==0)? MF_GRAYED:0;
	sMenu.AppendMenu(MF_STRING|iFlags,ID_FIELD_COPY,"Feld kopieren");
	iFlags = (hItem==0 || iCol>=2 || reg_on)? MF_GRAYED:0;
	sMenu.AppendMenu(MF_STRING|iFlags,ID_FULL_COPY ,"Vollen Pfad kopieren");

	sMenu.AppendMenu(MF_SEPARATOR);
	iFlags = (iCol>=2 || reg_on)? MF_GRAYED:0;
	sMenu.AppendMenu(MF_STRING|iFlags,ID_MAKE_REL  ,"Relativen Pfad erzeugen");
	iFlags = (iCol>=2 || reg_on)? MF_GRAYED:0;
	sMenu.AppendMenu(MF_STRING|iFlags,ID_SET_PATH  ,"Pfad ffnen");

	if((iCol==3 || iCol==2) && !reg_on)
		{
		filter_pos = iCol;
		sMenu.AppendMenu(MF_STRING,ID_DOFILTER  ,"Filterstellungen");
		}
	else{
		iFlags = (iCol!=6 || reg_on)? MF_GRAYED:0;
		sMenu.AppendMenu(MF_STRING|iFlags,ID_SETTINGS  ,"Spezialeinstellungen");
		}



	sMenu.TrackPopupMenu(0,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();


}

//*****************************************************************************
//*
//*		CheckHost
//*
//*****************************************************************************
//	Hostnamen prfen
//	Ergibt 1 wenn der Hostnamen ungleich oder nicht angegeben ist sonst 0.
int CBackupView::CheckHost(char **Zusatz)
{
static char		host[32];
char		   *ptr;
int				num;
int				ret;



	ptr = *Zusatz;

	if(!ptr || ptr[0]!='*' || ptr[1]!='[')
		{
		return 1;
		}


	ptr += 2;

	if(!host[0])
		{
		WSADATA		data;

		WSAStartup(2,&data);
		gethostname(host,sizeof(host));
		}


	for(num=0;ptr[num];num++)
		{
		if(ptr[num]==';')break;
		if(ptr[num]==']')break;
		}

	ret = 1;

	if(strnicmp(ptr,host,num))
		{
		ret = 0;
		}
	else if(host[num])
		{
		ret = 0;
		}


	ptr += num;

	if(*ptr==']')ptr++;
	if(*ptr==';')ptr++;

	*Zusatz = ptr;



return ret;
}

//*****************************************************************************
//*
//*		OnMenuFilter
//*
//*****************************************************************************
void CBackupView::OnMenuFilter(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(filter_on);
}

//*****************************************************************************
//*
//*		OnSetFilter
//*
//*****************************************************************************
void CBackupView::OnSetFilter()
{
int		pos;

	filter_on = !filter_on;

	if(filter_on)
		{
		base_item = list_view.InsertItem("",TV_NOIMAGE,TVI_ROOT,TVI_FIRST);

		for(pos=0;pos<MAX_X;pos++)
			{
			list_view.SetItemText(base_item,filters[pos],pos);
			}

		SetTimer(ID_FILTER,200,NULL);
		}
	else{
		list_view.DeleteItem(base_item);
		base_item = TVI_ROOT;
		KillTimer(ID_FILTER);
		}

	list_view.SetFixedLines((filter_on)? 1:0);

	UpdateFilters(0);

}

//*****************************************************************************
//*
//*		UpdateFilters
//*
//*****************************************************************************
void CBackupView::UpdateFilters(BOOL ReadBack)
{
HTREEITEM	item;
LPCTSTR		text;
int			pos;


	filter_tick = 0;

	if(!filter_on)
		{
		list_view.SetMultiStates(TVI_ROOT,TVIF_CHILDS,0,TVIS_HIDEITEM);
		return;
		}


	if(ReadBack)
		{
		for(pos=0;pos<MAX_X;pos++)
			{
			filters[pos] = list_view.GetItemText(base_item,pos);
			}
		}

	for(item=base_item;item;)
		{
			item = list_view.GetNextSiblingItem(item);
		if(!item)break;


		for(pos=0;pos<MAX_X;pos++)
			{
			if(filters[pos].IsEmpty())continue;

			text = list_view.GetItemText(item,pos);

			if(memxcmp(filters[pos],text,strlen(text),1))
				{
				break;
				}
			}

		list_view.HideItem(item,pos<MAX_X);
		}


}

//*****************************************************************************
//*
//*		MessageBoxOn
//*
//*****************************************************************************
int CBackupView::MessageBoxOn()
{
return mb_isshown;
}

//*****************************************************************************
//*
//*		MessageBox
//*
//*****************************************************************************
int CBackupView::MessageBox(LPCTSTR Text, LPCTSTR Caption,UINT Type)
{
CWnd   *main;
int		shown;
int		ret;


	mb_isshown = 1;
	main  = AfxGetMainWnd();
	shown = IsWindowVisible();
	if(!shown && main)TaskbarShow(main->m_hWnd);
	ret = CView::MessageBox(Text,Caption,Type);
	if(!shown && main)TaskbarHide(main->m_hWnd);
	mb_isshown = 0;


return ret;
}

//*****************************************************************************
//*
//*		CopyBackup
//*
//*****************************************************************************
//  Lscht rekursiv ein Verzeichnis auf einer FTP Verbindun
//	Path	: Ist der Dateipfad am FTP-Server
//	Size	: Ist die Lnge des Pfades
//	Max		: Ist die Puffergre fr den Pfad
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::DeleteFtpDir(char *Path,int Size,int Max,const char *Plus,const char *Minus)
{
const char     *text;
CString			name;
CStringChain	del_dirs;
CFtpBaseFind   *ftp_find;
time_t			time_file;
time_t			time_now;
int				ignore;				
int				diff;				
int				pos;
int				len;
int				ret;
int				ok;


	time_now = time(0);
	ret		 = 0;
	


	if(Size+5>Max)
		{
		return -1;
		}
													// Backslash anhngen
	if(Size<=0 || (Path[Size-1]!='/' && Path[Size-1]!='\\'))
		{
		Path[Size] = '/';
		Size++;
		}
	
	Path[Size] = 0;
	
	ftp_find = new CFtpBaseFind(ftp_conn);			// Suche in Zielverzeichnis

	if(dlg_view)dlg_view->SetBreak(FtpBreak,ftp_conn);
	ok = ftp_find->FindFile(Path,Plus,Minus,INTERNET_FLAG_NO_DOTS);
	if(dlg_view)dlg_view->SetBreak();

	if(!ok)											// Keine Dateien gefunden	
		{
		ftp_find->Close();
		delete ftp_find;
		Path[Size-1]=0;
		
		if(!ftp_conn->RemoveDirectory(Path))		// Das Verzeichniss lschen
			{
			return -1;
			}

		return 0;
		}


	ignore = 0;

	while(ok)										// Einlesen der Dateien am Zielpfad
		{
		if(dlg_view && dlg_view->IsBreak())
			{
			dlg_break = 1;
			}

		if(dlg_break)								// Benutzer Abbruch ?
			{
			ret = -2;
			break;
			}

		ok	 = ftp_find->FindNextFile();
		name = ftp_find->GetFileName();

		if(ftp_find->IsDirectory())
			{
			del_dirs.Add(name);
			continue;
			}

		time_file  = ftp_find->GetCreationTime();
		
		if(time_file<=0)
			{
			time_file  = ftp_find->GetLastWriteTime();
			}

		diff	   = (int)(time_now-time_file);

		if(diff<3600*24*60)							// Erst nach 2 Monaten lschen
			{
			ignore++;
			continue;
			}

		strlcpy(Path+Size,name,Max-Size);
		if(!ftp_conn->Remove(Path))ret=-1;			// Die Datei lschen
		}


	ftp_find->Close();
	delete ftp_find;

	
	for(;;)											// Unterverzeichnisse lschen
		{
		   pos = del_dirs.Count()-1;
		if(pos<0)break;

		text = del_dirs.Get(pos,len);

		if(Size+len<Max)
			{
			memcpy(Path+Size,text,len);
			
			if(DeleteFtpDir(Path,Size+len,Max,Plus,Minus)<0)
				{
				ignore++;
				}
			}

		del_dirs.Del(pos);
		}
			



	if(!ignore && 0)
		{	
		Path[Size-1]=0;
		
		if(!ftp_conn->RemoveDirectory(Path))		// Das Verzeichniss lschen
			{
			if(!ret)ret=-1;
			}
		}



return ret;
}

//*****************************************************************************
//*
//*		CopyBackup
//*
//*****************************************************************************
//  Mache eine Sicherheitskopie von Dateien auf/von einem Ftp Server
//  Ist bei Art Bit  0!=0 wird die Datei nur dann kopiert wenn das aktuelle Datum neuer ist
//  Ist bei Art Bit  1!=0 werden Fehlermeldungen ausgegeben
//  Ist bei Art Bit  8!=0 werden ber zhlige Dateien am FTP Server gelscht
//  Ist bei Art Bit 10!=0 wird die FTP-Verbindung nicht geschlossen
//  Ist bei Art Bit 11!=0 wird die FTP-Verbindung nicht neu geffnet
//	Zusatz	: <Dateigre>,<Kopien>,<Dateigre>,<Kopien>...;<*><[host]>;Verzeichnisse...
//  Die Klassen-Variabel kopie_anz wir bei jeder Kopie erhht
//  Ergibt   0   wenn kein Fehler auftrat
//			-1	 bei einem Fehler
//			-2	 bei einem Fehler mit Abbruch
int CBackupView::CopyBackup(char *Quelle, char *Ziel,char *Plus,char *Minus,int Unter,char *Zusatz,int Art)
{
CStringChain		deldirs;
CStringChain		folders;
CStringChain		src_flies(offsetof(WIN32_FIND_DATA,cFileName));
CStringChain		tar_flies(offsetof(WIN32_FIND_DATA,cFileName));
char				source[MAX_PATH+256+16];
char				target[MAX_PATH+256+16];
char				flocal[MAX_PATH+256+16];
int					list[16],list_size,num;
int					last[16],level,len,val;
char				mem   [1024];
char				plus   [512];
char				server [256];
char				passwd  [64];
char				username[64];
char				protocol[16];
int					x,y,exit;
CFtpBaseFind	   *ftp_find;
int					src_len;
int					tar_len;
char			   *fname;
char			   *name1;
char			   *name2;
char			   *name3;
__int64				len64;
int					mode;
char			   *text;
CString				name;
CStringChain		dirs;
unsigned			port;
FILETIME			tnow;
WIN32_FIND_DATA		data;
WIN32_FIND_DATA	   *ptr1;
WIN32_FIND_DATA	   *ptr2;
HANDLE				find;
DWORD				open;
int					mask;
int					diff;
int					pos1;
int					pos2;
int					len1;
int					len2;
int					pos;
int					max;
int					end;
int					cnt;
BOOL				ok;



	list[0] = 0;

	for(list_size=0;;)								// Paramteter holen
		{
		y = strtoi(Zusatz,0,&x);

		if(list_size<16 && x>0)
			{
			list[list_size]=y;
			list_size++;
			}

		Zusatz += x;
		Zusatz += strwlen(Zusatz,0x02);
		if(*Zusatz>='0' && *Zusatz<='9')continue;
		if(*Zusatz==','){Zusatz++;continue;}
		break;
		}



	list_size /= 2;

	if(list_size<=0)								// Standart Parameter
		{
		list[0]=0;		list[1]=30;					// Lschnen
		list[2]=64;		list[3]=4;
		list[4]=256;	list[5]=3;
		list[6]=1024;	list[7]=2;
		list[8]=4096;	list[9]=1;
		list_size = 5;
		}

	if(list[0]!=0)									// Lschwert einfgen
		{
		if(list_size>=8)list_size=7;
		memmove(list+2,list,sizeof(int)*14);
		list[0]=0;
		list[1]=30;
		list_size++;
		}

	for(x=1;x<list_size;x++)						// Prfe die Paramteter
		{
		if(list[x*2]<list[x*2-2])
			{
			list[x*2] = list[x*2-2];
			}

		if(list[x*2+1]>9)
			{
			list[x*2+1] = 9;
			}

		if(list[x*2+1]<1)
			{
			list[x*2+1] = 1;
			}
		}


	Zusatz += strwlen(Zusatz,0x02);
	if(*Zusatz==';')Zusatz++;


	if(!CheckHost(&Zusatz))							// Hostnamen prfen
		{
		exit = 0;
		goto Exit;
		}

	if(SetLockPath(Zusatz,1))						// Verzeichnisse auslassen
	if(ExistFile(Ziel)<2)
		{
		exit = 0;									// Wenn Ziel nicht existiert, dann nicht kopieren
		goto Exit;
		}

	if(dlg_view)
		{
		dlg_view->SetText("<ffne FTP-Ziel>",2);
		}

	CreateTempPath(flocal,sizeof(flocal),CTP_UNIQUE,"*?_Backup.tmp",len);

	if(ExistFile(Quelle)<2)							// Existiert der Quellpfad
		{
		if(Art&2)
			{
			strcpy (source,"Das Quellverzeichniss wurde nicht gefunden:\n");
			strlcat(source,Quelle,MAX_PATH+1024);
			if(dlg_view)x=dlg_view->MessageBox(source,0,MB_ICONERROR|MB_OK);
			else		x=          MessageBox(source,0,MB_ICONERROR|MB_OK);
			}

		exit = -1;
		goto Exit;
		}


	exit    = 0;
	src_len = GetFullPathName(Quelle,sizeof(source)-16,source,NULL);
	src_len = AddBackSlash(source,src_len);
	PathConvert(source,'/');


	try	{											// Verbindung zu FTP server ffnen
		server  [0] = 0;
		passwd  [0] = 0;
		username[0] = 0;
		port        = 0;
		mode		= GetFtpConnType(Ziel,FALSE);

		strparseurl(Ziel,server,sizeof(server),username,passwd,&port,protocol,target,sizeof(target)|STR_NOROOTSIGN);

		if(mode!=FTP_MODE_ARCH && mode!=FTP_MODE_SMB && mode!=FTP_MODE_DISK)
			{
			if(!username[0])throw "Falscher User-Namen";
			}

		if(mode!=FTP_MODE_ARCH && mode!=FTP_MODE_SMB && mode!=FTP_MODE_DISK)
			{
			if(!server  [0])throw "Falscher FTP-Server-Name";
			}

		if(mode==FTP_MODE_ARCH && !server[0])
			{
			strncpy(server,target,sizeof(server));
			target[0] = 0;
			}

		if(!ftp_conn || !(Art&0x800))				// Eine neue Verbindung ffnen
			{
			if(ftp_conn)
				{
				delete ftp_conn;
				ftp_conn = NULL;
				}

			ftp_conn = GetFtpConnectionEx(server,username,passwd,port,mode,target);
			}

													// Ab lokalen Pfad
		if(target[0]=='.' && (target[1]==0 || target[1]=='/' || target[1]=='\\'))
			{
			if(!ftp_conn->GetCurrentDirectory(name))throw "Kann aktuelles Verzeichnis nicht abfragen";
			if(target[1]){AddBackSlash(name,'/');name+=target+2;}
			strlcpy(target,name,sizeof(target));
			}
		}
	catch(char *error)
		{
		ftp_conn	= NULL;
		text		= error;
		exit		= -1;
		return -1;
		}
	catch(CInternetException *error)
		{
		text		= ErrorToText(error->m_dwError,"Keine Verbindung zum FTP-Server");
		ftp_conn	= NULL;
		exit		= -1;
		return -1;
		}
	catch(...)
		{
		ftp_conn	= NULL;
		text		= "Keine Verbindung zum FTP-Server";
		exit		= -1;
		return -1;
		}



	end = DelBackSlash(target);
	PathConvert(target,'/');

												// Filter "*" und "*.*" zu ""
	if(Plus[0]=='*' && (Plus[1]==0 || (Plus[1]=='.' && Plus[2]=='*' && Plus[3]==0)))
		{
		Plus = "";
		}

	if(Minus[0]=='*' && (Minus[1]==0 || (Minus[1]=='.' && Minus[2]=='*' && Minus[3]==0)))
		{
		Minus = "";
		}


	len = strlcpy(plus,Plus,sizeof(plus));

	if(len)
		{
		strlcpy(plus+len,";*.bak?",sizeof(plus)-len);
		}


	if(dlg_view)								// Ausgabe in Dialog ?
		{
		dlg_view->SetRange(16);
		dlg_view->SetPos  (0);
		dlg_view->SetText(server,0,0);
		dlg_view->SetText(Ziel  ,1,0);
		}



	last[0]	= src_len-1;
	level	= 0;

	GetSystemTimeAsFileTime(&tnow);
	dirs.DataLength(sizeof(int));
	dirs.Add(0,"",0,&level);
	time_from = GetTickCount();
	size_mode = 0;

	if(dlg_view)
		{
		dlg_view->SetTime (CopyPos,300,this);
		dlg_view->SetBreak(FtpBreak,ftp_conn);
		dlg_view->SetRange(32);
		}


	while(dirs.Count()>0)						// Verzeichnisse durchlaufen
		{
		if(dlg_view && dlg_view->IsBreak())
			{
			dlg_break = 1;
			}

		if(dlg_break)							// Benutzer Abbruch ?
			{
			exit = -2;
			break;
			}

		x					= dirs.Count()-1;
		level				= dirs.DataGet(x);
		src_len				= last[level];
		len					= dirs.Get(x,source+src_len,sizeof(source)-src_len);
		src_len 			= src_len+len;dirs.Del(x);
		level  			   += 1;

		src_len            += 1;
		last  [level    ]	= src_len;
		source[src_len-1]	= '/';
		source[src_len  ]	= 0;

		tar_len  = end;
		tar_len += strlcpy(target+end,source+last[0],sizeof(target)-end-16,src_len-last[0]);

		if(dlg_view)
			{
			y = (target[0]=='/')? 1:0;
			dlg_view->SetText(         source  ,0,1);
			dlg_view->SetText(protocol,target+y,1,1);
			dlg_view->SetText("<Suche Dateien>",2,0);
			dlg_view->SetPos(((GetTickCount()-time_from)/512)%32);
			}

		source[src_len  ]	= '*';
		source[src_len+1]	= 0;

		   find = FindFirstFile(source,&data);
		if(find==INVALID_HANDLE_VALUE)continue;

		src_flies.Del();
		tar_flies.Del();
		folders  .Del();
												// Quell-Dateien einlesen
		for(ok=TRUE;ok;ok=FindNextFile(find,&data))
			{
			len = strlen(data.cFileName);				

			if(data.dwFileAttributes&FILE_ATTRIBUTE_REPARSE_POINT)
				{								// Links ignorieren
				if(data.dwReserved0==IO_REPARSE_TAG_MOUNT_POINT)
					{
					continue;
					}
				}

			if(data.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
				{
				if(Unter==0)continue;

				if(data.cFileName[0]=='.')
					{
					if(len==1                          )continue;
					if(len==2 && data.cFileName[1]=='.')continue;
					}

				if(level>=15)continue;

				if(lock_str.Count())
					{
					num  = src_len;
					num += strlcpy(source+src_len,data.cFileName,sizeof(source)-src_len,len);
					if(IsLockPath(source+last[0],num-last[0]))continue;
					}

				dirs   .Add(len,data.cFileName,CSC_END,&level);
				folders.Add(len,data.cFileName,CSC_ABCG);
				continue;
				}
												// Datei einfgen
			if(*Plus  && memfilter(data.cFileName,len,Plus ,0x01)<=0)continue;
			if(*Minus && memfilter(data.cFileName,len,Minus,0x01)> 0)continue;

			src_flies.Add(len,data.cFileName,CSC_ABCG,&data);
			}

		FindClose(find);

		ftp_find = new CFtpBaseFind(ftp_conn);	// Suche in Zielverzeichnis


		if(dlg_view)dlg_view->SetBreak(FtpBreak,ftp_conn);
		ok = ftp_find->FindFile(target,plus,Minus,INTERNET_FLAG_NO_DOTS);
		if(dlg_view)dlg_view->SetBreak();

												// Zielpfad erstellen
		if(!ok && tar_len>1 && GetLastError()==ERROR_PATH_NOT_FOUND)
			{
			if(!ftp_conn->CreatePath(target) && (Art&2))
				{
				sprintf(mem,"Ein Pfad konnte nicht erstellt werden:\n%s",target);
				if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);

				if(x==IDCANCEL)
					{
					dlg_break=1;
					exit = -2;
					break;
					}
				}
			}

		data.dwReserved0	= 0;
		data.dwReserved1	= 0;
		data.cFileName[0]	= 0;

		deldirs.Del();

		while(ok)								// Einlesen der Dateien am Zielpfad
			{
			ok   = ftp_find->FindNextFile();
			name = ftp_find->GetFileName();

			if(ftp_find->IsDirectory())
				{
				if(folders.FindFast(name,0,-1,0x01)>=0)continue;
				deldirs.Add(name);
				continue;
				}

			ftp_find->GetCreationTime  (&data.ftCreationTime  );
			ftp_find->GetLastWriteTime (&data.ftLastWriteTime );
			ftp_find->GetLastAccessTime(&data.ftLastAccessTime);

			len64					= ftp_find->GetLength64();
			data.dwFileAttributes	= ftp_find->GetAttributes();
			data.nFileSizeLow		= (DWORD)(len64);
			data.nFileSizeHigh		= (DWORD)(len64>>32);

			tar_flies.Add(name.GetLength(),name,CSC_ABCG,&data);
			}

		ftp_find->Close();
		delete ftp_find;

		for(;;)									// Verzeichnisse reursiv lschen
			{
			   cnt = deldirs.Count()-1;
			if(cnt<0)break;

			name3 = deldirs.Get(cnt,num);

			strlcpy(target+tar_len,name3,sizeof(target)-tar_len);
			DeleteFtpDir(target,tar_len+num,sizeof(target),plus,Minus);
			deldirs.Del(cnt);
			}


		pos1 = 0;
		pos2 = 0;
												// Dateien synchronisieren
		while(pos1<src_flies.Count() || pos2<tar_flies.Count())
			{
			if(dlg_view)
				{
				dlg_view->SetText("",2);
				}

			if(dlg_view && dlg_view->IsBreak())
				{
				dlg_break = 1;
				}

			if(dlg_break)						// Benutzer Abbruch ?
				{
				exit = -2;
				break;
				}

			name1 = src_flies.Get(pos1,len1);
			name2 = tar_flies.Get(pos2,len2);
			num	  = len2;

		 	if(num>5 && ISBAK(name2+len2-5) && strwchar(name2[len2-1],0x01))num-=5;


												// Anzahl der Kopien ermitteln
			for(cnt=0,mask=0;pos2+cnt<tar_flies.Count();cnt++)
				{
				fname = tar_flies.Get(pos2+cnt,len);

				if(len>5 && ISBAK(fname+len-5) && strwchar(fname[len-1],0x01))
					{
					val  = fname[len-1]-'0'+1;
					len -= 5;
					}
				else{
					val  = 0;
					}

				if(len!=num || memicmp(name2,fname,len))
					{
					break;
					}

				mask |= 1<<val;
				max   = val;
				}

			if(dlg_view)						// Anzeige aktualisieren
				{
				dlg_view->SetPos(((GetTickCount()-time_from)/512)%32);
				}

			if(len1==0)							// Was kommt zuerst (target oder source)
				{
				x   =  1;
				}
			else if(len2==0)
				{
				x   = -1;
				}
			else{
				len	= (len1<num)? len1:num;
				x	= memicmp(name1,name2,len);

				if(x==0 && len1!=num)
					{
					len	= (len1<num)? -1:1;
					}
				}


			if(x>0)								// Lsche Dateien am Ziel
				{
				ptr2 = (WIN32_FIND_DATA*)tar_flies.Data(pos2);

				if(ptr2->dwFileAttributes&FILE_ATTRIBUTE_ARCHIVE)
					{
					data.dwFileAttributes					= ptr2->dwFileAttributes&~FILE_ATTRIBUTE_ARCHIVE;
					data.dwFileAttributes                  |= FILE_SET_ATTRIBUTE;
					data.ftLastWriteTime					= tnow;
					data.ftCreationTime  .dwHighDateTime	= 0;
					data.ftCreationTime  .dwLowDateTime		= 0;
					data.ftLastAccessTime.dwHighDateTime	= 0;
					data.ftLastAccessTime.dwLowDateTime		= 0;

					strlcpy(data.cFileName,target,sizeof(data.cFileName),tar_len);
					strlcpy(data.cFileName+tar_len,name2,sizeof(data.cFileName)-tar_len,len2);

					if(dlg_view)
						{
						dlg_view->SetText("Set Flag: ",name2,2);
						}
												// Archive Attribut lschen
					ftp_conn->SetOption(INTERNET_OPTION_SETSTAT,&data,sizeof(WIN32_FIND_DATA));

					pos2 += cnt;
					continue;
					}

				   diff = DiffDays(tnow,ptr2->ftLastWriteTime);
				if(diff>list[1])				// Dateien lschen nach N Tagen
					{
					for(y=0;y<cnt;y++)
						{
						tar_flies.Get(pos2+y,target+tar_len,sizeof(target)-tar_len);

						if(dlg_view)
							{
							dlg_view->SetText("Lsche: ",name2,2);
							}

						if(!ftp_conn->Remove(target) && (Art&2))
							{
							sprintf(mem,"Eine Datei konnte nicht gelscht werden:\n%s",target);
							if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
							else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);

							if(x==IDCANCEL)
								{
								dlg_break=1;
								exit = -2;
								pos1 = 0x70000000;
								pos2 = 0x70000000;
								break;
								}
							}
						}
					}

				pos2 += cnt;
				continue;
				}

			if(x==0)								// Dateien kopieren und alte Sicherungen verschieben
				{
				ptr1 = (WIN32_FIND_DATA*)src_flies.Data(pos1);
				ptr2 = (WIN32_FIND_DATA*)tar_flies.Data(pos2);

													// Hat sich die Datei verndert
				if(ptr1->nFileSizeLow==ptr2->nFileSizeLow && ptr1->nFileSizeHigh==ptr2->nFileSizeHigh)
					{
					   diff = DiffSecs(ptr1->ftLastWriteTime,ptr2->ftLastWriteTime);
					if(diff<0)diff=-diff;
					if(diff<=2 || (diff>=3558 && diff<=3602))
						{
						pos2 += cnt;
						pos1 += 1;
						continue;
						}
					}

				len  = strlcpy(source+src_len,name1,sizeof(target)-src_len-8,len1);
				len  = strlcpy(target+tar_len,name1,sizeof(target)-tar_len-8,len1);
				len += tar_len;
													// Bei kleinen gleich groen Dateien Unterschiede suchen
				if(ptr1->nFileSizeLow<=0x8000 && ptr1->nFileSizeHigh==0)
				if(ptr1->nFileSizeLow==ptr2->nFileSizeLow && ptr1->nFileSizeHigh==ptr2->nFileSizeHigh)
					{
					if(dlg_view)
						{
						dlg_view->SetText("Vergleiche: ",name1,2);
						}

					if(ftp_conn->GetFile(target,flocal))
						{
						if(CmpFileData(source,flocal))
							{
							pos2 += cnt;
							pos1 += 1;
							continue;
							}
						}
					}

				y	 = ptr1->nFileSizeHigh<<22;
				y   |= ptr1->nFileSizeLow >>10;

				for(x=list_size-1;x>1;x--)			// Suche Anzahl der Kopien
					{
					if(y>=list[x*2])break;
					}

				x	 = list[x*2+1];
				y	 = (1<<x)-1;
				pos	 = ((mask&y)!=y)? x:x-1;

				for(;pos<=max;pos++)				// Lsche berzhlige Dateien
					{
					if(!(mask&(1<<pos)))continue;
					mask &=  ~(1<<pos);
					if(y)sprintf(target+len,".bak%c",'0'-1+pos);

					if(dlg_view)
						{
						dlg_view->SetText("Lsche: ",name1,2);
						}

					ftp_conn->Remove(target);
					}

				pos = bit_find_0(&mask,x);
				memcpy(mem,target,len);

				if(dlg_view)
					{
					dlg_view->SetText("Umbennen: ",name1,2);
					}

				for(;pos>0;pos--)					// Alte Kopien umbenennen
					{
					if(pos<=1)mem[len]=0;else
					sprintf(mem   +len,".bak%c",'0'-2+pos);
					sprintf(target+len,".bak%c",'0'-1+pos);
					ftp_conn->Rename(mem,target);
					}

				pos2 += cnt;
				}

													// Datei existiert noch nicht im Ziel
			strlcpy(source+src_len,name1,sizeof(target)-src_len,len1);
			strlcpy(target+tar_len,name1,sizeof(target)-tar_len,len1);

			if(dlg_view)
				{
				dlg_view->SetText("Kopiere: ",name1,2);
				strlcpy(prog_text,name1,sizeof(prog_text));
				size_mode = 5;
				}
													// Kopiere die Datei zum Ziel
			if(!ftp_conn->PutFile(source,target) && (Art&2))
				{
				size_mode = 0;

				if(ftp_conn->QueryOption(INTERNET_OPTION_ERROPEN,open) && open==1)
					{
					pos1 += 1;
					continue;
					}

				sprintf(mem,"Eine Datei konnte nicht kopiert werden:\n%s",target);
				if(dlg_view)x=dlg_view->MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);
				else		x=          MessageBox(mem,0,MB_ICONERROR|MB_OKCANCEL);

				if(x==IDCANCEL)
					{
					dlg_break=1;
					exit = -2;
					pos1 = 0x70000000;
					pos2 = 0x70000000;
					break;
					}
				}
			else{
				kopie_anz++;
				}
											// Attribute und Zeiten kopieren
			ptr1 = (WIN32_FIND_DATA*)src_flies.Data(pos1);

			memcpy(&data,ptr1,offsetof(WIN32_FIND_DATA,cFileName));
			strlcpy(data.cFileName,target,sizeof(data.cFileName));
			data.dwFileAttributes |= FILE_ATTRIBUTE_ARCHIVE|FILE_SET_ATTRIBUTE;
			ftp_conn->SetOption(INTERNET_OPTION_SETSTAT,&data,sizeof(WIN32_FIND_DATA));

			size_mode = 0;
			pos1     += 1;
			}

		if(dlg_view)
			{
			dlg_view->SetText("",2);
			}
		}

	DeleteFile(flocal);

Exit:

	if(dlg_view)
		{
		dlg_view->SetTime (NULL,0,0);
		dlg_view->SetBreak();
		}

	size_mode = 0;

	if(ftp_conn && !(Art&0x400))
		{
		delete ftp_conn;
		ftp_conn = NULL;
		}



return exit;
}

//*****************************************************************************
//*
//*		OnSettings
//*
//*****************************************************************************
void CBackupView::OnSettings()
{
char			cText[MAX_PATH];
char			cLast[MAX_PATH];
CModeSizeDlg	cSizeDlg;
CModeBuffDlg	cBuffDlg;
CModeHostDlg	cHostDlg;
CModePathDlg	cPathDlg;
CModeCopyDlg	cCopyDlg;
CModeListDlg	cListDlg;
CTextDlg		cTextDlg;
LPCTSTR			pSource;
LPCTSTR			pTarget;
HTREEITEM		hItem;
int				iMode;



		hItem = list_view.GetFocusItem();
	if(!hItem)return;

	if(!list_view.GetItemText(hItem,cText,sizeof(cText),5))
		{
		return;
		}

 	for(iMode=0;modi[iMode];iMode++)
		{
		if(!stricmp(cText,modi[iMode]))break;
		}

	if(!modi[iMode])iMode=MODE_COPY;


	if(!list_view.GetItemText(hItem,cText,sizeof(cText),6))
		{
		return;
		}

	pSource = list_view.GetItemText(hItem,0);
	pTarget = list_view.GetItemText(hItem,1);

	strlcpy(cLast,cText,sizeof(cLast));


	switch(iMode)
		{
	case MODE_COPY:
	case MODE_COPYDEL:
	case MODE_COPYFILE:
						cCopyDlg.m_pBuffer	= cText;
						cCopyDlg.m_iSize	= sizeof(cText);
						if(cCopyDlg.DoModal()!=IDOK)return;
						break;
	case MODE_ZIP:
						if(!stricmp(GetFileType(pSource),"ZIP"))
							{
							cListDlg.m_pBuffer	= cText;
							cListDlg.m_iSize	= sizeof(cText);
							if(cListDlg.DoModal()!=IDOK)return;
							break;
							}
	case MODE_ZIPADD:
						if(stricmp(GetFileType(pTarget),"ZIP"))
							{
							cCopyDlg.m_pBuffer	= cText;
							cCopyDlg.m_iSize	= sizeof(cText);
	 						if(cCopyDlg.DoModal()!=IDOK)return;
							break;
							}

						cPathDlg.m_pBuffer	= cText;
						cPathDlg.m_iSize	= sizeof(cText);
						if(cPathDlg.DoModal()!=IDOK)return;
						break;
	case MODE_FTP:
	case MODE_FTPDEL:
	case MODE_UPDATE:
						cListDlg.m_pBuffer	= cText;
						cListDlg.m_iSize	= sizeof(cText);
						if(cListDlg.DoModal()!=IDOK)return;
						break;
	case MODE_SYNCH:
						cHostDlg.m_pBuffer	= cText;
						cHostDlg.m_iSize	= sizeof(cText);
						if(cHostDlg.DoModal()!=IDOK)return;
						break;
	case MODE_BUFFER:
						cBuffDlg.m_pBuffer	= cText;
						cBuffDlg.m_iSize	= sizeof(cText);
						if(cBuffDlg.DoModal()!=IDOK)return;
						break;
	case MODE_SHRINK:
						cSizeDlg.m_pBuffer	= cText;
						cSizeDlg.m_iSize	= sizeof(cText);
						if(cSizeDlg.DoModal()!=IDOK)return;
						break;
	case MODE_BACKUP:
						cSizeDlg.m_bBackup	= TRUE;
						cSizeDlg.m_pBuffer	= cText;
						cSizeDlg.m_iSize	= sizeof(cText);
						if(cSizeDlg.DoModal()!=IDOK)return;
						break;
	default:			return;
		}


	if(strcmp(cLast,cText)==0)return;

	list_view.SetItemText(hItem,cText,6);
	geaendert |= 1;


}

//*****************************************************************************
//*
//*		OnDoFilter
//*
//*****************************************************************************
void CBackupView::OnDoFilter()
{
char			cText[MAX_PATH];
char			cLast[MAX_PATH];
CModeListDlg	cListDlg;
HTREEITEM		hItem;




		hItem = list_view.GetFocusItem();
	if(!hItem)return;

	if(filter_pos<2 || filter_pos>3)return;

	if(!list_view.GetItemText(hItem,cText,sizeof(cText),filter_pos))
		{
		return;
		}

	strlcpy(cLast,cText,sizeof(cLast));

	cListDlg.m_sTitle		= (filter_pos==2)? "Plusfilter":"Minusfilter";
	cListDlg.m_sTextTitle	= (filter_pos==2)? "Welche Dateien sollen kopiert werden :":"Welche Dateien sollen ignoriert werden :";
	cListDlg.m_pBuffer		= cText;
	cListDlg.m_iSize		= sizeof(cText);

	if(cListDlg.DoModal()!=IDOK)return;
	if(strcmp(cLast,cText)== 0 )return;

	list_view.SetItemText(hItem,cText,filter_pos);
	geaendert |= 1;


}

